// @license magnet:?xt=urn:btih:87f119ba0b429ba17a44b4bffcab33165ebdacc0&dn=freebsd.txt BSD-2-Clause
(function(b) {
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function n(e) {
        return e.split("");
    }
    function Un(e, n) {
        return n.indexOf(e) >= 0;
    }
    function Vn(e, n) {
        for (var t = n.length; --t >= 0; ) if (e(n[t])) return n[t];
    }
    function t(e) {
        Object.defineProperty(e.prototype, "stack", {
            get: function() {
                var e = new Error(this.message);
                e.name = this.name;
                try {
                    throw e;
                } catch (e) {
                    return e.stack;
                }
            }
        });
    }
    function i(e, n) {
        this.message = e;
        this.defs = n;
    }
    i.prototype = Object.create(Error.prototype);
    i.prototype.constructor = i;
    i.prototype.name = "DefaultsError";
    t(i);
    function we(e, n, t) {
        if (t) for (var r in e) {
            if (et(e, r) && !et(n, r)) throw new i("`" + r + "` is not a supported option", n);
        }
        for (var r in e) {
            if (et(e, r)) n[r] = e[r];
        }
        return n;
    }
    function Wn() {}
    function cn() {
        return false;
    }
    function ln() {
        return true;
    }
    function Gn() {
        return this;
    }
    function Jn() {
        return null;
    }
    var Xn = function() {
        function e(e, n) {
            var t = [];
            for (var r = 0; r < e.length; r++) {
                var i = n(e[r], r);
                if (i === a) continue;
                if (i instanceof o) {
                    t.push.apply(t, i.v);
                } else {
                    t.push(i);
                }
            }
            return t;
        }
        e.is_op = function(e) {
            return e === a || e instanceof o;
        };
        e.splice = function(e) {
            return new o(e);
        };
        var a = e.skip = {};
        function o(e) {
            this.v = e;
        }
        return e;
    }();
    function Kn(e, n) {
        if (e.indexOf(n) < 0) return e.push(n);
    }
    function Qn(e, r) {
        return e.replace(/\{([^{}]+)\}/g, function(e, n) {
            var t = n == "this" ? r : r[n];
            if (t instanceof vn) return t.print_to_string();
            if (t instanceof te) return t.file + ":" + t.line + "," + t.col;
            return t;
        });
    }
    function Zn(e, n) {
        var t = e.indexOf(n);
        if (t >= 0) e.splice(t, 1);
    }
    function pn(e) {
        if (!Array.isArray(e)) e = e.split(" ");
        var n = Object.create(null);
        e.forEach(function(e) {
            n[e] = true;
        });
        return n;
    }
    function dn(e, n) {
        for (var t = e.length; --t >= 0; ) if (!n(e[t], t)) return false;
        return true;
    }
    function hn() {
        this.values = Object.create(null);
    }
    hn.prototype = {
        set: function(e, n) {
            if (e == "__proto__") {
                this.proto_value = n;
            } else {
                this.values[e] = n;
            }
            return this;
        },
        add: function(e, n) {
            var t = this.get(e);
            if (t) {
                t.push(n);
            } else {
                this.set(e, [ n ]);
            }
            return this;
        },
        get: function(e) {
            return e == "__proto__" ? this.proto_value : this.values[e];
        },
        del: function(e) {
            if (e == "__proto__") {
                delete this.proto_value;
            } else {
                delete this.values[e];
            }
            return this;
        },
        has: function(e) {
            return e == "__proto__" ? "proto_value" in this : e in this.values;
        },
        all: function(e) {
            for (var n in this.values) if (!e(this.values[n], n)) return false;
            if ("proto_value" in this && !e(this.proto_value, "__proto__")) return false;
            return true;
        },
        each: function(e) {
            for (var n in this.values) e(this.values[n], n);
            if ("proto_value" in this) e(this.proto_value, "__proto__");
        },
        size: function() {
            return Object.keys(this.values).length + ("proto_value" in this);
        },
        map: function(e) {
            var n = [];
            for (var t in this.values) n.push(e(this.values[t], t));
            if ("proto_value" in this) n.push(e(this.proto_value, "__proto__"));
            return n;
        },
        clone: function() {
            var t = new hn();
            this.each(function(e, n) {
                t.set(n, e);
            });
            return t;
        },
        toObject: function() {
            var t = {};
            this.each(function(e, n) {
                t["$" + n] = e;
            });
            return t;
        }
    };
    hn.fromObject = function(e) {
        var n = new hn();
        for (var t in e) if (et(e, t)) n.set(t.slice(1), e[t]);
        return n;
    };
    function et(e, n) {
        return Object.prototype.hasOwnProperty.call(e, n);
    }
    function nt(e, n, t) {
        var r = e.parent(-1);
        for (var i = 0, a; a = e.parent(i++); r = a) {
            if (kt(a)) {
                return n && a.value === r;
            } else if (a instanceof Cn) {
                if (a.left === r) continue;
            } else if (a.TYPE == "Call") {
                if (a.expression === r) continue;
            } else if (a instanceof Mn) {
                if (a.condition === r) continue;
            } else if (a instanceof lr) {
                return t;
            } else if (a instanceof An) {
                if (a.expression === r) continue;
            } else if (a instanceof Tn) {
                if (a.expressions[0] === r) continue;
            } else if (a instanceof _n) {
                return true;
            } else if (a instanceof Rr) {
                if (a.tag === r) continue;
            } else if (a instanceof mr) {
                if (a.expression === r) continue;
            }
            return false;
        }
    }
    function r(r, e) {
        if (e.length > 31) throw new Error("Too many properties: " + e.length + "\n" + e.join(", "));
        e.forEach(function(e, n) {
            var t = 1 << n;
            Object.defineProperty(r.prototype, e, {
                get: function() {
                    return !!(this._bits & t);
                },
                set: function(e) {
                    if (e) this._bits |= t; else this._bits &= ~t;
                }
            });
        });
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function e(e, n, t, r) {
        if (typeof r === "undefined") r = vn;
        n = n ? n.split(/\s+/) : [];
        var i = n;
        if (r && r.PROPS) n = n.concat(r.PROPS);
        var a = [ "return function AST_", e, "(props){", "this._bits=0;", "if(props){" ];
        n.forEach(function(e) {
            a.push("this.", e, "=props.", e, ";");
        });
        a.push("}");
        var o = Object.create(r && r.prototype);
        if (t.initialize || o.initialize) a.push("this.initialize();");
        a.push("};");
        var s = new Function(a.join(""))();
        s.prototype = o;
        s.prototype.CTOR = s;
        s.prototype.TYPE = s.TYPE = e;
        if (r) {
            s.BASE = r;
            r.SUBCLASSES.push(s);
        }
        s.DEFMETHOD = function(e, n) {
            this.prototype[e] = n;
        };
        s.PROPS = n;
        s.SELF_PROPS = i;
        s.SUBCLASSES = [];
        for (var f in t) if (et(t, f)) {
            if (/^\$/.test(f)) {
                s[f.substr(1)] = t[f];
            } else {
                s.DEFMETHOD(f, t[f]);
            }
        }
        if (typeof b !== "undefined") b["AST_" + e] = s;
        return s;
    }
    var te = e("Token", "type value line col pos endline endcol endpos nlb comments_before comments_after file raw", {}, null);
    var vn = e("Node", "start end", {
        _clone: function(e) {
            if (e) {
                var n = this.clone();
                return n.transform(new Zr(function(e) {
                    if (e !== n) {
                        return e.clone(true);
                    }
                }));
            }
            return new this.CTOR(this);
        },
        clone: function(e) {
            return this._clone(e);
        },
        $documentation: "Base class of all AST nodes",
        $propdoc: {
            start: "[AST_Token] The first token of this node",
            end: "[AST_Token] The last token of this node"
        },
        equals: function(e) {
            return this.TYPE == e.TYPE && this._equals(e);
        },
        walk: function(e) {
            e.visit(this);
        },
        _validate: function() {
            if (this.TYPE == "Node") throw new Error("should not instantiate AST_Node");
        },
        validate: function() {
            var e = this.CTOR;
            do {
                e.prototype._validate.call(this);
            } while (e = e.BASE);
        },
        validate_ast: function() {
            var n = {};
            this.walk(new Ln(function(e) {
                if (e.validate_visited === n) {
                    throw new Error(Qn("cannot reuse AST_{TYPE} from [{start}]", e));
                }
                e.validate_visited = n;
            }));
        }
    }, null);
    r(vn, [ "_optimized", "_squeezed", "call_only", "collapse_scanning", "defined", "evaluating", "falsy", "in_arg", "in_bool", "is_undefined", "inlined", "length_read", "nested", "new", "optional", "private", "pure", "redundant", "single_use", "static", "terminal", "truthy", "uses_eval", "uses_with" ]);
    (vn.log_function = function(n, e) {
        if (typeof n != "function") {
            vn.info = vn.warn = Wn;
            return;
        }
        var t = Object.create(null);
        vn.info = e ? function(e, n) {
            r("INFO: " + Qn(e, n));
        } : Wn;
        vn.warn = function(e, n) {
            r("WARN: " + Qn(e, n));
        };
        function r(e) {
            if (t[e]) return;
            t[e] = true;
            n(e);
        }
    })();
    var a = [];
    vn.enable_validation = function() {
        vn.disable_validation();
        (function e(n) {
            n.SUBCLASSES.forEach(e);
            if (!et(n.prototype, "transform")) return;
            var r = n.prototype.transform;
            n.prototype.transform = function(e, n) {
                var t = r.call(this, e, n);
                if (t instanceof vn) {
                    t.validate();
                } else if (!(t === null || n && Xn.is_op(t))) {
                    throw new Error("invalid transformed value: " + t);
                }
                return t;
            };
            a.push(function() {
                n.prototype.transform = r;
            });
        })(this);
    };
    vn.disable_validation = function() {
        var e;
        while (e = a.pop()) e();
    };
    function o(e, t) {
        return e.length == t.length && dn(e, function(e, n) {
            return e.equals(t[n]);
        });
    }
    function s(e, t) {
        return e.length == t.length && dn(e, function(e, n) {
            return e == t[n];
        });
    }
    function f(e, n) {
        if (e === n) return true;
        if (e == null) return n == null;
        return e instanceof vn && n instanceof vn && e.equals(n);
    }
    var tt = e("Statement", null, {
        $documentation: "Base class of all statements",
        _validate: function() {
            if (this.TYPE == "Statement") throw new Error("should not instantiate AST_Statement");
        }
    });
    var rt = e("Debugger", null, {
        $documentation: "Represents a debugger statement",
        _equals: ln
    }, tt);
    var it = e("Directive", "quote value", {
        $documentation: 'Represents a directive, like "use strict";',
        $propdoc: {
            quote: "[string?] the original quote character",
            value: "[string] The value of this directive as a plain string (it's not an AST_String!)"
        },
        _equals: function(e) {
            return this.value == e.value;
        },
        _validate: function() {
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, tt);
    var mn = e("EmptyStatement", null, {
        $documentation: "The empty statement (empty block or simply a semicolon)",
        _equals: ln
    }, tt);
    function at(e) {
        return e instanceof tt && !(e instanceof Ht) && !(e instanceof xt);
    }
    function u(e, n, t, r, i) {
        t = t ? "contain" : "be";
        if (!(e instanceof vn)) throw new Error(n + " must " + t + " AST_Node");
        if (e instanceof En) throw new Error(n + " cannot " + t + " AST_DefaultValue");
        if (e instanceof jn) throw new Error(n + " cannot " + t + " AST_Destructured");
        if (e instanceof Gr && !i) throw new Error(n + " cannot " + t + " AST_Hole");
        if (e instanceof On && !r) throw new Error(n + " cannot " + t + " AST_Spread");
        if (at(e)) throw new Error(n + " cannot " + t + " AST_Statement");
        if (e instanceof Dr) {
            throw new Error(n + " cannot " + t + " AST_SymbolDeclaration");
        }
    }
    function c(e, n) {
        u(e[n], n);
    }
    var _n = e("SimpleStatement", "body", {
        $documentation: "A statement consisting of an expression, i.e. a = 1 + 2",
        $propdoc: {
            body: "[AST_Node] an expression node (should not be instanceof AST_Statement)"
        },
        _equals: function(e) {
            return this.body.equals(e.body);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            c(this, "body");
        }
    }, tt);
    var ot = e("BlockScope", "_var_names enclosed functions make_def parent_scope variables", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            enclosed: "[SymbolDef*/S] a list of all symbol definitions that are accessed from this scope or any subscopes",
            functions: "[Dictionary/S] like `variables`, but only lists function declarations",
            parent_scope: "[AST_Scope?/S] link to the parent scope",
            variables: "[Dictionary/S] a map of name ---\x3e SymbolDef for all variables/functions defined in this scope"
        },
        clone: function(e) {
            var n = this._clone(e);
            if (this.enclosed) n.enclosed = this.enclosed.slice();
            if (this.functions) n.functions = this.functions.clone();
            if (this.variables) n.variables = this.variables.clone();
            return n;
        },
        pinned: function() {
            return this.resolve().pinned();
        },
        resolve: function() {
            return this.parent_scope.resolve();
        },
        _validate: function() {
            if (this.TYPE == "BlockScope") throw new Error("should not instantiate AST_BlockScope");
            if (this.parent_scope == null) return;
            if (!(this.parent_scope instanceof ot)) throw new Error("parent_scope must be AST_BlockScope");
            if (!(this.resolve() instanceof bn)) throw new Error("must be contained within AST_Scope");
        }
    }, tt);
    function st(e, n) {
        e.body.forEach(function(e) {
            e.walk(n);
        });
    }
    var ft = e("Block", "body", {
        $documentation: "A body of statements (usually braced)",
        $propdoc: {
            body: "[AST_Statement*] an array of statements"
        },
        _equals: function(e) {
            return o(this.body, e.body);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                st(n, e);
            });
        },
        _validate: function() {
            if (this.TYPE == "Block") throw new Error("should not instantiate AST_Block");
            this.body.forEach(function(e) {
                if (!at(e)) throw new Error("body must contain AST_Statement");
            });
        }
    }, ot);
    var gn = e("BlockStatement", null, {
        $documentation: "A block statement"
    }, ft);
    var N = e("StatementWithBody", "body", {
        $documentation: "Base class for all statements that contain one nested body: `For`, `ForIn`, `Do`, `While`, `With`",
        $propdoc: {
            body: "[AST_Statement] the body; this should always be present, even if it's an AST_EmptyStatement"
        },
        _validate: function() {
            if (this.TYPE == "StatementWithBody") throw new Error("should not instantiate AST_StatementWithBody");
            if (!at(this.body)) throw new Error("body must be AST_Statement");
        }
    }, ot);
    var ut = e("LabeledStatement", "label", {
        $documentation: "Statement with a label",
        $propdoc: {
            label: "[AST_Label] a label definition"
        },
        _equals: function(e) {
            return this.label.equals(e.label) && this.body.equals(e.body);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.label.walk(e);
                n.body.walk(e);
            });
        },
        clone: function(e) {
            var n = this._clone(e);
            if (e) {
                var t = n.label;
                var r = this.label;
                n.walk(new Ln(function(e) {
                    if (e instanceof Xt) {
                        if (!e.label || e.label.thedef !== r) return;
                        e.label.thedef = t;
                        t.references.push(e);
                        return true;
                    }
                    if (e instanceof bn) return true;
                }));
            }
            return n;
        },
        _validate: function() {
            if (!(this.label instanceof Se)) throw new Error("label must be AST_Label");
        }
    }, N);
    var ct = e("IterationStatement", null, {
        $documentation: "Internal class.  All loops inherit from it.",
        _validate: function() {
            if (this.TYPE == "IterationStatement") throw new Error("should not instantiate AST_IterationStatement");
        }
    }, N);
    var lt = e("DWLoop", "condition", {
        $documentation: "Base class for do/while statements",
        $propdoc: {
            condition: "[AST_Node] the loop condition.  Should not be instanceof AST_Statement"
        },
        _equals: function(e) {
            return this.body.equals(e.body) && this.condition.equals(e.condition);
        },
        _validate: function() {
            if (this.TYPE == "DWLoop") throw new Error("should not instantiate AST_DWLoop");
            c(this, "condition");
        }
    }, ct);
    var pt = e("Do", null, {
        $documentation: "A `do` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
                n.condition.walk(e);
            });
        }
    }, lt);
    var dt = e("While", null, {
        $documentation: "A `while` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
            });
        }
    }, lt);
    var ht = e("For", "init condition step", {
        $documentation: "A `for` statement",
        $propdoc: {
            init: "[AST_Node?] the `for` initialization code, or null if empty",
            condition: "[AST_Node?] the `for` termination clause, or null if empty",
            step: "[AST_Node?] the `for` update clause, or null if empty"
        },
        _equals: function(e) {
            return f(this.init, e.init) && f(this.condition, e.condition) && f(this.step, e.step) && this.body.equals(e.body);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.init) n.init.walk(e);
                if (n.condition) n.condition.walk(e);
                if (n.step) n.step.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.init != null) {
                if (!(this.init instanceof vn)) throw new Error("init must be AST_Node");
                if (at(this.init) && !(this.init instanceof or)) {
                    throw new Error("init cannot be AST_Statement");
                }
            }
            if (this.condition != null) c(this, "condition");
            if (this.step != null) c(this, "step");
        }
    }, ct);
    var vt = e("ForEnumeration", "init object", {
        $documentation: "Base class for enumeration loops, i.e. `for ... in`, `for ... of` & `for await ... of`",
        $propdoc: {
            init: "[AST_Node] the assignment target during iteration",
            object: "[AST_Node] the object to iterate over"
        },
        _equals: function(e) {
            return this.init.equals(e.init) && this.object.equals(e.object) && this.body.equals(e.body);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.init.walk(e);
                n.object.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "ForEnumeration") throw new Error("should not instantiate AST_ForEnumeration");
            if (this.init instanceof or) {
                if (this.init.definitions.length != 1) throw new Error("init must have single declaration");
            } else {
                p(this.init, function(e) {
                    if (!(e instanceof An || e instanceof Hn)) {
                        throw new Error("init must be assignable: " + e.TYPE);
                    }
                });
            }
            c(this, "object");
        }
    }, ct);
    var mt = e("ForIn", null, {
        $documentation: "A `for ... in` statement"
    }, vt);
    var xe = e("ForOf", null, {
        $documentation: "A `for ... of` statement"
    }, vt);
    var _t = e("ForAwaitOf", null, {
        $documentation: "A `for await ... of` statement"
    }, xe);
    var gt = e("With", "expression", {
        $documentation: "A `with` statement",
        $propdoc: {
            expression: "[AST_Node] the `with` expression"
        },
        _equals: function(e) {
            return this.expression.equals(e.expression) && this.body.equals(e.body);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            c(this, "expression");
        }
    }, N);
    var bn = e("Scope", "fn_defs may_call_this uses_eval uses_with", {
        $documentation: "Base class for all statements introducing a lambda scope",
        $propdoc: {
            uses_eval: "[boolean/S] tells whether this scope contains a direct call to the global `eval`",
            uses_with: "[boolean/S] tells whether this scope uses the `with` statement"
        },
        pinned: function() {
            return this.uses_eval || this.uses_with;
        },
        resolve: Gn,
        _validate: function() {
            if (this.TYPE == "Scope") throw new Error("should not instantiate AST_Scope");
        }
    }, ft);
    var bt = e("Toplevel", "globals", {
        $documentation: "The toplevel scope",
        $propdoc: {
            globals: "[Dictionary/S] a map of name ---\x3e SymbolDef for all undeclared names"
        },
        wrap: function(e) {
            var n = this.body;
            return ai([ "(function(exports){'$ORIG';})(typeof ", e, "=='undefined'?(", e, "={}):", e, ");" ].join(""), {
                filename: "wrap=" + JSON.stringify(e)
            }).transform(new Zr(function(e) {
                if (e instanceof it && e.value == "$ORIG") {
                    return Xn.splice(n);
                }
            }));
        },
        enclose: function(e) {
            if (typeof e != "string") e = "";
            var n = e.indexOf(":");
            if (n < 0) n = e.length;
            var t = this.body;
            return ai([ "(function(", e.slice(0, n), '){"$ORIG"})(', e.slice(n + 1), ")" ].join(""), {
                filename: "enclose=" + JSON.stringify(e)
            }).transform(new Zr(function(e) {
                if (e instanceof it && e.value == "$ORIG") {
                    return Xn.splice(t);
                }
            }));
        }
    }, bn);
    var yt = e("ClassInitBlock", null, {
        $documentation: "Value for `class` static initialization blocks"
    }, bn);
    var yn = e("Lambda", "argnames length_read rest safe_ids uses_arguments", {
        $documentation: "Base class for functions",
        $propdoc: {
            argnames: "[(AST_DefaultValue|AST_Destructured|AST_SymbolFunarg)*] array of function arguments and/or destructured literals",
            length_read: "[boolean/S] whether length property of this function is accessed",
            rest: "[(AST_Destructured|AST_SymbolFunarg)?] rest parameter, or null if absent",
            uses_arguments: "[boolean|number/S] whether this function accesses the arguments array"
        },
        each_argname: function(n) {
            var t = new Ln(function(e) {
                if (e instanceof En) {
                    e.name.walk(t);
                    return true;
                }
                if (e instanceof yr) {
                    e.value.walk(t);
                    return true;
                }
                if (e instanceof In) n(e);
            });
            this.argnames.forEach(function(e) {
                e.walk(t);
            });
            if (this.rest) this.rest.walk(t);
        },
        _equals: function(e) {
            return f(this.rest, e.rest) && f(this.name, e.name) && f(this.value, e.value) && o(this.argnames, e.argnames) && o(this.body, e.body);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.name) e.name.walk(n);
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                st(e, n);
            });
        },
        _validate: function() {
            if (this.TYPE == "Lambda") throw new Error("should not instantiate AST_Lambda");
            this.argnames.forEach(function(e) {
                p(e, function(e) {
                    if (!(e instanceof In)) throw new Error("argnames must be AST_SymbolFunarg[]");
                }, true);
            });
            if (this.rest != null) p(this.rest, function(e) {
                if (!(e instanceof In)) throw new Error("rest must be AST_SymbolFunarg");
            });
        }
    }, bn);
    var wt = e("Accessor", null, {
        $documentation: "A getter/setter function",
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
        }
    }, yn);
    var xt = e("LambdaExpression", "inlined", {
        $documentation: "Base class for function expressions",
        $propdoc: {
            inlined: "[boolean/S] whether this function has been inlined"
        },
        _validate: function() {
            if (this.TYPE == "LambdaExpression") throw new Error("should not instantiate AST_LambdaExpression");
        }
    }, yn);
    function kt(e) {
        return e instanceof At || e instanceof Dt;
    }
    function Et(e) {
        return e instanceof Dt || e instanceof Mt || e instanceof qt || e instanceof Ft || e instanceof Ot;
    }
    function St(e) {
        return e instanceof Ft || e instanceof Ot || e instanceof jt || e instanceof zt;
    }
    function Tt(e, n) {
        if (kt(e) && e.value) {
            e.value.walk(n);
        } else {
            st(e, n);
        }
    }
    var At = e("Arrow", "value", {
        $documentation: "An arrow function expression",
        $propdoc: {
            value: "[AST_Node?] simple return expression, or null if using function body."
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                if (e.value) {
                    e.value.walk(n);
                } else {
                    st(e, n);
                }
            });
        },
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
            if (this.uses_arguments) throw new Error("uses_arguments must be false");
            if (this.value != null) {
                c(this, "value");
                if (this.body.length) throw new Error("body must be empty if value exists");
            }
        }
    }, xt);
    var Dt = e("AsyncArrow", "value", {
        $documentation: "An asynchronous arrow function expression",
        $propdoc: {
            value: "[AST_Node?] simple return expression, or null if using function body."
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                if (e.value) {
                    e.value.walk(n);
                } else {
                    st(e, n);
                }
            });
        },
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
            if (this.uses_arguments) throw new Error("uses_arguments must be false");
            if (this.value != null) {
                c(this, "value");
                if (this.body.length) throw new Error("body must be empty if value exists");
            }
        }
    }, xt);
    var qt = e("AsyncFunction", "name", {
        $documentation: "An asynchronous function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof Mr)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, xt);
    var Ot = e("AsyncGeneratorFunction", "name", {
        $documentation: "An asynchronous generator function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof Mr)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, xt);
    var $t = e("Function", "name", {
        $documentation: "A function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof Mr)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, xt);
    var zt = e("GeneratorFunction", "name", {
        $documentation: "A generator function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof Mr)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, xt);
    var Ct = e("LambdaDefinition", "inlined name", {
        $documentation: "Base class for function definitions",
        $propdoc: {
            inlined: "[boolean/S] whether this function has been inlined",
            name: "[AST_SymbolDefun] the name of this function"
        },
        _validate: function() {
            if (this.TYPE == "LambdaDefinition") throw new Error("should not instantiate AST_LambdaDefinition");
            if (!(this.name instanceof Cr)) throw new Error("name must be AST_SymbolDefun");
        }
    }, yn);
    var Mt = e("AsyncDefun", null, {
        $documentation: "An asynchronous function definition"
    }, Ct);
    var Ft = e("AsyncGeneratorDefun", null, {
        $documentation: "An asynchronous generator function definition"
    }, Ct);
    var Pt = e("Defun", null, {
        $documentation: "A function definition"
    }, Ct);
    var jt = e("GeneratorDefun", null, {
        $documentation: "A generator function definition"
    }, Ct);
    var Nt = e("Class", "extends name properties", {
        $documentation: "Base class for class literals",
        $propdoc: {
            extends: "[AST_Node?] the super class, or null if not specified",
            properties: "[AST_ClassProperty*] array of class properties"
        },
        _equals: function(e) {
            return f(this.name, e.name) && f(this.extends, e.extends) && o(this.properties, e.properties);
        },
        resolve: function(e) {
            return e ? this : this.parent_scope.resolve();
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.name) e.name.walk(n);
                if (e.extends) e.extends.walk(n);
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.TYPE == "Class") throw new Error("should not instantiate AST_Class");
            if (this.extends != null) c(this, "extends");
            this.properties.forEach(function(e) {
                if (!(e instanceof Yt)) throw new Error("properties must contain AST_ClassProperty");
            });
        }
    }, ot);
    var It = e("DefClass", null, {
        $documentation: "A class definition",
        $propdoc: {
            name: "[AST_SymbolDefClass] the name of this class"
        },
        _validate: function() {
            if (!(this.name instanceof Ee)) throw new Error("name must be AST_SymbolDefClass");
        }
    }, Nt);
    var Ht = e("ClassExpression", null, {
        $documentation: "A class expression",
        $propdoc: {
            name: "[AST_SymbolClass?] the name of this class, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof Fr)) throw new Error("name must be AST_SymbolClass");
            }
        }
    }, Nt);
    var Yt = e("ClassProperty", "key private static value", {
        $documentation: "Base class for `class` properties",
        $propdoc: {
            key: "[string|AST_Node?] property name (AST_Node for computed property, null for initialization block)",
            private: "[boolean] whether this is a private property",
            static: "[boolean] whether this is a static property",
            value: "[AST_Node?] property value (AST_Accessor for getters/setters, AST_LambdaExpression for methods, null if not specified for fields)"
        },
        _equals: function(e) {
            return !this.private == !e.private && !this.static == !e.static && f(this.key, e.key) && f(this.value, e.value);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof vn) n.key.walk(e);
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "ClassProperty") throw new Error("should not instantiate AST_ClassProperty");
            if (this instanceof Vt) {
                if (this.key != null) throw new Error("key must be null");
            } else if (typeof this.key != "string") {
                if (!(this.key instanceof vn)) throw new Error("key must be string or AST_Node");
                c(this, "key");
            }
            if (this.value != null) {
                if (!(this.value instanceof vn)) throw new Error("value must be AST_Node");
            }
        }
    });
    var Rt = e("ClassField", null, {
        $documentation: "A `class` field",
        _validate: function() {
            if (this.value != null) c(this, "value");
        }
    }, Yt);
    var Bt = e("ClassGetter", null, {
        $documentation: "A `class` getter",
        _validate: function() {
            if (!(this.value instanceof wt)) throw new Error("value must be AST_Accessor");
        }
    }, Yt);
    var Lt = e("ClassSetter", null, {
        $documentation: "A `class` setter",
        _validate: function() {
            if (!(this.value instanceof wt)) throw new Error("value must be AST_Accessor");
        }
    }, Yt);
    var Ut = e("ClassMethod", null, {
        $documentation: "A `class` method",
        _validate: function() {
            if (!(this.value instanceof xt)) throw new Error("value must be AST_LambdaExpression");
            if (kt(this.value)) throw new Error("value cannot be AST_Arrow or AST_AsyncArrow");
            if (this.value.name != null) throw new Error("name of class method's lambda must be null");
        }
    }, Yt);
    var Vt = e("ClassInit", null, {
        $documentation: "A `class` static initialization block",
        _validate: function() {
            if (!this.static) throw new Error("static must be true");
            if (!(this.value instanceof yt)) throw new Error("value must be AST_ClassInitBlock");
        },
        initialize: function() {
            this.static = true;
        }
    }, Yt);
    var Wt = e("Jump", null, {
        $documentation: "Base class for “jumps” (for now that's `return`, `throw`, `break` and `continue`)",
        _validate: function() {
            if (this.TYPE == "Jump") throw new Error("should not instantiate AST_Jump");
        }
    }, tt);
    var Gt = e("Exit", "value", {
        $documentation: "Base class for “exits” (`return` and `throw`)",
        $propdoc: {
            value: "[AST_Node?] the value returned or thrown by this statement; could be null for AST_Return"
        },
        _equals: function(e) {
            return f(this.value, e.value);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "Exit") throw new Error("should not instantiate AST_Exit");
        }
    }, Wt);
    var wn = e("Return", null, {
        $documentation: "A `return` statement",
        _validate: function() {
            if (this.value != null) c(this, "value");
        }
    }, Gt);
    var Jt = e("Throw", null, {
        $documentation: "A `throw` statement",
        _validate: function() {
            c(this, "value");
        }
    }, Gt);
    var Xt = e("LoopControl", "label", {
        $documentation: "Base class for loop control statements (`break` and `continue`)",
        $propdoc: {
            label: "[AST_LabelRef?] the label, or null if none"
        },
        _equals: function(e) {
            return f(this.label, e.label);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.label) n.label.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "LoopControl") throw new Error("should not instantiate AST_LoopControl");
            if (this.label != null) {
                if (!(this.label instanceof Te)) throw new Error("label must be AST_LabelRef");
            }
        }
    }, Wt);
    var Kt = e("Break", null, {
        $documentation: "A `break` statement"
    }, Xt);
    var Qt = e("Continue", null, {
        $documentation: "A `continue` statement"
    }, Xt);
    var xn = e("If", "condition alternative", {
        $documentation: "A `if` statement",
        $propdoc: {
            condition: "[AST_Node] the `if` condition",
            alternative: "[AST_Statement?] the `else` part, or null if not present"
        },
        _equals: function(e) {
            return this.body.equals(e.body) && this.condition.equals(e.condition) && f(this.alternative, e.alternative);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
                if (n.alternative) n.alternative.walk(e);
            });
        },
        _validate: function() {
            c(this, "condition");
            if (this.alternative != null) {
                if (!at(this.alternative)) throw new Error("alternative must be AST_Statement");
            }
        }
    }, N);
    var Zt = e("Switch", "expression", {
        $documentation: "A `switch` statement",
        $propdoc: {
            expression: "[AST_Node] the `switch` “discriminant”"
        },
        _equals: function(e) {
            return this.expression.equals(e.expression) && o(this.body, e.body);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                st(n, e);
            });
        },
        _validate: function() {
            c(this, "expression");
            this.body.forEach(function(e) {
                if (!(e instanceof er)) throw new Error("body must be AST_SwitchBranch[]");
            });
        }
    }, ft);
    var er = e("SwitchBranch", null, {
        $documentation: "Base class for `switch` branches",
        _validate: function() {
            if (this.TYPE == "SwitchBranch") throw new Error("should not instantiate AST_SwitchBranch");
        }
    }, ft);
    var nr = e("Default", null, {
        $documentation: "A `default` switch branch"
    }, er);
    var tr = e("Case", "expression", {
        $documentation: "A `case` switch branch",
        $propdoc: {
            expression: "[AST_Node] the `case` expression"
        },
        _equals: function(e) {
            return this.expression.equals(e.expression) && o(this.body, e.body);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                st(n, e);
            });
        },
        _validate: function() {
            c(this, "expression");
        }
    }, er);
    var rr = e("Try", "bcatch bfinally", {
        $documentation: "A `try` statement",
        $propdoc: {
            bcatch: "[AST_Catch?] the catch block, or null if not present",
            bfinally: "[AST_Finally?] the finally block, or null if not present"
        },
        _equals: function(e) {
            return o(this.body, e.body) && f(this.bcatch, e.bcatch) && f(this.bfinally, e.bfinally);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                st(n, e);
                if (n.bcatch) n.bcatch.walk(e);
                if (n.bfinally) n.bfinally.walk(e);
            });
        },
        _validate: function() {
            if (this.bcatch != null) {
                if (!(this.bcatch instanceof ir)) throw new Error("bcatch must be AST_Catch");
            }
            if (this.bfinally != null) {
                if (!(this.bfinally instanceof ar)) throw new Error("bfinally must be AST_Finally");
            }
        }
    }, ft);
    var ir = e("Catch", "argname", {
        $documentation: "A `catch` node; only makes sense as part of a `try` statement",
        $propdoc: {
            argname: "[(AST_Destructured|AST_SymbolCatch)?] symbol for the exception, or null if not present"
        },
        _equals: function(e) {
            return f(this.argname, e.argname) && o(this.body, e.body);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.argname) n.argname.walk(e);
                st(n, e);
            });
        },
        _validate: function() {
            if (this.argname != null) p(this.argname, function(e) {
                if (!(e instanceof Pr)) throw new Error("argname must be AST_SymbolCatch");
            });
        }
    }, ft);
    var ar = e("Finally", null, {
        $documentation: "A `finally` node; only makes sense as part of a `try` statement"
    }, ft);
    var or = e("Definitions", "definitions", {
        $documentation: "Base class for `var` nodes (variable declarations/initializations)",
        $propdoc: {
            definitions: "[AST_VarDef*] array of variable definitions"
        },
        _equals: function(e) {
            return o(this.definitions, e.definitions);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.definitions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.TYPE == "Definitions") throw new Error("should not instantiate AST_Definitions");
            if (this.definitions.length < 1) throw new Error("must have at least one definition");
        }
    }, tt);
    var sr = e("Const", null, {
        $documentation: "A `const` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof kn)) throw new Error("definitions must be AST_VarDef[]");
                p(e.name, function(e) {
                    if (!(e instanceof qr)) throw new Error("name must be AST_SymbolConst");
                });
            });
        }
    }, or);
    var fr = e("Let", null, {
        $documentation: "A `let` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof kn)) throw new Error("definitions must be AST_VarDef[]");
                p(e.name, function(e) {
                    if (!(e instanceof $r)) throw new Error("name must be AST_SymbolLet");
                });
            });
        }
    }, or);
    var ur = e("Var", null, {
        $documentation: "A `var` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof kn)) throw new Error("definitions must be AST_VarDef[]");
                p(e.name, function(e) {
                    if (!(e instanceof zr)) throw new Error("name must be AST_SymbolVar");
                });
            });
        }
    }, or);
    var kn = e("VarDef", "name value", {
        $documentation: "A variable declaration; only appears in a AST_Definitions node",
        $propdoc: {
            name: "[AST_Destructured|AST_SymbolVar] name of the variable",
            value: "[AST_Node?] initializer, or null of there's no initializer"
        },
        _equals: function(e) {
            return this.name.equals(e.name) && f(this.value, e.value);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.name.walk(e);
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.value != null) c(this, "value");
        }
    });
    var cr = e("ExportDeclaration", "body", {
        $documentation: "An `export` statement",
        $propdoc: {
            body: "[AST_DefClass|AST_Definitions|AST_LambdaDefinition] the statement to export"
        },
        _equals: function(e) {
            return this.body.equals(e.body);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (!(this.body instanceof It || this.body instanceof or || this.body instanceof Ct)) {
                throw new Error("body must be AST_DefClass, AST_Definitions or AST_LambdaDefinition");
            }
        }
    }, tt);
    var lr = e("ExportDefault", "body", {
        $documentation: "An `export default` statement",
        $propdoc: {
            body: "[AST_Node] the default export"
        },
        _equals: function(e) {
            return this.body.equals(e.body);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (!(this.body instanceof It || this.body instanceof Ct)) {
                c(this, "body");
            }
        }
    }, tt);
    var ke = e("ExportForeign", "aliases keys path", {
        $documentation: "An `export ... from '...'` statement",
        $propdoc: {
            aliases: "[AST_String*] array of aliases to export",
            keys: "[AST_String*] array of keys to import",
            path: "[AST_String] the path to import module"
        },
        _equals: function(e) {
            return this.path.equals(e.path) && o(this.aliases, e.aliases) && o(this.keys, e.keys);
        },
        _validate: function() {
            if (this.aliases.length != this.keys.length) {
                throw new Error("aliases:key length mismatch: " + this.aliases.length + " != " + this.keys.length);
            }
            this.aliases.forEach(function(e) {
                if (!(e instanceof Rn)) throw new Error("aliases must contain AST_String");
            });
            this.keys.forEach(function(e) {
                if (!(e instanceof Rn)) throw new Error("keys must contain AST_String");
            });
            if (!(this.path instanceof Rn)) throw new Error("path must be AST_String");
        }
    }, tt);
    var pr = e("ExportReferences", "properties", {
        $documentation: "An `export { ... }` statement",
        $propdoc: {
            properties: "[AST_SymbolExport*] array of aliases to export"
        },
        _equals: function(e) {
            return o(this.properties, e.properties);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof jr)) throw new Error("properties must contain AST_SymbolExport");
            });
        }
    }, tt);
    var dr = e("Import", "all default path properties", {
        $documentation: "An `import` statement",
        $propdoc: {
            all: "[AST_SymbolImport?] the imported namespace, or null if not specified",
            default: "[AST_SymbolImport?] the alias for default `export`, or null if not specified",
            path: "[AST_String] the path to import module",
            properties: "[(AST_SymbolImport*)?] array of aliases, or null if not specified"
        },
        _equals: function(e) {
            return this.path.equals(e.path) && f(this.all, e.all) && f(this.default, e.default) && !this.properties == !e.properties && (!this.properties || o(this.properties, e.properties));
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.all) e.all.walk(n);
                if (e.default) e.default.walk(n);
                if (e.properties) e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.all != null) {
                if (!(this.all instanceof Or)) throw new Error("all must be AST_SymbolImport");
                if (this.properties != null) throw new Error("cannot import both * and {} in the same statement");
            }
            if (this.default != null) {
                if (!(this.default instanceof Or)) throw new Error("default must be AST_SymbolImport");
                if (this.default.key.value !== "") throw new Error("invalid default key: " + this.default.key.value);
            }
            if (!(this.path instanceof Rn)) throw new Error("path must be AST_String");
            if (this.properties != null) this.properties.forEach(function(e) {
                if (!(e instanceof Or)) throw new Error("properties must contain AST_SymbolImport");
            });
        }
    }, tt);
    var En = e("DefaultValue", "name value", {
        $documentation: "A default value declaration",
        $propdoc: {
            name: "[AST_Destructured|AST_SymbolDeclaration] name of the variable",
            value: "[AST_Node] value to assign if variable is `undefined`"
        },
        _equals: function(e) {
            return this.name.equals(e.name) && this.value.equals(e.value);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.name.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            c(this, "value");
        }
    });
    function l(e, n, t, r) {
        e[n].forEach(function(e) {
            u(e, n, true, t, r);
        });
    }
    var Sn = e("Call", "args expression optional pure terminal", {
        $documentation: "A function call expression",
        $propdoc: {
            args: "[AST_Node*] array of arguments",
            expression: "[AST_Node] expression to invoke as function",
            optional: "[boolean] whether the expression is optional chaining",
            pure: "[boolean/S] marker for side-effect-free call expression",
            terminal: "[boolean] whether the chain has ended"
        },
        _equals: function(e) {
            return !this.optional == !e.optional && this.expression.equals(e.expression) && o(this.args, e.args);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expression.walk(n);
                e.args.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            c(this, "expression");
            l(this, "args", true);
        }
    });
    var hr = e("New", null, {
        $documentation: "An object instantiation.  Derives from a function call since it has exactly the same properties",
        _validate: function() {
            if (this.optional) throw new Error("optional must be false");
            if (this.terminal) throw new Error("terminal must be false");
        }
    }, Sn);
    var Tn = e("Sequence", "expressions", {
        $documentation: "A sequence expression (comma-separated expressions)",
        $propdoc: {
            expressions: "[AST_Node*] array of expressions (at least two)"
        },
        _equals: function(e) {
            return o(this.expressions, e.expressions);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expressions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.expressions.length < 2) throw new Error("expressions must contain multiple elements");
            l(this, "expressions");
        }
    });
    function vr(e) {
        while (e instanceof An) e = e.expression;
        return e;
    }
    var An = e("PropAccess", "expression optional property terminal", {
        $documentation: 'Base class for property access expressions, i.e. `a.foo` or `a["foo"]`',
        $propdoc: {
            expression: "[AST_Node] the “container” expression",
            optional: "[boolean] whether the expression is optional chaining",
            property: "[AST_Node|string] the property to access.  For AST_Dot this is always a plain string, while for AST_Sub it's an arbitrary AST_Node",
            terminal: "[boolean] whether the chain has ended"
        },
        _equals: function(e) {
            return !this.optional == !e.optional && f(this.property, e.property) && this.expression.equals(e.expression);
        },
        get_property: function() {
            var e = this.property;
            if (e instanceof Yn) return e.value;
            if (e instanceof zn && e.operator == "void" && e.expression instanceof Yn) return;
            return e;
        },
        _validate: function() {
            if (this.TYPE == "PropAccess") throw new Error("should not instantiate AST_PropAccess");
            c(this, "expression");
        }
    });
    var Dn = e("Dot", null, {
        $documentation: "A dotted property access expression",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.property != "string") throw new Error("property must be string");
        }
    }, An);
    var qn = e("Sub", null, {
        $documentation: 'Index-style property access, i.e. `a["foo"]`',
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.property.walk(e);
            });
        },
        _validate: function() {
            c(this, "property");
        }
    }, An);
    var On = e("Spread", "expression", {
        $documentation: "Spread expression in array/object literals or function calls",
        $propdoc: {
            expression: "[AST_Node] expression to be expanded"
        },
        _equals: function(e) {
            return this.expression.equals(e.expression);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            c(this, "expression");
        }
    });
    var $n = e("Unary", "operator expression", {
        $documentation: "Base class for unary expressions",
        $propdoc: {
            operator: "[string] the operator",
            expression: "[AST_Node] expression that this unary operator applies to"
        },
        _equals: function(e) {
            return this.operator == e.operator && this.expression.equals(e.expression);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "Unary") throw new Error("should not instantiate AST_Unary");
            if (typeof this.operator != "string") throw new Error("operator must be string");
            c(this, "expression");
        }
    });
    var zn = e("UnaryPrefix", null, {
        $documentation: "Unary prefix expression, i.e. `typeof i` or `++i`"
    }, $n);
    var mr = e("UnaryPostfix", null, {
        $documentation: "Unary postfix expression, i.e. `i++`"
    }, $n);
    var Cn = e("Binary", "operator left right", {
        $documentation: "Binary expression, i.e. `a + b`",
        $propdoc: {
            left: "[AST_Node] left-hand side expression",
            operator: "[string] the operator",
            right: "[AST_Node] right-hand side expression"
        },
        _equals: function(e) {
            return this.operator == e.operator && this.left.equals(e.left) && this.right.equals(e.right);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.left.walk(e);
                n.right.walk(e);
            });
        },
        _validate: function() {
            if (!(this instanceof Fn)) c(this, "left");
            if (typeof this.operator != "string") throw new Error("operator must be string");
            c(this, "right");
        }
    });
    var Mn = e("Conditional", "condition consequent alternative", {
        $documentation: "Conditional expression using the ternary operator, i.e. `a ? b : c`",
        $propdoc: {
            condition: "[AST_Node]",
            consequent: "[AST_Node]",
            alternative: "[AST_Node]"
        },
        _equals: function(e) {
            return this.condition.equals(e.condition) && this.consequent.equals(e.consequent) && this.alternative.equals(e.alternative);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.consequent.walk(e);
                n.alternative.walk(e);
            });
        },
        _validate: function() {
            c(this, "condition");
            c(this, "consequent");
            c(this, "alternative");
        }
    });
    var Fn = e("Assign", null, {
        $documentation: "An assignment expression — `a = b + 5`",
        _validate: function() {
            if (this.operator.indexOf("=") < 0) throw new Error('operator must contain "="');
            if (this.left instanceof jn) {
                if (this.operator != "=") throw new Error("invalid destructuring operator: " + this.operator);
                p(this.left, function(e) {
                    if (!(e instanceof An || e instanceof Hn)) {
                        throw new Error("left must be assignable: " + e.TYPE);
                    }
                });
            } else if (!(this.left instanceof Jr || this.left instanceof Vr || this.left instanceof An && !this.left.optional || this.left instanceof Hn || this.left instanceof Wr)) {
                throw new Error("left must be assignable");
            }
        }
    }, Cn);
    var _r = e("Await", "expression", {
        $documentation: "An await expression",
        $propdoc: {
            expression: "[AST_Node] expression with Promise to resolve on"
        },
        _equals: function(e) {
            return this.expression.equals(e.expression);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            c(this, "expression");
        }
    });
    var gr = e("Yield", "expression nested", {
        $documentation: "A yield expression",
        $propdoc: {
            expression: "[AST_Node?] return value for iterator, or null if undefined",
            nested: "[boolean] whether to iterate over expression as generator"
        },
        _equals: function(e) {
            return !this.nested == !e.nested && f(this.expression, e.expression);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.expression) n.expression.walk(e);
            });
        },
        _validate: function() {
            if (this.expression != null) {
                c(this, "expression");
            } else if (this.nested) {
                throw new Error("yield* must contain expression");
            }
        }
    });
    var Pn = e("Array", "elements", {
        $documentation: "An array literal",
        $propdoc: {
            elements: "[AST_Node*] array of elements"
        },
        _equals: function(e) {
            return o(this.elements, e.elements);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            l(this, "elements", true, true);
        }
    });
    var jn = e("Destructured", "rest", {
        $documentation: "Base class for destructured literal",
        $propdoc: {
            rest: "[(AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef)?] rest parameter, or null if absent"
        },
        _validate: function() {
            if (this.TYPE == "Destructured") throw new Error("should not instantiate AST_Destructured");
        }
    });
    function p(e, n, t) {
        if (e instanceof En && t) return p(e.name, n);
        if (e instanceof jn) {
            if (e.rest != null) p(e.rest, n);
            if (e instanceof br) return e.elements.forEach(function(e) {
                if (!(e instanceof Gr)) p(e, n, true);
            });
            if (e instanceof wr) return e.properties.forEach(function(e) {
                p(e.value, n, true);
            });
        }
        n(e);
    }
    var br = e("DestructuredArray", "elements", {
        $documentation: "A destructured array literal",
        $propdoc: {
            elements: "[(AST_DefaultValue|AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef)*] array of elements"
        },
        _equals: function(e) {
            return f(this.rest, e.rest) && o(this.elements, e.elements);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
            });
        }
    }, jn);
    var yr = e("DestructuredKeyVal", "key value", {
        $documentation: "A key: value destructured property",
        $propdoc: {
            key: "[string|AST_Node] property name.  For computed property this is an AST_Node.",
            value: "[AST_DefaultValue|AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef] property value"
        },
        _equals: function(e) {
            return f(this.key, e.key) && this.value.equals(e.value);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof vn) n.key.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.key != "string") {
                if (!(this.key instanceof vn)) throw new Error("key must be string or AST_Node");
                c(this, "key");
            }
            if (!(this.value instanceof vn)) throw new Error("value must be AST_Node");
        }
    });
    var wr = e("DestructuredObject", "properties", {
        $documentation: "A destructured object literal",
        $propdoc: {
            properties: "[AST_DestructuredKeyVal*] array of properties"
        },
        _equals: function(e) {
            return f(this.rest, e.rest) && o(this.properties, e.properties);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof yr)) throw new Error("properties must be AST_DestructuredKeyVal[]");
            });
        }
    }, jn);
    var Nn = e("Object", "properties", {
        $documentation: "An object literal",
        $propdoc: {
            properties: "[(AST_ObjectProperty|AST_Spread)*] array of properties"
        },
        _equals: function(e) {
            return o(this.properties, e.properties);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof xr || e instanceof On)) {
                    throw new Error("properties must contain AST_ObjectProperty and/or AST_Spread only");
                }
            });
        }
    });
    var xr = e("ObjectProperty", "key value", {
        $documentation: "Base class for literal object properties",
        $propdoc: {
            key: "[string|AST_Node] property name.  For computed property this is an AST_Node.",
            value: "[AST_Node] property value.  For getters and setters this is an AST_Accessor."
        },
        _equals: function(e) {
            return f(this.key, e.key) && this.value.equals(e.value);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof vn) n.key.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "ObjectProperty") throw new Error("should not instantiate AST_ObjectProperty");
            if (typeof this.key != "string") {
                if (!(this.key instanceof vn)) throw new Error("key must be string or AST_Node");
                c(this, "key");
            }
            if (!(this.value instanceof vn)) throw new Error("value must be AST_Node");
        }
    });
    var kr = e("ObjectKeyVal", null, {
        $documentation: "A key: value object property",
        _validate: function() {
            c(this, "value");
        }
    }, xr);
    var Er = e("ObjectMethod", null, {
        $documentation: "A key(){} object property",
        _validate: function() {
            if (!(this.value instanceof xt)) throw new Error("value must be AST_LambdaExpression");
            if (kt(this.value)) throw new Error("value cannot be AST_Arrow or AST_AsyncArrow");
            if (this.value.name != null) throw new Error("name of object method's lambda must be null");
        }
    }, kr);
    var Sr = e("ObjectSetter", null, {
        $documentation: "An object setter property",
        _validate: function() {
            if (!(this.value instanceof wt)) throw new Error("value must be AST_Accessor");
        }
    }, xr);
    var Tr = e("ObjectGetter", null, {
        $documentation: "An object getter property",
        _validate: function() {
            if (!(this.value instanceof wt)) throw new Error("value must be AST_Accessor");
        }
    }, xr);
    var Ar = e("Symbol", "scope name thedef", {
        $documentation: "Base class for all symbols",
        $propdoc: {
            name: "[string] name of this symbol",
            scope: "[AST_Scope/S] the current scope (not necessarily the definition scope)",
            thedef: "[SymbolDef/S] the definition of this symbol"
        },
        _equals: function(e) {
            return this.thedef ? this.thedef === e.thedef : this.name == e.name;
        },
        _validate: function() {
            if (this.TYPE == "Symbol") throw new Error("should not instantiate AST_Symbol");
            if (typeof this.name != "string") throw new Error("name must be string");
        }
    });
    var Dr = e("SymbolDeclaration", "init", {
        $documentation: "A declaration symbol (symbol in var, function name or argument, symbol in catch)"
    }, Ar);
    var qr = e("SymbolConst", null, {
        $documentation: "Symbol defining a constant"
    }, Dr);
    var Or = e("SymbolImport", "key", {
        $documentation: "Symbol defined by an `import` statement",
        $propdoc: {
            key: "[AST_String] the original `export` name"
        },
        _equals: function(e) {
            return this.name == e.name && this.key.equals(e.key);
        },
        _validate: function() {
            if (!(this.key instanceof Rn)) throw new Error("key must be AST_String");
        }
    }, qr);
    var $r = e("SymbolLet", null, {
        $documentation: "Symbol defining a lexical-scoped variable"
    }, Dr);
    var zr = e("SymbolVar", null, {
        $documentation: "Symbol defining a variable"
    }, Dr);
    var In = e("SymbolFunarg", "unused", {
        $documentation: "Symbol naming a function argument"
    }, zr);
    var Cr = e("SymbolDefun", null, {
        $documentation: "Symbol defining a function"
    }, Dr);
    var Mr = e("SymbolLambda", null, {
        $documentation: "Symbol naming a function expression"
    }, Dr);
    var Ee = e("SymbolDefClass", null, {
        $documentation: "Symbol defining a class"
    }, qr);
    var Fr = e("SymbolClass", null, {
        $documentation: "Symbol naming a class expression"
    }, qr);
    var Pr = e("SymbolCatch", null, {
        $documentation: "Symbol naming the exception in catch"
    }, Dr);
    var Se = e("Label", "references", {
        $documentation: "Symbol naming a label (declaration)",
        $propdoc: {
            references: "[AST_LoopControl*] a list of nodes referring to this label"
        },
        initialize: function() {
            this.references = [];
            this.thedef = this;
        }
    }, Ar);
    var Hn = e("SymbolRef", "fixed in_arg redef", {
        $documentation: "Reference to some symbol (not definition/declaration)"
    }, Ar);
    var jr = e("SymbolExport", "alias", {
        $documentation: "Reference in an `export` statement",
        $propdoc: {
            alias: "[AST_String] the `export` alias"
        },
        _equals: function(e) {
            return this.name == e.name && this.alias.equals(e.alias);
        },
        _validate: function() {
            if (!(this.alias instanceof Rn)) throw new Error("alias must be AST_String");
        }
    }, Hn);
    var Te = e("LabelRef", null, {
        $documentation: "Reference to a label symbol"
    }, Ar);
    var Nr = e("ObjectIdentity", null, {
        $documentation: "Base class for `super` & `this`",
        _equals: ln,
        _validate: function() {
            if (this.TYPE == "ObjectIdentity") throw new Error("should not instantiate AST_ObjectIdentity");
        }
    }, Ar);
    var Ir = e("Super", null, {
        $documentation: "The `super` symbol",
        _validate: function() {
            if (this.name !== "super") throw new Error('name must be "super"');
        }
    }, Nr);
    var Hr = e("This", null, {
        $documentation: "The `this` symbol",
        _validate: function() {
            if (this.TYPE == "This" && this.name !== "this") throw new Error('name must be "this"');
        }
    }, Nr);
    var Yr = e("NewTarget", null, {
        $documentation: "The `new.target` symbol",
        initialize: function() {
            this.name = "new.target";
        },
        _validate: function() {
            if (this.name !== "new.target") throw new Error('name must be "new.target": ' + this.name);
        }
    }, Hr);
    var Rr = e("Template", "expressions strings tag", {
        $documentation: "A template literal, i.e. tag`str1${expr1}...strN${exprN}strN+1`",
        $propdoc: {
            expressions: "[AST_Node*] the placeholder expressions",
            strings: "[string*] the raw text segments",
            tag: "[AST_Node?] tag function, or null if absent"
        },
        _equals: function(e) {
            return f(this.tag, e.tag) && s(this.strings, e.strings) && o(this.expressions, e.expressions);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.tag) e.tag.walk(n);
                e.expressions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.expressions.length + 1 != this.strings.length) {
                throw new Error("malformed template with " + this.expressions.length + " placeholder(s) but " + this.strings.length + " text segment(s)");
            }
            l(this, "expressions");
            this.strings.forEach(function(e) {
                if (typeof e != "string") throw new Error("strings must contain string");
            });
            if (this.tag != null) c(this, "tag");
        }
    });
    var Yn = e("Constant", null, {
        $documentation: "Base class for all constants",
        _equals: function(e) {
            return this.value === e.value;
        },
        _validate: function() {
            if (this.TYPE == "Constant") throw new Error("should not instantiate AST_Constant");
        }
    });
    var Rn = e("String", "quote value", {
        $documentation: "A string literal",
        $propdoc: {
            quote: "[string?] the original quote character",
            value: "[string] the contents of this string"
        },
        _validate: function() {
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, Yn);
    var Bn = e("Number", "value", {
        $documentation: "A number literal",
        $propdoc: {
            value: "[number] the numeric value"
        },
        _validate: function() {
            if (typeof this.value != "number") throw new Error("value must be number");
            if (!isFinite(this.value)) throw new Error("value must be finite");
            if (this.value < 0) throw new Error("value cannot be negative");
        }
    }, Yn);
    var Br = e("BigInt", "value", {
        $documentation: "A BigInt literal",
        $propdoc: {
            value: "[string] the numeric representation"
        },
        _validate: function() {
            if (typeof this.value != "string") throw new Error("value must be string");
            if (this.value[0] == "-") throw new Error("value cannot be negative");
        }
    }, Yn);
    var Lr = e("RegExp", "value", {
        $documentation: "A regexp literal",
        $propdoc: {
            value: "[RegExp] the actual regexp"
        },
        _equals: function(e) {
            return "" + this.value == "" + e.value;
        },
        _validate: function() {
            if (!(this.value instanceof RegExp)) throw new Error("value must be RegExp");
        }
    }, Yn);
    var y = e("Atom", null, {
        $documentation: "Base class for atoms",
        _equals: ln,
        _validate: function() {
            if (this.TYPE == "Atom") throw new Error("should not instantiate AST_Atom");
        }
    }, Yn);
    var Ur = e("Null", null, {
        $documentation: "The `null` atom",
        value: null
    }, y);
    var Vr = e("NaN", null, {
        $documentation: "The impossible value",
        value: 0 / 0
    }, y);
    var Wr = e("Undefined", null, {
        $documentation: "The `undefined` value",
        value: function() {}()
    }, y);
    var Gr = e("Hole", null, {
        $documentation: "A hole in an array",
        value: function() {}()
    }, y);
    var Jr = e("Infinity", null, {
        $documentation: "The `Infinity` value",
        value: 1 / 0
    }, y);
    var Xr = e("Boolean", null, {
        $documentation: "Base class for booleans",
        _validate: function() {
            if (this.TYPE == "Boolean") throw new Error("should not instantiate AST_Boolean");
        }
    }, y);
    var Kr = e("False", null, {
        $documentation: "The `false` atom",
        value: false
    }, Xr);
    var Qr = e("True", null, {
        $documentation: "The `true` atom",
        value: true
    }, Xr);
    function Ln(e) {
        this.callback = e;
        this.directives = Object.create(null);
        this.stack = [];
    }
    Ln.prototype = {
        visit: function(e, n) {
            this.push(e);
            var t = this.callback(e, n || Wn);
            if (!t && n) n();
            this.pop();
        },
        parent: function(e) {
            return this.stack[this.stack.length - 2 - (e || 0)];
        },
        push: function(e) {
            var n;
            if (e instanceof Nt) {
                this.directives = Object.create(this.directives);
                n = "use strict";
            } else if (e instanceof it) {
                n = e.value;
            } else if (e instanceof yn) {
                this.directives = Object.create(this.directives);
            }
            if (n && !this.directives[n]) this.directives[n] = e;
            this.stack.push(e);
        },
        pop: function() {
            var e = this.stack.pop();
            if (e instanceof Nt || e instanceof yn) {
                this.directives = Object.getPrototypeOf(this.directives);
            }
        },
        self: function() {
            return this.stack[this.stack.length - 1];
        },
        find_parent: function(e) {
            var n = this.stack;
            for (var t = n.length - 1; --t >= 0; ) {
                var r = n[t];
                if (r instanceof e) return r;
            }
        },
        has_directive: function(e) {
            var n = this.directives[e];
            if (n) return n;
            var t = this.stack[this.stack.length - 1];
            if (t instanceof bn) {
                for (var r = 0; r < t.body.length; ++r) {
                    var i = t.body[r];
                    if (!(i instanceof it)) break;
                    if (i.value == e) return i;
                }
            }
        },
        loopcontrol_target: function(e) {
            var n = this.stack;
            if (e.label) for (var t = n.length; --t >= 0; ) {
                var r = n[t];
                if (r instanceof ut && r.label.name == e.label.name) return r.body;
            } else for (var t = n.length; --t >= 0; ) {
                var r = n[t];
                if (r instanceof ct || e instanceof Kt && r instanceof Zt) return r;
            }
        },
        in_boolean_context: function() {
            for (var e = true, n = 0, t, r = this.self(); t = this.parent(n++); r = t) {
                if (t instanceof Cn) switch (t.operator) {
                  case "&&":
                  case "||":
                    if (t.left === r) e = false;
                    continue;

                  default:
                    return false;
                }
                if (t instanceof Mn) {
                    if (t.condition === r) return true;
                    continue;
                }
                if (t instanceof lt) return t.condition === r;
                if (t instanceof ht) return t.condition === r;
                if (t instanceof xn) return t.condition === r;
                if (t instanceof wn) {
                    if (t.in_bool) return true;
                    while (t = this.parent(n++)) {
                        if (t instanceof yn) {
                            if (t.name) return false;
                            t = this.parent(n++);
                            if (t.TYPE != "Call") return false;
                            break;
                        }
                    }
                }
                if (t instanceof Tn) {
                    if (t.tail_node() === r) continue;
                    return e ? "d" : true;
                }
                if (t instanceof _n) return e ? "d" : true;
                if (t instanceof zn) return t.operator == "!";
                return false;
            }
        }
    };
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function Zr(e, n) {
        Ln.call(this);
        this.before = e;
        this.after = n;
    }
    Zr.prototype = new Ln();
    (function(e) {
        function t(e, n) {
            return Xn(e, function(e) {
                return e.transform(n, true);
            });
        }
        e(vn, Wn);
        e(ut, function(e, n) {
            e.label = e.label.transform(n);
            e.body = e.body.transform(n);
        });
        e(_n, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(ft, function(e, n) {
            e.body = t(e.body, n);
        });
        e(pt, function(e, n) {
            e.body = e.body.transform(n);
            e.condition = e.condition.transform(n);
        });
        e(dt, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
        });
        e(ht, function(e, n) {
            if (e.init) e.init = e.init.transform(n);
            if (e.condition) e.condition = e.condition.transform(n);
            if (e.step) e.step = e.step.transform(n);
            e.body = e.body.transform(n);
        });
        e(vt, function(e, n) {
            e.init = e.init.transform(n);
            e.object = e.object.transform(n);
            e.body = e.body.transform(n);
        });
        e(gt, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = e.body.transform(n);
        });
        e(Gt, function(e, n) {
            if (e.value) e.value = e.value.transform(n);
        });
        e(Xt, function(e, n) {
            if (e.label) e.label = e.label.transform(n);
        });
        e(xn, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
            if (e.alternative) e.alternative = e.alternative.transform(n);
        });
        e(Zt, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(tr, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(rr, function(e, n) {
            e.body = t(e.body, n);
            if (e.bcatch) e.bcatch = e.bcatch.transform(n);
            if (e.bfinally) e.bfinally = e.bfinally.transform(n);
        });
        e(ir, function(e, n) {
            if (e.argname) e.argname = e.argname.transform(n);
            e.body = t(e.body, n);
        });
        e(or, function(e, n) {
            e.definitions = t(e.definitions, n);
        });
        e(kn, function(e, n) {
            e.name = e.name.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e(En, function(e, n) {
            e.name = e.name.transform(n);
            e.value = e.value.transform(n);
        });
        e(yn, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            e.argnames = t(e.argnames, n);
            if (e.rest) e.rest = e.rest.transform(n);
            e.body = t(e.body, n);
        });
        function n(e, n) {
            e.argnames = t(e.argnames, n);
            if (e.rest) e.rest = e.rest.transform(n);
            if (e.value) {
                e.value = e.value.transform(n);
            } else {
                e.body = t(e.body, n);
            }
        }
        e(At, n);
        e(Dt, n);
        e(Nt, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            if (e.extends) e.extends = e.extends.transform(n);
            e.properties = t(e.properties, n);
        });
        e(Yt, function(e, n) {
            if (e.key instanceof vn) e.key = e.key.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e(Sn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.args = t(e.args, n);
        });
        e(Tn, function(e, n) {
            e.expressions = t(e.expressions, n);
        });
        e(_r, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(gr, function(e, n) {
            if (e.expression) e.expression = e.expression.transform(n);
        });
        e(Dn, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(qn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.property = e.property.transform(n);
        });
        e(On, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e($n, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Cn, function(e, n) {
            e.left = e.left.transform(n);
            e.right = e.right.transform(n);
        });
        e(Mn, function(e, n) {
            e.condition = e.condition.transform(n);
            e.consequent = e.consequent.transform(n);
            e.alternative = e.alternative.transform(n);
        });
        e(Pn, function(e, n) {
            e.elements = t(e.elements, n);
        });
        e(br, function(e, n) {
            e.elements = t(e.elements, n);
            if (e.rest) e.rest = e.rest.transform(n);
        });
        e(yr, function(e, n) {
            if (e.key instanceof vn) e.key = e.key.transform(n);
            e.value = e.value.transform(n);
        });
        e(wr, function(e, n) {
            e.properties = t(e.properties, n);
            if (e.rest) e.rest = e.rest.transform(n);
        });
        e(Nn, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(xr, function(e, n) {
            if (e.key instanceof vn) e.key = e.key.transform(n);
            e.value = e.value.transform(n);
        });
        e(cr, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(lr, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(pr, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(dr, function(e, n) {
            if (e.all) e.all = e.all.transform(n);
            if (e.default) e.default = e.default.transform(n);
            if (e.properties) e.properties = t(e.properties, n);
        });
        e(Rr, function(e, n) {
            if (e.tag) e.tag = e.tag.transform(n);
            e.expressions = t(e.expressions, n);
        });
    })(function(e, i) {
        e.DEFMETHOD("transform", function(e, n) {
            var t, r;
            e.push(this);
            if (e.before) t = e.before(this, i, n);
            if (typeof t === "undefined") {
                t = this;
                i(t, e);
                if (e.after) {
                    r = e.after(t, n);
                    if (typeof r !== "undefined") t = r;
                }
            }
            e.pop();
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>
    Parser based on parse-js (http://marijn.haverbeke.nl/parse-js/).

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var Ae = "break case catch class const continue debugger default delete do else extends finally for function if in instanceof new return switch throw try typeof var void while with";
    var C = "false null true";
    var I = [ "abstract async await boolean byte char double enum export final float goto implements import int interface let long native package private protected public short static super synchronized this throws transient volatile yield", C, Ae ].join(" ");
    var M = "return new delete throw else case";
    Ae = pn(Ae);
    I = pn(I);
    M = pn(M);
    C = pn(C);
    var d = /^0b([01]+)$/i;
    var h = /^0x([0-9a-f]+)$/i;
    var v = /^0o?([0-7]+)$/i;
    var F = pn([ "in", "instanceof", "typeof", "new", "void", "delete", "++", "--", "+", "-", "!", "~", "&", "|", "^", "*", "/", "%", "**", ">>", "<<", ">>>", "<", ">", "<=", ">=", "==", "===", "!=", "!==", "?", "=", "+=", "-=", "/=", "*=", "%=", "**=", ">>=", "<<=", ">>>=", "&=", "|=", "^=", "&&", "||", "??", "&&=", "||=", "??=" ]);
    var P = "\n\r\u2028\u2029";
    var j = "+-*&%=<>!?|~^";
    var m = "[{(";
    var _ = ",;:";
    var g = ")}]";
    var De = _ + g;
    var H = m + _;
    var Y = H + "`" + g;
    var R = P + "  \t\f\v​             　\ufeff";
    var B = pn(n("./'\"#" + j + Y + R));
    P = pn(n(P));
    j = pn(n(j));
    De = pn(n(De));
    H = pn(n(H));
    Y = pn(n(Y));
    R = pn(n(R));
    function re(e) {
        return e >= 55296 && e <= 56319;
    }
    function ie(e) {
        return e >= 56320 && e <= 57343;
    }
    function L(e) {
        return e >= 48 && e <= 57;
    }
    function ae(e) {
        return !B[e];
    }
    function ei(e) {
        return /^[a-z_$][a-z0-9_$]*$/i.test(e);
    }
    function ni(e) {
        switch (e[0]) {
          case "b":
            return "\b";

          case "f":
            return "\f";

          case "n":
            return "\n";

          case "r":
            return "\r";

          case "t":
            return "\t";

          case "u":
            var n;
            if (e[1] == "{" && e.slice(-1) == "}") {
                n = e.slice(2, -1);
            } else if (e.length == 5) {
                n = e.slice(1);
            } else {
                return;
            }
            var t = parseInt(n, 16);
            if (t < 0 || isNaN(t)) return;
            if (t < 65536) return String.fromCharCode(t);
            if (t > 1114111) return;
            return String.fromCharCode((t >> 10) + 55232) + String.fromCharCode((t & 1023) + 56320);

          case "v":
            return "\v";

          case "x":
            if (e.length != 3) return;
            var t = parseInt(e.slice(1), 16);
            if (t < 0 || isNaN(t)) return;
            return String.fromCharCode(t);

          case "\r":
          case "\n":
            return "";

          default:
            if (e == "0") return "\0";
            if (e[0] >= "0" && e[0] <= "9") return;
            return e;
        }
    }
    function U(e) {
        var n;
        if (n = d.exec(e)) return parseInt(n[1], 2);
        if (n = h.exec(e)) return parseInt(n[1], 16);
        if (n = v.exec(e)) return parseInt(n[1], 8);
        var t = parseFloat(e);
        if (t == e) return t;
    }
    function ti(e, n, t, r, i) {
        this.message = e;
        this.filename = n;
        this.line = t;
        this.col = r;
        this.pos = i;
    }
    ti.prototype = Object.create(Error.prototype);
    ti.prototype.constructor = ti;
    ti.prototype.name = "SyntaxError";
    t(ti);
    function qe(e, n, t, r, i) {
        throw new ti(e, n, t, r, i);
    }
    function Oe(e, n, t) {
        return e.type == n && (t == null || e.value == t);
    }
    var V = {};
    function $e(i, a, o, s) {
        var f = {
            text: i,
            filename: a,
            pos: 0,
            tokpos: 0,
            line: 1,
            tokline: 0,
            col: 0,
            tokcol: 0,
            newline_before: false,
            regex_allowed: false,
            comments_before: [],
            directives: Object.create(null),
            read_template: n("Unterminated template literal", function(e) {
                var n = "";
                for (;;) {
                    var t = r();
                    switch (t) {
                      case "\\":
                        t += r();
                        break;

                      case "`":
                        e.push(n);
                        return;

                      case "$":
                        if (c() == "{") {
                            l();
                            e.push(n);
                            f.regex_allowed = true;
                            return true;
                        }
                    }
                    n += t;
                }
                function r() {
                    var e = l(true, true);
                    return e == "\r" ? "\n" : e;
                }
            })
        };
        var u = false;
        function c() {
            return f.text.charAt(f.pos);
        }
        function l(e, n) {
            var t = f.text.charAt(f.pos++);
            if (e && !t) throw V;
            if (P[t]) {
                f.col = 0;
                f.line++;
                if (!n) f.newline_before = true;
                if (t == "\r" && c() == "\n") {
                    f.pos++;
                    t = "\n";
                }
            } else {
                f.col++;
            }
            return t;
        }
        function p(e) {
            while (e-- > 0) l();
        }
        function d(e) {
            return f.text.substr(f.pos, e.length) == e;
        }
        function h() {
            var e = f.text;
            for (var n = f.pos; n < f.text.length; ++n) {
                if (P[e[n]]) return n;
            }
            return -1;
        }
        function r(e, n) {
            var t = f.text.indexOf(e, f.pos);
            if (n && t == -1) throw V;
            return t;
        }
        function v() {
            f.tokline = f.line;
            f.tokcol = f.col;
            f.tokpos = f.pos;
        }
        function m(e, n, t) {
            f.regex_allowed = e == "operator" && !ri[n] || e == "keyword" && M[n] || e == "punc" && H[n];
            if (e == "punc" && n == ".") u = true; else if (!t) u = false;
            var r = {
                type: e,
                value: n,
                line: f.tokline,
                col: f.tokcol,
                pos: f.tokpos,
                endline: f.line,
                endcol: f.col,
                endpos: f.pos,
                nlb: f.newline_before,
                file: a
            };
            if (/^(?:num|string|regexp)$/i.test(e)) {
                r.raw = i.substring(r.pos, r.endpos);
            }
            if (!t) {
                r.comments_before = f.comments_before;
                r.comments_after = f.comments_before = [];
            }
            f.newline_before = false;
            return new te(r);
        }
        function _() {
            while (R[c()]) l();
        }
        function g(e) {
            var n = "", t;
            while ((t = c()) && e(t, n)) n += l();
            return n;
        }
        function b(e) {
            qe(e, a, f.tokline, f.tokcol, f.tokpos);
        }
        function y(e) {
            return /^0[0-7_]+$/.test(e);
        }
        function w(e) {
            var t = false, r = false, i = false, a = e == ".";
            var n = g(function(e, n) {
                switch (e) {
                  case "x":
                  case "X":
                    return i ? false : i = true;

                  case "e":
                  case "E":
                    return i ? true : t ? false : t = r = true;

                  case "+":
                  case "-":
                    return r;

                  case r = false, ".":
                    return a || t || i || y(n) ? false : a = true;
                }
                return /[_0-9a-dfo]/i.test(e);
            });
            if (e) n = e + n;
            if (y(n)) {
                if (z.has_directive("use strict")) b("Legacy octal literals are not allowed in strict mode");
            } else {
                n = n.replace(i ? /([1-9a-f]|.0)_(?=[0-9a-f])/gi : /([1-9]|.0)_(?=[0-9])/gi, "$1");
            }
            var o = U(n);
            if (isNaN(o)) b("Invalid syntax: " + n);
            if (a || t || c() != "n") return m("num", o);
            return m("bigint", n.toLowerCase() + l());
        }
        function x(e) {
            var n = l(true, e);
            if (n >= "0" && n <= "7") return k(n);
            if (n == "u") {
                var t = l(true, e);
                n += t;
                if (t != "{") {
                    n += l(true, e) + l(true, e) + l(true, e);
                } else do {
                    t = l(true, e);
                    n += t;
                } while (t != "}");
            } else if (n == "x") {
                n += l(true, e) + l(true, e);
            }
            var r = ni(n);
            if (typeof r != "string") b("Invalid escape sequence: \\" + n);
            return r;
        }
        function k(e) {
            var n = c();
            if (n >= "0" && n <= "7") {
                e += l(true);
                if (e[0] <= "3" && (n = c()) >= "0" && n <= "7") e += l(true);
            }
            if (e === "0") return "\0";
            if (e.length > 0 && z.has_directive("use strict")) b("Legacy octal escape sequences are not allowed in strict mode");
            return String.fromCharCode(parseInt(e, 8));
        }
        var E = n("Unterminated string constant", function(e) {
            var n = l(), t = "";
            for (;;) {
                var r = l(true, true);
                if (r == "\\") r = x(true); else if (P[r]) b("Unterminated string constant"); else if (r == n) break;
                t += r;
            }
            var i = m("string", t);
            i.quote = e;
            return i;
        });
        function S(e) {
            var n = f.regex_allowed;
            var t = h(), r;
            if (t == -1) {
                r = f.text.substr(f.pos);
                f.pos = f.text.length;
            } else {
                r = f.text.substring(f.pos, t);
                f.pos = t;
            }
            f.col = f.tokcol + (f.pos - f.tokpos);
            f.comments_before.push(m(e, r, true));
            f.regex_allowed = n;
            return z;
        }
        var e = n("Unterminated multiline comment", function() {
            var e = f.regex_allowed;
            var n = r("*/", true);
            var t = f.text.substring(f.pos, n).replace(/\r\n|\r|\u2028|\u2029/g, "\n");
            p(t.length + 2);
            f.comments_before.push(m("comment2", t, true));
            f.regex_allowed = e;
            return z;
        });
        function T() {
            var e = false, n, t = false, r = c() == "#" ? l() : "";
            while (n = c()) {
                if (!e) {
                    if (n == "\\") t = e = true, l(); else if (ae(n)) r += l(); else break;
                } else {
                    if (n != "u") b("Expecting UnicodeEscapeSequence -- uXXXX");
                    n = x();
                    if (!ae(n)) b("Unicode char: " + n.charCodeAt(0) + " is not valid in identifier");
                    r += n;
                    e = false;
                }
            }
            if (Ae[r] && t) {
                var i = r.charCodeAt(0).toString(16).toUpperCase();
                r = "\\u" + "0000".substr(i.length) + i + r.slice(1);
            }
            return r;
        }
        var A = n("Unterminated regular expression", function(e) {
            var n = false, t, r = false;
            while (t = l(true)) if (P[t]) {
                b("Unexpected line terminator");
            } else if (n) {
                e += "\\" + t;
                n = false;
            } else if (t == "[") {
                r = true;
                e += t;
            } else if (t == "]" && r) {
                r = false;
                e += t;
            } else if (t == "/" && !r) {
                break;
            } else if (t == "\\") {
                n = true;
            } else {
                e += t;
            }
            var i = T();
            try {
                var a = new RegExp(e, i);
                a.raw_source = e;
                return m("regexp", a);
            } catch (e) {
                b(e.message);
            }
        });
        function D(e) {
            function t(e) {
                if (!c()) return e;
                var n = e + c();
                if (F[n]) {
                    l();
                    return t(n);
                } else {
                    return e;
                }
            }
            return m("operator", t(e || l()));
        }
        function q() {
            l();
            switch (c()) {
              case "/":
                l();
                return S("comment1");

              case "*":
                l();
                return e();
            }
            return f.regex_allowed ? A("") : D("/");
        }
        function O() {
            l();
            if (d("..")) return m("operator", "." + l() + l());
            return L(c().charCodeAt(0)) ? w(".") : m("punc", ".");
        }
        function $() {
            var e = T();
            if (u) return m("name", e);
            return C[e] ? m("atom", e) : !Ae[e] ? m("name", e) : F[e] ? m("operator", e) : m("keyword", e);
        }
        function n(n, t) {
            return function(e) {
                try {
                    return t(e);
                } catch (e) {
                    if (e === V) b(n); else throw e;
                }
            };
        }
        function z(e) {
            if (e != null) return A(e);
            if (s && f.pos == 0 && d("#!")) {
                v();
                p(2);
                S("comment5");
            }
            for (;;) {
                _();
                v();
                if (o) {
                    if (d("\x3c!--")) {
                        p(4);
                        S("comment3");
                        continue;
                    }
                    if (d("--\x3e") && f.newline_before) {
                        p(3);
                        S("comment4");
                        continue;
                    }
                }
                var n = c();
                if (!n) return m("eof");
                var t = n.charCodeAt(0);
                switch (t) {
                  case 34:
                  case 39:
                    return E(n);

                  case 46:
                    return O();

                  case 47:
                    var r = q();
                    if (r === z) continue;
                    return r;
                }
                if (L(t)) return w();
                if (Y[n]) return m("punc", l());
                if (d("=>")) return m("punc", l() + l());
                if (j[n]) return D();
                if (t == 35 || t == 92 || !B[n]) return $();
                break;
            }
            b("Unexpected character '" + n + "'");
        }
        z.context = function(e) {
            if (e) f = e;
            return f;
        };
        z.add_directive = function(e) {
            f.directives[e] = true;
        };
        z.push_directives_stack = function() {
            f.directives = Object.create(f.directives);
        };
        z.pop_directives_stack = function() {
            f.directives = Object.getPrototypeOf(f.directives);
        };
        z.has_directive = function(e) {
            return !!f.directives[e];
        };
        return z;
    }
    var ze = pn("typeof void delete -- ++ ! ~ - +");
    var ri = pn("-- ++");
    var Ce = pn("= += -= /= *= %= **= >>= <<= >>>= &= |= ^= &&= ||= ??=");
    var ii = function(e, n) {
        for (var t = 0; t < e.length; ) {
            var r = e[t++];
            for (var i = 0; i < r.length; i++) {
                n[r[i]] = t;
            }
        }
        return n;
    }([ [ "??" ], [ "||" ], [ "&&" ], [ "|" ], [ "^" ], [ "&" ], [ "==", "===", "!=", "!==" ], [ "<", ">", "<=", ">=", "in", "instanceof" ], [ ">>", "<<", ">>>" ], [ "+", "-" ], [ "*", "/", "%" ], [ "**" ] ], {});
    var Me = pn("atom bigint num regexp string");
    function ai(t, l) {
        l = we(l, {
            bare_returns: false,
            expression: false,
            filename: null,
            html5_comments: true,
            module: false,
            shebang: true,
            strict: false,
            toplevel: null
        }, true);
        var _ = {
            input: typeof t == "string" ? $e(t, l.filename, l.html5_comments, l.shebang) : t,
            in_async: false,
            in_directives: true,
            in_funarg: -1,
            in_function: 0,
            in_generator: false,
            in_loop: 0,
            labels: [],
            peeked: null,
            prev: null,
            token: null
        };
        _.token = b();
        function g(e, n) {
            return Oe(_.token, e, n);
        }
        function p() {
            return _.peeked || (_.peeked = _.input());
        }
        function b() {
            _.prev = _.token;
            if (_.peeked) {
                _.token = _.peeked;
                _.peeked = null;
            } else {
                _.token = _.input();
            }
            _.in_directives = _.in_directives && (_.token.type == "string" || g("punc", ";"));
            return _.token;
        }
        function y() {
            return _.prev;
        }
        function s(e, n, t, r) {
            var i = _.input.context();
            qe(e, i.filename, n != null ? n : i.tokline, t != null ? t : i.tokcol, r != null ? r : i.tokpos);
        }
        function o(e, n) {
            s(n, e.line, e.col);
        }
        function r(e, n) {
            return e + (n === undefined ? "" : " «" + n + "»");
        }
        function w(e) {
            if (e == null) e = _.token;
            o(e, "Unexpected token: " + r(e.type, e.value));
        }
        function f(e, n) {
            if (g(e, n)) return b();
            o(_.token, "Unexpected token: " + r(_.token.type, _.token.value) + ", expected: " + r(e, n));
        }
        function x(e) {
            return f("punc", e);
        }
        function u(e) {
            return e.nlb || !dn(e.comments_before, function(e) {
                return !e.nlb;
            });
        }
        function c() {
            return !l.strict && (g("eof") || g("punc", "}") || u(_.token));
        }
        function k(e) {
            if (g("punc", ";")) b(); else if (!e && !c()) x(";");
        }
        function d() {
            x("(");
            var e = N();
            x(")");
            return e;
        }
        function e(r) {
            return function() {
                var e = _.token;
                var n = r.apply(null, arguments);
                var t = y();
                n.start = e;
                n.end = t;
                return n;
            };
        }
        function E() {
            if (g("operator", "/") || g("operator", "/=")) {
                _.peeked = null;
                _.token = _.input(_.token.value.substr(1));
            }
        }
        var h = e(function(e) {
            E();
            switch (_.token.type) {
              case "string":
                var n = _.in_directives;
                var t = N();
                if (n) {
                    if (t instanceof Rn) {
                        var r = t.start.raw.slice(1, -1);
                        _.input.add_directive(r);
                        t.value = r;
                    } else {
                        _.in_directives = n = false;
                    }
                }
                k();
                return n ? new it(t) : new _n({
                    body: t
                });

              case "num":
              case "bigint":
              case "regexp":
              case "operator":
              case "atom":
                return v();

              case "name":
                switch (_.token.value) {
                  case "async":
                    if (Oe(p(), "keyword", "function")) {
                        b();
                        b();
                        if (!g("operator", "*")) return A(Mt);
                        b();
                        return A(Ft);
                    }
                    break;

                  case "await":
                    if (_.in_async) return v();
                    break;

                  case "export":
                    if (!e && l.module !== "") w();
                    b();
                    return W();

                  case "import":
                    var i = p();
                    if (i.type == "punc" && /^[(.]$/.test(i.value)) break;
                    if (!e && l.module !== "") w();
                    b();
                    return X();

                  case "let":
                    if (ee()) {
                        b();
                        var a = te();
                        k();
                        return a;
                    }
                    break;

                  case "yield":
                    if (_.in_generator) return v();
                    break;
                }
                return Oe(p(), "punc", ":") ? H() : v();

              case "punc":
                switch (_.token.value) {
                  case "{":
                    return new gn({
                        start: _.token,
                        body: q(),
                        end: y()
                    });

                  case "[":
                  case "(":
                  case "`":
                    return v();

                  case ";":
                    _.in_directives = false;
                    b();
                    return new mn();

                  default:
                    w();
                }

              case "keyword":
                switch (_.token.value) {
                  case "break":
                    b();
                    return Y(Kt);

                  case "class":
                    b();
                    return m(It);

                  case "const":
                    b();
                    var a = ne();
                    k();
                    return a;

                  case "continue":
                    b();
                    return Y(Qt);

                  case "debugger":
                    b();
                    k();
                    return new rt();

                  case "do":
                    b();
                    var t = I(h);
                    f("keyword", "while");
                    var o = d();
                    k(true);
                    return new pt({
                        body: t,
                        condition: o
                    });

                  case "while":
                    b();
                    return new dt({
                        condition: d(),
                        body: I(h)
                    });

                  case "for":
                    b();
                    return B();

                  case "function":
                    b();
                    if (!g("operator", "*")) return A(Pt);
                    b();
                    return A(jt);

                  case "if":
                    b();
                    return L();

                  case "return":
                    if (_.in_function == 0 && !l.bare_returns) s("'return' outside of function");
                    b();
                    var r = null;
                    if (g("punc", ";")) {
                        b();
                    } else if (!c()) {
                        r = N();
                        k();
                    }
                    return new wn({
                        value: r
                    });

                  case "switch":
                    b();
                    return new Zt({
                        expression: d(),
                        body: I(K)
                    });

                  case "throw":
                    b();
                    if (u(_.token)) s("Illegal newline after 'throw'");
                    var r = N();
                    k();
                    return new Jt({
                        value: r
                    });

                  case "try":
                    b();
                    return Q();

                  case "var":
                    b();
                    var a = re();
                    k();
                    return a;

                  case "with":
                    if (_.input.has_directive("use strict")) {
                        s("Strict mode may not include a with statement");
                    }
                    b();
                    return new gt({
                        expression: d(),
                        body: h()
                    });
                }
            }
            w();
        });
        function H() {
            var n = z(Se);
            if (!dn(_.labels, function(e) {
                return e.name != n.name;
            })) {
                s("Label " + n.name + " defined twice");
            }
            x(":");
            _.labels.push(n);
            var e = h();
            _.labels.pop();
            if (!(e instanceof ct)) {
                n.references.forEach(function(e) {
                    if (e instanceof Qt) {
                        o(e.label.start, "Continue label `" + n.name + "` must refer to IterationStatement");
                    }
                });
            }
            return new ut({
                body: e,
                label: n
            });
        }
        function v() {
            var e = N();
            k();
            return new _n({
                body: e
            });
        }
        function Y(e) {
            var n = null, t;
            if (!c()) {
                n = z(Te, true);
            }
            if (n != null) {
                t = Vn(function(e) {
                    return e.name == n.name;
                }, _.labels);
                if (!t) o(n.start, "Undefined label " + n.name);
                n.thedef = t;
            } else if (_.in_loop == 0) s(e.TYPE + " not inside a loop or switch");
            k();
            var r = new e({
                label: n
            });
            if (t) t.references.push(r);
            return r;
        }
        function R(e, n) {
            if (!g("name", e)) return;
            var t = p();
            if (!t) return;
            if (Oe(t, "operator", "=")) return;
            if (t.type == "punc" && /^[(;}]$/.test(t.value)) return;
            if (n && u(t)) return;
            return b();
        }
        function m(e) {
            var n = _.in_async;
            var t = _.in_generator;
            _.input.push_directives_stack();
            _.input.add_directive("use strict");
            var r;
            if (e === It) {
                r = z(Ee);
            } else {
                r = z(Fr, true);
            }
            var i = null;
            if (g("keyword", "extends")) {
                b();
                E();
                i = oe(true);
            }
            x("{");
            var a = [];
            while (!g("punc", "}")) {
                if (g("punc", ";")) {
                    b();
                    continue;
                }
                var o = _.token;
                var s = !!R("static");
                var f = R("async", true);
                if (g("operator", "*")) {
                    b();
                    var u = g("name") && /^#/.test(_.token.value);
                    var c = $();
                    var l = _.token;
                    var p = A(f ? Ot : zt);
                    p.start = l;
                    p.end = y();
                    a.push(new Ut({
                        start: o,
                        static: s,
                        private: u,
                        key: c,
                        value: p,
                        end: y()
                    }));
                    continue;
                }
                if (s && g("punc", "{")) {
                    a.push(new Vt({
                        start: o,
                        value: new yt({
                            start: o,
                            body: q(),
                            end: y()
                        }),
                        end: y()
                    }));
                    continue;
                }
                var u = g("name") && /^#/.test(_.token.value);
                var c = $();
                if (g("punc", "(")) {
                    var d = _.token;
                    var h = A(f ? qt : $t);
                    h.start = d;
                    h.end = y();
                    a.push(new Ut({
                        start: o,
                        static: s,
                        private: u,
                        key: c,
                        value: h,
                        end: y()
                    }));
                    continue;
                }
                if (f) w(f);
                var v = null;
                if (g("operator", "=")) {
                    b();
                    _.in_async = false;
                    _.in_generator = false;
                    v = j();
                    _.in_generator = t;
                    _.in_async = n;
                } else if (!(g("punc", ";") || g("punc", "}"))) {
                    var m = null;
                    switch (c) {
                      case "get":
                        m = Bt;
                        break;

                      case "set":
                        m = Lt;
                        break;
                    }
                    if (m) {
                        a.push(new m({
                            start: o,
                            static: s,
                            private: g("name") && /^#/.test(_.token.value),
                            key: $(),
                            value: fe(),
                            end: y()
                        }));
                        continue;
                    }
                }
                k();
                a.push(new Rt({
                    start: o,
                    static: s,
                    private: u,
                    key: c,
                    value: v,
                    end: y()
                }));
            }
            b();
            _.input.pop_directives_stack();
            _.in_generator = t;
            _.in_async = n;
            return new e({
                extends: i,
                name: r,
                properties: a
            });
        }
        function B() {
            var e = g("name", "await") && b();
            x("(");
            var n = null;
            if (e || !g("punc", ";")) {
                n = g("keyword", "const") ? (b(), ne(true)) : g("name", "let") && ee() ? (b(), 
                te(true)) : g("keyword", "var") ? (b(), re(true)) : N(true);
                var t;
                if (e) {
                    f("name", "of");
                    t = _t;
                } else if (g("operator", "in")) {
                    b();
                    t = mt;
                } else if (g("name", "of")) {
                    b();
                    t = xe;
                }
                if (t) {
                    if (n instanceof or) {
                        if (n.definitions.length > 1) {
                            o(n.start, "Only one variable declaration allowed in for..in/of loop");
                        }
                        if (t !== mt && n.definitions[0].value) {
                            o(n.definitions[0].value.start, "No initializers allowed in for..of loop");
                        }
                    } else if (!(F(n) || (n = P(n)) instanceof jn)) {
                        o(n.start, "Invalid left-hand side in for..in/of loop");
                    }
                    return a(t, n);
                }
            }
            return i(n);
        }
        function i(e) {
            x(";");
            var n = g("punc", ";") ? null : N();
            x(";");
            var t = g("punc", ")") ? null : N();
            x(")");
            return new ht({
                init: e,
                condition: n,
                step: t,
                body: I(h)
            });
        }
        function a(e, n) {
            E();
            var t = N();
            x(")");
            return new e({
                init: n,
                object: t,
                body: I(h)
            });
        }
        function S(e) {
            if (e instanceof Pn) {
                var n = null;
                if (e.elements[e.elements.length - 1] instanceof On) {
                    n = S(e.elements.pop().expression);
                }
                return new br({
                    start: e.start,
                    elements: e.elements.map(S),
                    rest: n,
                    end: e.end
                });
            }
            if (e instanceof Fn) return new En({
                start: e.start,
                name: S(e.left),
                value: e.right,
                end: e.end
            });
            if (e instanceof En) {
                e.name = S(e.name);
                return e;
            }
            if (e instanceof br) {
                e.elements = e.elements.map(S);
                if (e.rest) e.rest = S(e.rest);
                return e;
            }
            if (e instanceof wr) {
                e.properties.forEach(function(e) {
                    e.value = S(e.value);
                });
                if (e.rest) e.rest = S(e.rest);
                return e;
            }
            if (e instanceof Gr) return e;
            if (e instanceof Nn) {
                var n = null;
                if (e.properties[e.properties.length - 1] instanceof On) {
                    n = S(e.properties.pop().expression);
                }
                return new wr({
                    start: e.start,
                    properties: e.properties.map(function(e) {
                        if (!(e instanceof kr)) o(e.start, "Invalid destructuring assignment");
                        return new yr({
                            start: e.start,
                            key: e.key,
                            value: S(e.value),
                            end: e.end
                        });
                    }),
                    rest: n,
                    end: e.end
                });
            }
            if (e instanceof In) return e;
            if (e instanceof Hn) return new In(e);
            if (e instanceof gr) return new In({
                start: e.start,
                name: "yield",
                end: e.end
            });
            o(e.start, "Invalid arrow parameter");
        }
        function T(e, n, t) {
            var r = _.in_async;
            var i = _.in_generator;
            _.in_async = t;
            _.in_generator = false;
            var a = _.in_funarg;
            _.in_funarg = _.in_function;
            var o = e.map(S);
            var s = e.rest || null;
            if (s) s = S(s);
            _.in_funarg = a;
            x("=>");
            var f, u;
            var c = _.in_loop;
            var l = _.labels;
            ++_.in_function;
            _.input.push_directives_stack();
            _.in_loop = 0;
            _.labels = [];
            if (g("punc", "{")) {
                _.in_directives = true;
                f = q();
                u = null;
            } else {
                f = [];
                E();
                u = j();
            }
            var p = _.input.has_directive("use strict");
            _.input.pop_directives_stack();
            --_.in_function;
            _.in_loop = c;
            _.labels = l;
            _.in_generator = i;
            _.in_async = r;
            var d = new (t ? Dt : At)({
                start: n,
                argnames: o,
                rest: s,
                body: f,
                value: u,
                end: y()
            });
            if (p) d.each_argname(pe);
            return d;
        }
        var A = function(e) {
            var n = _.in_async;
            var t = _.in_generator;
            var r;
            if (/Defun$/.test(e.TYPE)) {
                r = z(Cr);
                _.in_async = /^Async/.test(e.TYPE);
                _.in_generator = /Generator/.test(e.TYPE);
            } else {
                _.in_async = /^Async/.test(e.TYPE);
                _.in_generator = /Generator/.test(e.TYPE);
                r = z(Mr, true);
            }
            if (r && e !== wt && !(r instanceof Dr)) w(y());
            x("(");
            var i = _.in_funarg;
            _.in_funarg = _.in_function;
            var a = O(")", !l.strict, false, function() {
                return de(In);
            });
            _.in_funarg = i;
            var o = _.in_loop;
            var s = _.labels;
            ++_.in_function;
            _.in_directives = true;
            _.input.push_directives_stack();
            _.in_loop = 0;
            _.labels = [];
            var f = q();
            var u = _.input.has_directive("use strict");
            _.input.pop_directives_stack();
            --_.in_function;
            _.in_loop = o;
            _.labels = s;
            _.in_generator = t;
            _.in_async = n;
            var c = new e({
                name: r,
                argnames: a,
                rest: a.rest || null,
                body: f
            });
            if (u) {
                if (r) pe(r);
                c.each_argname(pe);
            }
            return c;
        };
        function L() {
            var e = d(), n = h(), t = null;
            if (g("keyword", "else")) {
                b();
                t = h();
            }
            return new xn({
                condition: e,
                body: n,
                alternative: t
            });
        }
        function U() {
            return g("name") || g("string") || ei(_.token.value);
        }
        function D(e) {
            return new Rn({
                start: e,
                quote: e.quote,
                value: e.value,
                end: e
            });
        }
        function V() {
            var e = _.token;
            f("string");
            k();
            return D(e);
        }
        function W() {
            if (g("operator", "*")) {
                var e = _.token;
                var n = e;
                b();
                if (g("name", "as")) {
                    b();
                    if (!U()) f("name");
                    n = _.token;
                    b();
                }
                f("name", "from");
                return new ke({
                    aliases: [ D(n) ],
                    keys: [ D(e) ],
                    path: V()
                });
            }
            if (g("punc", "{")) {
                b();
                var r = [];
                var t = [];
                while (U()) {
                    var e = _.token;
                    b();
                    t.push(e);
                    if (g("name", "as")) {
                        b();
                        if (!U()) f("name");
                        r.push(_.token);
                        b();
                    } else {
                        r.push(e);
                    }
                    if (!g("punc", "}")) x(",");
                }
                x("}");
                if (g("name", "from")) {
                    b();
                    return new ke({
                        aliases: r.map(D),
                        keys: t.map(D),
                        path: V()
                    });
                }
                k();
                return new pr({
                    properties: t.map(function(e, n) {
                        if (!Oe(e, "name")) o(e, "Name expected");
                        var t = le(jr, e);
                        t.alias = D(r[n]);
                        return t;
                    })
                });
            }
            if (g("keyword", "default")) {
                b();
                var i = _.token;
                var a = G();
                if (a) {
                    a.start = i;
                    a.end = y();
                } else {
                    E();
                    a = N();
                    k();
                }
                return new lr({
                    body: a
                });
            }
            return new cr({
                body: J()
            });
        }
        function n(e, n) {
            if (n.name) {
                n = new e(n);
                n.name = new (e === It ? Ee : Cr)(n.name);
            }
            return n;
        }
        function G() {
            if (g("name", "async")) {
                if (!Oe(p(), "keyword", "function")) return;
                b();
                b();
                if (!g("operator", "*")) return n(Mt, A(qt));
                b();
                return n(Ft, A(Ot));
            } else if (g("keyword")) switch (_.token.value) {
              case "class":
                b();
                return n(It, m(Ht));

              case "function":
                b();
                if (!g("operator", "*")) return n(Pt, A($t));
                b();
                return n(jt, A(zt));
            }
        }
        var J = e(function() {
            if (g("name")) switch (_.token.value) {
              case "async":
                b();
                f("keyword", "function");
                if (!g("operator", "*")) return A(Mt);
                b();
                return A(Ft);

              case "let":
                b();
                var e = te();
                k();
                return e;
            } else if (g("keyword")) switch (_.token.value) {
              case "class":
                b();
                return m(It);

              case "const":
                b();
                var e = ne();
                k();
                return e;

              case "function":
                b();
                if (!g("operator", "*")) return A(Pt);
                b();
                return A(jt);

              case "var":
                b();
                var e = re();
                k();
                return e;
            }
            w();
        });
        function X() {
            var e = null;
            var n = z(Or, true);
            var t = null;
            var r;
            if (n) {
                n.key = new Rn({
                    start: n.start,
                    value: "",
                    end: n.end
                });
                if (r = g("punc", ",")) b();
            } else {
                r = !g("string");
            }
            if (r) {
                if (g("operator", "*")) {
                    var i = _.token;
                    b();
                    f("name", "as");
                    e = z(Or);
                    e.key = D(i);
                } else {
                    x("{");
                    t = [];
                    while (U()) {
                        var a;
                        if (Oe(p(), "name", "as")) {
                            var i = _.token;
                            b();
                            b();
                            a = z(Or);
                            a.key = D(i);
                        } else {
                            a = z(Or);
                            a.key = new Rn({
                                start: a.start,
                                value: a.name,
                                end: a.end
                            });
                        }
                        t.push(a);
                        if (!g("punc", "}")) x(",");
                    }
                    x("}");
                }
            }
            if (e || n || t) f("name", "from");
            return new dr({
                all: e,
                default: n,
                path: V(),
                properties: t
            });
        }
        function q() {
            x("{");
            var e = [];
            while (!g("punc", "}")) {
                if (g("eof")) x("}");
                e.push(h());
            }
            b();
            return e;
        }
        function K() {
            x("{");
            var e = [], n, t, r, i;
            while (!g("punc", "}")) {
                if (g("eof")) x("}");
                if (g("keyword", "case")) {
                    if (n) n.end = y();
                    t = [];
                    n = new tr({
                        start: (i = _.token, b(), i),
                        expression: N(),
                        body: t
                    });
                    e.push(n);
                    x(":");
                } else if (g("keyword", "default")) {
                    if (n) n.end = y();
                    if (r) s("More than one default clause in switch statement");
                    t = [];
                    n = new nr({
                        start: (i = _.token, b(), x(":"), i),
                        body: t
                    });
                    e.push(n);
                    r = n;
                } else {
                    if (!t) w();
                    t.push(h());
                }
            }
            if (n) n.end = y();
            b();
            return e;
        }
        function Q() {
            var e = q(), n = null, t = null;
            if (g("keyword", "catch")) {
                var r = _.token;
                b();
                var i = null;
                if (g("punc", "(")) {
                    b();
                    i = C(Pr);
                    x(")");
                }
                n = new ir({
                    start: r,
                    argname: i,
                    body: q(),
                    end: y()
                });
            }
            if (g("keyword", "finally")) {
                var r = _.token;
                b();
                t = new ar({
                    start: r,
                    body: q(),
                    end: y()
                });
            }
            if (!n && !t) s("Missing catch/finally blocks");
            return new rr({
                body: e,
                bcatch: n,
                bfinally: t
            });
        }
        function Z(e, n) {
            var t = [];
            for (;;) {
                var r = _.token;
                var i = C(e);
                var a = null;
                if (g("operator", "=")) {
                    b();
                    a = j(n);
                } else if (!n && (e === qr || i instanceof jn)) {
                    s("Missing initializer in declaration");
                }
                t.push(new kn({
                    start: r,
                    name: i,
                    value: a,
                    end: y()
                }));
                if (!g("punc", ",")) break;
                b();
            }
            return t;
        }
        function ee() {
            var e = p();
            return Oe(e, "name") || Oe(e, "punc", "[") || Oe(e, "punc", "{");
        }
        var ne = function(e) {
            return new sr({
                start: y(),
                definitions: Z(qr, e),
                end: y()
            });
        };
        var te = function(e) {
            return new fr({
                start: y(),
                definitions: Z($r, e),
                end: y()
            });
        };
        var re = function(e) {
            return new ur({
                start: y(),
                definitions: Z(zr, e),
                end: y()
            });
        };
        var ie = function(e) {
            var n = _.token;
            f("operator", "new");
            var t;
            if (g("punc", ".") && Oe(p(), "name", "target")) {
                b();
                b();
                t = new Yr();
            } else {
                var r = oe(false), i;
                if (g("punc", "(")) {
                    b();
                    i = O(")", !l.strict);
                } else {
                    i = [];
                }
                t = new hr({
                    expression: r,
                    args: i
                });
            }
            t.start = n;
            t.end = y();
            return M(t, e);
        };
        function ae() {
            var e, n = _.token, t = n.value;
            switch (n.type) {
              case "num":
                if (isFinite(t)) {
                    e = new Bn({
                        value: t
                    });
                } else {
                    e = new Jr();
                    if (t < 0) e = new zn({
                        operator: "-",
                        expression: e
                    });
                }
                break;

              case "bigint":
                e = new Br({
                    value: t
                });
                break;

              case "string":
                e = new Rn({
                    value: t,
                    quote: n.quote
                });
                break;

              case "regexp":
                e = new Lr({
                    value: t
                });
                break;

              case "atom":
                switch (t) {
                  case "false":
                    e = new Kr();
                    break;

                  case "true":
                    e = new Qr();
                    break;

                  case "null":
                    e = new Ur();
                    break;

                  default:
                    w();
                }
                break;

              default:
                w();
            }
            b();
            e.start = e.end = n;
            return e;
        }
        var oe = function(e) {
            if (g("operator", "new")) {
                return ie(e);
            }
            var n = _.token;
            if (g("punc")) {
                switch (n.value) {
                  case "`":
                    return M(he(null), e);

                  case "(":
                    b();
                    if (g("punc", ")")) {
                        b();
                        return T([], n);
                    }
                    var t = N(false, true);
                    var r = n.comments_before.length;
                    [].unshift.apply(t.start.comments_before, n.comments_before);
                    n.comments_before.length = 0;
                    n.comments_before = t.start.comments_before;
                    n.comments_before_length = r;
                    if (r == 0 && n.comments_before.length > 0) {
                        var i = n.comments_before[0];
                        if (!i.nlb) {
                            i.nlb = n.nlb;
                            n.nlb = false;
                        }
                    }
                    n.comments_after = t.start.comments_after;
                    t.start = n;
                    x(")");
                    var a = y();
                    a.comments_before = t.end.comments_before;
                    a.comments_after.forEach(function(e) {
                        t.end.comments_after.push(e);
                        if (e.nlb) _.token.nlb = true;
                    });
                    a.comments_after.length = 0;
                    a.comments_after = t.end.comments_after;
                    t.end = a;
                    if (g("punc", "=>")) return T(t instanceof Tn ? t.expressions : [ t ], n);
                    return M(t, e);

                  case "[":
                    return M(se(), e);

                  case "{":
                    return M(ue(), e);
                }
                w();
            }
            if (g("keyword")) switch (n.value) {
              case "class":
                b();
                var o = m(Ht);
                o.start = n;
                o.end = y();
                return M(o, e);

              case "function":
                b();
                var s;
                if (g("operator", "*")) {
                    b();
                    s = A(zt);
                } else {
                    s = A($t);
                }
                s.start = n;
                s.end = y();
                return M(s, e);
            }
            if (g("name")) {
                var f = le(Hn, n);
                b();
                if (f.name == "async") {
                    if (g("keyword", "function")) {
                        b();
                        var s;
                        if (g("operator", "*")) {
                            b();
                            s = A(Ot);
                        } else {
                            s = A(qt);
                        }
                        s.start = n;
                        s.end = y();
                        return M(s, e);
                    }
                    if (g("name") && Oe(p(), "punc", "=>")) {
                        n = _.token;
                        f = le(Hn, n);
                        b();
                        return T([ f ], n, true);
                    }
                    if (g("punc", "(")) {
                        var u = M(f, e);
                        if (!g("punc", "=>")) return u;
                        var c = u.args;
                        if (c[c.length - 1] instanceof On) {
                            c.rest = c.pop().expression;
                        }
                        return T(c, n, true);
                    }
                }
                return g("punc", "=>") ? T([ f ], n) : M(f, e);
            }
            if (Me[_.token.type]) {
                return M(ae(), e);
            }
            w();
        };
        function O(e, n, t, r) {
            if (!r) r = j;
            var i = true, a = [];
            while (!g("punc", e)) {
                if (i) i = false; else x(",");
                if (n && g("punc", e)) break;
                if (t && g("punc", ",")) {
                    a.push(new Gr({
                        start: _.token,
                        end: _.token
                    }));
                } else if (!g("operator", "...")) {
                    a.push(r());
                } else if (r === j) {
                    a.push(new On({
                        start: _.token,
                        expression: (b(), r()),
                        end: y()
                    }));
                } else {
                    b();
                    a.rest = r();
                    if (a.rest instanceof En) o(a.rest.start, "Invalid rest parameter");
                    break;
                }
            }
            x(e);
            return a;
        }
        var se = e(function() {
            x("[");
            return new Pn({
                elements: O("]", !l.strict, true)
            });
        });
        var fe = e(function() {
            return A(wt);
        });
        var ue = e(function() {
            x("{");
            var e = true, n = [];
            while (!g("punc", "}")) {
                if (e) e = false; else x(",");
                if (!l.strict && g("punc", "}")) break;
                var t = _.token;
                if (g("operator", "*")) {
                    b();
                    var r = $();
                    var i = _.token;
                    var a = A(zt);
                    a.start = i;
                    a.end = y();
                    n.push(new Er({
                        start: t,
                        key: r,
                        value: a,
                        end: y()
                    }));
                    continue;
                }
                if (g("operator", "...")) {
                    b();
                    n.push(new On({
                        start: t,
                        expression: j(),
                        end: y()
                    }));
                    continue;
                }
                if (Oe(p(), "operator", "=")) {
                    var o = z(Hn);
                    b();
                    n.push(new kr({
                        start: t,
                        key: t.value,
                        value: new Fn({
                            start: t,
                            left: o,
                            operator: "=",
                            right: j(),
                            end: y()
                        }),
                        end: y()
                    }));
                    continue;
                }
                if (Oe(p(), "punc", ",") || Oe(p(), "punc", "}")) {
                    n.push(new kr({
                        start: t,
                        key: t.value,
                        value: z(Hn),
                        end: y()
                    }));
                    continue;
                }
                var r = $();
                if (g("punc", "(")) {
                    var s = _.token;
                    var f = A($t);
                    f.start = s;
                    f.end = y();
                    n.push(new Er({
                        start: t,
                        key: r,
                        value: f,
                        end: y()
                    }));
                    continue;
                }
                if (g("punc", ":")) {
                    b();
                    n.push(new kr({
                        start: t,
                        key: r,
                        value: j(),
                        end: y()
                    }));
                    continue;
                }
                if (t.type == "name") switch (r) {
                  case "async":
                    var u = g("operator", "*") && b();
                    r = $();
                    var s = _.token;
                    var f = A(u ? Ot : qt);
                    f.start = s;
                    f.end = y();
                    n.push(new Er({
                        start: t,
                        key: r,
                        value: f,
                        end: y()
                    }));
                    continue;

                  case "get":
                    n.push(new Tr({
                        start: t,
                        key: $(),
                        value: fe(),
                        end: y()
                    }));
                    continue;

                  case "set":
                    n.push(new Sr({
                        start: t,
                        key: $(),
                        value: fe(),
                        end: y()
                    }));
                    continue;
                }
                w();
            }
            b();
            return new Nn({
                properties: n
            });
        });
        function $() {
            var e = _.token;
            switch (e.type) {
              case "operator":
                if (!Ae[e.value]) w();

              case "num":
              case "string":
              case "name":
              case "keyword":
              case "atom":
                b();
                return "" + e.value;

              case "punc":
                x("[");
                var n = j();
                x("]");
                return n;

              default:
                w();
            }
        }
        function ce() {
            var e = _.token.value;
            f("name");
            return e;
        }
        function le(e, n) {
            var t = n.value;
            switch (t) {
              case "await":
                if (_.in_async) w(n);
                break;

              case "super":
                e = Ir;
                break;

              case "this":
                e = Hr;
                break;

              case "yield":
                if (_.in_generator) w(n);
                break;
            }
            return new e({
                name: "" + t,
                start: n,
                end: n
            });
        }
        function pe(e) {
            if (e.name == "arguments" || e.name == "eval" || e.name == "let") o(e.start, "Unexpected " + e.name + " in strict mode");
        }
        function z(e, n) {
            if (!g("name")) {
                if (!n) s("Name expected");
                return null;
            }
            var t = le(e, _.token);
            if (_.input.has_directive("use strict") && t instanceof Dr) {
                pe(t);
            }
            b();
            return t;
        }
        function C(e) {
            var n = _.token;
            if (g("punc", "[")) {
                b();
                var t = O("]", !l.strict, true, function() {
                    return de(e);
                });
                return new br({
                    start: n,
                    elements: t,
                    rest: t.rest || null,
                    end: y()
                });
            }
            if (g("punc", "{")) {
                b();
                var r = true, i = [], a = null;
                while (!g("punc", "}")) {
                    if (r) r = false; else x(",");
                    if (!l.strict && g("punc", "}")) break;
                    var o = _.token;
                    if (g("punc", "[") || Oe(p(), "punc", ":")) {
                        var s = $();
                        x(":");
                        i.push(new yr({
                            start: o,
                            key: s,
                            value: de(e),
                            end: y()
                        }));
                        continue;
                    }
                    if (g("operator", "...")) {
                        b();
                        a = C(e);
                        break;
                    }
                    var f = z(e);
                    if (g("operator", "=")) {
                        b();
                        f = new En({
                            start: f.start,
                            name: f,
                            value: j(),
                            end: y()
                        });
                    }
                    i.push(new yr({
                        start: o,
                        key: o.value,
                        value: f,
                        end: y()
                    }));
                }
                x("}");
                return new wr({
                    start: n,
                    properties: i,
                    rest: a,
                    end: y()
                });
            }
            return z(e);
        }
        function de(e) {
            var n = _.token;
            var t = C(e);
            if (!g("operator", "=")) return t;
            b();
            return new En({
                start: n,
                name: t,
                value: j(),
                end: y()
            });
        }
        function he(e) {
            var n = e ? e.start : _.token;
            var t = _.input.context().read_template;
            var r = [];
            var i = [];
            while (t(r)) {
                b();
                i.push(N());
                if (!g("punc", "}")) w();
            }
            b();
            return new Rr({
                start: n,
                expressions: i,
                strings: r,
                tag: e,
                end: y()
            });
        }
        function M(e, n) {
            var t = e.start;
            var r = null;
            while (true) {
                if (g("operator", "?") && Oe(p(), "punc", ".")) {
                    b();
                    b();
                    r = e;
                }
                if (g("punc", "[")) {
                    b();
                    var i = N();
                    x("]");
                    e = new qn({
                        start: t,
                        optional: r === e,
                        expression: e,
                        property: i,
                        end: y()
                    });
                } else if (n && g("punc", "(")) {
                    b();
                    e = new Sn({
                        start: t,
                        optional: r === e,
                        expression: e,
                        args: O(")", !l.strict),
                        end: y()
                    });
                } else if (r === e || g("punc", ".")) {
                    if (r !== e) b();
                    e = new Dn({
                        start: t,
                        optional: r === e,
                        expression: e,
                        property: ce(),
                        end: y()
                    });
                } else if (g("punc", "`")) {
                    if (r) s("Invalid template on optional chain");
                    e = he(e);
                } else {
                    break;
                }
            }
            if (r) e.terminal = true;
            if (e instanceof Sn && !e.pure) {
                var t = e.start;
                var a = t.comments_before;
                var o = et(t, "comments_before_length") ? t.comments_before_length : a.length;
                while (--o >= 0) {
                    if (/[@#]__PURE__/.test(a[o].value)) {
                        e.pure = true;
                        break;
                    }
                }
            }
            return e;
        }
        function ve(e) {
            var n = _.token;
            if (_.in_async && g("name", "await")) {
                if (_.in_funarg === _.in_function) s("Invalid use of await in function argument");
                _.input.context().regex_allowed = true;
                b();
                return new _r({
                    start: n,
                    expression: ve(e),
                    end: y()
                });
            }
            if (_.in_generator && g("name", "yield")) {
                if (_.in_funarg === _.in_function) s("Invalid use of yield in function argument");
                _.input.context().regex_allowed = true;
                b();
                var t = null;
                var r = false;
                if (g("operator", "*")) {
                    b();
                    t = j(e);
                    r = true;
                } else if (g("punc") ? !De[_.token.value] : !c()) {
                    t = j(e);
                }
                return new gr({
                    start: n,
                    expression: t,
                    nested: r,
                    end: y()
                });
            }
            if (g("operator") && ze[n.value]) {
                b();
                E();
                var i = me(zn, n, ve(e));
                i.start = n;
                i.end = y();
                return i;
            }
            var a = oe(true);
            while (g("operator") && ri[_.token.value] && !u(_.token)) {
                a = me(mr, _.token, a);
                a.start = n;
                a.end = _.token;
                b();
            }
            return a;
        }
        function me(e, n, t) {
            var r = n.value;
            switch (r) {
              case "++":
              case "--":
                if (!F(t)) o(n, "Invalid use of " + r + " operator");
                break;

              case "delete":
                if (t instanceof Hn && _.input.has_directive("use strict")) o(t.start, "Calling delete on expression not allowed in strict mode");
                break;
            }
            return new e({
                operator: r,
                expression: t
            });
        }
        var _e = function(e, n, t) {
            var r = g("operator") ? _.token.value : null;
            if (r == "in" && t) r = null;
            var i = r != null ? ii[r] : null;
            if (i != null && i > n) {
                b();
                var a = _e(ve(t), r == "**" ? i - 1 : i, t);
                return _e(new Cn({
                    start: e.start,
                    left: e,
                    operator: r,
                    right: a,
                    end: a.end
                }), n, t);
            }
            return e;
        };
        function ge(e) {
            return _e(ve(e), 0, e);
        }
        var be = function(e) {
            var n = _.token;
            var t = ge(e);
            if (g("operator", "?")) {
                b();
                var r = j();
                x(":");
                return new Mn({
                    start: n,
                    condition: t,
                    consequent: r,
                    alternative: j(e),
                    end: y()
                });
            }
            return t;
        };
        function F(e) {
            return e instanceof An && !e.optional || e instanceof Hn;
        }
        function P(e) {
            if (e instanceof Pn) {
                var n = null;
                if (e.elements[e.elements.length - 1] instanceof On) {
                    n = P(e.elements.pop().expression);
                    if (!(n instanceof jn || F(n))) return e;
                }
                var t = e.elements.map(P);
                return dn(t, function(e) {
                    return e instanceof En || e instanceof jn || e instanceof Gr || F(e);
                }) ? new br({
                    start: e.start,
                    elements: t,
                    rest: n,
                    end: e.end
                }) : e;
            }
            if (e instanceof Fn) {
                var r = P(e.left);
                return r instanceof jn || F(r) ? new En({
                    start: e.start,
                    name: r,
                    value: e.right,
                    end: e.end
                }) : e;
            }
            if (!(e instanceof Nn)) return e;
            var n = null;
            if (e.properties[e.properties.length - 1] instanceof On) {
                n = P(e.properties.pop().expression);
                if (!(n instanceof jn || F(n))) return e;
            }
            var i = [];
            for (var a = 0; a < e.properties.length; a++) {
                var o = e.properties[a];
                if (!(o instanceof kr)) return e;
                var s = P(o.value);
                if (!(s instanceof En || s instanceof jn || F(s))) {
                    return e;
                }
                i.push(new yr({
                    start: o.start,
                    key: o.key,
                    value: s,
                    end: o.end
                }));
            }
            return new wr({
                start: e.start,
                properties: i,
                rest: n,
                end: e.end
            });
        }
        function j(e) {
            var n = _.token;
            var t = be(e), r = _.token.value;
            if (g("operator") && Ce[r]) {
                if (F(t) || r == "=" && (t = P(t)) instanceof jn) {
                    b();
                    return new Fn({
                        start: n,
                        left: t,
                        operator: r,
                        right: j(e),
                        end: y()
                    });
                }
                s("Invalid assignment");
            }
            return t;
        }
        function N(e, n) {
            var t = _.token;
            var r = [];
            while (true) {
                if (n && g("operator", "...")) {
                    b();
                    r.rest = C(In);
                    break;
                }
                r.push(j(e));
                if (!g("punc", ",")) break;
                b();
                if (n && g("punc", ")") && Oe(p(), "punc", "=>")) break;
            }
            return r.length == 1 && !r.rest ? r[0] : new Tn({
                start: t,
                expressions: r,
                end: y()
            });
        }
        function I(e) {
            ++_.in_loop;
            var n = e();
            --_.in_loop;
            return n;
        }
        if (l.expression) {
            E();
            var ye = N();
            f("eof");
            return ye;
        }
        return function() {
            var e = _.token;
            var n = [];
            if (l.module) {
                _.in_async = true;
                _.input.add_directive("use strict");
            }
            _.input.push_directives_stack();
            while (!g("eof")) n.push(h(true));
            _.input.pop_directives_stack();
            var t = y() || e;
            var r = l.toplevel;
            if (r) {
                r.body = r.body.concat(n);
                r.end = t;
            } else {
                r = new bt({
                    start: e,
                    body: n,
                    end: t
                });
            }
            return r;
        }();
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function w(e, n, t, r) {
        this._bits = 0;
        this.defun = undefined;
        this.eliminated = 0;
        this.id = e;
        this.init = r;
        this.mangled_name = null;
        this.name = t.name;
        this.orig = [ t ];
        this.references = [];
        this.replaced = 0;
        this.safe_ids = undefined;
        this.scope = n;
    }
    w.prototype = {
        forEach: function(e) {
            this.orig.forEach(e);
            this.references.forEach(e);
        },
        mangle: function(e) {
            if (this.mangled_name) return;
            var n = this.global && e.cache && e.cache.props;
            if (n && n.has(this.name)) {
                this.mangled_name = n.get(this.name);
            } else if (this.unmangleable(e)) {
                E(this.scope, e).set(this.name, true);
            } else {
                var t = this.redefined();
                if (t) {
                    this.mangled_name = t.mangled_name || t.name;
                } else {
                    this.mangled_name = S(this, e);
                }
                if (n) n.set(this.name, this.mangled_name);
            }
        },
        redefined: function() {
            var e = this;
            var n = e.defun;
            if (!n) return;
            var t = e.name;
            var r = n.variables.get(t) || n instanceof bt && n.globals.get(t) || e.orig[0] instanceof qr && Vn(function(e) {
                return e.name == t;
            }, n.enclosed);
            if (r && r !== e) return r.redefined() || r;
        },
        unmangleable: function(e) {
            if (this.exported) return true;
            if (this.undeclared) return true;
            if (!e.eval && this.scope.pinned()) return true;
            if (e.keep_fargs && oi(this)) return true;
            if (e.keep_fnames) {
                var n = this.orig[0];
                if (n instanceof Fr) return true;
                if (n instanceof Ee) return true;
                if (n instanceof Cr) return true;
                if (n instanceof Mr) return true;
            }
            if (!e.toplevel && this.global) return true;
            return false;
        }
    };
    r(w, [ "const_redefs", "cross_loop", "direct_access", "exported", "global", "undeclared" ]);
    function oi(e) {
        return e.orig[0] instanceof In || e.orig[1] instanceof In;
    }
    var si = pn("delete ++ --");
    function fi(e, n) {
        if (n instanceof Fn) return n.left === e && e;
        if (n instanceof En) return n.name === e && e;
        if (n instanceof jn) return e;
        if (n instanceof yr) return e;
        if (n instanceof vt) return n.init === e && e;
        if (n instanceof $n) return si[n.operator] && n.expression;
    }
    bt.DEFMETHOD("figure_out_scope", function(c) {
        c = we(c, {
            cache: null,
            ie: false
        });
        var l = this;
        var o = null;
        var s = false;
        var t = 0;
        var f = l.parent_scope = null;
        var p = new Ln(function(r, e) {
            if (r instanceof It) {
                var n = s;
                s = p.parent() instanceof cr;
                r.name.walk(p);
                s = n;
                a(function() {
                    if (r.extends) r.extends.walk(p);
                    r.properties.forEach(function(e) {
                        e.walk(p);
                    });
                });
                return true;
            }
            if (r instanceof or) {
                var n = s;
                s = p.parent() instanceof cr;
                e();
                s = n;
                return true;
            }
            if (r instanceof Ct) {
                var n = s;
                s = p.parent() instanceof cr;
                r.name.walk(p);
                s = n;
                a(function() {
                    r.argnames.forEach(function(e) {
                        e.walk(p);
                    });
                    if (r.rest) r.rest.walk(p);
                    st(r, p);
                });
                return true;
            }
            if (r instanceof er) {
                r.init_vars(f);
                e();
                return true;
            }
            if (r instanceof rr) {
                a(function() {
                    st(r, p);
                });
                if (r.bcatch) r.bcatch.walk(p);
                if (r.bfinally) r.bfinally.walk(p);
                return true;
            }
            if (r instanceof gt) {
                var t = f;
                do {
                    t = t.resolve();
                    if (t.uses_with) break;
                    t.uses_with = true;
                } while (t = t.parent_scope);
                a(e);
                return true;
            }
            if (r instanceof ot) {
                a(e);
                return true;
            }
            if (r instanceof Ar) {
                r.scope = f;
            }
            if (r instanceof Se) {
                r.thedef = r;
                r.references = [];
            }
            if (r instanceof Pr) {
                f.def_variable(r).defun = o;
            } else if (r instanceof qr) {
                var i = f.def_variable(r);
                i.defun = o;
                if (s) i.exported = true;
            } else if (r instanceof Cr) {
                var i = o.def_function(r, p.parent());
                if (s) i.exported = true;
            } else if (r instanceof In) {
                o.def_variable(r);
            } else if (r instanceof Mr) {
                var i = o.def_function(r, r.name == "arguments" ? undefined : o);
                if (c.ie && r.name != "arguments") i.defun = o.parent_scope.resolve();
            } else if (r instanceof $r) {
                var i = f.def_variable(r);
                if (s) i.exported = true;
            } else if (r instanceof zr) {
                var i = o.def_variable(r, r instanceof Or ? undefined : null);
                if (s) i.exported = true;
            }
            function a(e) {
                r.init_vars(f);
                var n = o;
                var t = f;
                if (r instanceof bn) o = r;
                f = r;
                e();
                f = t;
                o = n;
            }
        });
        l.make_def = function(e, n) {
            return new w(++t, this, e, n);
        };
        l.walk(p);
        l.globals = new hn();
        var d = [];
        var p = new Ln(function(e) {
            if (e instanceof ir) {
                if (!(e.argname instanceof jn)) return;
                d.push(e);
                e.argname.walk(p);
                d.pop();
                st(e, p);
                return true;
            }
            if (e instanceof yn) {
                d.push(e);
                if (e.name) e.name.walk(p);
                e.argnames.forEach(function(e) {
                    e.walk(p);
                });
                if (e.rest) e.rest.walk(p);
                d.pop();
                Tt(e, p);
                return true;
            }
            if (e instanceof Xt) {
                if (e.label) e.label.thedef.references.push(e);
                return true;
            }
            if (e instanceof Dr) {
                var n = e.definition();
                n.preinit = n.references.length;
                if (e instanceof Pr) {
                    var t = n.redefined();
                    if (t) for (var r = e.scope; r; r = r.parent_scope) {
                        if (!Kn(r.enclosed, t)) break;
                        if (r === t.scope) break;
                    }
                } else if (e instanceof qr) {
                    var t = n.redefined();
                    if (t) t.const_redefs = true;
                } else if (n.scope !== e.scope && (e instanceof Cr || e instanceof In || e instanceof zr)) {
                    e.mark_enclosed(c);
                    var t = e.scope.find_variable(e.name);
                    if (e.thedef !== t) {
                        e.thedef = t;
                        t.orig.push(e);
                        e.mark_enclosed(c);
                    }
                }
                if (e.name != "arguments") return true;
                var i = e instanceof zr && p.parent();
                if (i instanceof kn && !i.value) return true;
                var a = e.scope.resolve().find_variable("arguments");
                if (a && h(a)) a.scope.uses_arguments = 3;
                return true;
            }
            if (e instanceof Hn) {
                var o = e.name;
                var a = e.scope.find_variable(o);
                for (var s = d.length; s > 0 && a; ) {
                    s = d.lastIndexOf(a.scope, s - 1);
                    if (s < 0) break;
                    var f = a.orig[0];
                    if (f instanceof Pr || f instanceof In || f instanceof Mr) {
                        e.in_arg = true;
                        break;
                    }
                    a = a.scope.parent_scope.find_variable(o);
                }
                if (!a) {
                    a = l.def_global(e);
                } else if (o == "arguments" && h(a)) {
                    var i = p.parent();
                    if (fi(e, i)) {
                        a.scope.uses_arguments = 3;
                    } else if (a.scope.uses_arguments < 2 && !(i instanceof An && i.expression === e)) {
                        a.scope.uses_arguments = 2;
                    } else if (!a.scope.uses_arguments) {
                        a.scope.uses_arguments = true;
                    }
                }
                if (o == "eval") {
                    var i = p.parent();
                    if (i.TYPE == "Call" && i.expression === e) {
                        var r = e.scope;
                        do {
                            r = r.resolve();
                            if (r.uses_eval) break;
                            r.uses_eval = true;
                        } while (r = r.parent_scope);
                    } else if (a.undeclared) {
                        l.uses_eval = true;
                    }
                }
                if (a.init instanceof Ct && a.scope !== a.init.name.scope) {
                    var u = e.scope;
                    do {
                        if (u === a.init.name.scope) break;
                    } while (u = u.parent_scope);
                    if (!u) a.init = undefined;
                }
                e.thedef = a;
                e.reference(c);
                return true;
            }
        });
        l.walk(p);
        if (c.ie) l.walk(new Ln(function(e) {
            if (e instanceof Pr) {
                var n = e.thedef.defun;
                if (n.name instanceof Mr && n.name.name == e.name) {
                    n = n.parent_scope.resolve();
                }
                r(e, n);
                return true;
            }
            if (e instanceof Mr) {
                var t = e.thedef;
                if (!r(e, e.scope.parent_scope.resolve())) {
                    t.defun = undefined;
                } else if (typeof e.thedef.init !== "undefined") {
                    e.thedef.init = false;
                } else if (t.init) {
                    e.thedef.init = t.init;
                }
                return true;
            }
        }));
        function h(e) {
            return e.orig[0] instanceof In && !(e.orig[1] instanceof In || e.orig[2] instanceof In) && !kt(e.scope);
        }
        function r(e, n) {
            var t = e.name;
            var r = e.thedef;
            if (!dn(r.orig, function(e) {
                return !(e instanceof qr || e instanceof $r);
            })) return false;
            var i = n.find_variable(t);
            if (i) {
                var a = i.redefined();
                if (a) i = a;
            } else {
                i = l.globals.get(t);
            }
            if (i) {
                i.orig.push(e);
            } else {
                i = n.def_variable(e);
            }
            if (i.undeclared) l.variables.set(t, i);
            if (t == "arguments" && h(r) && e instanceof Mr) return true;
            r.defun = i.scope;
            r.forEach(function(e) {
                e.redef = r;
                e.thedef = i;
                e.reference(c);
            });
            return true;
        }
    });
    bt.DEFMETHOD("def_global", function(e) {
        var n = this.globals, t = e.name;
        if (n.has(t)) {
            return n.get(t);
        } else {
            var r = this.make_def(e);
            r.undeclared = true;
            r.global = true;
            n.set(t, r);
            return r;
        }
    });
    function x(e, n) {
        e.enclosed = [];
        e.parent_scope = n;
        e.functions = new hn();
        e.variables = new hn();
        if (n) e.make_def = n.make_def;
    }
    function k(e, n) {
        x(e, n);
        e.uses_eval = false;
        e.uses_with = false;
    }
    ot.DEFMETHOD("init_vars", function(e) {
        x(this, e);
    });
    bn.DEFMETHOD("init_vars", function(e) {
        k(this, e);
    });
    At.DEFMETHOD("init_vars", function(e) {
        k(this, e);
        return this;
    });
    Dt.DEFMETHOD("init_vars", function(e) {
        k(this, e);
    });
    yn.DEFMETHOD("init_vars", function(e) {
        k(this, e);
        this.uses_arguments = false;
        this.def_variable(new In({
            name: "arguments",
            scope: this,
            start: this.start,
            end: this.end
        }));
        return this;
    });
    Ar.DEFMETHOD("mark_enclosed", function(e) {
        var n = this.definition();
        for (var t = this.scope; t; t = t.parent_scope) {
            if (!Kn(t.enclosed, n)) break;
            if (!e) {
                t._var_names = undefined;
            } else {
                if (e.keep_fargs && t instanceof yn) t.each_argname(function(e) {
                    Kn(n.scope.enclosed, e.definition());
                });
                if (e.keep_fnames) t.functions.each(function(e) {
                    Kn(n.scope.enclosed, e);
                });
            }
            if (t === n.scope) break;
        }
    });
    Ar.DEFMETHOD("reference", function(e) {
        this.definition().references.push(this);
        this.mark_enclosed(e);
    });
    ot.DEFMETHOD("find_variable", function(e) {
        return this.variables.get(e) || this.parent_scope && this.parent_scope.find_variable(e);
    });
    ot.DEFMETHOD("def_function", function(e, n) {
        var t = this.def_variable(e, n);
        if (!t.init || t.init instanceof Ct) t.init = n;
        this.functions.set(e.name, t);
        return t;
    });
    ot.DEFMETHOD("def_variable", function(e, n) {
        var t = this.variables.get(e.name);
        if (t) {
            t.orig.push(e);
            if (t.init instanceof xt) t.init = n;
        } else {
            t = this.make_def(e, n);
            this.variables.set(e.name, t);
            t.global = !this.parent_scope;
        }
        return e.thedef = t;
    });
    function E(e, n) {
        var t = e.names_in_use;
        if (!t) {
            e.cname = -1;
            e.cname_holes = [];
            e.names_in_use = t = new hn();
            var r = n.cache && n.cache.props;
            e.enclosed.forEach(function(e) {
                if (e.unmangleable(n)) t.set(e.name, true);
                if (e.global && r && r.has(e.name)) {
                    t.set(r.get(e.name), true);
                }
            });
        }
        return t;
    }
    function S(e, t) {
        var n = e.scope;
        var r = E(n, t);
        var i = n.cname_holes;
        var a = new hn();
        var o = [ n ];
        e.forEach(function(e) {
            var n = e.scope;
            do {
                if (Un(n, o)) break;
                E(n, t).each(function(e, n) {
                    a.set(n, e);
                });
                o.push(n);
            } while (n = n.parent_scope);
        });
        var s;
        for (var f = 0; f < i.length; f++) {
            s = A(i[f]);
            if (a.has(s)) continue;
            i.splice(f, 1);
            r.set(s, true);
            return s;
        }
        while (true) {
            s = A(++n.cname);
            if (r.has(s) || I[s] || t.reserved.has[s]) continue;
            if (!a.has(s)) break;
            i.push(n.cname);
        }
        r.set(s, true);
        return s;
    }
    Ar.DEFMETHOD("unmangleable", function(e) {
        var n = this.definition();
        return !n || n.unmangleable(e);
    });
    Se.DEFMETHOD("unmangleable", cn);
    Ar.DEFMETHOD("definition", function() {
        return this.thedef;
    });
    function T(e) {
        e = we(e, {
            eval: false,
            ie: false,
            keep_fargs: false,
            keep_fnames: false,
            reserved: [],
            toplevel: false,
            v8: false,
            webkit: false
        });
        if (!Array.isArray(e.reserved)) e.reserved = [];
        Kn(e.reserved, "arguments");
        e.reserved.has = pn(e.reserved);
        return e;
    }
    bt.DEFMETHOD("mangle_names", function(s) {
        s = T(s);
        if (s.cache && s.cache.props) {
            var n = E(this, s);
            s.cache.props.each(function(e) {
                n.set(e, true);
            });
        }
        var f = 36;
        var u = -1;
        var a = [];
        var c = new Ln(function(e, n) {
            var t;
            if (e instanceof ot) {
                if (e instanceof ut) t = u;
                if (s.webkit && e instanceof ct && e.init instanceof fr) {
                    e.init.definitions.forEach(function(e) {
                        e.name.match_symbol(function(e) {
                            if (!(e instanceof $r)) return;
                            var n = e.definition();
                            var t = e.scope.parent_scope;
                            var r = t.def_variable(e);
                            e.thedef = n;
                            t.to_mangle.push(r);
                            n.redefined = function() {
                                return r;
                            };
                        });
                    }, true);
                }
                var r = e.to_mangle = [];
                e.variables.each(function(e) {
                    if (!p(e)) r.push(e);
                });
                n();
                if (s.cache && e instanceof bt) {
                    e.globals.each(l);
                }
                if (e instanceof Pt && c.has_directive("use asm")) {
                    var i = new Hn(e.name);
                    i.scope = e;
                    i.reference(s);
                }
                if (r.length > f) {
                    var a = r.map(function(e, n) {
                        return n;
                    }).sort(function(e, n) {
                        return r[n].references.length - r[e].references.length || e - n;
                    });
                    r = a.slice(0, f).sort(function(e, n) {
                        return e - n;
                    }).map(function(e) {
                        return r[e];
                    }).concat(a.slice(f).sort(function(e, n) {
                        return e - n;
                    }).map(function(e) {
                        return r[e];
                    }));
                }
                r.forEach(l);
                if (e instanceof ut && !(s.v8 && d(c))) u = t;
                return true;
            }
            if (e instanceof Se) {
                var o;
                do {
                    o = A(++u);
                } while (I[o]);
                e.mangled_name = o;
                return true;
            }
        });
        this.walk(c);
        a.forEach(l);
        function l(e) {
            if (s.reserved.has[e.name]) return;
            e.mangle(s);
        }
        function p(n) {
            var e = n.orig[0];
            var t = n.redefined();
            if (!t) {
                if (!(e instanceof qr)) return false;
                var r = n.scope.resolve();
                if (n.scope === r) return false;
                if (n.scope.parent_scope.find_variable(e.name)) return false;
                t = r.def_variable(e);
                r.to_mangle.push(t);
            }
            a.push(n);
            n.references.forEach(i);
            if (e instanceof Pr || e instanceof qr) {
                i(e);
                n.redefined = function() {
                    return t;
                };
            }
            return true;
            function i(e) {
                e.thedef = t;
                e.reference(s);
                e.thedef = n;
            }
        }
        function d(e) {
            var n = 0, t;
            while (t = e.parent(n++)) {
                if (t instanceof ft) return t instanceof bt && !s.toplevel;
                if (t instanceof ut) return true;
            }
        }
    });
    bt.DEFMETHOD("find_colliding_names", function(t) {
        var r = t.cache && t.cache.props;
        var n = Object.create(I);
        t.reserved.forEach(i);
        this.globals.each(a);
        this.walk(new Ln(function(e) {
            if (e instanceof ot) e.variables.each(a);
        }));
        return n;
        function i(e) {
            n[e] = true;
        }
        function a(e) {
            var n = e.name;
            if (e.global && r && r.has(n)) n = r.get(n); else if (!e.unmangleable(t)) return;
            i(n);
        }
    });
    bt.DEFMETHOD("expand_names", function(r) {
        A.reset();
        A.sort();
        r = T(r);
        var n = this.find_colliding_names(r);
        var t = 0;
        this.globals.each(a);
        this.walk(new Ln(function(e) {
            if (e instanceof ot) e.variables.each(a);
        }));
        function i() {
            var e;
            do {
                e = A(t++);
            } while (n[e]);
            return e;
        }
        function a(n) {
            if (n.global && r.cache) return;
            if (n.unmangleable(r)) return;
            if (r.reserved.has[n.name]) return;
            var e = n.redefined();
            var t = e ? e.rename || e.name : i();
            n.rename = t;
            n.forEach(function(e) {
                if (e.definition() === n) e.name = t;
            });
        }
    });
    vn.DEFMETHOD("tail_node", Gn);
    Tn.DEFMETHOD("tail_node", function() {
        return this.expressions[this.expressions.length - 1];
    });
    bt.DEFMETHOD("compute_char_frequency", function(e) {
        e = T(e);
        A.reset();
        var n = Ar.prototype.add_source_map;
        try {
            Ar.prototype.add_source_map = function() {
                if (!this.unmangleable(e)) A.consider(this.name, -1);
            };
            if (e.properties) {
                Dn.prototype.add_source_map = function() {
                    A.consider(this.property, -1);
                };
                qn.prototype.add_source_map = function() {
                    t(this.property);
                };
            }
            A.consider(this.print_to_string(), 1);
        } finally {
            Ar.prototype.add_source_map = n;
            delete Dn.prototype.add_source_map;
            delete qn.prototype.add_source_map;
        }
        A.sort();
        function t(e) {
            if (e instanceof Rn) {
                A.consider(e.value, -1);
            } else if (e instanceof Mn) {
                t(e.consequent);
                t(e.alternative);
            } else if (e instanceof Tn) {
                t(e.tail_node());
            }
        }
    });
    var A = function() {
        var i = Object.create(null);
        function e(e) {
            var n = [];
            for (var t = 0; t < e.length; t++) {
                var r = e[t];
                n.push(r);
                i[r] = -.01 * t;
            }
            return n;
        }
        var n = e("0123456789");
        var t = e("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_");
        var r, a;
        function o() {
            r = null;
            a = Object.create(i);
        }
        f.consider = function(e, n) {
            for (var t = e.length; --t >= 0; ) {
                a[e[t]] += n;
            }
        };
        function s(e, n) {
            return a[n] - a[e];
        }
        f.sort = function() {
            r = t.sort(s).concat(n).sort(s);
        };
        f.reset = o;
        o();
        function f(e) {
            var n = t[e % 54];
            for (e = Math.floor(e / 54); --e >= 0; e >>= 6) {
                n += r[e & 63];
            }
            return n;
        }
        return f;
    }();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function ui(e, n) {
        if (!(this instanceof ui)) return new ui(e, n);
        Zr.call(this, this.before, this.after);
        this.options = we(e, {
            annotations: !n,
            arguments: !n,
            arrows: !n,
            assignments: !n,
            awaits: !n,
            booleans: !n,
            collapse_vars: !n,
            comparisons: !n,
            conditionals: !n,
            dead_code: !n,
            default_values: !n,
            directives: !n,
            drop_console: false,
            drop_debugger: !n,
            evaluate: !n,
            expression: false,
            functions: !n,
            global_defs: false,
            hoist_exports: !n,
            hoist_funs: false,
            hoist_props: !n,
            hoist_vars: false,
            ie: false,
            if_return: !n,
            imports: !n,
            inline: !n,
            join_vars: !n,
            keep_fargs: n,
            keep_fnames: false,
            keep_infinity: false,
            loops: !n,
            merge_vars: !n,
            module: false,
            negate_iife: !n,
            objects: !n,
            optional_chains: !n,
            passes: 1,
            properties: !n,
            pure_funcs: null,
            pure_getters: !n && "strict",
            reduce_funcs: !n,
            reduce_vars: !n,
            rests: !n,
            sequences: !n,
            side_effects: !n,
            spreads: !n,
            strings: !n,
            switches: !n,
            templates: !n,
            top_retain: null,
            toplevel: !!(e && (e["module"] || e["top_retain"])),
            typeofs: !n,
            unsafe: false,
            unsafe_comps: false,
            unsafe_Function: false,
            unsafe_math: false,
            unsafe_proto: false,
            unsafe_regexp: false,
            unsafe_undefined: false,
            unused: !n,
            varify: !n,
            webkit: false,
            yields: !n
        }, true);
        var t = this.options["evaluate"];
        this.eval_threshold = /eager/.test(t) ? 1 / 0 : +t;
        var r = this.options["global_defs"];
        if (typeof r == "object") for (var i in r) {
            if (/^@/.test(i) && et(r, i)) {
                r[i.slice(1)] = ai(r[i], {
                    expression: true
                });
            }
        }
        if (this.options["inline"] === true) this.options["inline"] = 4;
        this.drop_fargs = this.options["keep_fargs"] ? cn : function(e, n) {
            if (e.length_read) return false;
            var t = e.name;
            if (!t) return n && n.TYPE == "Call" && n.expression === e;
            if (t.fixed_value() !== e) return false;
            var r = t.definition();
            if (r.direct_access) return false;
            var i = r.escaped;
            return i && i.depth != 1;
        };
        if (this.options["module"]) this.directives["use strict"] = true;
        var a = this.options["pure_funcs"];
        if (typeof a == "function") {
            this.pure_funcs = a;
        } else if (typeof a == "string") {
            this.pure_funcs = function(e) {
                var n;
                if (e instanceof Sn) {
                    n = e.expression;
                } else if (e instanceof Rr) {
                    n = e.tag;
                }
                return !(n && a === n.print_to_string());
            };
        } else if (Array.isArray(a)) {
            this.pure_funcs = function(e) {
                var n;
                if (e instanceof Sn) {
                    n = e.expression;
                } else if (e instanceof Rr) {
                    n = e.tag;
                }
                return !(n && Un(n.print_to_string(), a));
            };
        } else {
            this.pure_funcs = ln;
        }
        var o = this.options["sequences"];
        this.sequences_limit = o == 1 ? 800 : o | 0;
        var s = this.options["top_retain"];
        if (s instanceof RegExp) {
            this.top_retain = function(e) {
                return s.test(e.name);
            };
        } else if (typeof s == "function") {
            this.top_retain = s;
        } else if (s) {
            if (typeof s == "string") {
                s = s.split(/,/);
            }
            this.top_retain = function(e) {
                return Un(e.name, s);
            };
        }
        var f = this.options["toplevel"];
        this.toplevel = typeof f == "string" ? {
            funcs: /funcs/.test(f),
            vars: /vars/.test(f)
        } : {
            funcs: f,
            vars: f
        };
    }
    ui.prototype = new Zr(function(e, n, t) {
        if (e._squeezed) return e;
        var r = e instanceof bn;
        if (r) {
            e.hoist_properties(this);
            e.hoist_declarations(this);
            e.process_returns(this);
        }
        n(e, this);
        n(e, this);
        var i = e.optimize(this);
        if (r && i === e && !this.has_directive("use asm") && !i.pinned()) {
            i.drop_unused(this);
            if (i.merge_variables(this)) i.drop_unused(this);
            n(i, this);
        }
        if (i === e) i._squeezed = true;
        return i;
    });
    ui.prototype.option = function(e) {
        return this.options[e];
    };
    ui.prototype.exposed = function(e) {
        if (e.exported) return true;
        if (e.undeclared) return true;
        if (!(e.global || e.scope.resolve() instanceof bt)) return false;
        var n = this.toplevel;
        return !dn(e.orig, function(e) {
            return n[e instanceof Cr ? "funcs" : "vars"];
        });
    };
    ui.prototype.compress = function(e) {
        e = e.resolve_defines(this);
        e.hoist_exports(this);
        if (this.option("expression")) e.process_expression(true);
        var n = this.options.merge_vars;
        var t = +this.options.passes || 1;
        var r = 1 / 0;
        var i = false;
        var a = {
            ie: this.option("ie")
        };
        for (var o = 0; o < t; o++) {
            e.figure_out_scope(a);
            if (o > 0 || this.option("reduce_vars")) e.reset_opt_flags(this);
            this.options.merge_vars = n && (i || o == t - 1);
            e = e.transform(this);
            if (t > 1) {
                var s = 0;
                e.walk(new Ln(function() {
                    s++;
                }));
                vn.info("pass {pass}: last_count: {min_count}, count: {count}", {
                    pass: o,
                    min_count: r,
                    count: s
                });
                if (s < r) {
                    r = s;
                    i = false;
                } else if (i) {
                    break;
                } else {
                    i = true;
                }
            }
        }
        if (this.option("expression")) e.process_expression(false);
        return e;
    };
    (function(e) {
        e(vn, function(e, n) {
            return e;
        });
        bt.DEFMETHOD("hoist_exports", function(e) {
            if (!e.option("hoist_exports")) return;
            var n = this.body, t = [];
            for (var r = 0; r < n.length; r++) {
                var i = n[r];
                if (i instanceof cr) {
                    n[r] = i = i.body;
                    if (i instanceof or) {
                        i.definitions.forEach(function(e) {
                            e.name.match_symbol(a, true);
                        });
                    } else {
                        a(i.name);
                    }
                } else if (i instanceof pr) {
                    n.splice(r--, 1);
                    [].push.apply(t, i.properties);
                }
            }
            if (t.length) n.push(Fe(pr, this, {
                properties: t
            }));
            function a(e) {
                if (!(e instanceof Dr)) return;
                var n = Fe(jr, e);
                n.alias = Fe(Rn, n, {
                    value: n.name
                });
                t.push(n);
            }
        });
        bn.DEFMETHOD("process_expression", function(i, a) {
            var o = this;
            var s = new Zr(function(e) {
                if (i) {
                    if (e instanceof it) e = Fe(_n, e, {
                        body: Fe(Rn, e)
                    });
                    if (e instanceof _n) {
                        return a ? a(e) : Fe(wn, e, {
                            value: e.body
                        });
                    }
                } else if (e instanceof wn) {
                    if (a) return a(e);
                    var n = e.value;
                    if (n instanceof Rn) return Fe(it, n);
                    return Fe(_n, e, {
                        body: n || Fe(zn, e, {
                            operator: "void",
                            expression: Fe(Bn, e, {
                                value: 0
                            })
                        })
                    });
                }
                if (e instanceof ft) {
                    if (e instanceof yn) {
                        if (e !== o) return e;
                    } else if (i === "awaits" && e instanceof rr) {
                        if (e.bfinally) return e;
                    }
                    for (var t = e.body.length; --t >= 0; ) {
                        var r = e.body[t];
                        if (!Y(r, true)) {
                            e.body[t] = r.transform(s);
                            break;
                        }
                    }
                } else if (e instanceof xn) {
                    e.body = e.body.transform(s);
                    if (e.alternative) e.alternative = e.alternative.transform(s);
                } else if (e instanceof gt) {
                    e.body = e.body.transform(s);
                }
                return e;
            });
            o.transform(s);
        });
        bt.DEFMETHOD("unwrap_expression", function() {
            var e = this;
            switch (e.body.length) {
              case 0:
                return Fe(zn, e, {
                    operator: "void",
                    expression: Fe(Bn, e, {
                        value: 0
                    })
                });

              case 1:
                var n = e.body[0];
                if (n instanceof it) return Fe(Rn, n);
                if (n instanceof _n) return n.body;

              default:
                return Fe(Sn, e, {
                    expression: Fe($t, e, {
                        argnames: [],
                        body: e.body
                    }).init_vars(e),
                    args: []
                });
            }
            return e;
        });
        vn.DEFMETHOD("wrap_expression", function() {
            var e = this;
            if (!at(e)) e = Fe(_n, e, {
                body: e
            });
            if (!(e instanceof bt)) e = Fe(bt, e, {
                body: [ e ]
            });
            return e;
        });
        function M(e, n) {
            var t = n.get_property();
            if (t instanceof vn) return;
            var r;
            if (e instanceof Pn) {
                var i = e.elements;
                if (t == "length") return fe(i.length, e);
                if (typeof t == "number" && t in i) r = i[t];
            } else if (e instanceof yn) {
                if (t == "length") {
                    e.length_read = true;
                    return fe(e.argnames.length, e);
                }
            } else if (e instanceof Nn) {
                t = "" + t;
                var a = e.properties;
                for (var o = a.length; --o >= 0; ) {
                    var s = a[o];
                    if (!on(s)) return;
                    if (!r && a[o].key === t) r = a[o].value;
                }
            }
            return r instanceof Hn && r.fixed_value() || r;
        }
        function l(e, n) {
            if (e instanceof Xr) return b.Boolean[n];
            if (e instanceof Bn) return b.Number[n];
            if (e instanceof Rn) return b.String[n];
            if (n == "valueOf") return false;
            if (e instanceof Pn) return b.Array[n];
            if (e instanceof yn) return b.Function[n];
            if (e instanceof Nn) return b.Object[n];
            if (e instanceof Lr) return b.RegExp[n] && !e.value.global;
        }
        function $e(e, n, t, r, i, a, o) {
            var s = n.parent(i);
            if (e.option("unsafe") && s instanceof Dn && l(r, s.property)) {
                return;
            }
            var f = fi(t, s);
            if (f) return f;
            if (i == 0 && r && r.is_constant()) return;
            if (s instanceof Pn) return $e(e, n, s, s, i + 1);
            if (s instanceof Fn) switch (s.operator) {
              case "=":
                return $e(e, n, s, r, i + 1, a, o);

              case "&&=":
              case "||=":
              case "??=":
                return $e(e, n, s, s, i + 1);

              default:
                return;
            }
            if (s instanceof Cn) {
                if (!He[s.operator]) return;
                return $e(e, n, s, s, i + 1);
            }
            if (s instanceof Sn) {
                return !a && s.expression === t && !s.is_expr_pure(e) && (!(r instanceof xt) || !(s instanceof hr) && r.contains_this());
            }
            if (s instanceof Mn) {
                if (s.condition === t) return;
                return $e(e, n, s, s, i + 1);
            }
            if (s instanceof vt) return s.init === t;
            if (s instanceof kr) {
                if (s.value !== t) return;
                var u = n.parent(i + 1);
                return $e(e, n, u, u, i + 2);
            }
            if (s instanceof An) {
                if (s.expression !== t) return;
                var c = M(r, s);
                return (!a || o) && $e(e, n, s, c, i + 1);
            }
            if (s instanceof Tn) {
                if (s.tail_node() !== t) return;
                return $e(e, n, s, r, i + 1, a, o);
            }
        }
        function O(e) {
            return e instanceof Nt || e instanceof yn;
        }
        function Be(e) {
            return e instanceof Nt || e instanceof Pt || e instanceof $t;
        }
        function ze(e) {
            return e.name == "arguments" && e.scope.uses_arguments;
        }
        function ne(e, n) {
            do {
                if (e === n) return false;
                if (n instanceof bn) return true;
            } while (n = n.parent_scope);
        }
        function Ce(e, n, t) {
            var r = e.redef || e.definition();
            if (e.in_arg && oi(r)) return false;
            return dn(r.orig, function(e) {
                if (e instanceof qr || e instanceof $r) {
                    if (e instanceof Or) return true;
                    return n && Q(n, e);
                }
                return !(t && e instanceof Mr);
            });
        }
        function Le(e, n, t, r) {
            if (r instanceof Fn) return r.operator == "=" && r.right === t;
            if (r instanceof Sn) return r.expression !== t || r instanceof hr;
            if (r instanceof Gt) return r.value === t && n.resolve() !== e.scope.resolve();
            if (r instanceof kn) return r.value === t;
        }
        var F = /^(0|[1-9][0-9]*)$/;
        (function(e) {
            e(vn, Wn);
            function a(e, n, t) {
                t.assignments = 0;
                t.bool_return = 0;
                t.drop_return = 0;
                t.cross_loop = false;
                t.direct_access = false;
                t.escaped = [];
                t.fixed = !t.const_redefs && !t.scope.pinned() && !n.exposed(t) && !(t.init instanceof xt && t.init !== t.scope) && t.init;
                t.reassigned = 0;
                t.recursive_refs = 0;
                t.references = [];
                t.single_use = undefined;
            }
            function s(n, t, e) {
                e.variables.each(function(e) {
                    a(n, t, e);
                });
            }
            function p(t, r, i) {
                i.fn_defs = [];
                i.variables.each(function(e) {
                    a(t, r, e);
                    var n = e.init;
                    if (n instanceof Ct) {
                        i.fn_defs.push(n);
                        n.safe_ids = null;
                    }
                    if (e.fixed === null) {
                        e.safe_ids = t.safe_ids;
                        _(t, e);
                    } else if (e.fixed) {
                        t.loop_ids[e.id] = t.in_loop;
                        _(t, e);
                    }
                });
                i.may_call_this = function() {
                    i.may_call_this = i.contains_this() ? ln : cn;
                };
                if (i.uses_arguments) i.each_argname(function(e) {
                    e.definition().last_ref = false;
                });
                if (r.option("ie")) i.variables.each(function(e) {
                    var n = e.orig[0].definition();
                    if (n !== e) n.fixed = false;
                });
            }
            function o(e, n) {
                var t = n.safe_ids;
                return t === undefined || t === e.safe_ids;
            }
            function f(e, n) {
                var t = e.fn_scanning;
                e.fn_scanning = n;
                n.walk(e);
                e.fn_scanning = t;
            }
            function u(t, r) {
                r.enclosed.forEach(function(e) {
                    if (r.variables.get(e.name) === e) return;
                    if (b(t, e)) return;
                    e.single_use = false;
                    var n = e.fixed;
                    if (typeof n == "function") n = n();
                    if (n instanceof yn && n.safe_ids !== undefined) return;
                    e.fixed = false;
                });
            }
            function h(e, n, t) {
                var r = t.safe_ids;
                if (r === undefined) return;
                if (r === false) return;
                if (t.parent_scope.resolve().may_call_this === ln) {
                    if (Un(t, e.fn_visited)) u(e, t);
                } else if (r) {
                    var i = Un(t, e.fn_visited);
                    if (r === e.safe_ids) {
                        if (!i) f(e, t);
                    } else if (i) {
                        u(e, t);
                    } else {
                        t.safe_ids = false;
                    }
                } else if (e.fn_scanning && e.fn_scanning !== n.scope.resolve()) {
                    t.safe_ids = false;
                } else {
                    t.safe_ids = e.safe_ids;
                    f(e, t);
                }
            }
            function d(n, e) {
                var t = e.fn_defs;
                var r = e.may_call_this === ln ? t : t.filter(function(e) {
                    if (e.safe_ids === false) return true;
                    e.safe_ids = n.safe_ids;
                    f(n, e);
                    return false;
                });
                m(n);
                r.forEach(function(e) {
                    e.safe_ids = n.safe_ids;
                    f(n, e);
                });
                t.forEach(function(e) {
                    e.safe_ids = undefined;
                });
                e.fn_defs = undefined;
                e.may_call_this = undefined;
            }
            function v(e) {
                e.safe_ids = Object.create(e.safe_ids);
            }
            function m(e) {
                e.safe_ids = Object.getPrototypeOf(e.safe_ids);
            }
            function _(e, n) {
                e.safe_ids[n.id] = {};
            }
            function g(e, n) {
                e.references.push(n);
                if (e.last_ref !== false) e.last_ref = n;
            }
            function b(e, n) {
                if (n.single_use == "m") return false;
                var t = e.safe_ids[n.id];
                if (t) {
                    var r = et(e.safe_ids, n.id);
                    if (!r) t.read = t.read && t.read !== e.safe_ids ? true : e.safe_ids;
                    if (n.fixed == null) {
                        if (ze(n)) return false;
                        if (n.global && n.name == "arguments") return false;
                        e.loop_ids[n.id] = null;
                        n.fixed = Fe(Wr, n.orig[0]);
                        if (r) n.safe_ids = undefined;
                        return true;
                    }
                    return !t.assign || t.assign === e.safe_ids;
                }
                return n.fixed instanceof Ct;
            }
            function y(e, n, t) {
                if (!t) {
                    if (oi(n) && n.scope.uses_arguments && !e.has_directive("use strict")) return false;
                    if (!dn(n.orig, function(e) {
                        return !(e instanceof qr);
                    })) return false;
                }
                if (n.fixed === undefined) return t || dn(n.orig, function(e) {
                    return !(e instanceof $r);
                });
                if (n.fixed === false || n.fixed === 0) return false;
                var r = e.safe_ids[n.id];
                if (n.safe_ids) {
                    n.safe_ids[n.id] = false;
                    n.safe_ids = undefined;
                    return n.fixed === null || et(e.safe_ids, n.id) && !r.read;
                }
                if (!et(e.safe_ids, n.id)) {
                    if (!r) return false;
                    if (r.read || e.in_loop) {
                        var i = e.find_parent(ot);
                        if (i instanceof Nt) return false;
                        if (n.scope.resolve() !== i.resolve()) return false;
                    }
                    r.assign = r.assign && r.assign !== e.safe_ids ? true : e.safe_ids;
                }
                if (n.fixed != null && r.read) {
                    if (r.read !== e.safe_ids) return false;
                    if (e.loop_ids[n.id] !== e.in_loop) return false;
                }
                return b(e, n) && dn(n.orig, function(e) {
                    return !(e instanceof Mr);
                });
            }
            function w(e, n) {
                var t = Fe(Hn, e);
                t.fixed = n || Fe(Wr, e);
                return t;
            }
            function x(t, r) {
                return function() {
                    var e = w(t, r);
                    var n = t.definition();
                    n.references.push(e);
                    n.replaced++;
                    return e;
                };
            }
            function c(e, n) {
                return e.option("unused") && !n.scope.pinned() && n.single_use !== false && n.references.length - n.recursive_refs == 1 && !(oi(n) && n.scope.uses_arguments);
            }
            function k(e) {
                if (!e) return false;
                if (e instanceof Fn) {
                    var n = e.operator;
                    return n == "=" ? k(e.right) : !He[n.slice(0, -1)];
                }
                if (e instanceof Tn) return k(e.tail_node());
                return e.is_constant() || O(e) || e instanceof Nr;
            }
            function l(e, n) {
                if (n instanceof Pn) return true;
                if (n instanceof Cn) return He[n.operator];
                if (n instanceof Mn) return n.condition !== e;
                if (n instanceof Tn) return n.tail_node() === e;
                if (n instanceof On) return true;
            }
            function E(e, n, t, r, i, a, o) {
                var s = e.parent(a);
                if (i && i.is_constant()) return;
                if (Le(n, t, r, s)) {
                    n.escaped.push(s);
                    if (o > 1 && !(i && i.is_constant_expression(t))) o = 1;
                    if (!n.escaped.depth || n.escaped.depth > o) n.escaped.depth = o;
                    if (n.scope.resolve() !== t.resolve()) n.escaped.cross_scope = true;
                    if (n.fixed) n.fixed.escaped = n.escaped;
                    return;
                } else if (l(r, s)) {
                    E(e, n, t, s, s, a + 1, o);
                } else if (s instanceof kr && s.value === r) {
                    var f = e.parent(a + 1);
                    E(e, n, t, f, f, a + 2, o);
                } else if (s instanceof An && s.expression === r) {
                    i = M(i, s);
                    E(e, n, t, s, i, a + 1, o + 1);
                    if (i) return;
                }
                if (a > 0) return;
                if (s instanceof Sn && s.expression === r) return;
                if (s instanceof Tn && s.tail_node() !== r) return;
                if (s instanceof _n) return;
                if (s instanceof $n && !si[s.operator]) return;
                n.direct_access = true;
                if (n.fixed) n.fixed.direct_access = true;
            }
            function S(e) {
                if (!(e instanceof qn)) return;
                var n = e.expression;
                if (!(n instanceof Hn)) return;
                var t = n.definition();
                if (!ze(t)) return;
                var r = e.property;
                if (r.is_constant()) r = r.value;
                if (!(r instanceof vn) && !F.test(r)) return;
                t.reassigned++;
                (r instanceof vn ? t.scope.argnames : [ t.scope.argnames[r] ]).forEach(function(e) {
                    if (e instanceof In) e.definition().fixed = false;
                });
            }
            function T(n, t) {
                var r, i;
                return function() {
                    var e = n();
                    if (r !== e) {
                        r = e;
                        i = t(e);
                    }
                    return i;
                };
            }
            function A(t, r, i) {
                var a, o;
                return function() {
                    if (o === r) return r;
                    var e = i();
                    var n = C(t, e, true);
                    if (n instanceof vn) {
                        o = r;
                    } else if (a !== e) {
                        a = e;
                        o = n === undefined ? Pe(r, [ e, r.value ]) : e;
                    }
                    return o;
                };
            }
            function D(a, n, e, o, t) {
                var s = new Ln(function(r) {
                    if (r instanceof En) {
                        $(r);
                        v(a);
                        r.value.walk(a);
                        m(a);
                        var e = o;
                        if (e) o = A(n, r, e);
                        r.name.walk(s);
                        o = e;
                        return true;
                    }
                    if (r instanceof br) {
                        $(r);
                        var e = o;
                        r.elements.forEach(function(n, t) {
                            if (n instanceof Gr) return $(n);
                            if (e) o = T(e, function(e) {
                                return Fe(qn, n, {
                                    expression: e,
                                    property: Fe(Bn, n, {
                                        value: t
                                    })
                                });
                            });
                            n.walk(s);
                        });
                        if (r.rest) {
                            var i;
                            if (e) o = n.option("rests") && T(e, function(e) {
                                if (!(e instanceof Pn)) return r;
                                for (var n = 0, t = r.elements.length; n < t; n++) {
                                    if (e.elements[n] instanceof On) return r;
                                }
                                if (!i) i = Fe(Pn, r, {});
                                i.elements = e.elements.slice(t);
                                return i;
                            });
                            r.rest.walk(s);
                        }
                        o = e;
                        return true;
                    }
                    if (r instanceof wr) {
                        $(r);
                        var e = o;
                        r.properties.forEach(function(r) {
                            $(r);
                            if (r.key instanceof vn) {
                                v(a);
                                r.key.walk(a);
                                m(a);
                            }
                            if (e) o = T(e, function(e) {
                                var n = r.key;
                                var t = qn;
                                if (typeof n == "string") {
                                    if (ei(n)) {
                                        t = Dn;
                                    } else {
                                        n = fe(n, r);
                                    }
                                }
                                return Fe(t, r, {
                                    expression: e,
                                    property: n
                                });
                            });
                            r.value.walk(s);
                        });
                        if (r.rest) {
                            o = false;
                            r.rest.walk(s);
                        }
                        o = e;
                        return true;
                    }
                    t(r, o, function() {
                        var e = a.stack.length;
                        for (var n = 0, t = s.stack.length - 1; n < t; n++) {
                            a.stack.push(s.stack[n]);
                        }
                        r.walk(a);
                        a.stack.length = e;
                    });
                    return true;
                });
                e.walk(s);
            }
            function q(i, e, n) {
                var a = this;
                a.inlined = false;
                var o = i.parent();
                var t = Et(a) || St(a);
                var r = false;
                a.walk(new Ln(function(e) {
                    if (t) return r = true;
                    if (e instanceof wn) return t = true;
                    if (e instanceof bn && e !== a) return true;
                }));
                if (r) v(i);
                p(i, n, a);
                var s = !a.uses_arguments || i.has_directive("use strict");
                a.argnames.forEach(function(t, e) {
                    var r = o.args[e];
                    D(i, n, t, function() {
                        var e = a.argnames.indexOf(t);
                        var n = e < 0 ? r : o.args[e];
                        if (n instanceof Tn && n.expressions.length < 2) n = n.expressions[0];
                        return n || Fe(Wr, o);
                    }, l);
                });
                var f = a.rest, u;
                if (f) D(i, n, f, n.option("rests") && function() {
                    if (a.rest !== f) return f;
                    if (!u) u = Fe(Pn, a, {});
                    u.elements = o.args.slice(a.argnames.length);
                    return u;
                }, l);
                Tt(a, i);
                var c = i.safe_ids;
                d(i, a);
                if (!r) i.safe_ids = c;
                return true;
                function l(e, n) {
                    var t = e.definition();
                    if (n && s && t.fixed === undefined) {
                        _(i, t);
                        i.loop_ids[t.id] = i.in_loop;
                        t.fixed = n;
                        t.fixed.assigns = [ e ];
                    } else {
                        t.fixed = false;
                    }
                }
            }
            e(Fn, function(a, e, n) {
                var o = this;
                var s = o.left;
                var f = o.right;
                var t = s instanceof Hn && s.definition();
                var r = t || s instanceof jn;
                switch (o.operator) {
                  case "=":
                    if (s.equals(f) && !s.has_side_effects(n)) {
                        f.walk(a);
                        l(s);
                        o.redundant = true;
                        return true;
                    }
                    if (t && f instanceof xt) {
                        p();
                        f.parent_scope.resolve().fn_defs.push(f);
                        f.safe_ids = null;
                        if (!t.fixed || !o.write_only) h(a, t, f);
                        return true;
                    }
                    if (r) {
                        f.walk(a);
                        p();
                        return true;
                    }
                    S(s);
                    return;

                  case "&&=":
                  case "||=":
                  case "??=":
                    var i = true;

                  default:
                    if (!r) {
                        S(s);
                        return d();
                    }
                    t.assignments++;
                    var u = t.fixed;
                    if ($e(n, a, o, o, 0)) {
                        t.fixed = false;
                        return d();
                    }
                    var c = b(a, t);
                    if (i) v(a);
                    f.walk(a);
                    if (i) m(a);
                    if (c && !s.in_arg && y(a, t)) {
                        g(t, s);
                        _(a, t);
                        if (t.single_use) t.single_use = false;
                        s.fixed = t.fixed = function() {
                            return Fe(Cn, o, {
                                operator: o.operator.slice(0, -1),
                                left: w(s, u),
                                right: o.right
                            });
                        };
                        s.fixed.assigns = !u || !u.assigns ? [ t.orig[0] ] : u.assigns.slice();
                        s.fixed.assigns.push(o);
                        s.fixed.to_binary = x(s, u);
                    } else {
                        s.walk(a);
                        t.fixed = false;
                    }
                    return true;
                }
                function l(e) {
                    if (e instanceof Dn) {
                        l(e.expression);
                    } else if (e instanceof qn) {
                        l(e.expression);
                        e.property.walk(a);
                    } else if (e instanceof Hn) {
                        var n = e.definition();
                        g(n, e);
                        if (n.fixed) {
                            e.fixed = n.fixed;
                            if (e.fixed.assigns) {
                                e.fixed.assigns.push(o);
                            } else {
                                e.fixed.assigns = [ o ];
                            }
                        }
                    } else {
                        e.walk(a);
                    }
                }
                function p() {
                    var e = t && Qe(a, t);
                    var i = $e(n, a, o, f, 0, k(f), e);
                    D(a, n, s, function() {
                        return o.right;
                    }, function(e, n, t) {
                        if (!(e instanceof Hn)) {
                            S(e);
                            t();
                            return;
                        }
                        var r = e.definition();
                        r.assignments++;
                        if (!n || e.in_arg || !y(a, r)) {
                            t();
                            r.fixed = false;
                        } else if (i) {
                            t();
                            r.fixed = 0;
                        } else {
                            g(r, e);
                            _(a, r);
                            if (s instanceof jn || r.orig.length == 1 && r.orig[0] instanceof Cr) {
                                r.single_use = false;
                            }
                            a.loop_ids[r.id] = a.in_loop;
                            e.fixed = r.fixed = n;
                            e.fixed.assigns = [ o ];
                            E(a, r, e.scope, o, f, 0, 1);
                        }
                    });
                }
                function d() {
                    if (!i) return;
                    s.walk(a);
                    v(a);
                    f.walk(a);
                    m(a);
                    return true;
                }
            });
            e(Cn, function(e) {
                if (!He[this.operator]) return;
                this.left.walk(e);
                v(e);
                this.right.walk(e);
                m(e);
                return true;
            });
            e(ot, function(e, n, t) {
                s(e, t, this);
            });
            e(Sn, function(n, e) {
                var t = this;
                var r = t.expression;
                if (r instanceof xt) {
                    var i = We(t);
                    t.args.forEach(function(e) {
                        e.walk(n);
                        if (e instanceof On) i = false;
                    });
                    if (i) r.reduce_vars = q;
                    r.walk(n);
                    if (i) delete r.reduce_vars;
                    return true;
                }
                if (t.TYPE == "Call") switch (n.in_boolean_context()) {
                  case "d":
                    var a = true;

                  case true:
                    f(r, a);
                }
                r.walk(n);
                var o = t.optional;
                if (o) v(n);
                t.args.forEach(function(e) {
                    e.walk(n);
                });
                if (o) m(n);
                var s = r instanceof Hn && r.fixed_value();
                if (s instanceof yn) {
                    h(n, r.definition(), s);
                } else {
                    n.find_parent(bn).may_call_this();
                }
                return true;
                function f(e, n) {
                    if (e instanceof Fn) {
                        if (e.operator != "=") return;
                        f(e.left, n);
                        f(e.right, n);
                    } else if (e instanceof Cn) {
                        if (!He[e.operator]) return;
                        f(e.left, n);
                        f(e.right, n);
                    } else if (e instanceof Mn) {
                        f(e.consequent, n);
                        f(e.alternative, n);
                    } else if (e instanceof Hn) {
                        var t = e.definition();
                        t.bool_return++;
                        if (n) t.drop_return++;
                    }
                }
            });
            e(Nt, function(n, e, t) {
                var r = this;
                s(n, t, r);
                if (r.extends) r.extends.walk(n);
                var i = r.properties.filter(function(e) {
                    $(e);
                    if (e.key instanceof vn) e.key.walk(n);
                    return e.value;
                });
                if (r.name) {
                    var a = r.name.definition();
                    var o = n.parent();
                    if (o instanceof cr || o instanceof lr) a.single_use = false;
                    if (y(n, a, true)) {
                        _(n, a);
                        n.loop_ids[a.id] = n.in_loop;
                        a.fixed = function() {
                            return r;
                        };
                        a.fixed.assigns = [ r ];
                        if (!Ye(a)) a.single_use = false;
                    } else {
                        a.fixed = false;
                    }
                }
                i.forEach(function(e) {
                    if (!e.static || te(e) && e.value.contains_this()) {
                        v(n);
                        e.value.walk(n);
                        m(n);
                    } else {
                        e.value.walk(n);
                    }
                });
                return true;
            });
            e(yt, function(e, n, t) {
                var r = this;
                v(e);
                p(e, t, r);
                n();
                d(e, r);
                return true;
            });
            e(Mn, function(e) {
                this.condition.walk(e);
                v(e);
                this.consequent.walk(e);
                m(e);
                v(e);
                this.alternative.walk(e);
                m(e);
                return true;
            });
            e(En, function(e) {
                this.name.walk(e);
                v(e);
                this.value.walk(e);
                m(e);
                return true;
            });
            e(pt, function(e) {
                var n = e.in_loop;
                e.in_loop = this;
                v(e);
                this.body.walk(e);
                if (I(this, e.parent())) {
                    m(e);
                    v(e);
                }
                this.condition.walk(e);
                m(e);
                e.in_loop = n;
                return true;
            });
            e(ht, function(e, n, t) {
                var r = this;
                s(e, t, r);
                if (r.init) r.init.walk(e);
                var i = e.in_loop;
                e.in_loop = r;
                v(e);
                if (r.condition) r.condition.walk(e);
                r.body.walk(e);
                if (r.step) {
                    if (I(r, e.parent())) {
                        m(e);
                        v(e);
                    }
                    r.step.walk(e);
                }
                m(e);
                e.in_loop = i;
                return true;
            });
            e(vt, function(e, n, t) {
                var r = this;
                s(e, t, r);
                r.object.walk(e);
                var i = e.in_loop;
                e.in_loop = r;
                v(e);
                var a = r.init;
                if (a instanceof or) {
                    a.definitions[0].name.mark_symbol(function(e) {
                        if (e instanceof Dr) {
                            var n = e.definition();
                            n.assignments++;
                            n.fixed = false;
                        }
                    }, e);
                } else if (a instanceof jn || a instanceof Hn) {
                    a.mark_symbol(function(e) {
                        if (e instanceof Hn) {
                            var n = e.definition();
                            g(n, e);
                            n.assignments++;
                            if (!e.is_immutable()) n.fixed = false;
                        }
                    }, e);
                } else {
                    a.walk(e);
                }
                r.body.walk(e);
                m(e);
                e.in_loop = i;
                return true;
            });
            e(xn, function(e) {
                this.condition.walk(e);
                v(e);
                this.body.walk(e);
                m(e);
                if (this.alternative) {
                    v(e);
                    this.alternative.walk(e);
                    m(e);
                }
                return true;
            });
            e(ut, function(e) {
                v(e);
                this.body.walk(e);
                m(e);
                return true;
            });
            e(yn, function(e, n, t) {
                var r = this;
                if (!o(e, r)) return true;
                if (!Kn(e.fn_visited, r)) return true;
                r.inlined = false;
                v(e);
                p(e, t, r);
                n();
                d(e, r);
                if (r.name) E(e, r.name.definition(), r, r.name, r, 0, 1);
                return true;
            });
            e(Ct, function(e, n, t) {
                var r = this;
                var i = r.name.definition();
                var a = e.parent();
                if (a instanceof cr || a instanceof lr) i.single_use = false;
                if (!o(e, r)) return true;
                if (!Kn(e.fn_visited, r)) return true;
                r.inlined = false;
                v(e);
                p(e, t, r);
                n();
                d(e, r);
                return true;
            });
            e(qn, function(e) {
                if (!this.optional) return;
                this.expression.walk(e);
                v(e);
                this.property.walk(e);
                m(e);
                return true;
            });
            e(Zt, function(n, e, t) {
                var r = this;
                s(n, t, r);
                r.expression.walk(n);
                var i = true;
                r.body.forEach(function(e) {
                    if (e instanceof nr) return;
                    e.expression.walk(n);
                    if (i) {
                        i = false;
                        v(n);
                    }
                });
                if (!i) m(n);
                st(r, n);
                return true;
            });
            e(er, function(e) {
                v(e);
                st(this, e);
                m(e);
                return true;
            });
            e(Pr, function() {
                this.definition().fixed = false;
            });
            e(Or, function() {
                this.definition().fixed = false;
            });
            e(Hn, function(r, e, n) {
                var i = this.definition();
                g(i, this);
                if (i.references.length == 1 && !i.fixed && i.orig[0] instanceof Cr) {
                    r.loop_ids[i.id] = r.in_loop;
                }
                var a = Qe(r, i);
                if (a) a.enclosed.forEach(function(e) {
                    if (i === e) return;
                    if (e.scope.resolve() === a) return;
                    var n = e.fixed && e.fixed.assigns;
                    if (!n) return;
                    if (n[n.length - 1] instanceof kn) return;
                    var t = r.safe_ids[e.id];
                    if (!t) return;
                    t.assign = true;
                });
                if (i.fixed === false || i.fixed === 0) {
                    var t = i.redefined();
                    if (t && ne(i.scope, this.scope)) t.single_use = false;
                } else if (i.fixed === undefined || !b(r, i)) {
                    i.fixed = false;
                } else if (i.fixed) {
                    if (this.in_arg && i.orig[0] instanceof Mr) this.fixed = i.scope;
                    var o = this.fixed_value();
                    if (a) {
                        i.recursive_refs++;
                    } else if (o && c(n, i)) {
                        i.in_loop = r.loop_ids[i.id] !== r.in_loop;
                        i.single_use = O(o) && !o.pinned() && (!i.in_loop || r.parent() instanceof Sn) || !i.in_loop && i.scope === this.scope.resolve() && o.is_constant_expression();
                    } else {
                        i.single_use = false;
                    }
                    if ($e(n, r, this, o, 0, k(o), a)) {
                        if (i.single_use) {
                            i.single_use = "m";
                        } else {
                            i.fixed = 0;
                        }
                    }
                    if (i.fixed && r.loop_ids[i.id] !== r.in_loop) i.cross_loop = true;
                    E(r, i, this.scope, this, o, 0, 1);
                }
                if (!this.fixed) this.fixed = i.fixed;
                var s;
                if (o instanceof yn && !((s = r.parent()) instanceof Sn && s.expression === this)) {
                    h(r, i, o);
                }
            });
            e(Rr, function(n, e) {
                var t = this;
                var r = t.tag;
                if (!r) return;
                if (r instanceof xt) {
                    t.expressions.forEach(function(e) {
                        e.walk(n);
                    });
                    r.walk(n);
                    return true;
                }
                r.walk(n);
                t.expressions.forEach(function(e) {
                    e.walk(n);
                });
                var i = r instanceof Hn && r.fixed_value();
                if (i instanceof yn) {
                    h(n, r.definition(), i);
                } else {
                    n.find_parent(bn).may_call_this();
                }
                return true;
            });
            e(bt, function(n, e, t) {
                var r = this;
                r.globals.each(function(e) {
                    a(n, t, e);
                });
                v(n);
                p(n, t, r);
                e();
                d(n, r);
                return true;
            });
            e(rr, function(e, n, t) {
                var r = this;
                s(e, t, r);
                v(e);
                st(r, e);
                m(e);
                if (r.bcatch) {
                    v(e);
                    r.bcatch.walk(e);
                    m(e);
                }
                if (r.bfinally) r.bfinally.walk(e);
                return true;
            });
            e($n, function(e, n) {
                var t = this;
                if (!ri[t.operator]) return;
                var r = t.expression;
                if (!(r instanceof Hn)) {
                    S(r);
                    return;
                }
                var i = r.definition();
                i.assignments++;
                var a = i.fixed;
                if (b(e, i) && !r.in_arg && y(e, i)) {
                    g(i, r);
                    _(e, i);
                    if (i.single_use) i.single_use = false;
                    i.fixed = function() {
                        return Fe(Cn, t, {
                            operator: t.operator.slice(0, -1),
                            left: Fe(zn, t, {
                                operator: "+",
                                expression: w(r, a)
                            }),
                            right: Fe(Bn, t, {
                                value: 1
                            })
                        });
                    };
                    i.fixed.assigns = a && a.assigns ? a.assigns.slice() : [];
                    i.fixed.assigns.push(t);
                    if (t instanceof zn) {
                        r.fixed = i.fixed;
                    } else {
                        r.fixed = function() {
                            return Fe(zn, t, {
                                operator: "+",
                                expression: w(r, a)
                            });
                        };
                        r.fixed.assigns = a && a.assigns;
                        r.fixed.to_prefix = x(r, i.fixed);
                    }
                } else {
                    r.walk(e);
                    i.fixed = false;
                }
                return true;
            });
            e(kn, function(r, e, n) {
                var i = this;
                var t = i.value;
                if (t instanceof xt && i.name instanceof Dr) {
                    o();
                    t.parent_scope.resolve().fn_defs.push(t);
                    t.safe_ids = null;
                    var a = i.name.definition();
                    if (!a.fixed) h(r, a, t);
                } else if (t) {
                    t.walk(r);
                    o();
                } else if (r.parent() instanceof fr) {
                    o();
                }
                return true;
                function o() {
                    D(r, n, i.name, function() {
                        return i.value || Fe(Wr, i);
                    }, function(e, n) {
                        var t = e.definition();
                        if (n && y(r, t, true)) {
                            _(r, t);
                            r.loop_ids[t.id] = r.in_loop;
                            t.fixed = n;
                            t.fixed.assigns = [ i ];
                            if (e instanceof qr && t.redefined() || !(Ce(e) || Ye(t))) {
                                t.single_use = false;
                            }
                        } else {
                            t.fixed = false;
                        }
                    });
                }
            });
            e(dt, function(e, n) {
                var t = e.in_loop;
                e.in_loop = this;
                v(e);
                n();
                m(e);
                e.in_loop = t;
                return true;
            });
        })(function(e, n) {
            e.DEFMETHOD("reduce_vars", n);
        });
        function $(e) {
            e._squeezed = false;
            e._optimized = false;
            if (e instanceof ot) e._var_names = undefined;
            if (e instanceof Hn) e.fixed = undefined;
        }
        bt.DEFMETHOD("reset_opt_flags", function(t) {
            var r = new Ln(t.option("reduce_vars") ? function(e, n) {
                $(e);
                return e.reduce_vars(r, n, t);
            } : $);
            r.fn_scanning = null;
            r.fn_visited = [];
            r.in_loop = null;
            r.loop_ids = Object.create(null);
            r.safe_ids = Object.create(null);
            this.walk(r);
        });
        Ar.DEFMETHOD("fixed_value", function() {
            var e = this.definition().fixed;
            if (e) {
                if (this.fixed) e = this.fixed;
                return (e instanceof vn ? e : e()).tail_node();
            }
            e = e === 0 && this.fixed;
            if (!e) return e;
            var n = (e instanceof vn ? e : e()).tail_node();
            return n.is_constant() && n;
        });
        Hn.DEFMETHOD("is_immutable", function() {
            var e = this.redef || this.definition();
            if (!(e.orig[0] instanceof Mr)) return false;
            if (e.orig.length == 1) return true;
            if (!this.in_arg) return false;
            return !(e.orig[1] instanceof In);
        });
        vn.DEFMETHOD("convert_symbol", Wn);
        function t(t, r) {
            return this.transform(new Zr(function(e, n) {
                if (e instanceof En) {
                    e = e.clone();
                    e.name = e.name.transform(this);
                    return e;
                }
                if (e instanceof jn) {
                    e = e.clone();
                    n(e, this);
                    return e;
                }
                if (e instanceof yr) {
                    e = e.clone();
                    e.value = e.value.transform(this);
                    return e;
                }
                return e.convert_symbol(t, r);
            }));
        }
        En.DEFMETHOD("convert_symbol", t);
        jn.DEFMETHOD("convert_symbol", t);
        function r(e, n) {
            var t = Fe(e, this);
            return n(t, this) || t;
        }
        Dr.DEFMETHOD("convert_symbol", r);
        Hn.DEFMETHOD("convert_symbol", r);
        function P(e) {
            var n = e.definition();
            n.assignments++;
            n.references.push(e);
        }
        function i(n, t) {
            var r = new Ln(function(e) {
                if (e instanceof En) {
                    e.value.walk(t);
                    e.name.walk(r);
                    return true;
                }
                if (e instanceof yr) {
                    if (e.key instanceof vn) e.key.walk(t);
                    e.value.walk(r);
                    return true;
                }
                return n(e);
            });
            this.walk(r);
        }
        En.DEFMETHOD("mark_symbol", i);
        jn.DEFMETHOD("mark_symbol", i);
        function a(e) {
            return e(this);
        }
        Dr.DEFMETHOD("mark_symbol", a);
        Hn.DEFMETHOD("mark_symbol", a);
        vn.DEFMETHOD("match_symbol", function(e) {
            return e(this);
        });
        function o(n, t) {
            var r = false;
            var i = new Ln(function(e) {
                if (r) return true;
                if (e instanceof En) {
                    if (!t) return r = true;
                    e.name.walk(i);
                    return true;
                }
                if (e instanceof yr) {
                    if (!t && e.key instanceof vn) return r = true;
                    e.value.walk(i);
                    return true;
                }
                if (n(e)) return r = true;
            });
            this.walk(i);
            return r;
        }
        En.DEFMETHOD("match_symbol", o);
        jn.DEFMETHOD("match_symbol", o);
        function H(e) {
            return e instanceof Ft || e instanceof Ot;
        }
        function Me(e) {
            var n = 0, t;
            while (t = e.parent(n++)) {
                if (t.variables) return t;
            }
        }
        function Ue(e, n, t, r, i, a) {
            for (var o; o = e.parent(n++); t = o) {
                if (o === r) return false;
                if (a && o instanceof yn) {
                    if (o.name || Et(o) || St(o)) return true;
                } else if (o instanceof rr) {
                    if (o.bfinally && o.bfinally !== t) return true;
                    if (i && o.bcatch && o.bcatch !== t) return true;
                }
            }
            return false;
        }
        var _e = pn("Infinity NaN undefined");
        function Ve(e, n) {
            if (e instanceof Nr) return true;
            if (e instanceof An) {
                if (e.property === "__proto__") return true;
                e = e.expression;
                if (e instanceof Hn) {
                    if (e.is_immutable()) return false;
                    e = e.fixed_value();
                }
                if (!e) return true;
                if (e.tail_node().is_constant()) return true;
                return Ve(e, n);
            }
            if (e instanceof Hn) {
                if (e.is_immutable()) return true;
                var t = e.definition();
                return n.exposed(t) && _e[t.name];
            }
            return false;
        }
        function Fe(e, n, t) {
            if (t) {
                t.start = n.start;
                t.end = n.end;
            } else {
                t = n;
            }
            return new e(t);
        }
        function Pe(e, n) {
            if (n.length == 1) return n[0];
            return Fe(Tn, e, {
                expressions: n.reduce(k, [])
            });
        }
        function fe(e, n) {
            switch (typeof e) {
              case "string":
                return Fe(Rn, n, {
                    value: e
                });

              case "number":
                if (isNaN(e)) return Fe(Vr, n);
                if (isFinite(e)) {
                    return 1 / e < 0 ? Fe(zn, n, {
                        operator: "-",
                        expression: Fe(Bn, n, {
                            value: -e
                        })
                    }) : Fe(Bn, n, {
                        value: e
                    });
                }
                return e < 0 ? Fe(zn, n, {
                    operator: "-",
                    expression: Fe(Jr, n)
                }) : Fe(Jr, n);

              case "boolean":
                return Fe(e ? Qr : Kr, n);

              case "undefined":
                return Fe(Wr, n);

              default:
                if (e === null) {
                    return Fe(Ur, n);
                }
                if (e instanceof RegExp) {
                    return Fe(Lr, n, {
                        value: e
                    });
                }
                throw new Error(Qn("Can't handle constant of type: {type}", {
                    type: typeof e
                }));
            }
        }
        function ge(e) {
            return e instanceof An || Ne(e) && e.name == "eval";
        }
        function je(e, n, t) {
            var r = false;
            if (e.TYPE == "Call") {
                r = e.expression === n && ge(t);
            } else if (e instanceof Rr) {
                r = e.tag === n && ge(t);
            } else if (e instanceof zn) {
                r = e.operator == "delete" || e.operator == "typeof" && Ne(t);
            }
            return r ? Pe(n, [ Fe(Bn, n, {
                value: 0
            }), t ]) : t;
        }
        function k(e, n) {
            if (n instanceof Tn) {
                [].push.apply(e, n.expressions);
            } else {
                e.push(n);
            }
            return e;
        }
        function L(e) {
            return e instanceof sr || e instanceof It || e instanceof fr;
        }
        function S(e) {
            if (e instanceof Ct) {
                var n = e.name.definition();
                var t = e.name.scope;
                return n.scope === t || dn(n.references, function(e) {
                    var n = e.scope;
                    do {
                        if (n === t) return true;
                    } while (n = n.parent_scope);
                });
            }
            return !L(e);
        }
        function U(e) {
            if (e === null) return [];
            if (e instanceof gn) return dn(e.body, S) ? e.body : [ e ];
            if (e instanceof mn) return [];
            if (at(e)) return [ e ];
            throw new Error("Can't convert thing to statement array");
        }
        function ue(e) {
            if (e === null) return true;
            if (e instanceof mn) return true;
            if (e instanceof gn) return e.body.length == 0;
            return false;
        }
        function E(e) {
            return dn(e.body, function(e) {
                return ue(e) || e instanceof Pt || e instanceof ur && ce(e);
            });
        }
        function V(e) {
            if (e instanceof ct) {
                return e.body instanceof gn ? e.body : e;
            }
            return e;
        }
        function be(e) {
            if (e.TYPE != "Call") return false;
            do {
                e = e.expression;
            } while (e instanceof An);
            return e instanceof xt ? !kt(e) : be(e);
        }
        function We(e) {
            var n = e.expression;
            if (n.name) return false;
            if (!(e instanceof hr)) return true;
            var t = false;
            n.walk(new Ln(function(e) {
                if (t) return true;
                if (e instanceof Yr) return t = true;
                if (e instanceof bn && e !== n) return true;
            }));
            return !t;
        }
        function Ne(e) {
            return e instanceof Hn && e.definition().undeclared;
        }
        var Ge = pn("Array Boolean clearInterval clearTimeout console Date decodeURI decodeURIComponent encodeURI encodeURIComponent Error escape eval EvalError Function isFinite isNaN JSON Map Math Number parseFloat parseInt RangeError ReferenceError RegExp Object Set setInterval setTimeout String SyntaxError TypeError unescape URIError WeakMap WeakSet");
        Hn.DEFMETHOD("is_declared", function(e) {
            return this.defined || !this.definition().undeclared || e.option("unsafe") && Ge[this.name];
        });
        function te(e) {
            return e.static && e.value && (e instanceof Rt || e instanceof Vt);
        }
        function ce(e) {
            return dn(e.definitions, function(e) {
                return !e.value;
            });
        }
        function Y(e, n) {
            if (e instanceof It) return n && !e.extends && dn(e.properties, function(e) {
                if (e.key instanceof vn) return false;
                return !te(e);
            });
            if (e instanceof or) return (n || e instanceof ur) && ce(e);
            if (e instanceof cr) return Y(e.body, n);
            if (e instanceof lr) return Y(e.body, n);
            return e instanceof Ct;
        }
        function T(e, n) {
            var t = e.lastIndexOf(n);
            if (t < 0) return false;
            while (++t < e.length) {
                if (!Y(e[t], true)) return false;
            }
            return true;
        }
        function Je(e, n) {
            var t;
            if (e.init instanceof gn) {
                t = e.init;
                e.init = t.body.pop();
                t.body.push(e);
            }
            if (e.init instanceof Pt) {
                if (!t) t = Fe(gn, e, {
                    body: [ e ]
                });
                t.body.splice(-1, 0, e.init);
                e.init = null;
            } else if (e.init instanceof _n) {
                e.init = e.init.body;
            } else if (ue(e.init)) {
                e.init = null;
            }
            if (!t) return;
            return n ? Xn.splice(t.body) : t;
        }
        function c(e, s) {
            var N = I(s, function(e) {
                return e instanceof yn;
            });
            var Se, Te, Ae, De, qe, Oe;
            i();
            var n, t, r = 10;
            do {
                t = n;
                n = 0;
                if (o(e)) n = 1;
                if (!n && t == 1) break;
                if (s.option("dead_code")) {
                    if (u(e, s)) n = 2;
                    if (!n && t == 2) break;
                }
                if (s.option("if_return")) {
                    if (f(e, s)) n = 3;
                    if (!n && t == 3) break;
                }
                if (s.option("awaits") && s.option("side_effects")) {
                    if (c(e, s)) n = 4;
                    if (!n && t == 4) break;
                }
                if (s.option("inline") >= 4) {
                    if (l(e, s)) n = 5;
                    if (!n && t == 5) break;
                }
                if (s.sequences_limit > 0) {
                    if (p(e, s)) n = 6;
                    if (!n && t == 6) break;
                    if (h(e, s)) n = 7;
                    if (!n && t == 7) break;
                }
                if (s.option("join_vars")) {
                    if (w(e)) n = 8;
                    if (!n && t == 8) break;
                }
                if (s.option("collapse_vars")) {
                    if (a(e, s)) n = 9;
                }
            } while (n && r-- > 0);
            return e;
            function I(e, n) {
                var t = e.self(), r = 0, i;
                do {
                    if (t instanceof ir) {
                        t = e.parent(r++);
                    } else if (t instanceof ut) {
                        t = t.body;
                    } else if (t instanceof er) {
                        var a = e.parent(r);
                        if (a.body[a.body.length - 1] === t || o(t.body)) {
                            r++;
                            t = a;
                        }
                    }
                    do {
                        i = t;
                        if (n(i)) return i;
                        t = e.parent(r++);
                    } while (t instanceof xn);
                } while (i && (t instanceof gn || t instanceof ir || t instanceof bn || t instanceof er || t instanceof rr) && T(t.body, i));
                function o(e) {
                    for (var n = e.length; --n >= 0; ) {
                        if (e[n] instanceof Kt) return true;
                    }
                    return false;
                }
            }
            function i() {
                var e = s.self(), n = 0;
                do {
                    if (!Se && e.variables) Se = e;
                    if (e instanceof ir) {
                        if (s.parent(n).bfinally) {
                            if (!qe) qe = {};
                            qe.bfinally = true;
                        }
                        n++;
                    } else if (e instanceof ar) {
                        n++;
                    } else if (e instanceof ct) {
                        De = true;
                    } else if (e instanceof bn) {
                        Oe = e;
                        break;
                    } else if (e instanceof rr) {
                        if (!qe) qe = {};
                        if (e.bcatch) qe.bcatch = true;
                        if (e.bfinally) qe.bfinally = true;
                    }
                } while (e = s.parent(n++));
            }
            function a(i, d) {
                if (Oe.pinned()) return;
                var h;
                var j = new hn();
                var v = [];
                var N = false;
                var p = new hn();
                var I;
                var a = i.length;
                var m = new Zr(function(e, n) {
                    if (D) return e;
                    if (!A) {
                        if (e !== _[g]) return e;
                        g++;
                        if (g < _.length) return z(e, m);
                        A = true;
                        y = (b ? F : ie)(e, 0);
                        if (y === e) D = true;
                        return e;
                    }
                    var t = m.parent();
                    if (!w && ne(e, t)) {
                        w = t;
                    }
                    if (R && Y && O && !w && e instanceof Fn && e.operator != "=" && e.left.equals(x)) {
                        q++;
                        N = true;
                        vn.info("Cascading {this} [{start}]", e);
                        O = false;
                        S = _e(x);
                        e.right.transform(m);
                        he(f);
                        var r;
                        if (D) {
                            r = f;
                        } else {
                            D = true;
                            r = Fe(Cn, f, {
                                operator: R,
                                left: x.fixed && x.definition().fixed ? x.fixed.to_binary() : x,
                                right: T
                            });
                        }
                        return Fe(Fn, e, {
                            operator: "=",
                            left: e.left,
                            right: Fe(Cn, e, {
                                operator: e.operator.slice(0, -1),
                                left: r,
                                right: e.right
                            })
                        });
                    }
                    if (Z(e, t)) {
                        D = true;
                        return e;
                    }
                    if (e.single_use) return e;
                    var i;
                    if (!(e instanceof Dr) && (Y && x.equals(e) || E && (i = E(e, this)))) {
                        if (!O || w && (i || !J || !K)) {
                            if (!i && !b) D = true;
                            return e;
                        }
                        if (fi(e, t)) {
                            if (b && !i) c = true;
                            return e;
                        }
                        if (!i && H && e.fixed !== x.fixed) {
                            D = true;
                            return e;
                        }
                        if (b) {
                            if (w && u == 0) u = l - q;
                            if (!i) q++;
                            return e;
                        }
                        q++;
                        N = D = true;
                        vn.info("Collapsing {this} [{start}]", e);
                        if (f.TYPE == "Binary") {
                            ve(f, e);
                            return Fe(Fn, f, {
                                operator: "=",
                                left: f.right.left,
                                right: f.operator == "&&" ? Fe(Mn, f, {
                                    condition: f.left,
                                    consequent: f.right.right,
                                    alternative: e
                                }) : Fe(Mn, f, {
                                    condition: f.left,
                                    consequent: e,
                                    alternative: f.right.right
                                })
                            });
                        }
                        if (f instanceof mr) return Fe(zn, f, {
                            operator: f.operator,
                            expression: x.fixed && x.definition().fixed ? x.fixed.to_prefix() : x
                        });
                        if (f instanceof zn) {
                            he(f);
                            return f;
                        }
                        ve(T, e);
                        if (f instanceof kn) {
                            var a = f.name.definition();
                            if (a.references.length - a.replaced == 1 && !d.exposed(a)) {
                                a.replaced++;
                                return je(t, e, T);
                            }
                            return Fe(Fn, f, {
                                operator: "=",
                                left: e,
                                right: T
                            });
                        }
                        he(T);
                        var o = f.clone();
                        o.right = T;
                        return o;
                    }
                    if (ee(e, t)) {
                        D = true;
                        return e;
                    }
                    if (te(e, t) || L(e)) {
                        y = e;
                        if (e instanceof bn) D = true;
                    }
                    if (e instanceof wt) {
                        var s = O;
                        O = false;
                        n(e, m);
                        O = s;
                        return $(e);
                    }
                    if (e instanceof jn) {
                        var s = O;
                        O = false;
                        n(e, m);
                        O = s;
                        return $(e);
                    }
                    if (e instanceof En) {
                        e.name = e.name.transform(m);
                        var s = O;
                        O = false;
                        e.value = e.value.transform(m);
                        O = s;
                        return $(e);
                    }
                    if (e instanceof ot && !(e instanceof bn) && !(e.variables && e.variables.all(function(e) {
                        return !W.has(e.name) && !S.has(e.name);
                    }))) {
                        var s = O;
                        O = false;
                        if (!z(e, m)) n(e, m);
                        O = s;
                        return $(e);
                    }
                    if (z(e, m)) return $(e);
                }, $);
                var r = new Zr(function(e) {
                    if (D) return e;
                    if (!A) {
                        if (e !== _[g]) return e;
                        g++;
                        switch (_.length - g) {
                          case 0:
                            A = true;
                            if (c) return e;
                            if (e !== f) return e;
                            if (e instanceof kn) return e;
                            s.replaced++;
                            var n = r.parent();
                            if (n instanceof Tn && n.tail_node() !== e) {
                                b.replaced++;
                                if (T === o) return Xn.skip;
                                return Pe(o, o.expressions.slice(0, -1));
                            }
                            return T;

                          case 1:
                            if (!c && e.body === f) {
                                A = true;
                                s.replaced++;
                                b.replaced++;
                                return null;
                            }

                          default:
                            return z(e, r);
                        }
                    }
                    if (e instanceof Hn && e.definition() === s) {
                        if (fi(e, r.parent())) return e;
                        if (!--q) D = true;
                        vn.info("Replacing {this} [{start}]", e);
                        var t = T.clone();
                        t.scope = e.scope;
                        t.reference();
                        if (q == u) {
                            D = true;
                            return Fe(Fn, f, {
                                operator: "=",
                                left: e,
                                right: t
                            });
                        }
                        s.replaced++;
                        return t;
                    }
                    if (e instanceof nr || e instanceof bn) return e;
                }, function(e) {
                    return be(e, r);
                });
                while (--a >= 0) {
                    if (a == 0 && d.option("unused")) re();
                    var _ = [];
                    M(i[a]);
                    while (v.length > 0) {
                        _ = v.pop();
                        var g = 0;
                        var f = _[_.length - 1];
                        var u = -1;
                        var c = false;
                        var H = false;
                        var l;
                        var b = null;
                        var y = null;
                        var w = null;
                        var x = ue(f);
                        var k = x && x.has_side_effects(d);
                        var Y = x && (!k || x instanceof Hn) && !Ve(x, d);
                        var E = pe(f);
                        if (!Y && !E) continue;
                        var R = f instanceof Fn && f.operator.slice(0, -1);
                        var B = f.name instanceof In;
                        var L = cn;
                        if (f.may_throw(d)) {
                            if (B && Et(Oe)) continue;
                            L = qe ? function(e) {
                                return e.has_side_effects(d);
                            } : t;
                        }
                        var U = false;
                        var V = false;
                        var W = new hn();
                        var G = true;
                        var S = _e(f);
                        var J = ye(x);
                        var o = ce(f);
                        var T = o;
                        if (!k) {
                            if (!R && T instanceof Tn) T = T.tail_node();
                            k = we();
                        }
                        var X = qe || !J ? function(e) {
                            return e instanceof jn;
                        } : cn;
                        var K = xe(f);
                        var A = B;
                        var D = false;
                        var q = 0;
                        var O = !h || !A;
                        if (!O) {
                            for (var n = f.arg_index + 1; !D && n < h.length; n++) {
                                if (h[n]) h[n].transform(m);
                            }
                            O = true;
                        }
                        for (var e = a; !D && e < i.length; e++) {
                            i[e].transform(m);
                        }
                        if (b) {
                            if (!q || l > q + c) {
                                v.push(_);
                                I = true;
                                continue;
                            }
                            if (q == u) c = true;
                            var s = x.definition();
                            D = false;
                            g = 0;
                            A = B;
                            for (var e = a; !D && e < i.length; e++) {
                                if (!i[e].transform(r)) i.splice(e--, 1);
                            }
                            q = f instanceof kn && f === _[_.length - 1] && s.references.length == s.replaced && !d.exposed(s);
                            b.last_ref = false;
                            b.single_use = false;
                            N = true;
                        }
                        if (q) ge(f);
                    }
                }
                return N;
                function $(e) {
                    if (D) return e;
                    if (y === e) D = true;
                    if (w === e) w = null;
                    return e;
                }
                function z(e, n) {
                    if (!(e instanceof ot)) return;
                    if (e instanceof bn) return e;
                    if (e instanceof Nt) {
                        if (e.name) e.name = e.name.transform(n);
                        if (!D && e.extends) e.extends = e.extends.transform(n);
                        var t = [], r = [];
                        for (var i = 0; !D && i < e.properties.length; i++) {
                            var a = e.properties[i];
                            if (a.key instanceof vn) a.key = a.key.transform(n);
                            if (!a.static) continue;
                            if (a instanceof Rt) {
                                if (a.value) t.push(a);
                            } else if (a instanceof Vt) {
                                [].push.apply(r, a.value.body);
                            }
                        }
                        for (var i = 0; !D && i < r.length; i++) {
                            r[i].transform(n);
                        }
                        for (var i = 0; !D && i < t.length; i++) {
                            var a = t[i];
                            a.value = a.value.transform(n);
                        }
                        return e;
                    }
                    if (e instanceof vt) {
                        e.object = e.object.transform(n);
                        D = true;
                        return e;
                    }
                    if (e instanceof Zt) {
                        e.expression = e.expression.transform(n);
                        for (var i = 0; !D && i < e.body.length; i++) {
                            var o = e.body[i];
                            if (o instanceof tr) {
                                if (!A) {
                                    if (o !== _[g]) continue;
                                    g++;
                                }
                                o.expression = o.expression.transform(n);
                                if (!K) break;
                                E = false;
                            }
                        }
                        D = true;
                        return e;
                    }
                }
                function Q(e, n) {
                    if (n instanceof Fn) return n.operator == "=" && n.left === e;
                    if (n instanceof En) return n.name === e;
                    if (n instanceof br) return true;
                    if (n instanceof yr) return n.value === e;
                }
                function Z(e, n) {
                    if (e === T) return true;
                    if (n instanceof ht) {
                        if (e !== n.init) return true;
                    }
                    if (e instanceof Fn) {
                        return e.operator != "=" && x.equals(e.left);
                    }
                    if (e instanceof Sn) {
                        if (!(x instanceof An)) return false;
                        if (!x.equals(e.expression)) return false;
                        return !(T instanceof xt && !T.contains_this());
                    }
                    if (e instanceof Nt) return !d.has_directive("use strict");
                    if (e instanceof rt) return true;
                    if (e instanceof Pt) return B && x.name === e.name.name;
                    if (e instanceof yr) return e.key instanceof vn;
                    if (e instanceof lt) return true;
                    if (e instanceof Xt) return true;
                    if (e instanceof rr) return true;
                    if (e instanceof gt) return true;
                    return false;
                }
                function ee(e, n) {
                    if (!(e instanceof Hn)) return false;
                    if (e.is_declared(d)) {
                        if (e.fixed_value()) return false;
                        if (Ce(e)) {
                            return !(n instanceof An && n.expression === e) && ze(e.definition());
                        }
                    } else if (Q(e, n)) {
                        return false;
                    }
                    if (!K) return true;
                    E = false;
                    return false;
                }
                function ne(e, n) {
                    if (n instanceof Fn) return n.left !== e && He[n.operator.slice(0, -1)];
                    if (n instanceof Cn) return n.left !== e && He[n.operator];
                    if (n instanceof Sn) return n.optional && n.expression !== e;
                    if (n instanceof tr) return n.expression !== e;
                    if (n instanceof Mn) return n.condition !== e;
                    if (n instanceof xn) return n.condition !== e;
                    if (n instanceof qn) return n.optional && n.expression !== e;
                }
                function te(e, n) {
                    if (e instanceof _r) return true;
                    if (e.TYPE == "Binary") return !Ke(e.operator, e.right, d);
                    if (e instanceof Sn) {
                        var t, r = e.expression;
                        if (r instanceof Hn) {
                            t = r.definition();
                            r = r.fixed_value();
                        }
                        if (!(r instanceof yn)) return !e.is_expr_pure(d);
                        if (t && Qe(d, t, r)) return true;
                        if (r.collapse_scanning) return false;
                        r.collapse_scanning = true;
                        var i = O;
                        O = false;
                        var a = y;
                        var o = w;
                        for (var s = 0; !D && s < r.argnames.length; s++) {
                            if (C(p, r.argnames[s], e.args[s])) D = true;
                        }
                        if (!D) {
                            if (r.rest && C(p, r.rest, Fe(Pn, e, {
                                elements: e.args.slice(s)
                            }))) {
                                D = true;
                            } else if (kt(r) && r.value) {
                                r.value.transform(m);
                            } else for (var s = 0; !D && s < r.body.length; s++) {
                                var f = r.body[s];
                                if (f instanceof wn) {
                                    if (f.value) f.value.transform(m);
                                    break;
                                }
                                f.transform(m);
                            }
                        }
                        w = o;
                        y = a;
                        O = i;
                        r.collapse_scanning = false;
                        if (!D) return false;
                        D = false;
                        return true;
                    }
                    if (e instanceof Nt) {
                        if (!qe) return false;
                        var u = e.extends;
                        if (!u) return false;
                        if (u instanceof Hn) u = u.fixed_value();
                        return !Be(u);
                    }
                    if (e instanceof Gt) {
                        if (qe) {
                            if (qe.bfinally) return true;
                            if (qe.bcatch && e instanceof Jt) return true;
                        }
                        return k || x instanceof An || Ee(x);
                    }
                    if (e instanceof $t) {
                        return d.option("ie") && e.name && S.has(e.name.name);
                    }
                    if (e instanceof Nr) return ke(e, n);
                    if (e instanceof An) {
                        if (k) return true;
                        var c = e.expression;
                        if (c instanceof Hn && ze(c.definition())) return true;
                        if (d.option("unsafe")) {
                            if (Ne(c) && Ge[c.name]) return false;
                            if (Xe(c)) return false;
                        }
                        if (!G) return true;
                        if (b) return false;
                        if (!qe && J) return false;
                        if (e.optional) return false;
                        return c.may_throw_on_access(d);
                    }
                    if (e instanceof On) return true;
                    if (e instanceof Hn) {
                        if (ke(e, n)) return !Q(e, n);
                        if (k && Ee(e)) return true;
                        var t = e.definition();
                        return (qe || t.scope.resolve() !== Oe) && !Ce(e);
                    }
                    if (e instanceof Rr) return !e.is_expr_pure(d);
                    if (e instanceof kn) {
                        if (X(e.name)) return true;
                        return (e.value || n instanceof fr) && e.name.match_symbol(function(e) {
                            return e instanceof Dr && (S.has(e.name) || k && Ee(e));
                        }, true);
                    }
                    if (e instanceof gr) return true;
                    var l = fi(e.left, e);
                    if (!l) return false;
                    if (l instanceof An) return true;
                    if (X(l)) return true;
                    return l.match_symbol(function(e) {
                        return e instanceof Hn && (S.has(e.name) || U && d.exposed(e.definition()));
                    }, true);
                    function p(e) {
                        e.transform(m);
                        return D;
                    }
                }
                function C(t, e, r) {
                    if (e instanceof En) {
                        return t(e.value) || C(t, e.name, e.value) || !Ie(r) && C(t, e.name, r);
                    }
                    if (!r) return !(e instanceof Ar);
                    if (e instanceof jn) {
                        if (e.rest && C(t, e.rest)) return true;
                        if (e instanceof br) {
                            if (r instanceof Pn) return !dn(e.elements, function(e, n) {
                                return !C(t, e, r[n]);
                            });
                            if (!r.is_string(d)) return true;
                            return !dn(e.elements, function(e) {
                                return !C(t, e);
                            });
                        }
                        if (e instanceof wr) {
                            if (r.may_throw_on_access(d)) return true;
                            return !dn(e.properties, function(e) {
                                if (e.key instanceof vn && t(e.key)) return false;
                                return !C(t, e.value);
                            });
                        }
                    }
                }
                function re() {
                    if (Ae === false) return;
                    var e = d.parent(), i = d.self();
                    if (Ae === undefined) {
                        if (!(i instanceof xt) || St(i) || i.uses_arguments || i.pinned() || !(e instanceof Sn) || e.expression !== i || !dn(e.args, function(e) {
                            return !(e instanceof On);
                        })) {
                            Ae = false;
                            return;
                        }
                        if (!We(e)) return;
                        Ae = true;
                    }
                    var a = i.in_strict_mode(d) && !i.parent_scope.resolve(true).in_strict_mode(d);
                    var o;
                    if (Et(i)) {
                        o = function(e) {
                            return e instanceof Ar && e.name == "await";
                        };
                        Te = true;
                    } else {
                        o = function(e) {
                            return e instanceof _r && !n.find_parent(bn);
                        };
                        if (Te === undefined) Te = Ue(d, 1, e, null, true, true);
                    }
                    var s = null;
                    var n = new Ln(function(e, n) {
                        if (!c) return true;
                        if (o(e) || e instanceof gr) {
                            c = null;
                            return true;
                        }
                        if (e instanceof Nr) {
                            if (a || !s) c = null;
                            return true;
                        }
                        if (e instanceof Hn) {
                            var t;
                            if (e.in_arg && !Ye(e.definition()) || (t = i.variables.get(e.name)) && t !== e.definition()) {
                                c = null;
                            }
                            return true;
                        }
                        if (e instanceof bn && !kt(e)) {
                            var r = s;
                            s = e;
                            n();
                            s = r;
                            return true;
                        }
                    });
                    h = e.args.slice();
                    var t = h.length;
                    var r = new hn();
                    for (var f = i.argnames.length; --f >= 0; ) {
                        var u = i.argnames[f];
                        var c = h[f];
                        var l = null;
                        if (u instanceof En) {
                            l = u.value;
                            u = u.name;
                            h[t + f] = l;
                        }
                        if (u instanceof jn) {
                            if (Te && C(function(e) {
                                return e.has_side_effects(d);
                            }, u, c)) {
                                v.length = 0;
                                break;
                            }
                            h[t + f] = i.argnames[f];
                            continue;
                        }
                        if (r.has(u.name)) continue;
                        r.set(u.name, true);
                        if (l) c = Ie(c) ? l : null;
                        if (!c && !l) {
                            c = Fe(Wr, u).transform(d);
                        } else if (c instanceof yn && c.pinned()) {
                            c = null;
                        } else if (c) {
                            c.walk(n);
                        }
                        if (!c) continue;
                        var p = Fe(kn, u, {
                            name: u,
                            value: c
                        });
                        p.name_index = f;
                        p.arg_index = l ? t + f : f;
                        v.unshift([ p ]);
                    }
                    if (i.rest) h.push(i.rest);
                }
                function M(e, n) {
                    _.push(e);
                    if (e instanceof Pn) {
                        e.elements.forEach(function(e) {
                            M(e, n);
                        });
                    } else if (e instanceof Fn) {
                        var t = e.left;
                        if (!(t instanceof jn)) v.push(_.slice());
                        M(t);
                        M(e.right);
                        if (t instanceof Hn && e.operator == "=") {
                            j.set(t.name, (j.get(t.name) || 0) + 1);
                        }
                    } else if (e instanceof _r) {
                        M(e.expression, n);
                    } else if (e instanceof Cn) {
                        var r = He[e.operator];
                        if (n && r && e.operator != "??" && e.right instanceof Fn && e.right.operator == "=" && !(e.right.left instanceof jn)) {
                            v.push(_.slice());
                        }
                        M(e.left, !r && n);
                        M(e.right, n);
                    } else if (e instanceof Sn) {
                        M(e.expression);
                        e.args.forEach(M);
                    } else if (e instanceof tr) {
                        M(e.expression);
                    } else if (e instanceof Mn) {
                        M(e.condition);
                        M(e.consequent, n);
                        M(e.alternative, n);
                    } else if (e instanceof or) {
                        e.definitions.forEach(M);
                    } else if (e instanceof Dn) {
                        M(e.expression);
                    } else if (e instanceof lt) {
                        M(e.condition);
                        if (!(e.body instanceof ft)) {
                            M(e.body);
                        }
                    } else if (e instanceof Gt) {
                        if (e.value) M(e.value);
                    } else if (e instanceof ht) {
                        if (e.init) M(e.init, true);
                        if (e.condition) M(e.condition);
                        if (e.step) M(e.step, true);
                        if (!(e.body instanceof ft)) {
                            M(e.body);
                        }
                    } else if (e instanceof vt) {
                        M(e.object);
                        if (!(e.body instanceof ft)) {
                            M(e.body);
                        }
                    } else if (e instanceof xn) {
                        M(e.condition);
                        if (!(e.body instanceof ft)) {
                            M(e.body);
                        }
                        if (e.alternative && !(e.alternative instanceof ft)) {
                            M(e.alternative);
                        }
                    } else if (e instanceof Nn) {
                        e.properties.forEach(function(e) {
                            _.push(e);
                            if (e.key instanceof vn) M(e.key);
                            if (e instanceof kr) M(e.value, n);
                            _.pop();
                        });
                    } else if (e instanceof Tn) {
                        var i = e.expressions.length - (n ? 0 : 1);
                        e.expressions.forEach(function(e, n) {
                            M(e, n < i);
                        });
                    } else if (e instanceof _n) {
                        M(e.body, true);
                    } else if (e instanceof On) {
                        M(e.expression);
                    } else if (e instanceof qn) {
                        M(e.expression);
                        M(e.property);
                    } else if (e instanceof Zt) {
                        M(e.expression);
                        e.body.forEach(M);
                    } else if (e instanceof $n) {
                        if (ri[e.operator]) {
                            v.push(_.slice());
                        } else {
                            M(e.expression);
                        }
                    } else if (e instanceof kn) {
                        if (e.name instanceof zr) {
                            if (e.value) {
                                var a = e.name.definition();
                                if (a.references.length > a.replaced) {
                                    v.push(_.slice());
                                }
                            } else {
                                p.set(e.name.name, (p.get(e.name.name) || 0) + 1);
                            }
                        }
                        if (e.value) M(e.value);
                    } else if (e instanceof gr) {
                        if (e.expression) M(e.expression);
                    }
                    _.pop();
                }
                function ie(e, n) {
                    var t = m.parent(n);
                    if (t instanceof Pn) return e;
                    if (t instanceof Fn) return e;
                    if (t instanceof _r) return e;
                    if (t instanceof Cn) return e;
                    if (t instanceof Sn) return e;
                    if (t instanceof tr) return e;
                    if (t instanceof Mn) return e;
                    if (t instanceof or) return P(t, n + 1);
                    if (t instanceof Gt) return e;
                    if (t instanceof xn) return e;
                    if (t instanceof ct) return e;
                    if (t instanceof xr) return e;
                    if (t instanceof An) return e;
                    if (t instanceof Tn) {
                        return (t.tail_node() === e ? ie : P)(t, n + 1);
                    }
                    if (t instanceof _n) return P(t, n + 1);
                    if (t instanceof On) return e;
                    if (t instanceof Zt) return e;
                    if (t instanceof $n) return e;
                    if (t instanceof kn) return e;
                    if (t instanceof gr) return e;
                    return null;
                }
                function ae(e, n, t) {
                    var r;
                    do {
                        r = e;
                        e = m.parent(++t);
                    } while (e instanceof Fn && e.operator.slice(0, -1) == n || e instanceof Cn && e.operator == n);
                    return r;
                }
                function oe(e, n, t, r, i) {
                    var a = O;
                    O = false;
                    var o = y;
                    var s = w;
                    var f = m.stack;
                    m.stack = [ r ];
                    e.transform(m);
                    m.stack = f;
                    w = s;
                    y = o;
                    O = a;
                    if (D) {
                        D = false;
                        return t;
                    }
                    return n(r, i + 1);
                }
                function F(e, n) {
                    var t = m.parent(n);
                    if (t instanceof Pn) return F(t, n + 1);
                    if (t instanceof Fn) {
                        if (L(t)) return e;
                        if (t.left.match_symbol(function(e) {
                            return e instanceof Hn && (x.name == e.name || b.name == e.name);
                        })) return e;
                        var r;
                        if (t.left === e || !He[r = t.operator.slice(0, -1)]) {
                            return F(t, n + 1);
                        }
                        return ae(t, r, n);
                    }
                    if (t instanceof _r) return F(t, n + 1);
                    if (t instanceof Cn) {
                        var r;
                        if (t.left === e || !He[r = t.operator]) {
                            return F(t, n + 1);
                        }
                        return ae(t, r, n);
                    }
                    if (t instanceof Sn) return t;
                    if (t instanceof tr) {
                        if (t.expression !== e) return e;
                        return F(t, n + 1);
                    }
                    if (t instanceof Mn) {
                        if (t.condition !== e) return e;
                        return F(t, n + 1);
                    }
                    if (t instanceof or) return P(t, n + 1);
                    if (t instanceof pt) return e;
                    if (t instanceof Gt) return P(t, n + 1);
                    if (t instanceof ht) {
                        if (t.init !== e && t.condition !== e) return e;
                        return F(t, n + 1);
                    }
                    if (t instanceof vt) {
                        if (t.init !== e) return e;
                        return F(t, n + 1);
                    }
                    if (t instanceof xn) {
                        if (t.condition !== e) return e;
                        return F(t, n + 1);
                    }
                    if (t instanceof xr) {
                        var i = m.parent(n + 1);
                        return dn(i.properties, function(e) {
                            return e instanceof kr;
                        }) ? F(i, n + 2) : i;
                    }
                    if (t instanceof An) {
                        var a = t.expression;
                        return a === e ? F(t, n + 1) : e;
                    }
                    if (t instanceof Tn) {
                        return (t.tail_node() === e ? F : P)(t, n + 1);
                    }
                    if (t instanceof _n) return P(t, n + 1);
                    if (t instanceof On) return F(t, n + 1);
                    if (t instanceof Zt) {
                        if (t.expression !== e) return e;
                        return F(t, n + 1);
                    }
                    if (t instanceof $n) {
                        if (t.operator == "delete") return e;
                        return F(t, n + 1);
                    }
                    if (t instanceof kn) return t.name.match_symbol(function(e) {
                        return e instanceof Dr && (x.name == e.name || b.name == e.name);
                    }) ? e : F(t, n + 1);
                    if (t instanceof dt) {
                        if (t.condition !== e) return e;
                        return F(t, n + 1);
                    }
                    if (t instanceof gr) return F(t, n + 1);
                    return null;
                }
                function P(n, t) {
                    var r = m.parent(t);
                    if (te(n, r)) return n;
                    if (ne(n, r)) return n;
                    if (r instanceof Pn) return P(r, t + 1);
                    if (r instanceof Fn) return a(r.left);
                    if (r instanceof _r) return n;
                    if (r instanceof Cn) return P(r, t + 1);
                    if (r instanceof Sn) return P(r, t + 1);
                    if (r instanceof tr) return P(r, t + 1);
                    if (r instanceof Mn) return P(r, t + 1);
                    if (r instanceof or) return P(r, t + 1);
                    if (r instanceof Gt) return P(r, t + 1);
                    if (r instanceof xn) return P(r, t + 1);
                    if (r instanceof ct) return n;
                    if (r instanceof xr) {
                        var e = m.parent(t + 1);
                        return dn(e.properties, function(e) {
                            return e instanceof kr;
                        }) ? P(e, t + 2) : e;
                    }
                    if (r instanceof An) {
                        var i = r.expression;
                        if (i === n) return P(r, t + 1);
                        return oe(i, P, n, r, t);
                    }
                    if (r instanceof Tn) return P(r, t + 1);
                    if (r instanceof _n) return P(r, t + 1);
                    if (r instanceof On) return n;
                    if (r instanceof Zt) return P(r, t + 1);
                    if (r instanceof $n) return P(r, t + 1);
                    if (r instanceof kn) return a(r.name);
                    if (r instanceof gr) return n;
                    return null;
                    function a(e) {
                        if (L(r)) return n;
                        if (e !== n && e instanceof jn) {
                            return oe(e, P, n, r, t);
                        }
                        return P(r, t + 1);
                    }
                }
                function se(e) {
                    if (I) {
                        I = false;
                        return;
                    }
                    if (l < 1) return;
                    e = e.tail_node();
                    var n = e instanceof Fn && e.operator == "=" ? e.left : e;
                    if (!(n instanceof Hn)) return;
                    var t = n.definition();
                    if (t.undeclared) return;
                    if (ze(t)) return;
                    if (n !== e) {
                        if (Ve(n, d)) return;
                        var r = t.references.length - t.replaced;
                        if (r < 2) return;
                        var i = f.clone();
                        i[i instanceof Fn ? "right" : "value"] = n;
                        if (f.name_index >= 0) {
                            i.name_index = f.name_index;
                            i.arg_index = f.arg_index;
                        }
                        f = i;
                    }
                    return b = t;
                }
                function fe(e) {
                    return e.references.length - e.replaced - (j.get(e.name) || 0);
                }
                function ue(t) {
                    if (t instanceof Fn) {
                        var r = t.left;
                        if (!(r instanceof Hn)) return r;
                        var e = r.definition();
                        if (Oe.uses_arguments && oi(e)) return r;
                        if (d.exposed(e)) return r;
                        l = fe(e);
                        if (e.fixed && r.fixed) {
                            var n = e.references.filter(function(e) {
                                return e.fixed === r.fixed;
                            }).length - 1;
                            if (n < l) {
                                l = n;
                                u = 0;
                                H = true;
                            }
                        }
                        if (t.operator == "=") se(t.right);
                        return r;
                    }
                    if (t instanceof Cn) return t.right.left;
                    if (t instanceof $n) return t.expression;
                    if (t instanceof kn) {
                        var r = t.name;
                        var e = r.definition();
                        if (e.const_redefs) return;
                        if (!Un(r, e.orig)) return;
                        if (Oe.uses_arguments && oi(e)) return;
                        var i = e.orig.length - e.eliminated - (p.get(e.name) || 0);
                        l = fe(e);
                        if (e.fixed) l = Math.min(l, e.references.filter(function(e) {
                            if (!e.fixed) return true;
                            if (!e.fixed.assigns) return true;
                            var n = e.fixed.assigns[0];
                            return n === r || ce(n) === t.value;
                        }).length);
                        if (i > 1 && !(r instanceof In)) {
                            se(t.value);
                            return Fe(Hn, r);
                        }
                        if (se(t.value) || l == 1 && !d.exposed(e)) {
                            return Fe(Hn, r);
                        }
                        return;
                    }
                }
                function ce(e) {
                    if (e instanceof Fn) return e.right;
                    if (e instanceof Cn) {
                        var n = e.clone();
                        n.right = e.right.right;
                        return n;
                    }
                    if (e instanceof kn) return e.value;
                }
                function le(e) {
                    if (e instanceof Pn) return false;
                    if (e instanceof Cn && He[e.operator]) {
                        return le(e.left) && le(e.right);
                    }
                    if (e instanceof Sn) return false;
                    if (e instanceof Mn) {
                        return le(e.consequent) && le(e.alternative);
                    }
                    if (e instanceof Nn) return false;
                    return !e.has_side_effects(d);
                }
                function pe(n) {
                    if (n instanceof Fn && n.right.single_use) return;
                    var t = Object.create(null);
                    var e = new Ln(function(e) {
                        if (e instanceof Hn) t[e.definition().id] = true;
                    });
                    while (n instanceof Fn && n.operator == "=") {
                        n.left.walk(e);
                        n = n.right;
                    }
                    if (n instanceof Nr) return o;
                    if (n instanceof Hn) {
                        var r = n.evaluate(d);
                        if (r === n) return o;
                        return de(r, o);
                    }
                    if (n.is_truthy()) return de(true, cn);
                    if (n.is_constant()) {
                        var i = n.evaluate(d);
                        if (!(i instanceof vn)) return de(i, o);
                    }
                    if (!(x instanceof Hn)) return false;
                    if (!le(n)) return false;
                    var a;
                    n.walk(new Ln(function(e) {
                        if (a) return true;
                        if (e instanceof Hn && t[e.definition().id]) a = true;
                    }));
                    return !a && o;
                    function o(e) {
                        return n.equals(e);
                    }
                }
                function de(r, i) {
                    return function(e, n) {
                        if (n.in_boolean_context()) {
                            if (r && e.is_truthy() && !e.has_side_effects(d)) {
                                return true;
                            }
                            if (e.is_constant()) {
                                var t = e.evaluate(d);
                                if (!(t instanceof vn)) return !t == !r;
                            }
                        }
                        return i(e);
                    };
                }
                function he(e) {
                    while (e.write_only) {
                        e.write_only = false;
                        if (!(e instanceof Fn)) break;
                        e = e.right;
                    }
                }
                function ve(e, n) {
                    var t = n.scope || Me(m) || Se;
                    e.walk(new Ln(function(e) {
                        if (e instanceof ot) return true;
                        if (e instanceof Ar) e.scope = t;
                    }));
                }
                function me(e) {
                    if (e instanceof Hn) {
                        e = e.fixed_value();
                        if (!e) return true;
                    }
                    if (e instanceof Fn) return e.operator == "=" && me(e.right);
                    return e instanceof An || e instanceof Nr;
                }
                function _e(f) {
                    var u = new hn();
                    if (f instanceof kn) {
                        if (!f.name.definition().fixed) G = false;
                        u.add(f.name.name, x);
                    }
                    var c = Oe.uses_arguments && !d.has_directive("use strict");
                    var l = Oe instanceof bt;
                    var p = new Ln(function(n) {
                        var e;
                        if (n instanceof Hn) {
                            e = n.fixed_value();
                            if (!e) {
                                e = n;
                                var t = n.definition();
                                var r = n.fixed && n.fixed.escaped || t.escaped;
                                if (!t.undeclared && (t.assignments || !r || r.cross_scope) && (Le(t, n.scope, n, p.parent()) || !Re(t))) {
                                    G = false;
                                }
                            }
                        } else if (n instanceof Nr) {
                            e = n;
                        }
                        if (e) {
                            u.add(n.name, $e(d, p, n, e, 0));
                        } else if (n instanceof yn) {
                            for (var i = 0, a, o = n; a = p.parent(i++); o = a) {
                                if (a instanceof Fn) {
                                    if (a.left === o) break;
                                    if (a.operator == "=") continue;
                                    if (He[a.operator.slice(0, -1)]) continue;
                                    break;
                                }
                                if (a instanceof Cn) {
                                    if (He[a.operator]) continue;
                                    break;
                                }
                                if (a instanceof Sn) return;
                                if (a instanceof bn) return;
                                if (a instanceof Tn) {
                                    if (a.tail_node() === o) continue;
                                    break;
                                }
                                if (a instanceof Rr) {
                                    if (a.tag) return;
                                    break;
                                }
                            }
                            n.enclosed.forEach(function(e) {
                                if (e.scope !== n) W.set(e.name, true);
                            });
                            return true;
                        } else if (c && n instanceof qn) {
                            Oe.each_argname(function(e) {
                                if (!d.option("reduce_vars") || e.definition().assignments) {
                                    if (!e.definition().fixed) G = false;
                                    u.add(e.name, true);
                                }
                            });
                            c = false;
                        }
                        if (!l) return;
                        if (n.TYPE == "Call") {
                            if (V) return;
                            var s = n.expression;
                            if (s instanceof An) return;
                            if (s instanceof xt && !s.contains_this()) return;
                            V = true;
                        } else if (n instanceof An && me(n.expression)) {
                            if (n === x && !(f instanceof $n)) {
                                V = true;
                            } else {
                                U = true;
                            }
                        }
                    });
                    f.walk(p);
                    return u;
                }
                function ge(e) {
                    var f = T === o ? null : Pe(o, o.expressions.slice(0, -1));
                    var n = e.name_index;
                    if (n >= 0) {
                        var t, r = Oe.argnames[n];
                        if (r instanceof En) {
                            Oe.argnames[n] = r = r.clone();
                            r.value = f || Fe(Bn, r, {
                                value: 0
                            });
                        } else if ((t = d.parent().args)[n]) {
                            Oe.argnames[n] = r.clone();
                            t[n] = f || Fe(Bn, t[n], {
                                value: 0
                            });
                        }
                        return;
                    }
                    var u = _.length - 1;
                    var c = _[u];
                    if (c instanceof kn || _[u - 1].body === c) u--;
                    var l = new Zr(function(e, n, t) {
                        if (A) return e;
                        if (e !== _[g]) return e;
                        g++;
                        if (g <= u) return z(e, l);
                        A = true;
                        if (e instanceof or) {
                            p.set(c.name.name, (p.get(c.name.name) || 0) + 1);
                            if (b) b.replaced++;
                            var r = e.definitions;
                            var i = r.indexOf(c);
                            var a = c.clone();
                            a.value = null;
                            if (!f) {
                                e.definitions[i] = a;
                                return e;
                            }
                            var o = [ Fe(_n, f, {
                                body: f
                            }) ];
                            if (i > 0) {
                                var s = e.clone();
                                s.definitions = r.slice(0, i);
                                o.unshift(s);
                                e = e.clone();
                                e.definitions = r.slice(i);
                            }
                            o.push(e);
                            e.definitions[0] = a;
                            return t ? Xn.splice(o) : Fe(gn, e, {
                                body: o
                            });
                        }
                        if (!f) return t ? Xn.skip : null;
                        return at(e) ? Fe(_n, f, {
                            body: f
                        }) : f;
                    }, function(e, n) {
                        if (e instanceof ht) return Je(e, n);
                        return be(e, l);
                    });
                    D = false;
                    A = false;
                    g = 0;
                    if (!(i[a] = i[a].transform(l))) i.splice(a, 1);
                }
                function be(e, n) {
                    if (e instanceof Tn) switch (e.expressions.length) {
                      case 0:
                        return null;

                      case 1:
                        return je(n.parent(), e, e.expressions[0]);
                    }
                }
                function ye(e) {
                    var n = vr(e);
                    if (!(n instanceof Hn)) return false;
                    if (n.definition().scope.resolve() !== Oe) return false;
                    if (!De) return true;
                    if (R) return false;
                    if (f instanceof $n) return false;
                    var t = S.get(n.name);
                    return !t || t[0] === e;
                }
                function we() {
                    if (f instanceof $n) return false;
                    return T.has_side_effects(d);
                }
                function xe(e) {
                    if (e instanceof $n) return false;
                    if (k) return false;
                    if (b) return true;
                    if (!(x instanceof Hn)) return false;
                    var n;
                    if (e instanceof kn) {
                        n = 1;
                    } else if (e.operator == "=") {
                        n = 2;
                    } else {
                        return false;
                    }
                    var t = x.definition();
                    if (t.references.length - t.replaced == n) return true;
                    if (!t.fixed) return false;
                    if (!x.fixed) return false;
                    if (t.references.filter(function(e) {
                        return e.fixed === x.fixed;
                    }).length != n) return false;
                    H = true;
                    return true;
                }
                function ke(e, n) {
                    var t = S.get(e.name);
                    if (!t || dn(t, function(e) {
                        return !e;
                    })) return;
                    if (t[0] !== x) return true;
                    E = false;
                }
                function Ee(e) {
                    var n = e.definition();
                    if (n.orig.length == 1 && n.orig[0] instanceof Cr) return false;
                    if (n.scope.resolve() !== Oe) return true;
                    if (V && d.exposed(n)) return true;
                    return !dn(n.references, function(e) {
                        return e.scope.resolve(true) === Oe;
                    });
                }
                function t(e, n) {
                    if (e instanceof Fn) return t(e.left, true);
                    if (e instanceof $n) return t(e.expression, true);
                    if (e instanceof kn) return e.value && t(e.value);
                    if (n) {
                        if (e instanceof Dn) return t(e.expression, true);
                        if (e instanceof qn) return t(e.expression, true);
                        if (e instanceof Hn) return e.definition().scope.resolve() !== Oe;
                    }
                    return false;
                }
            }
            function o(e) {
                var n = false, t = [];
                for (var r = 0; r < e.length; ) {
                    var i = e[r];
                    if (i instanceof gn) {
                        if (dn(i.body, S)) {
                            n = true;
                            o(i.body);
                            [].splice.apply(e, [ r, 1 ].concat(i.body));
                            r += i.body.length;
                            continue;
                        }
                    }
                    if (i instanceof it) {
                        if (Un(i.value, t)) {
                            n = true;
                            e.splice(r, 1);
                            continue;
                        }
                        t.push(i.value);
                    }
                    if (i instanceof mn) {
                        n = true;
                        e.splice(r, 1);
                        continue;
                    }
                    r++;
                }
                return n;
            }
            function f(s, r) {
                var e = false;
                var i = r.parent();
                var a = r.self();
                var o, f, u;
                var n = N && i && i.TYPE == "Call" && i.expression === a;
                var t = N && r.option("conditionals") && r.option("sequences");
                var c = A(s);
                for (var l = s.length; --l >= 0; ) {
                    var p = s[l];
                    var d = M(l);
                    var h = s[d];
                    if (N && o && !h && p instanceof wn && !(a instanceof er) && !(qe && qe.bfinally && H(N))) {
                        var v = p.value;
                        if (!v) {
                            e = true;
                            s.splice(l, 1);
                            continue;
                        }
                        var m = v.tail_node();
                        if (Ie(m)) {
                            e = true;
                            if (v instanceof zn) {
                                v = v.expression;
                            } else if (m instanceof zn) {
                                v = v.clone();
                                v.expressions[v.expressions.length - 1] = m.expression;
                            }
                            s[l] = Fe(_n, p, {
                                body: v
                            });
                            continue;
                        }
                    }
                    if (p instanceof xn) {
                        var _ = R(p.body);
                        if (O(_)) {
                            if (_.label) Zn(_.label.thedef.references, _);
                            e = true;
                            p = p.clone();
                            p.body = Fe(gn, p, {
                                body: C(p.body, _)
                            });
                            p.alternative = Fe(gn, p, {
                                body: U(p.alternative).concat($(u, f))
                            });
                            s[l] = p;
                            s[l] = p.transform(r);
                            continue;
                        }
                        if (_ && !p.alternative && h instanceof Wt) {
                            var g = p.condition;
                            var b = l + 1 == d && p.body instanceof gn;
                            g = le(g, g.negate(r), b);
                            if (g !== p.condition) {
                                e = true;
                                p = p.clone();
                                p.condition = g;
                                var v = p.body;
                                p.body = Fe(gn, h, {
                                    body: $(true, null, d + 1)
                                });
                                s.splice(l, 1, p, v);
                                if (!N || a instanceof ft && a.body === s) {
                                    s[l] = p.transform(r);
                                }
                                continue;
                            }
                        }
                        var y = R(p.alternative);
                        if (O(y)) {
                            if (y.label) Zn(y.label.thedef.references, y);
                            e = true;
                            p = p.clone();
                            p.body = Fe(gn, p.body, {
                                body: U(p.body).concat($(u, f))
                            });
                            p.alternative = Fe(gn, p.alternative, {
                                body: C(p.alternative, y)
                            });
                            s[l] = p;
                            s[l] = p.transform(r);
                            continue;
                        }
                        if (r.option("typeofs")) {
                            if (_ && !y) {
                                var w = Fe(gn, a, {
                                    body: s.slice(l + 1)
                                });
                                B(p.condition, null, w);
                            }
                            if (!_ && y) {
                                var w = Fe(gn, a, {
                                    body: s.slice(l + 1)
                                });
                                B(p.condition, w);
                            }
                        }
                    }
                    if (p instanceof xn && p.body instanceof wn) {
                        var x = p.body.value;
                        var k = p.body.in_bool || h instanceof wn && h.in_bool;
                        if (!p.alternative && h instanceof wn) {
                            e = true;
                            p = p.clone();
                            p.alternative = Fe(gn, h, {
                                body: $(true, null, d + 1)
                            });
                            s[l] = p;
                            s[l] = p.transform(r);
                            continue;
                        }
                        if (N && o && !h && !p.alternative && (k || x && c || x instanceof Mn && (Ie(x.consequent, r) || Ie(x.alternative, r)))) {
                            e = true;
                            p = p.clone();
                            p.alternative = Fe(wn, p, {
                                value: null
                            });
                            s[l] = p;
                            s[l] = p.transform(r);
                            continue;
                        }
                        var E, S;
                        if (t && !p.alternative && (!(S = s[E = j(l)]) && n || S instanceof xn && S.body instanceof wn) && (!h ? !o : h instanceof _n && M(d) == s.length)) {
                            e = true;
                            var T = [];
                            p = p.clone();
                            T.push(p.condition);
                            p.condition = Pe(p, T);
                            p.alternative = Fe(gn, a, {
                                body: $().concat(Fe(wn, a, {
                                    value: null
                                }))
                            });
                            s[l] = p.transform(r);
                            l = E + 1;
                            continue;
                        }
                    }
                    if (p instanceof Kt || p instanceof Gt) {
                        f = p;
                        continue;
                    }
                    if (f && f === h) F(p);
                }
                return e;
                function A(e) {
                    var n = 0;
                    for (var t = e.length; --t >= 0; ) {
                        var r = e[t];
                        if (r instanceof xn && r.body instanceof wn) {
                            if (++n > 1) return true;
                        }
                    }
                    return false;
                }
                function D(n) {
                    return I(r, function(e) {
                        return e === n;
                    });
                }
                function q(e, n) {
                    if (!f) return false;
                    if (f.TYPE != e.TYPE) return false;
                    var t = e.value;
                    if (!t) return false;
                    var r = f.equals(e);
                    if (!r && t instanceof Tn) {
                        t = t.tail_node();
                        if (f.value && f.value.equals(t)) r = 2;
                    }
                    if (!r && !n && f.value instanceof Tn) {
                        if (f.value.tail_node().equals(t)) r = 3;
                    }
                    return r;
                }
                function P(e) {
                    if (e instanceof Gt) {
                        if (u = q(e)) return true;
                        if (!N) return false;
                        if (!(e instanceof wn)) return false;
                        var n = e.value;
                        if (n && !Ie(n.tail_node())) return false;
                        if (!(a instanceof er)) return true;
                        if (!f) return false;
                        if (f instanceof Gt && f.value) return false;
                        u = 4;
                        return true;
                    }
                    if (!(e instanceof Xt)) return false;
                    if (f && a instanceof er) {
                        if (f instanceof Gt) {
                            if (!N) return false;
                            if (f.value) return false;
                        } else if (r.loopcontrol_target(f) !== i) {
                            return false;
                        }
                        u = true;
                    }
                    var t = r.loopcontrol_target(e);
                    if (e instanceof Qt) return D(V(t));
                    if (t instanceof ct) return false;
                    return D(t);
                }
                function O(e) {
                    u = false;
                    if (!P(e)) return false;
                    for (var n = s.length; --n > l; ) {
                        var t = s[n];
                        if (t instanceof It) {
                            if (t.name.definition().preinit) return false;
                        } else if (t instanceof sr || t instanceof fr) {
                            if (!dn(t.definitions, function(e) {
                                return !e.name.match_symbol(function(e) {
                                    return e instanceof Dr && e.definition().preinit;
                                });
                            })) return false;
                        }
                    }
                    return true;
                }
                function $(e, n, t) {
                    var r = [];
                    var i = false;
                    var a = l + 1;
                    if (!e) {
                        t = s.length;
                        f = null;
                    } else if (n) {
                        t = s.lastIndexOf(n);
                    } else {
                        n = s[t];
                        if (n !== f) f = null;
                    }
                    var o = s.splice(a, t - a).filter(function(e) {
                        if (e instanceof Ct) {
                            r.push(e);
                            return false;
                        }
                        if (L(e)) i = true;
                        return true;
                    });
                    if (e === 3) {
                        o.push(Fe(_n, n.value, {
                            body: Pe(n.value, n.value.expressions.slice(0, -1))
                        }));
                        n.value = n.value.tail_node();
                    }
                    [].push.apply(i ? o : s, r);
                    return o;
                }
                function z(e, n) {
                    if (e) switch (n) {
                      case 4:
                        return e;

                      case 3:
                        if (!(e instanceof Tn)) break;

                      case 2:
                        return Pe(e, e.expressions.slice(0, -1));
                    }
                }
                function C(e, n) {
                    var t = U(e);
                    var r = t, i;
                    while ((i = r[r.length - 1]) !== n) {
                        r = i.body;
                    }
                    r.pop();
                    var a = n.value;
                    if (u) a = z(a, u);
                    if (a) r.push(Fe(_n, a, {
                        body: a
                    }));
                    return t;
                }
                function M(e) {
                    o = true;
                    for (var n = e; ++n < s.length; ) {
                        var t = s[n];
                        if (Y(t)) continue;
                        if (t instanceof ur) {
                            o = false;
                            continue;
                        }
                        break;
                    }
                    return n;
                }
                function j(e) {
                    for (var n = e; --n >= 0; ) {
                        var t = s[n];
                        if (t instanceof ur) continue;
                        if (Y(t)) continue;
                        break;
                    }
                    return n;
                }
                function F(e, n) {
                    if (e instanceof Gt) {
                        var t = q(e, true);
                        if (t) {
                            var r = z(e.value, t);
                            if (r) return Fe(_n, r, {
                                body: r
                            });
                            return n ? null : Fe(mn, e);
                        }
                    } else if (e instanceof xn) {
                        e.body = F(e.body);
                        if (e.alternative) e.alternative = F(e.alternative);
                    } else if (e instanceof ut) {
                        e.body = F(e.body);
                    } else if (e instanceof rr) {
                        if (!e.bfinally || !f.value || f.value.is_constant()) {
                            if (e.bcatch) F(e.bcatch);
                            var i = F(e.body.pop(), true);
                            if (i) e.body.push(i);
                        }
                    } else if (e instanceof ft && !(e instanceof bn || e instanceof Zt)) {
                        var i = F(e.body.pop(), true);
                        if (i) e.body.push(i);
                    }
                    return e;
                }
            }
            function u(n, t) {
                var e;
                var r = t.self();
                if (r instanceof ir) {
                    r = t.parent();
                } else if (r instanceof ut) {
                    r = r.body;
                }
                for (var i = 0, a = 0, o = n.length; i < o; i++) {
                    var s = n[i];
                    if (s instanceof Xt) {
                        var f = t.loopcontrol_target(s);
                        if (V(f) !== r || s instanceof Kt && f instanceof ct) {
                            n[a++] = s;
                        } else if (s.label) {
                            Zn(s.label.thedef.references, s);
                        }
                    } else {
                        n[a++] = s;
                    }
                    if (R(s)) {
                        e = n.slice(i + 1);
                        break;
                    }
                }
                n.length = a;
                if (e) e.forEach(function(e) {
                    z(t, e, n);
                });
                return n.length != o;
            }
            function c(e, n) {
                if (!N || qe && qe.bfinally) return;
                var t = false;
                for (var r = e.length; --r >= 0; ) {
                    var i = e[r];
                    if (!(i instanceof _n)) break;
                    var a = i.body;
                    if (!(a instanceof _r)) break;
                    var o = a.expression;
                    if (!x(n, o)) break;
                    t = true;
                    o = o.drop_side_effect_free(n, true);
                    if (o) {
                        i.body = o;
                        break;
                    }
                }
                e.length = r + 1;
                return t;
            }
            function l(e, n) {
                var t = false;
                var r = e.length - 1;
                if (N && r >= 0) {
                    var i = qe && qe.bfinally && H(Oe);
                    var a = e[r].try_inline(n, Se, i);
                    if (a) {
                        e[r--] = a;
                        t = true;
                    }
                }
                var o = De && qe && qe.bfinally ? "try" : De;
                for (;r >= 0; r--) {
                    var a = e[r].try_inline(n, Se, true, o);
                    if (!a) continue;
                    e[r] = a;
                    t = true;
                }
                return t;
            }
            function p(n, e) {
                if (n.length < 2) return;
                var t = [], r = 0;
                function i() {
                    if (!t.length) return;
                    var e = Pe(t[0], t);
                    n[r++] = Fe(_n, e, {
                        body: e
                    });
                    t = [];
                }
                for (var a = 0, o = n.length; a < o; a++) {
                    var s = n[a];
                    if (s instanceof _n) {
                        if (t.length >= e.sequences_limit) i();
                        k(t, s.body);
                    } else if (Y(s)) {
                        n[r++] = s;
                    } else {
                        i();
                        n[r++] = s;
                    }
                }
                i();
                n.length = r;
                return r != o;
            }
            function d(e, n) {
                if (!(e instanceof gn)) return e;
                var t = null;
                for (var r = 0; r < e.body.length; r++) {
                    var i = e.body[r];
                    if (i instanceof ur && ce(i)) {
                        n.push(i);
                    } else if (t || L(i)) {
                        return false;
                    } else {
                        t = i;
                    }
                }
                return t;
            }
            function h(e, n) {
                var t = false, r = 0, i;
                for (var a = 0; a < e.length; a++) {
                    var o = e[a];
                    if (i) {
                        if (o instanceof Gt) {
                            if (o.value || !H(Oe)) {
                                o.value = p(o.value || Fe(Wr, o)).optimize(n);
                            }
                        } else if (o instanceof ht) {
                            if (!(o.init instanceof or)) {
                                var s = false;
                                i.body.walk(new Ln(function(e) {
                                    if (s || e instanceof bn) return true;
                                    if (e instanceof Cn && e.operator == "in") {
                                        s = true;
                                        return true;
                                    }
                                }));
                                if (!s) {
                                    if (o.init) o.init = p(o.init); else {
                                        o.init = i.body;
                                        r--;
                                        t = true;
                                    }
                                }
                            }
                        } else if (o instanceof mt) {
                            if (!L(o.init)) o.object = p(o.object);
                        } else if (o instanceof xn) {
                            o.condition = p(o.condition);
                        } else if (o instanceof Zt) {
                            o.expression = p(o.expression);
                        } else if (o instanceof gt) {
                            o.expression = p(o.expression);
                        }
                    }
                    if (n.option("conditionals") && o instanceof xn) {
                        var f = [];
                        var u = d(o.body, f);
                        var c = d(o.alternative, f);
                        if (u !== false && c !== false && f.length > 0) {
                            var l = f.length;
                            f.push(Fe(xn, o, {
                                condition: o.condition,
                                body: u || Fe(mn, o.body),
                                alternative: c
                            }));
                            f.unshift(r, 1);
                            [].splice.apply(e, f);
                            a += l;
                            r += l + 1;
                            i = null;
                            t = true;
                            continue;
                        }
                    }
                    e[r++] = o;
                    i = o instanceof _n ? o : null;
                }
                e.length = r;
                return t;
                function p(e) {
                    r--;
                    t = true;
                    var n = i.body;
                    return Pe(n, [ n, e ]);
                }
            }
            function v(e) {
                if (e instanceof Fn) return [ e ];
                if (e instanceof Tn) return e.expressions.slice();
            }
            function m(e, n, t) {
                var r = v(n);
                if (!r) return;
                t = t || 0;
                var i = false;
                for (var a = r.length - t; --a >= 0; ) {
                    var o = r[a];
                    if (!c(o)) continue;
                    var s;
                    if (o.left instanceof Hn) {
                        s = r.slice(a + 1);
                    } else if (o.left instanceof An && c(o.left.expression)) {
                        s = r.slice(a + 1);
                        var f = o.clone();
                        o = o.left.expression;
                        f.left = f.left.clone();
                        f.left.expression = o.left.clone();
                        s.unshift(f);
                    } else {
                        continue;
                    }
                    if (s.length == 0) continue;
                    if (!y(o.left, o.right, s)) continue;
                    i = true;
                    r = r.slice(0, a).concat(o, s);
                }
                if (e instanceof or) {
                    for (var a = e.definitions.length; --a >= 0; ) {
                        var u = e.definitions[a];
                        if (!u.value) continue;
                        if (y(u.name, u.value, r)) i = true;
                        if (g(u, r, t)) i = true;
                        break;
                    }
                    if (e instanceof ur && b(e.definitions, r, t)) i = true;
                }
                return i && r;
                function c(e) {
                    return e instanceof Fn && e.operator == "=";
                }
            }
            function _(e, n) {
                if (!(e instanceof _n)) return;
                if (ce(n)) return;
                var t = v(e.body);
                if (!t) return;
                var r = [];
                if (!b(r, t.reverse(), 0)) return;
                n.definitions = r.reverse().concat(n.definitions);
                return t.reverse();
            }
            function g(e, n, t) {
                if (!s.option("conditionals")) return;
                if (e.name instanceof jn) return;
                var r = false;
                var i = e.name.definition();
                while (n.length > t) {
                    var a = ee(s, i, e.value, n[0]);
                    if (!a) break;
                    e.value = a;
                    n.shift();
                    r = true;
                }
                return r;
            }
            function b(e, n, t) {
                var r = false;
                while (n.length > t) {
                    var i = n[0];
                    if (!(i instanceof Fn)) break;
                    if (i.operator != "=") break;
                    var a = i.left;
                    if (!(a instanceof Hn)) break;
                    if (Ne(a)) break;
                    if (a.scope.resolve() !== Oe) break;
                    var o = a.definition();
                    if (o.scope !== Oe) break;
                    if (o.orig.length > o.eliminated + 1) break;
                    if (o.orig[0].TYPE != "SymbolVar") break;
                    var s = Fe(zr, a);
                    e.push(Fe(kn, i, {
                        name: s,
                        value: i.right
                    }));
                    o.orig.push(s);
                    o.replaced++;
                    n.shift();
                    r = true;
                }
                return r;
            }
            function y(e, i, n) {
                var a = new hn();
                a.set(e.name, true);
                while (i instanceof Fn && i.operator == "=") {
                    if (i.left instanceof Hn) a.set(i.left.name, true);
                    i = i.right;
                }
                if (!(i instanceof Nn)) return;
                var t = false;
                do {
                    if (!o(n[0])) break;
                    n.shift();
                    t = true;
                } while (n.length);
                return t;
                function o(e) {
                    if (!(e instanceof Fn)) return;
                    if (e.operator != "=") return;
                    if (!(e.left instanceof An)) return;
                    var n = e.left.expression;
                    if (!(n instanceof Hn)) return;
                    if (!a.has(n.name)) return;
                    if (!e.right.is_constant_expression(Oe)) return;
                    var t = e.left.property;
                    if (t instanceof vn) {
                        if (o(t)) t = e.left.property = t.right.clone();
                        t = t.evaluate(s);
                    }
                    if (t instanceof vn) return;
                    t = "" + t;
                    var r = t == "__proto__" || s.has_directive("use strict") ? function(e) {
                        var n = e.key;
                        return typeof n == "string" && n != t && n != "__proto__";
                    } : function(e) {
                        var n = e.key;
                        if (e instanceof Tr || e instanceof Sr) {
                            return typeof n == "string" && n != t;
                        }
                        return n !== "__proto__";
                    };
                    if (!dn(i.properties, r)) return;
                    i.properties.push(Fe(kr, e, {
                        key: t,
                        value: e.right
                    }));
                    return true;
                }
            }
            function w(e) {
                var i = false, a;
                for (var n = 0, t = -1; n < e.length; n++) {
                    var r = e[n];
                    var o = e[t];
                    if (r instanceof or) {
                        if (o && o.TYPE == r.TYPE) {
                            o.definitions = o.definitions.concat(r.definitions);
                            i = true;
                        } else if (a && a.TYPE == r.TYPE && ce(r)) {
                            a.definitions = a.definitions.concat(r.definitions);
                            i = true;
                        } else if (r instanceof ur) {
                            var s = _(o, r);
                            if (s) {
                                if (s.length) {
                                    o.body = Pe(o, s);
                                    t++;
                                }
                                i = true;
                            } else {
                                t++;
                            }
                            e[t] = a = r;
                        } else {
                            e[++t] = r;
                        }
                        continue;
                    } else if (r instanceof Gt) {
                        r.value = c(r.value);
                    } else if (r instanceof ht) {
                        var s = m(o, r.init);
                        if (s) {
                            i = true;
                            r.init = s.length ? Pe(r.init, s) : null;
                        } else if (o instanceof ur && (!r.init || r.init.TYPE == o.TYPE)) {
                            if (r.init) {
                                o.definitions = o.definitions.concat(r.init.definitions);
                            }
                            r = r.clone();
                            a = r.init = o;
                            e[t] = l(r);
                            i = true;
                            continue;
                        } else if (a && r.init && a.TYPE == r.init.TYPE && ce(r.init)) {
                            a.definitions = a.definitions.concat(r.init.definitions);
                            r.init = null;
                            i = true;
                        } else if (r.init instanceof ur) {
                            a = r.init;
                            s = _(o, r.init);
                            if (s) {
                                i = true;
                                if (s.length == 0) {
                                    e[t] = l(r);
                                    continue;
                                }
                                o.body = Pe(o, s);
                            }
                        }
                    } else if (r instanceof vt) {
                        if (a && a.TYPE == r.init.TYPE) {
                            var f = a.definitions.slice();
                            r.init = r.init.definitions[0].name.convert_symbol(Hn, function(e, n) {
                                f.push(Fe(kn, n, {
                                    name: n,
                                    value: null
                                }));
                                n.definition().references.push(e);
                            });
                            a.definitions = f;
                            i = true;
                        }
                        r.object = c(r.object);
                    } else if (r instanceof xn) {
                        r.condition = c(r.condition);
                    } else if (r instanceof _n) {
                        var s = m(o, r.body), u;
                        if (s) {
                            i = true;
                            if (!s.length) continue;
                            r.body = Pe(r.body, s);
                        } else if (o instanceof or && (u = e[n + 1]) && o.TYPE == u.TYPE && (u = u.definitions[0]).value) {
                            i = true;
                            u.value = Pe(r, [ r.body, u.value ]);
                            continue;
                        }
                    } else if (r instanceof Zt) {
                        r.expression = c(r.expression);
                    } else if (r instanceof gt) {
                        r.expression = c(r.expression);
                    }
                    e[++t] = a ? l(r) : r;
                }
                e.length = t + 1;
                return i;
                function c(e) {
                    var n = m(o, e, 1);
                    if (!n) return e;
                    i = true;
                    var t = e.tail_node();
                    if (n[n.length - 1] !== t) n.push(t.left);
                    return Pe(e, n);
                }
                function l(e) {
                    return e.transform(new Zr(function(e, n, t) {
                        if (e instanceof or) {
                            if (a === e) return e;
                            if (a.TYPE != e.TYPE) return e;
                            var r = this.parent();
                            if (r instanceof vt && r.init === e) return e;
                            if (!ce(e)) return e;
                            a.definitions = a.definitions.concat(e.definitions);
                            i = true;
                            if (r instanceof ht && r.init === e) return null;
                            return t ? Xn.skip : Fe(mn, e);
                        }
                        if (e instanceof cr) return e;
                        if (e instanceof bn) return e;
                        if (!at(e)) return e;
                    }));
                }
            }
        }
        function z(i, a, o) {
            var s;
            var f = false;
            a.walk(new Ln(function(e, n) {
                if (e instanceof It) {
                    e.extends = null;
                    e.properties = [];
                    u(e);
                    return true;
                }
                if (e instanceof or) {
                    var t = [];
                    if (e.remove_initializers(i, t)) {
                        vn.warn("Dropping initialization in unreachable code [{start}]", e);
                    }
                    if (t.length > 0) {
                        e.definitions = t;
                        u(e);
                    }
                    return true;
                }
                if (e instanceof Ct) {
                    u(e);
                    return true;
                }
                if (e instanceof bn) return true;
                if (e instanceof ot) {
                    var r = s;
                    s = [];
                    n();
                    if (s.required) {
                        o.push(Fe(gn, a, {
                            body: s
                        }));
                    } else if (s.length) {
                        [].push.apply(o, s);
                    }
                    s = r;
                    return true;
                }
                if (!(e instanceof Xt)) f = true;
            }));
            if (f) vn.warn("Dropping unreachable code [{start}]", a);
            function u(e) {
                if (s) {
                    s.push(e);
                    if (!S(e)) s.required = true;
                } else {
                    o.push(e);
                }
            }
        }
        function Ie(e, n) {
            return e == null || e.is_undefined || e instanceof Wr || e instanceof zn && e.operator == "void" && !(n && e.expression.has_side_effects(n));
        }
        (function(e) {
            e(Nt, ln);
            e(bn, function(e) {
                var n = this.body;
                for (var t = 0; t < n.length; t++) {
                    var r = n[t];
                    if (!(r instanceof it)) break;
                    if (r.value == "use strict") return true;
                }
                var i = this.parent_scope;
                if (!i) return e.option("module");
                return i.resolve(true).in_strict_mode(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("in_strict_mode", n);
        });
        (function(e) {
            e(vn, cn);
            e(Pn, ln);
            e(Fn, function() {
                return this.operator == "=" && this.right.is_truthy();
            });
            e(yn, ln);
            e(Nn, ln);
            e(Lr, ln);
            e(Tn, function() {
                return this.tail_node().is_truthy();
            });
            e(Hn, function() {
                var e = this.fixed_value();
                if (!e) return false;
                this.is_truthy = cn;
                var n = e.is_truthy();
                delete this.is_truthy;
                return n;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_truthy", n);
        });
        (function(e) {
            e(vn, ln);
            e(Pn, cn);
            function n(e, n, t) {
                switch (e) {
                  case "-":
                    return n.is_negative_zero() && (!(t instanceof Yn) || t.value == 0);

                  case "&&":
                  case "||":
                    return n.is_negative_zero() || t.is_negative_zero();

                  case "*":
                  case "/":
                  case "%":
                  case "**":
                    return true;

                  default:
                    return false;
                }
            }
            e(Fn, function() {
                var e = this.operator;
                if (e == "=") return this.right.is_negative_zero();
                return n(e.slice(0, -1), this.left, this.right);
            });
            e(Cn, function() {
                return n(this.operator, this.left, this.right);
            });
            e(Yn, function() {
                return this.value == 0 && 1 / this.value < 0;
            });
            e(yn, cn);
            e(Nn, cn);
            e(Lr, cn);
            e(Tn, function() {
                return this.tail_node().is_negative_zero();
            });
            e(Hn, function() {
                var e = this.fixed_value();
                if (!e) return true;
                this.is_negative_zero = ln;
                var n = e.is_negative_zero();
                delete this.is_negative_zero;
                return n;
            });
            e(zn, function() {
                return this.operator == "+" && this.expression.is_negative_zero() || this.operator == "-";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_negative_zero", n);
        });
        (function(e) {
            vn.DEFMETHOD("may_throw_on_access", function(e, n) {
                return !e.option("pure_getters") || this._dot_throw(e, n);
            });
            function i(e, n) {
                return n || /strict/.test(e.option("pure_getters"));
            }
            e(vn, i);
            e(Pn, cn);
            e(Fn, function(e) {
                var n = this.operator;
                var t = this.left;
                var r = this.right;
                if (n != "=") {
                    return He[n.slice(0, -1)] && (t._dot_throw(e) || r._dot_throw(e));
                }
                if (!r._dot_throw(e)) return false;
                if (!(t instanceof Hn)) return true;
                if (r instanceof Cn && r.operator == "||" && t.name == r.left.name) {
                    return r.right._dot_throw(e);
                }
                return true;
            });
            e(Cn, function(e) {
                return He[this.operator] && (this.left._dot_throw(e) || this.right._dot_throw(e));
            });
            e(Nt, function(e, n) {
                return i(e, n) && !dn(this.properties, function(e) {
                    if (e.private) return true;
                    if (!e.static) return true;
                    return !(e instanceof Bt || e instanceof Lt);
                });
            });
            e(Mn, function(e) {
                return this.consequent._dot_throw(e) || this.alternative._dot_throw(e);
            });
            e(Yn, cn);
            e(Dn, function(e, n) {
                if (!i(e, n)) return false;
                var t = this.expression;
                if (t instanceof Hn) t = t.fixed_value();
                return !(this.property == "prototype" && O(t));
            });
            e(yn, cn);
            e(Ur, ln);
            e(Nn, function(n, t) {
                return i(n, t) && !dn(this.properties, function(e) {
                    if (e instanceof Tr || e instanceof Sr) return false;
                    return !(e.key === "__proto__" && e.value._dot_throw(n, t));
                });
            });
            e(Nr, function(e, n) {
                return i(e, n) && !this.scope.resolve().new;
            });
            e(Tn, function(e) {
                return this.tail_node()._dot_throw(e);
            });
            e(Hn, function(e, n) {
                if (this.is_undefined) return true;
                if (!i(e, n)) return false;
                if (Ne(this) && this.is_declared(e)) return false;
                if (this.is_immutable()) return false;
                var t = this.definition();
                if (ze(t) && !t.scope.rest && dn(t.scope.argnames, function(e) {
                    return e instanceof In;
                })) return t.scope.uses_arguments > 2;
                var r = this.fixed_value();
                if (!r) return true;
                this._dot_throw = ln;
                if (r._dot_throw(e)) {
                    delete this._dot_throw;
                    return true;
                }
                this._dot_throw = cn;
                return false;
            });
            e(zn, function() {
                return this.operator == "void";
            });
            e(mr, cn);
            e(Wr, ln);
        })(function(e, n) {
            e.DEFMETHOD("_dot_throw", n);
        });
        (function(e) {
            e(vn, cn);
            e(Pn, ln);
            function t(e, n, t) {
                switch (n) {
                  case "&&":
                    return t.left.is_defined(e) && t.right.is_defined(e);

                  case "||":
                    return t.left.is_truthy() || t.right.is_defined(e);

                  case "??":
                    return t.left.is_defined(e) || t.right.is_defined(e);

                  default:
                    return true;
                }
            }
            e(Fn, function(e) {
                var n = this.operator;
                if (n == "=") return this.right.is_defined(e);
                return t(e, n.slice(0, -1), this);
            });
            e(Cn, function(e) {
                return t(e, this.operator, this);
            });
            e(Mn, function(e) {
                return this.consequent.is_defined(e) && this.alternative.is_defined(e);
            });
            e(Yn, ln);
            e(Gr, cn);
            e(yn, ln);
            e(Nn, ln);
            e(Tn, function(e) {
                return this.tail_node().is_defined(e);
            });
            e(Hn, function(e) {
                if (this.is_undefined) return false;
                if (Ne(this) && this.is_declared(e)) return true;
                if (this.is_immutable()) return true;
                var n = this.fixed_value();
                if (!n) return false;
                this.is_defined = cn;
                var t = n.is_defined(e);
                delete this.is_defined;
                return t;
            });
            e(zn, function() {
                return this.operator != "void";
            });
            e(mr, ln);
            e(Wr, cn);
        })(function(e, n) {
            e.DEFMETHOD("is_defined", n);
        });
        (function(e) {
            e(vn, cn);
            e(Fn, function(e) {
                return this.operator == "=" && this.right.is_boolean(e);
            });
            var n = pn("in instanceof == != === !== < <= >= >");
            e(Cn, function(e) {
                return n[this.operator] || He[this.operator] && this.left.is_boolean(e) && this.right.is_boolean(e);
            });
            e(Xr, ln);
            var t = pn("every hasOwnProperty isPrototypeOf propertyIsEnumerable some");
            e(Sn, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof Dn && (t[n.property] || n.property == "test" && n.expression instanceof Lr);
            });
            e(Mn, function(e) {
                return this.consequent.is_boolean(e) && this.alternative.is_boolean(e);
            });
            e(hr, cn);
            e(Tn, function(e) {
                return this.tail_node().is_boolean(e);
            });
            e(Hn, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_boolean = cn;
                var t = n.is_boolean(e);
                delete this.is_boolean;
                return t;
            });
            var r = pn("! delete");
            e(zn, function() {
                return r[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_boolean", n);
        });
        (function(e) {
            e(vn, cn);
            var n = pn("- * / % ** & | ^ << >> >>>");
            e(Fn, function(e) {
                return n[this.operator.slice(0, -1)] || this.operator == "=" && this.right.is_number(e);
            });
            e(Cn, function(e) {
                if (n[this.operator]) return true;
                if (this.operator != "+") return false;
                return (this.left.is_boolean(e) || this.left.is_number(e)) && (this.right.is_boolean(e) || this.right.is_number(e));
            });
            var t = pn([ "charCodeAt", "getDate", "getDay", "getFullYear", "getHours", "getMilliseconds", "getMinutes", "getMonth", "getSeconds", "getTime", "getTimezoneOffset", "getUTCDate", "getUTCDay", "getUTCFullYear", "getUTCHours", "getUTCMilliseconds", "getUTCMinutes", "getUTCMonth", "getUTCSeconds", "getYear", "indexOf", "lastIndexOf", "localeCompare", "push", "search", "setDate", "setFullYear", "setHours", "setMilliseconds", "setMinutes", "setMonth", "setSeconds", "setTime", "setUTCDate", "setUTCFullYear", "setUTCHours", "setUTCMilliseconds", "setUTCMinutes", "setUTCMonth", "setUTCSeconds", "setYear" ]);
            e(Sn, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof Dn && (t[n.property] || Ne(n.expression) && n.expression.name == "Math");
            });
            e(Mn, function(e) {
                return this.consequent.is_number(e) && this.alternative.is_number(e);
            });
            e(hr, cn);
            e(Bn, ln);
            e(Tn, function(e) {
                return this.tail_node().is_number(e);
            });
            e(Hn, function(e, n) {
                var t = this.fixed_value();
                if (!t) return false;
                if (n && t instanceof zn && t.operator == "+" && t.expression.equals(this)) {
                    return false;
                }
                this.is_number = cn;
                var r = t.is_number(e);
                delete this.is_number;
                return r;
            });
            var r = pn("+ - ~ ++ --");
            e($n, function() {
                return r[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_number", n);
        });
        (function(e) {
            e(vn, cn);
            e(Fn, function(e) {
                switch (this.operator) {
                  case "+=":
                    if (this.left.is_string(e)) return true;

                  case "=":
                    return this.right.is_string(e);
                }
            });
            e(Cn, function(e) {
                return this.operator == "+" && (this.left.is_string(e) || this.right.is_string(e));
            });
            var t = pn([ "charAt", "substr", "substring", "toExponential", "toFixed", "toLowerCase", "toPrecision", "toString", "toUpperCase", "trim" ]);
            e(Sn, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof Dn && t[n.property];
            });
            e(Mn, function(e) {
                return this.consequent.is_string(e) && this.alternative.is_string(e);
            });
            e(Tn, function(e) {
                return this.tail_node().is_string(e);
            });
            e(Rn, ln);
            e(Hn, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_string = cn;
                var t = n.is_string(e);
                delete this.is_string;
                return t;
            });
            e(Rr, function(e) {
                return !this.tag || Oe(e, this.tag);
            });
            e(zn, function() {
                return this.operator == "typeof";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_string", n);
        });
        var He = pn("&& || ??");
        (function(e) {
            function i(e, n) {
                if (e instanceof vn) return e.clone(true);
                if (Array.isArray(e)) return Fe(Pn, n, {
                    elements: e.map(function(e) {
                        return i(e, n);
                    })
                });
                if (e && typeof e == "object") {
                    var t = [];
                    for (var r in e) if (et(e, r)) {
                        t.push(Fe(kr, n, {
                            key: r,
                            value: i(e[r], n)
                        }));
                    }
                    return Fe(Nn, n, {
                        properties: t
                    });
                }
                return fe(e, n);
            }
            function o(e) {
                vn.warn("global_defs {this} redefined [{start}]", e);
            }
            bt.DEFMETHOD("resolve_defines", function(a) {
                if (!a.option("global_defs")) return this;
                this.figure_out_scope({
                    ie: a.option("ie")
                });
                return this.transform(new Zr(function(e) {
                    var n = e._find_defs(a, "");
                    if (!n) return;
                    var t = 0, r = e, i;
                    while (i = this.parent(t++)) {
                        if (!(i instanceof An)) break;
                        if (i.expression !== r) break;
                        r = i;
                    }
                    if (fi(r, i)) {
                        o(e);
                        return;
                    }
                    return n;
                }));
            });
            e(vn, Wn);
            e(Dn, function(e, n) {
                return this.expression._find_defs(e, "." + this.property + n);
            });
            e(Dr, function(e) {
                if (!this.definition().global) return;
                if (et(e.option("global_defs"), this.name)) o(this);
            });
            e(Hn, function(e, n) {
                if (!this.definition().global) return;
                var t = e.option("global_defs");
                var r = this.name + n;
                if (et(t, r)) return i(t[r], this);
            });
        })(function(e, n) {
            e.DEFMETHOD("_find_defs", n);
        });
        function le(e, n, t) {
            var r = n.print_to_string().length - e.print_to_string().length;
            return r < (t || 0) ? n : e;
        }
        function A(e, n, t) {
            return le(Fe(_n, e, {
                body: e
            }), Fe(_n, n, {
                body: n
            }), t).body;
        }
        function pe(e, n, t, r) {
            return (nt(e) ? A : le)(n, t, r);
        }
        function s(n) {
            var t = Object.create(null);
            Object.keys(n).forEach(function(e) {
                t[e] = pn(n[e]);
            });
            return t;
        }
        function f(e) {
            for (var n = 0; n < e.length; n++) {
                var t = e[n];
                if (!(t instanceof it)) return t;
            }
        }
        function u() {
            if (this.value) return Fe(wn, this.value, {
                value: this.value
            });
            return f(this.body);
        }
        At.DEFMETHOD("first_statement", u);
        Dt.DEFMETHOD("first_statement", u);
        yn.DEFMETHOD("first_statement", function() {
            return f(this.body);
        });
        yn.DEFMETHOD("length", function() {
            var e = this.argnames;
            for (var n = 0; n < e.length; n++) {
                if (e[n] instanceof En) break;
            }
            return n;
        });
        function de(e, n) {
            var t = n.evaluate(e);
            if (t === n) return n;
            t = fe(t, n).optimize(e);
            return pe(e, n, t, e.eval_threshold);
        }
        var n = [ "constructor", "toString", "valueOf" ];
        var b = s({
            Array: [ "indexOf", "join", "lastIndexOf", "slice" ].concat(n),
            Boolean: n,
            Function: n,
            Number: [ "toExponential", "toFixed", "toPrecision" ].concat(n),
            Object: n,
            RegExp: [ "exec", "test" ].concat(n),
            String: [ "charAt", "charCodeAt", "concat", "indexOf", "italics", "lastIndexOf", "match", "replace", "search", "slice", "split", "substr", "substring", "toLowerCase", "toUpperCase", "trim" ].concat(n)
        });
        var w = s({
            Array: [ "isArray" ],
            Math: [ "abs", "acos", "asin", "atan", "ceil", "cos", "exp", "floor", "log", "round", "sin", "sqrt", "tan", "atan2", "pow", "max", "min" ],
            Number: [ "isFinite", "isNaN" ],
            Object: [ "create", "getOwnPropertyDescriptor", "getOwnPropertyNames", "getPrototypeOf", "isExtensible", "isFrozen", "isSealed", "keys" ],
            String: [ "fromCharCode", "raw" ]
        });
        function Xe(e) {
            if (!(e instanceof Dn)) return false;
            var n = e.expression;
            if (!Ne(n)) return false;
            var t = w[n.name];
            return t && (t[e.property] || n.name == "Math" && e.property == "random");
        }
        (function(e) {
            e(vn, cn);
            e(Yn, ln);
            e(Lr, cn);
            var n = pn("! ~ - + void");
            e(zn, function() {
                return n[this.operator] && this.expression instanceof Yn;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant", n);
        });
        (function(e) {
            vn.DEFMETHOD("evaluate", function(e, n) {
                if (!e.option("evaluate")) return this;
                var t = [];
                var r = this._eval(e, n, t, 1);
                t.forEach(function(e) {
                    delete e._eval;
                });
                if (n) return r;
                if (!r || r instanceof RegExp) return r;
                if (typeof r == "function" || typeof r == "object") return this;
                return r;
            });
            var m = new Ln(function(e) {
                if (e instanceof Fn) u(e.left);
                if (e instanceof vt) u(e.init);
                if (e instanceof $n && ri[e.operator]) u(e.expression);
            });
            function u(e) {
                if (e instanceof br) {
                    e.elements.forEach(u);
                } else if (e instanceof wr) {
                    e.properties.forEach(function(e) {
                        u(e.value);
                    });
                } else if (e instanceof An) {
                    u(e.expression);
                } else if (e instanceof Hn) {
                    e.definition().references.forEach(function(e) {
                        delete e._eval;
                    });
                }
            }
            e(tt, function() {
                throw new Error(Qn("Cannot evaluate a statement [{start}]", this));
            });
            e(wt, Gn);
            e(Br, Gn);
            e(Nt, Gn);
            e(vn, Gn);
            e(Yn, function() {
                return this.value;
            });
            e(Fn, function(e, n, t, r) {
                var i = this.left;
                if (!n) {
                    if (!(i instanceof Hn)) return this;
                    if (!et(i, "_eval")) {
                        if (!i.fixed) return this;
                        var a = i.definition();
                        if (!a.fixed) return this;
                        if (a.undeclared) return this;
                        if (a.last_ref !== i) return this;
                        if (a.single_use == "m") return this;
                        if (this.right.has_side_effects(e)) return this;
                    }
                }
                var o = this.operator;
                var s;
                if (!et(i, "_eval") && i instanceof Hn && i.fixed && i.definition().fixed) {
                    s = i;
                } else if (o == "=") {
                    s = this.right;
                } else {
                    s = Fe(Cn, this, {
                        operator: o.slice(0, -1),
                        left: i,
                        right: this.right
                    });
                }
                i.walk(m);
                var f = s._eval(e, n, t, r);
                if (typeof f == "object") return this;
                u(i);
                return f;
            });
            e(Tn, function(e, n, t, r) {
                if (!n) return this;
                var i = this.expressions;
                for (var a = 0, o = i.length - 1; a < o; a++) {
                    i[a].walk(m);
                }
                var s = i[o];
                var f = s._eval(e, n, t, r);
                return f === s ? this : f;
            });
            e(yn, function(e) {
                if (e.option("unsafe")) {
                    var n = function() {};
                    n.node = this;
                    n.toString = function() {
                        return "function(){}";
                    };
                    return n;
                }
                return this;
            });
            e(Pn, function(e, n, t, r) {
                if (e.option("unsafe")) {
                    var i = [];
                    for (var a = 0; a < this.elements.length; a++) {
                        var o = this.elements[a];
                        if (o instanceof Gr) return this;
                        var s = o._eval(e, n, t, r);
                        if (o === s) return this;
                        i.push(s);
                    }
                    return i;
                }
                return this;
            });
            e(Nn, function(e, n, t, r) {
                if (e.option("unsafe")) {
                    var i = {};
                    for (var a = 0; a < this.properties.length; a++) {
                        var o = this.properties[a];
                        if (!(o instanceof kr)) return this;
                        var s = o.key;
                        if (s instanceof vn) {
                            s = s._eval(e, n, t, r);
                            if (s === o.key) return this;
                        }
                        switch (s) {
                          case "__proto__":
                          case "toString":
                          case "valueOf":
                            return this;
                        }
                        i[s] = o.value._eval(e, n, t, r);
                        if (i[s] === o.value) return this;
                    }
                    return i;
                }
                return this;
            });
            var f = pn("! typeof void");
            e(zn, function(e, n, t, r) {
                var i = this.expression;
                var a = this.operator;
                if (e.option("typeofs") && a == "typeof" && (i instanceof yn || i instanceof Hn && i.fixed_value() instanceof yn)) {
                    return typeof function() {};
                }
                var o = i instanceof Hn && i.definition();
                if (!f[a] && !(o && o.fixed)) r++;
                i.walk(m);
                var s = i._eval(e, n, t, r);
                if (s === i) {
                    if (n && a == "void") return;
                    return this;
                }
                switch (a) {
                  case "!":
                    return !s;

                  case "typeof":
                    if (s instanceof RegExp) return this;
                    return typeof s;

                  case "void":
                    return;

                  case "~":
                    return ~s;

                  case "-":
                    return -s;

                  case "+":
                    return +s;

                  case "++":
                  case "--":
                    if (!o) return this;
                    if (!n) {
                        if (o.undeclared) return this;
                        if (o.last_ref !== i) return this;
                    }
                    if (et(i, "_eval")) s = +(a[0] + 1) + +s;
                    u(i);
                    return s;
                }
                return this;
            });
            e(mr, function(e, n, t, r) {
                var i = this.expression;
                if (!(i instanceof Hn)) {
                    if (!n) return this;
                } else if (!et(i, "_eval")) {
                    if (!i.fixed) return this;
                    if (!n) {
                        var a = i.definition();
                        if (!a.fixed) return this;
                        if (a.undeclared) return this;
                        if (a.last_ref !== i) return this;
                    }
                }
                if (!(i instanceof Hn && i.definition().fixed)) r++;
                i.walk(m);
                var o = i._eval(e, n, t, r);
                if (o === i) return this;
                u(i);
                return +o;
            });
            var c = pn("&& || === !==");
            e(Cn, function(e, n, t, r) {
                if (!c[this.operator]) r++;
                var i = this.left._eval(e, n, t, r);
                if (i === this.left) return this;
                if (this.operator == (i ? "||" : "&&")) return i;
                var a = n && !(i && typeof i == "object");
                var o = this.right._eval(e, a, t, r);
                if (o === this.right) return this;
                var s;
                switch (this.operator) {
                  case "&&":
                    s = i && o;
                    break;

                  case "||":
                    s = i || o;
                    break;

                  case "??":
                    s = i == null ? o : i;
                    break;

                  case "|":
                    s = i | o;
                    break;

                  case "&":
                    s = i & o;
                    break;

                  case "^":
                    s = i ^ o;
                    break;

                  case "+":
                    s = i + o;
                    break;

                  case "-":
                    s = i - o;
                    break;

                  case "*":
                    s = i * o;
                    break;

                  case "/":
                    s = i / o;
                    break;

                  case "%":
                    s = i % o;
                    break;

                  case "<<":
                    s = i << o;
                    break;

                  case ">>":
                    s = i >> o;
                    break;

                  case ">>>":
                    s = i >>> o;
                    break;

                  case "==":
                    s = i == o;
                    break;

                  case "===":
                    s = i === o;
                    break;

                  case "!=":
                    s = i != o;
                    break;

                  case "!==":
                    s = i !== o;
                    break;

                  case "<":
                    s = i < o;
                    break;

                  case "<=":
                    s = i <= o;
                    break;

                  case ">":
                    s = i > o;
                    break;

                  case ">=":
                    s = i >= o;
                    break;

                  case "**":
                    s = Math.pow(i, o);
                    break;

                  case "in":
                    if (o && typeof o == "object" && et(o, i)) {
                        s = true;
                        break;
                    }

                  default:
                    return this;
                }
                if (isNaN(s)) return e.find_parent(gt) ? this : s;
                if (e.option("unsafe_math") && !n && s && typeof s == "number" && (this.operator == "+" || this.operator == "-")) {
                    var f = Math.max(0, u(i), u(o));
                    if (f < 16) return +s.toFixed(f);
                }
                return s;
                function u(e) {
                    var n = /(\.[0-9]*)?(e[^e]+)?$/.exec(+e);
                    return (n[1] || ".").length - 1 - (n[2] || "").slice(1);
                }
            });
            e(Mn, function(e, n, t, r) {
                var i = this.condition._eval(e, n, t, r);
                if (i === this.condition) return this;
                var a = i ? this.consequent : this.alternative;
                var o = a._eval(e, n, t, r);
                return o === a ? this : o;
            });
            function o(n, e) {
                var t = n.definition().escaped;
                switch (t.length) {
                  case 0:
                    return true;

                  case 1:
                    var r = false;
                    t[0].walk(new Ln(function(e) {
                        if (r) return true;
                        if (e === n) return r = true;
                        if (e instanceof bn) return true;
                    }));
                    return r;

                  default:
                    return e <= t.depth;
                }
            }
            e(Hn, function(e, n, t, r) {
                var i = this.fixed_value();
                if (!i) return this;
                var a;
                if (et(i, "_eval")) {
                    a = i._eval();
                } else {
                    this._eval = Gn;
                    a = i._eval(e, n, t, r);
                    delete this._eval;
                    if (a === i) return this;
                    i._eval = function() {
                        return a;
                    };
                    t.push(i);
                }
                return a && typeof a == "object" && !o(this, r) ? this : a;
            });
            var _ = {
                Array: Array,
                Math: Math,
                Number: Number,
                Object: Object,
                String: String
            };
            var l = s({
                Math: [ "E", "LN10", "LN2", "LOG2E", "LOG10E", "PI", "SQRT1_2", "SQRT2" ],
                Number: [ "MAX_VALUE", "MIN_VALUE", "NaN", "NEGATIVE_INFINITY", "POSITIVE_INFINITY" ]
            });
            var p = pn("global ignoreCase multiline source");
            e(An, function(e, n, t, r) {
                if (e.option("unsafe")) {
                    var i;
                    var a = this.expression;
                    if (!Ne(a)) {
                        i = a._eval(e, n, t, r + 1);
                        if (i == null || i === a) return this;
                    }
                    var o = this.property;
                    if (o instanceof vn) {
                        o = o._eval(e, n, t, r);
                        if (o === this.property) return this;
                    }
                    if (i === undefined) {
                        var s = l[a.name];
                        if (!s || !s[o]) return this;
                        i = _[a.name];
                    } else if (i instanceof RegExp) {
                        if (!p[o]) return this;
                    } else if (typeof i == "object") {
                        if (!et(i, o)) return this;
                    } else if (typeof i == "function") switch (o) {
                      case "name":
                        return i.node.name ? i.node.name.name : "";

                      case "length":
                        return i.node.length();

                      default:
                        return this;
                    }
                    return i[o];
                }
                return this;
            });
            function g(e, n, t, r, i) {
                var a = [];
                for (var o = 0; o < e.length; o++) {
                    var s = e[o];
                    var f = s._eval(n, t, r, i);
                    if (s === f) return;
                    a.push(f);
                }
                return a;
            }
            e(Sn, function(r, i, a, o) {
                var e = this.expression;
                var n = e instanceof Hn ? e.fixed_value() : e;
                if (n instanceof At || n instanceof Pt || n instanceof $t) {
                    if (n.evaluating) return this;
                    if (n.name && n.name.definition().recursive_refs > 0) return this;
                    if (this.is_expr_pure(r)) return this;
                    var s = g(this.args, r, i, a, o);
                    if (!dn(n.argnames, function(e, n) {
                        if (e instanceof En) {
                            if (!s) return false;
                            if (s[n] === undefined) {
                                var t = e.value._eval(r, i, a, o);
                                if (t === e.value) return false;
                                s[n] = t;
                            }
                            e = e.name;
                        }
                        return !(e instanceof jn);
                    })) return this;
                    if (n.rest instanceof jn) return this;
                    if (!s && !i) return this;
                    var t = n.first_statement();
                    if (!(t instanceof wn)) {
                        if (i) {
                            n.walk(m);
                            var f = false;
                            n.evaluating = true;
                            st(n, new Ln(function(e) {
                                if (f) return true;
                                if (e instanceof wn) {
                                    if (e.value && e.value._eval(r, true, a, o) !== undefined) {
                                        f = true;
                                    }
                                    return true;
                                }
                                if (e instanceof bn && e !== n) return true;
                            }));
                            n.evaluating = false;
                            if (!f) return;
                        }
                        return this;
                    }
                    var u = t.value;
                    if (!u) return;
                    var c = [];
                    if (!s || dn(n.argnames, function(e, n) {
                        return v(e, s[n]);
                    }) && !(n.rest && !v(n.rest, s.slice(n.argnames.length))) || i) {
                        if (i) n.argnames.forEach(function(e) {
                            if (e instanceof En) e.value.walk(m);
                        });
                        n.evaluating = true;
                        u = u._eval(r, i, a, o);
                        n.evaluating = false;
                    }
                    c.forEach(function(e) {
                        delete e._eval;
                    });
                    return u === t.value ? this : u;
                } else if (r.option("unsafe") && e instanceof An) {
                    var l = e.property;
                    if (l instanceof vn) {
                        l = l._eval(r, i, a, o);
                        if (l === e.property) return this;
                    }
                    var u;
                    var p = e.expression;
                    if (Ne(p)) {
                        var d = w[p.name];
                        if (!d || !d[l]) return this;
                        u = _[p.name];
                    } else {
                        u = p._eval(r, i, a, o + 1);
                        if (u == null || u === p) return this;
                        var h = b[u.constructor.name];
                        if (!h || !h[l]) return this;
                        if (u instanceof RegExp && u.global && !(p instanceof Lr)) return this;
                    }
                    var s = g(this.args, r, i, a, o);
                    if (!s) return this;
                    if (l == "replace" && typeof s[1] == "function") return this;
                    try {
                        return u[l].apply(u, s);
                    } catch (e) {
                        vn.warn("Error evaluating {this} [{start}]", this);
                    } finally {
                        if (u instanceof RegExp) u.lastIndex = 0;
                    }
                }
                return this;
                function v(e, n) {
                    if (e instanceof En) e = e.name;
                    var t = e.definition();
                    if (t.orig[t.orig.length - 1] !== e) return false;
                    var r = n;
                    t.references.forEach(function(e) {
                        e._eval = function() {
                            return r;
                        };
                        c.push(e);
                    });
                    return true;
                }
            });
            e(hr, Gn);
            e(Rr, function(e, n, t, r) {
                if (!e.option("templates")) return this;
                if (this.tag) {
                    if (!Oe(e, this.tag)) return this;
                    f = function(e) {
                        return e;
                    };
                }
                var i = g(this.expressions, e, n, t, r);
                if (!i) return this;
                var a = false;
                var o = f(this.strings[0]);
                for (var s = 0; s < i.length; s++) {
                    o += i[s] + f(this.strings[s + 1]);
                }
                if (!a) return o;
                this._eval = Gn;
                return this;
                function f(e) {
                    e = Ze(e);
                    if (typeof e != "string") a = true;
                    return e;
                }
            });
        })(function(e, n) {
            e.DEFMETHOD("_eval", n);
        });
        (function(e) {
            function i(e) {
                return Fe(zn, e, {
                    operator: "!",
                    expression: e
                });
            }
            function a(e, n, t) {
                var r = i(e);
                if (t) return le(r, Fe(_n, n, {
                    body: n
                })) === r ? r : n;
                return le(r, n);
            }
            e(vn, function() {
                return i(this);
            });
            e(tt, function() {
                throw new Error("Cannot negate a statement");
            });
            e(Cn, function(e, n) {
                var t = this.clone(), r = this.operator;
                if (e.option("unsafe_comps")) {
                    switch (r) {
                      case "<=":
                        t.operator = ">";
                        return t;

                      case "<":
                        t.operator = ">=";
                        return t;

                      case ">=":
                        t.operator = "<";
                        return t;

                      case ">":
                        t.operator = "<=";
                        return t;
                    }
                }
                switch (r) {
                  case "==":
                    t.operator = "!=";
                    return t;

                  case "!=":
                    t.operator = "==";
                    return t;

                  case "===":
                    t.operator = "!==";
                    return t;

                  case "!==":
                    t.operator = "===";
                    return t;

                  case "&&":
                    t.operator = "||";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return a(this, t, n);

                  case "||":
                    t.operator = "&&";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return a(this, t, n);
                }
                return i(this);
            });
            e(Ht, function() {
                return i(this);
            });
            e(Mn, function(e, n) {
                var t = this.clone();
                t.consequent = t.consequent.negate(e);
                t.alternative = t.alternative.negate(e);
                return a(this, t, n);
            });
            e(xt, function() {
                return i(this);
            });
            e(Tn, function(e) {
                var n = this.expressions.slice();
                n.push(n.pop().negate(e));
                return Pe(this, n);
            });
            e(zn, function() {
                if (this.operator == "!") return this.expression;
                return i(this);
            });
        })(function(e, t) {
            e.DEFMETHOD("negate", function(e, n) {
                return t.call(this, e, n);
            });
        });
        var p = pn("Boolean decodeURI decodeURIComponent Date encodeURI encodeURIComponent Error escape EvalError isFinite isNaN Number Object parseFloat parseInt RangeError ReferenceError String SyntaxError TypeError unescape URIError");
        var d = pn("Map Set WeakMap WeakSet");
        Sn.DEFMETHOD("is_expr_pure", function(e) {
            if (e.option("unsafe")) {
                var n = this.expression;
                if (Ne(n)) {
                    if (p[n.name]) return true;
                    if (this instanceof hr && d[n.name]) return true;
                }
                if (Xe(n)) return true;
            }
            return e.option("annotations") && this.pure || !e.pure_funcs(this);
        });
        Rr.DEFMETHOD("is_expr_pure", function(e) {
            var n = this.tag;
            if (!n) return true;
            if (e.option("unsafe")) {
                if (Ne(n) && p[n.name]) return true;
                if (n instanceof Dn && Ne(n.expression)) {
                    var t = w[n.expression.name];
                    return t && (t[n.property] || n.expression.name == "Math" && n.property == "random");
                }
            }
            return !e.pure_funcs(this);
        });
        vn.DEFMETHOD("is_call_pure", cn);
        Sn.DEFMETHOD("is_call_pure", function(e) {
            if (!e.option("unsafe")) return false;
            var n = this.expression;
            if (!(n instanceof Dn)) return false;
            var t = n.expression;
            var r;
            var i = n.property;
            if (t instanceof Pn) {
                r = b.Array;
            } else if (t.is_boolean(e)) {
                r = b.Boolean;
            } else if (t.is_number(e)) {
                r = b.Number;
            } else if (t instanceof Lr) {
                r = b.RegExp;
            } else if (t.is_string(e)) {
                r = b.String;
                if (i == "replace") {
                    var a = this.args[1];
                    if (a && !a.is_string(e)) return false;
                }
            } else if (!n.may_throw_on_access(e)) {
                r = b.Object;
            }
            return r && r[i];
        });
        (function(e) {
            e(vn, cn);
            e(Pn, ln);
            e(Fn, function() {
                switch (this.operator) {
                  case "=":
                    return this.right.safe_to_spread();

                  case "&&=":
                  case "||=":
                  case "??=":
                    return this.left.safe_to_spread() && this.right.safe_to_spread();
                }
                return true;
            });
            e(Cn, function() {
                return !He[this.operator] || this.left.safe_to_spread() && this.right.safe_to_spread();
            });
            e(Yn, ln);
            e(yn, ln);
            e(Nn, function() {
                return dn(this.properties, function(e) {
                    return !(e instanceof Tr || e instanceof On);
                });
            });
            e(Tn, function() {
                return this.tail_node().safe_to_spread();
            });
            e(Hn, function() {
                var e = this.fixed_value();
                return e && e.safe_to_spread();
            });
            e($n, ln);
        })(function(e, n) {
            e.DEFMETHOD("safe_to_spread", n);
        });
        (function(e) {
            function t(e, n, t) {
                return !dn(e, t ? function(e) {
                    return e instanceof On ? !t(e, n) : !e.has_side_effects(n);
                } : function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function n(e, n) {
                var t = e.expression;
                return !t.is_string(n) || t.has_side_effects(n);
            }
            e(vn, ln);
            e(Pn, function(e) {
                return t(this.elements, e, n);
            });
            e(Fn, function(e) {
                var n = this.left;
                if (!(n instanceof An)) return true;
                var t = n.expression;
                return !(t instanceof Nr) || !t.scope.resolve().new || n instanceof qn && n.property.has_side_effects(e) || this.right.has_side_effects(e);
            });
            e(Cn, function(e) {
                return this.left.has_side_effects(e) || this.right.has_side_effects(e) || !Ke(this.operator, this.right, e);
            });
            e(ft, function(e) {
                return t(this.body, e);
            });
            e(Sn, function(e) {
                if (!this.is_expr_pure(e) && (!this.is_call_pure(e) || this.expression.has_side_effects(e))) {
                    return true;
                }
                return t(this.args, e, n);
            });
            e(tr, function(e) {
                return this.expression.has_side_effects(e) || t(this.body, e);
            });
            e(Nt, function(e) {
                var n = this.extends;
                if (n) {
                    if (n instanceof Hn) n = n.fixed_value();
                    if (!Be(n)) return true;
                }
                return t(this.properties, e);
            });
            e(Yt, function(e) {
                return this.key instanceof vn && this.key.has_side_effects(e) || this.static && this.value && this.value.has_side_effects(e);
            });
            e(Mn, function(e) {
                return this.condition.has_side_effects(e) || this.consequent.has_side_effects(e) || this.alternative.has_side_effects(e);
            });
            e(Yn, cn);
            e(or, function(e) {
                return t(this.definitions, e);
            });
            e(br, function(e) {
                return t(this.elements, e);
            });
            e(yr, function(e) {
                return this.key instanceof vn && this.key.has_side_effects(e) || this.value.has_side_effects(e);
            });
            e(wr, function(e) {
                return t(this.properties, e);
            });
            e(Dn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e);
            });
            e(mn, cn);
            e(xn, function(e) {
                return this.condition.has_side_effects(e) || this.body && this.body.has_side_effects(e) || this.alternative && this.alternative.has_side_effects(e);
            });
            e(ut, function(e) {
                return this.body.has_side_effects(e);
            });
            e(yn, cn);
            e(Nn, function(e) {
                return t(this.properties, e, function(e, n) {
                    var t = e.expression;
                    return !t.safe_to_spread() || t.has_side_effects(n);
                });
            });
            e(Nr, cn);
            e(xr, function(e) {
                return this.key instanceof vn && this.key.has_side_effects(e) || this.value.has_side_effects(e);
            });
            e(Tn, function(e) {
                return t(this.expressions, e);
            });
            e(_n, function(e) {
                return this.body.has_side_effects(e);
            });
            e(qn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e) || this.property.has_side_effects(e);
            });
            e(Zt, function(e) {
                return this.expression.has_side_effects(e) || t(this.body, e);
            });
            e(Dr, cn);
            e(Hn, function(e) {
                return !this.is_declared(e) || !Ce(this, e);
            });
            e(Rr, function(e) {
                return !this.is_expr_pure(e) || t(this.expressions, e);
            });
            e(rr, function(e) {
                return t(this.body, e) || this.bcatch && this.bcatch.has_side_effects(e) || this.bfinally && this.bfinally.has_side_effects(e);
            });
            e($n, function(e) {
                return si[this.operator] || this.expression.has_side_effects(e);
            });
            e(kn, function() {
                return this.value;
            });
        })(function(e, n) {
            e.DEFMETHOD("has_side_effects", n);
        });
        (function(e) {
            e(vn, ln);
            e(Yn, cn);
            e(mn, cn);
            e(yn, cn);
            e(Nr, cn);
            e(Dr, cn);
            function t(e, n) {
                for (var t = e.length; --t >= 0; ) if (e[t].may_throw(n)) return true;
                return false;
            }
            function r(e, n) {
                if (e.may_throw(n)) return true;
                if (e instanceof Hn) e = e.fixed_value();
                if (!(e instanceof yn)) return true;
                if (t(e.argnames, n)) return true;
                if (t(e.body, n)) return true;
                return kt(e) && e.value && e.value.may_throw(n);
            }
            e(Pn, function(e) {
                return t(this.elements, e);
            });
            e(Fn, function(e) {
                if (this.right.may_throw(e)) return true;
                if (!e.has_directive("use strict") && this.operator == "=" && this.left instanceof Hn) {
                    return false;
                }
                return this.left.may_throw(e);
            });
            e(_r, function(e) {
                return this.expression.may_throw(e);
            });
            e(Cn, function(e) {
                return this.left.may_throw(e) || this.right.may_throw(e) || !Ke(this.operator, this.right, e);
            });
            e(ft, function(e) {
                return t(this.body, e);
            });
            e(Sn, function(e) {
                if (t(this.args, e)) return true;
                if (this.is_expr_pure(e)) return false;
                this.may_throw = ln;
                var n = r(this.expression, e);
                delete this.may_throw;
                return n;
            });
            e(tr, function(e) {
                return this.expression.may_throw(e) || t(this.body, e);
            });
            e(Mn, function(e) {
                return this.condition.may_throw(e) || this.consequent.may_throw(e) || this.alternative.may_throw(e);
            });
            e(En, function(e) {
                return this.name.may_throw(e) || this.value && this.value.may_throw(e);
            });
            e(or, function(e) {
                return t(this.definitions, e);
            });
            e(Dn, function(e) {
                return !this.optional && this.expression.may_throw_on_access(e) || this.expression.may_throw(e);
            });
            e(vt, function(e) {
                if (this.init.may_throw(e)) return true;
                var n = this.object;
                if (n.may_throw(e)) return true;
                n = n.tail_node();
                if (!(n instanceof Pn || n.is_string(e))) return true;
                return this.body.may_throw(e);
            });
            e(xn, function(e) {
                return this.condition.may_throw(e) || this.body && this.body.may_throw(e) || this.alternative && this.alternative.may_throw(e);
            });
            e(ut, function(e) {
                return this.body.may_throw(e);
            });
            e(Nn, function(e) {
                return t(this.properties, e);
            });
            e(xr, function(e) {
                return this.value.may_throw(e) || this.key instanceof vn && this.key.may_throw(e);
            });
            e(wn, function(e) {
                return this.value && this.value.may_throw(e);
            });
            e(Tn, function(e) {
                return t(this.expressions, e);
            });
            e(_n, function(e) {
                return this.body.may_throw(e);
            });
            e(qn, function(e) {
                return !this.optional && this.expression.may_throw_on_access(e) || this.expression.may_throw(e) || this.property.may_throw(e);
            });
            e(Zt, function(e) {
                return this.expression.may_throw(e) || t(this.body, e);
            });
            e(Hn, function(e) {
                return !this.is_declared(e) || !Ce(this, e);
            });
            e(Rr, function(e) {
                if (t(this.expressions, e)) return true;
                if (this.is_expr_pure(e)) return false;
                if (!this.tag) return false;
                this.may_throw = ln;
                var n = r(this.tag, e);
                delete this.may_throw;
                return n;
            });
            e(rr, function(e) {
                return (this.bcatch ? this.bcatch.may_throw(e) : t(this.body, e)) || this.bfinally && this.bfinally.may_throw(e);
            });
            e($n, function(e) {
                return this.expression.may_throw(e) && !(this.operator == "typeof" && this.expression instanceof Hn);
            });
            e(kn, function(e) {
                return this.name.may_throw(e) || this.value && this.value.may_throw(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("may_throw", n);
        });
        (function(e) {
            function t(e, n) {
                for (var t = e.length; --t >= 0; ) if (!e[t].is_constant_expression(n)) return false;
                return true;
            }
            e(vn, cn);
            e(Pn, function(e) {
                return t(this.elements, e);
            });
            e(Cn, function(e) {
                return this.left.is_constant_expression(e) && this.right.is_constant_expression(e) && Ke(this.operator, this.right);
            });
            e(Nt, function(e) {
                var n = this.extends;
                if (n && !Be(n)) return false;
                return t(this.properties, e);
            });
            e(Yt, function(e) {
                return typeof this.key == "string" && (!this.value || this.value.is_constant_expression(e));
            });
            e(Yn, ln);
            e(yn, function(i) {
                var a = this;
                var o = true;
                var s = [];
                a.walk(new Ln(function(e, n) {
                    if (!o) return true;
                    if (e instanceof ot) {
                        if (e === a) return;
                        s.push(e);
                        n();
                        s.pop();
                        return true;
                    }
                    if (e instanceof Hn) {
                        if (a.inlined || e.redef || e.in_arg) {
                            o = false;
                            return true;
                        }
                        if (a.variables.has(e.name)) return true;
                        var t = e.definition();
                        if (Un(t.scope, s)) return true;
                        if (i && !t.redefined()) {
                            var r = i.find_variable(e.name);
                            if (r ? r === t : t.undeclared) {
                                o = "f";
                                return true;
                            }
                        }
                        o = false;
                        return true;
                    }
                    if (e instanceof Nr) {
                        if (kt(a) && dn(s, function(e) {
                            return !(e instanceof bn) || kt(e);
                        })) o = false;
                        return true;
                    }
                }));
                return o;
            });
            e(Nn, function(e) {
                return t(this.properties, e);
            });
            e(xr, function(e) {
                return typeof this.key == "string" && this.value.is_constant_expression(e);
            });
            e($n, function(e) {
                return this.expression.is_constant_expression(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant_expression", n);
        });
        function R(e) {
            return e && e.aborts();
        }
        (function(e) {
            e(tt, Jn);
            e(Wt, Gn);
            function n() {
                var e = this.body.length;
                return e > 0 && R(this.body[e - 1]);
            }
            e(gn, n);
            e(er, n);
            e(xn, function() {
                return this.alternative && R(this.body) && R(this.alternative) && this;
            });
        })(function(e, n) {
            e.DEFMETHOD("aborts", n);
        });
        var h = pn([ "use asm", "use strict" ]);
        e(it, function(e, n) {
            if (n.option("directives") && (!h[e.value] || n.has_directive(e.value) !== e)) {
                return Fe(mn, e);
            }
            return e;
        });
        e(rt, function(e, n) {
            if (n.option("drop_debugger")) return Fe(mn, e);
            return e;
        });
        e(ut, function(e, n) {
            if (e.body instanceof xn || e.body instanceof Kt) {
                var t = c([ e.body ], n);
                switch (t.length) {
                  case 0:
                    e.body = Fe(mn, e);
                    break;

                  case 1:
                    e.body = t[0];
                    break;

                  default:
                    e.body = Fe(gn, e, {
                        body: t
                    });
                    break;
                }
            }
            return n.option("unused") && e.label.references.length == 0 ? e.body : e;
        });
        e(Xt, function(e, n) {
            if (!n.option("dead_code")) return e;
            var t = e.label;
            if (t) {
                var r = n.loopcontrol_target(e);
                e.label = null;
                if (n.loopcontrol_target(e) === r) {
                    Zn(t.thedef.references, e);
                } else {
                    e.label = t;
                }
            }
            return e;
        });
        e(ft, function(e, n) {
            e.body = c(e.body, n);
            return e;
        });
        function q(e, n, t) {
            switch (e.body.length) {
              case 0:
                return t ? Xn.skip : Fe(mn, e);

              case 1:
                var r = e.body[0];
                if (!S(r)) return e;
                if (n instanceof ct && r instanceof Ct) return e;
                return r;
            }
            return e;
        }
        e(gn, function(e, n) {
            e.body = c(e.body, n);
            return q(e, n.parent());
        });
        function v(e, n) {
            if (!n.option("rests")) return;
            if (e.uses_arguments) return;
            if (!(e.rest instanceof br)) return;
            if (!n.drop_fargs(e, n.parent())) return;
            e.argnames = e.argnames.concat(e.rest.elements);
            e.rest = e.rest.rest;
        }
        e(yn, function(e, n) {
            v(e, n);
            e.body = c(e.body, n);
            return e;
        });
        function m(e, n) {
            if (!n.option("arrows")) return e;
            v(e, n);
            if (e.value) e.body = [ e.first_statement() ];
            var t = c(e.body, n);
            switch (t.length) {
              case 1:
                var r = t[0];
                if (r instanceof wn) {
                    e.body.length = 0;
                    e.value = r.value;
                    break;
                }

              default:
                e.body = t;
                e.value = null;
                break;
            }
            return e;
        }
        e(At, m);
        e(Dt, m);
        e($t, function(n, e) {
            v(n, e);
            n.body = c(n.body, e);
            var t = e.parent();
            if (e.option("inline")) for (var r = 0; r < n.body.length; r++) {
                var i = n.body[r];
                if (i instanceof it) continue;
                if (i instanceof wn) {
                    if (r != n.body.length - 1) break;
                    var a = i.value;
                    if (!a || a.TYPE != "Call") break;
                    if (a.is_expr_pure(e)) break;
                    var o = a.expression;
                    if (o instanceof Hn) {
                        if (n.name && n.name.definition() === o.definition()) break;
                        o = o.fixed_value();
                    }
                    if (!(o instanceof Pt || o instanceof $t)) break;
                    if (o.rest) break;
                    if (o.uses_arguments) break;
                    if (o === a.expression) {
                        if (o.parent_scope !== n) break;
                        if (!dn(o.enclosed, function(e) {
                            return e.scope !== n;
                        })) break;
                    }
                    if (o.name && (t instanceof Ut || t instanceof Er) && t.value === e.self()) break;
                    if (o.contains_this()) break;
                    var s = o.argnames.length;
                    if (s > 0 && e.option("inline") < 2) break;
                    if (s > n.argnames.length) break;
                    if (!dn(n.argnames, function(e) {
                        return e instanceof In;
                    })) break;
                    if (!dn(a.args, function(e) {
                        return !(e instanceof On);
                    })) break;
                    for (var f = 0; f < s; f++) {
                        var u = a.args[f];
                        if (!(u instanceof Hn)) break;
                        if (u.definition() !== n.argnames[f].definition()) break;
                    }
                    if (f < s) break;
                    for (;f < a.args.length; f++) {
                        if (a.args[f].has_side_effects(e)) break;
                    }
                    if (f < a.args.length) break;
                    if (s < n.argnames.length && !e.drop_fargs(n, t)) {
                        if (!e.drop_fargs(o, a)) break;
                        do {
                            o.argnames.push(o.make_var(In, o, "argument_" + s));
                        } while (++s < n.argnames.length);
                    }
                    return a.expression;
                }
                break;
            }
            return n;
        });
        var j = pn("arguments await yield");
        bn.DEFMETHOD("merge_variables", function(d) {
            if (!d.option("merge_vars")) return;
            var h = [], v, m, _ = {}, g = this;
            var o = [], s = [], f = 0;
            var b = new hn();
            var y = Object.create(null);
            var u = Object.create(null);
            var w = new Ln(function(t, e) {
                if (t instanceof Fn) {
                    var n = t.left;
                    var r = t.right;
                    if (n instanceof jn) {
                        r.walk(w);
                        E(Hn, S, n);
                        return true;
                    }
                    if (He[t.operator.slice(0, -1)]) {
                        n.walk(w);
                        x();
                        r.walk(w);
                        if (n instanceof Hn) S(n);
                        k();
                        return true;
                    }
                    if (n instanceof Hn) {
                        if (t.operator != "=") S(n, true);
                        r.walk(w);
                        S(n);
                        return true;
                    }
                    return;
                }
                if (t instanceof Cn) {
                    if (!He[t.operator]) return;
                    p(t);
                    return true;
                }
                if (t instanceof Kt) {
                    var i = w.loopcontrol_target(t);
                    if (!(i instanceof ct)) T(i);
                    return true;
                }
                if (t instanceof Sn) {
                    var a = t.expression;
                    if (a instanceof xt) {
                        t.args.forEach(function(e) {
                            e.walk(w);
                        });
                        a.walk(w);
                    } else {
                        e();
                        l(a);
                    }
                    return true;
                }
                if (t instanceof Nt) {
                    if (t.name) t.name.walk(w);
                    if (t.extends) t.extends.walk(w);
                    t.properties.filter(function(e) {
                        if (e.key instanceof vn) e.key.walk(w);
                        return e.value;
                    }).forEach(function(e) {
                        if (e.static) {
                            e.value.walk(w);
                        } else {
                            x();
                            _.block = t;
                            e.value.walk(w);
                            k();
                        }
                    });
                    return true;
                }
                if (t instanceof Mn) {
                    p(t.condition, t.consequent, t.alternative);
                    return true;
                }
                if (t instanceof Qt) {
                    var i = w.loopcontrol_target(t);
                    if (i instanceof pt) T(i);
                    return true;
                }
                if (t instanceof pt) {
                    x();
                    _.block = t;
                    _.loop = true;
                    var o = _;
                    t.body.walk(w);
                    if (_.inserted === t) _ = o;
                    t.condition.walk(w);
                    k();
                    return true;
                }
                if (t instanceof ht) {
                    if (t.init) t.init.walk(w);
                    x();
                    _.block = t;
                    _.loop = true;
                    if (t.condition) t.condition.walk(w);
                    t.body.walk(w);
                    if (t.step) t.step.walk(w);
                    k();
                    return true;
                }
                if (t instanceof vt) {
                    t.object.walk(w);
                    x();
                    _.block = t;
                    _.loop = true;
                    t.init.walk(w);
                    t.body.walk(w);
                    k();
                    return true;
                }
                if (t instanceof xn) {
                    p(t.condition, t.body, t.alternative);
                    return true;
                }
                if (t instanceof ut) {
                    x();
                    _.block = t;
                    var o = _;
                    t.body.walk(w);
                    if (_.inserted === t) _ = o;
                    k();
                    return true;
                }
                if (t instanceof bn) {
                    x();
                    _.block = t;
                    if (t === g) m = _;
                    if (t instanceof yn) {
                        if (t.name) y[t.name.definition().id] = false;
                        var s = t.uses_arguments && !w.has_directive("use strict") ? function(e) {
                            y[e.definition().id] = false;
                        } : function(e) {
                            S(e);
                        };
                        h.push(t);
                        t.argnames.forEach(function(e) {
                            E(In, s, e);
                        });
                        if (t.rest) E(In, s, t.rest);
                        h.pop();
                    }
                    Tt(t, w);
                    k();
                    return true;
                }
                if (t instanceof qn) {
                    var a = t.expression;
                    if (t.optional) {
                        a.walk(w);
                        x();
                        t.property.walk(w);
                        k();
                    } else {
                        e();
                    }
                    l(a);
                    return true;
                }
                if (t instanceof Zt) {
                    t.expression.walk(w);
                    var o = _;
                    t.body.forEach(function(e) {
                        if (e instanceof nr) return;
                        e.expression.walk(w);
                        if (o === _) x();
                    });
                    _ = o;
                    t.body.forEach(function(e) {
                        x();
                        _.block = t;
                        var n = _;
                        st(e, w);
                        if (_.inserted === t) _ = n;
                        k();
                    });
                    return true;
                }
                if (t instanceof qr || t instanceof $r) {
                    y[t.definition().id] = false;
                    return true;
                }
                if (t instanceof Hn) {
                    S(t, true);
                    return true;
                }
                if (t instanceof rr) {
                    var f = v;
                    v = t;
                    st(t, w);
                    if (t.bcatch) {
                        if (t.bcatch.argname) t.bcatch.argname.mark_symbol(function(e) {
                            if (e instanceof Pr) {
                                var n = e.definition();
                                y[n.id] = false;
                                if (n = n.redefined()) y[n.id] = false;
                            }
                        }, w);
                        if (t.bfinally || (v = f)) {
                            st(t.bcatch, w);
                        } else {
                            x();
                            st(t.bcatch, w);
                            k();
                        }
                    }
                    v = f;
                    if (t.bfinally) t.bfinally.walk(w);
                    return true;
                }
                if (t instanceof $n) {
                    if (!ri[t.operator]) return;
                    var u = t.expression;
                    if (!(u instanceof Hn)) return;
                    S(u, true);
                    return true;
                }
                if (t instanceof kn) {
                    var c = t.value;
                    if (c) {
                        c.walk(w);
                    } else {
                        c = _.block instanceof vt && _.block.init === w.parent();
                    }
                    E(Dr, c ? function(e) {
                        if (e instanceof zr) {
                            S(e);
                        } else {
                            y[e.definition().id] = false;
                        }
                    } : function(e) {
                        var n = e.definition().id;
                        if (!(e instanceof zr)) {
                            y[n] = false;
                        } else if (!(n in y)) {
                            b.add(n, e);
                        } else if (y[n]) {
                            y[n].push(e);
                        }
                    }, t.name);
                    return true;
                }
                if (t instanceof dt) {
                    x();
                    _.block = t;
                    _.loop = true;
                    e();
                    k();
                    return true;
                }
                function l(e) {
                    if (!d.option("ie")) return;
                    var n = vr(e);
                    if (n instanceof Hn) n.walk(w);
                }
                function p(e, n, t) {
                    var r = _;
                    var i = [ r, r ];
                    if (e instanceof Cn) switch (e.operator) {
                      case "&&":
                        i[0] = p(e.left, e.right)[0];
                        break;

                      case "||":
                      case "??":
                        i[1] = p(e.left, null, e.right)[1];
                        break;

                      default:
                        e.walk(w);
                        break;
                    } else if (e instanceof Mn) {
                        p(e.condition, e.consequent, e.alternative);
                    } else {
                        e.walk(w);
                    }
                    _ = i[0];
                    if (n) {
                        x();
                        n.walk(w);
                    }
                    i[0] = _;
                    _ = i[1];
                    if (t) {
                        x();
                        t.walk(w);
                    }
                    i[1] = _;
                    _ = r;
                    return i;
                }
            });
            w.directives = Object.create(d.directives);
            g.walk(w);
            var e = false;
            var n = Object.create(null);
            while (o.length && s.length) {
                var t = s.shift();
                if (!t) continue;
                var r = t.definition;
                var i = y[r.id];
                if (!i) continue;
                i = {
                    end: i.end
                };
                while (r.id in n) r = n[r.id];
                i.start = y[r.id].start;
                var a = [];
                do {
                    var c = o.shift();
                    if (t.index > c.index) continue;
                    var l = c.definition.id;
                    if (!(l in u)) continue;
                    var p = y[l];
                    if (!p) continue;
                    if (p.start.block !== i.start.block || !D(p, i) || (p.start.loop || !Re(r)) && !D(i, p) || d.option("webkit") && oi(r) !== oi(c.definition) || c.definition.const_redefs || !dn(p, function(e) {
                        return e.scope.find_variable(r.name) === r;
                    })) {
                        a.push(c);
                        continue;
                    }
                    p.forEach(function(e) {
                        e.thedef = r;
                        e.name = r.name;
                        if (e instanceof Hn) {
                            r.references.push(e);
                        } else {
                            r.orig.push(e);
                        }
                    });
                    if (!c.definition.fixed) r.fixed = false;
                    n[l] = r;
                    e = true;
                    break;
                } while (o.length);
                if (a.length) o = a.concat(o);
            }
            return e;
            function x() {
                _ = Object.create(_);
            }
            function k() {
                _ = Object.getPrototypeOf(_);
            }
            function E(n, t, e) {
                var r = new Ln(function(e) {
                    if (e instanceof jn) return;
                    if (e instanceof En) {
                        x();
                        e.value.walk(w);
                        k();
                        e.name.walk(r);
                    } else if (e instanceof yr) {
                        if (!(e.key instanceof vn)) {
                            e.value.walk(r);
                        } else if (e.value instanceof An) {
                            x();
                            _.block = e;
                            e.key.walk(w);
                            e.value.walk(r);
                            k();
                        } else {
                            e.key.walk(w);
                            e.value.walk(r);
                        }
                    } else if (e instanceof n) {
                        t(e);
                    } else {
                        e.walk(w);
                    }
                    return true;
                });
                e.walk(r);
            }
            function S(n, e) {
                var t = n.definition(), r;
                if (e && !dn(h, function(e) {
                    r = e.variables.get(n.name);
                    if (!r) return true;
                    if (!oi(r)) return true;
                    return r !== t && !t.undeclared && e.parent_scope.find_variable(n.name) !== t;
                })) return y[t.id] = y[r.id] = false;
                var i = _;
                if (v) {
                    x();
                    i = _;
                    k();
                }
                if (t.id in y) {
                    var a = y[t.id];
                    if (!a) return;
                    if (a.start.block !== i.block) return y[t.id] = false;
                    a.push(n);
                    a.end = i;
                    if (t.id in u) {
                        s[u[t.id]] = null;
                    } else if (!e) {
                        return;
                    }
                } else if ((r = g.variables.get(t.name)) !== t) {
                    if (r && m === i) y[r.id] = false;
                    return y[t.id] = false;
                } else if (d.exposed(t) || j[n.name]) {
                    return y[t.id] = false;
                } else {
                    var a = b.get(t.id) || [];
                    a.push(n);
                    y[t.id] = a;
                    if (!e) {
                        a.start = i;
                        return o.push({
                            index: f++,
                            definition: t
                        });
                    }
                    if (i.block !== g) return y[t.id] = false;
                    a.start = m;
                }
                u[t.id] = s.length;
                s.push({
                    index: f++,
                    definition: t
                });
            }
            function T(e) {
                var n = [];
                while (true) {
                    if (et(_, "block")) {
                        var t = _.block;
                        if (t instanceof ut) t = t.body;
                        if (t === e) break;
                    }
                    n.push(_);
                    k();
                }
                _.inserted = _.block;
                x();
                while (n.length) {
                    var r = n.pop();
                    x();
                    if (et(r, "block")) _.block = r.block;
                    if (et(r, "loop")) _.loop = r.loop;
                }
            }
            function A(e, n) {
                return e === n || e.isPrototypeOf(n);
            }
            function D(e, n) {
                return A(e.start, e.end) || A(e.start, n.start);
            }
        });
        function ye(e, n) {
            for (var t = n.length; --t >= 0; ) {
                if (!n[t]) n[t] = Fe(Gr, e);
            }
        }
        function re(e, n) {
            var t = Fe(Ht, e);
            if (t.name) t.name = n ? null : Fe(Fr, t.name);
            return t;
        }
        function we(e, n) {
            var t;
            switch (e.CTOR) {
              case Mt:
                t = qt;
                break;

              case Ft:
                t = Ot;
                break;

              case Pt:
                t = $t;
                break;

              case jt:
                t = zt;
                break;
            }
            var r = Fe(t, e);
            r.name = n ? null : Fe(Mr, e.name);
            return r;
        }
        bn.DEFMETHOD("drop_unused", function(z) {
            if (!z.option("unused")) return;
            var C = this;
            var M = !(C instanceof bt) || z.toplevel.funcs;
            var F = !(C instanceof bt) || z.toplevel.vars;
            var P = /keep_assign/.test(z.option("unused")) ? cn : function(e, n) {
                var t, i = false;
                if (e instanceof Fn) {
                    if (e.write_only || e.operator == "=") t = a(e.left, n);
                } else if (e instanceof $n) {
                    if (e.write_only) t = a(e.expression, n);
                }
                if (!(t instanceof Hn)) return;
                var r = t.definition();
                if (o[r.id]) return;
                if (z.exposed(r)) return;
                if (!Ce(t, z, i)) return;
                return t;
                function a(e, n) {
                    if (e instanceof An) {
                        var t = e.expression;
                        if (!t.may_throw_on_access(z, true)) {
                            i = true;
                            if (n && e instanceof qn) n.unshift(e.property);
                            return a(t, n);
                        }
                    } else if (e instanceof Fn && e.operator == "=") {
                        e.write_only = "p";
                        var r = a(e.right);
                        if (!n) return r;
                        n.assign = e;
                        return r instanceof Hn ? r : e.left;
                    }
                    return e;
                }
            };
            var j = Object.create(null);
            var o = Object.create(null);
            var v = function(e) {
                v = a(C, 0, Wn);
                return v(e);
                function a(e, n, r) {
                    var i = z.parent(n);
                    if (!i) return r;
                    var t = i instanceof yn && Un(e, i.argnames);
                    return a(i, n + 1, t ? function(e) {
                        var n = r(e);
                        if (n) return n;
                        n = i.variables.get(e);
                        if (n) {
                            var t = n.orig[0];
                            if (t instanceof In || t instanceof Mr) return n;
                        }
                    } : i.variables ? function(e) {
                        return r(e) || i.variables.get(e);
                    } : r);
                }
            };
            var N = Object.create(null);
            var m = [];
            var I = Object.create(null);
            var _ = Object.create(null);
            var g = Object.create(null);
            var b = Object.create(null);
            var H = Object.create(null);
            if (C instanceof bt && z.top_retain) {
                C.variables.each(function(e) {
                    if (z.top_retain(e) && !(e.id in I)) {
                        I[e.id] = true;
                        m.push(e);
                    }
                });
            }
            var y = new hn();
            var w = new hn();
            var Y = this;
            var x = new Ln(function(s, e) {
                if (s instanceof yn && s.uses_arguments && !x.has_directive("use strict")) {
                    s.each_argname(function(e) {
                        var n = e.definition();
                        if (!(n.id in I)) {
                            I[n.id] = true;
                            m.push(n);
                        }
                    });
                }
                if (s === C) return;
                if (Y === C) {
                    if (s instanceof It) {
                        var n = s.name.definition();
                        var t = M && !n.exported;
                        if (!t && !(n.id in I)) {
                            I[n.id] = true;
                            m.push(n);
                        }
                        var r = x.parent() instanceof lr;
                        if (r) {
                            o[n.id] = true;
                        } else if (t && !(n.id in _)) {
                            _[n.id] = 1;
                        }
                        if (s.extends) s.extends.walk(x);
                        var i = [];
                        s.properties.forEach(function(e) {
                            if (e.key instanceof vn) e.key.walk(x);
                            var n = e.value;
                            if (!n) return;
                            if (te(e)) {
                                if (!r && n.contains_this()) r = true;
                                a(n);
                            } else {
                                i.push(n);
                            }
                        });
                        i.forEach(t && r ? a : function(e) {
                            w.add(n.id, e);
                        });
                        return true;
                    }
                    if (s instanceof Ct) {
                        var n = s.name.definition();
                        var t = M && !n.exported;
                        if (!t && !(n.id in I)) {
                            I[n.id] = true;
                            m.push(n);
                        }
                        w.add(n.id, s);
                        if (x.parent() instanceof lr) {
                            o[n.id] = true;
                            return;
                        }
                        if (t && !(n.id in _)) _[n.id] = 1;
                        return true;
                    }
                    if (s instanceof or) {
                        s.definitions.forEach(function(r) {
                            var i = r.value;
                            var a = i && (r.name instanceof jn || i.has_side_effects(z));
                            var o = a && i.tail_node().operator == "=";
                            r.name.mark_symbol(function(e) {
                                if (!(e instanceof Dr)) return;
                                var n = e.definition();
                                H[n.id] = (H[n.id] || 0) + 1;
                                if (s instanceof ur && n.orig[0] instanceof Pr) {
                                    var t = n.redefined();
                                    if (t) H[t.id] = (H[t.id] || 0) + 1;
                                }
                                if (!(n.id in I) && (!F || n.exported || (s instanceof sr ? n.redefined() : n.const_redefs) || !(s instanceof ur || Ye(n)))) {
                                    I[n.id] = true;
                                    m.push(n);
                                }
                                if (i) {
                                    if (!a) {
                                        w.add(n.id, i);
                                    } else if (o) {
                                        S(n, e, b[n.id]);
                                    }
                                    y.add(n.id, r);
                                }
                                T(n);
                                return true;
                            }, x);
                            if (a) i.walk(x);
                        });
                        return true;
                    }
                    if (s instanceof In) {
                        var n = s.definition();
                        H[n.id] = (H[n.id] || 0) + 1;
                        y.add(n.id, s);
                        return true;
                    }
                    if (s instanceof Or) {
                        var n = s.definition();
                        if (!(n.id in I) && (!F || !Ye(n))) {
                            I[n.id] = true;
                            m.push(n);
                        }
                        return true;
                    }
                }
                return f(s, e, true);
                function a(e) {
                    var n = Y;
                    Y = s;
                    e.walk(x);
                    Y = n;
                }
            });
            x.directives = Object.create(z.directives);
            C.walk(x);
            var R = z.option("keep_fnames") ? cn : z.option("ie") ? function(e) {
                return !z.exposed(e) && e.references.length == e.replaced;
            } : function(e) {
                if (!(e.id in I)) return true;
                if (e.orig.length - e.eliminated < 2) return false;
                if (e.orig[1] instanceof In) return true;
                return dn(e.references, function(e) {
                    return !e.in_arg;
                });
            };
            if (z.option("ie")) w.each(function(e, n) {
                if (n in I) return;
                e.forEach(function(e) {
                    e.walk(new Ln(function(e) {
                        if (e instanceof $t && e.name && !R(e.name.definition())) {
                            e.walk(x);
                            return true;
                        }
                        if (e instanceof bn) return true;
                    }));
                });
            });
            x = new Ln(f);
            for (var e = 0; e < m.length; e++) {
                var n = w.get(m[e].id);
                if (n) n.forEach(function(e) {
                    e.walk(x);
                });
            }
            Object.keys(j).forEach(function(e) {
                var t = j[e];
                if (!t) {
                    delete j[e];
                    return;
                }
                t = t.reduce(function(n, e) {
                    e.forEach(function(e) {
                        Kn(n, e);
                    });
                    return n;
                }, []);
                var n = (y.get(e) || []).filter(function(n) {
                    return Vn(n instanceof $n ? function(e) {
                        return e === n;
                    } : function(e) {
                        if (e === n) return true;
                        if (e instanceof $n) return false;
                        return r(e) === r(n);
                    }, t);
                });
                if (t.length == n.length) {
                    j[e] = n;
                } else {
                    delete j[e];
                }
            });
            var B = [];
            var L = [];
            var U = new Zr(function(r) {
                if (r instanceof En) return D(U, r);
                if (r instanceof jn && r.rest) r.rest = r.rest.transform(U);
                if (r instanceof br) {
                    var e = !r.rest;
                    for (var n = r.elements.length; --n >= 0; ) {
                        var t = r.elements[n].transform(U);
                        if (t) {
                            r.elements[n] = t;
                            e = false;
                        } else if (e) {
                            r.elements.pop();
                        } else {
                            r.elements[n] = Fe(Gr, r.elements[n]);
                        }
                    }
                    return r;
                }
                if (r instanceof wr) {
                    var i = [];
                    r.properties.forEach(function(e) {
                        var n = false;
                        if (e.key instanceof vn) {
                            e.key = e.key.transform(V);
                            n = e.key.has_side_effects(z);
                        }
                        if ((n || r.rest) && a(e.value)) {
                            e.value = e.value.transform(V);
                            i.push(e);
                        } else {
                            var t = e.value.transform(U);
                            if (!t && r.rest) {
                                if (e.value instanceof br) {
                                    t = Fe(br, e.value, {
                                        elements: []
                                    });
                                } else {
                                    t = Fe(wr, e.value, {
                                        properties: []
                                    });
                                }
                            }
                            if (t) {
                                e.value = t;
                                i.push(e);
                            }
                        }
                    });
                    r.properties = i;
                    return r;
                }
                if (r instanceof Dr) return K(r);
            });
            var V = new Zr(function(_, n, e) {
                var g = V.parent();
                if (F) {
                    var t = [], r = P(_, t);
                    if (r) {
                        var i;
                        if (Z(r, _)) {
                            if (_ instanceof Fn) {
                                i = ee(_);
                                if (_.write_only === true) i = i.drop_side_effect_free(z);
                            }
                            if (!i) i = Fe(Bn, _, {
                                value: 0
                            });
                        }
                        if (i) {
                            if (t.assign) {
                                var a = t.assign.drop_side_effect_free(z);
                                if (a) {
                                    a.write_only = true;
                                    t.unshift(a);
                                }
                            }
                            if (!(g instanceof Tn) || g.tail_node() === _ || i.has_side_effects(z)) {
                                t.push(i);
                            }
                            switch (t.length) {
                              case 0:
                                return Xn.skip;

                              case 1:
                                return je(g, _, t[0].transform(V));

                              default:
                                return Pe(_, t.map(function(e) {
                                    return e.transform(V);
                                }));
                            }
                        }
                    } else if (_ instanceof mr && _.expression instanceof Hn && X(_.expression.definition(), _) < 0) {
                        return Fe(zn, _, {
                            operator: "+",
                            expression: _.expression
                        });
                    }
                }
                if (_ instanceof Cn && _.operator == "instanceof") {
                    var r = _.right;
                    if (!(r instanceof Hn)) return;
                    if (r.definition().id in I) return;
                    var o = _.left.drop_side_effect_free(z);
                    var i = Fe(Kr, _).optimize(z);
                    return o ? Pe(_, [ o, i ]) : i;
                }
                if (_ instanceof Sn) {
                    B.push(_);
                    _.args = _.args.map(function(e) {
                        return e.transform(V);
                    });
                    _.expression = _.expression.transform(V);
                    return _;
                }
                if (Y !== C) return;
                if (M && _ !== C && _ instanceof It) {
                    var s = _.name.definition();
                    if (!(s.id in I)) {
                        W(_.name, "Dropping unused class {name}");
                        s.eliminated++;
                        n(_, V);
                        var f = re(_, true);
                        if (g instanceof lr) return f;
                        f = f.drop_side_effect_free(z, true);
                        if (f) return Fe(_n, _, {
                            body: f
                        });
                        return e ? Xn.skip : Fe(mn, _);
                    }
                }
                if (_ instanceof Ht && _.name && R(_.name.definition())) {
                    _.name = null;
                }
                if (_ instanceof yn) {
                    if (M && _ !== C && _ instanceof Ct) {
                        var s = _.name.definition();
                        if (!(s.id in I)) {
                            W(_.name, "Dropping unused function {name}");
                            s.eliminated++;
                            if (g instanceof lr) {
                                $();
                                return we(_, true);
                            }
                            return e ? Xn.skip : Fe(mn, _);
                        }
                    }
                    if (_ instanceof xt && _.name && R(_.name.definition())) {
                        _.name = null;
                    }
                    if (!(_ instanceof wt)) {
                        var u, c, l = z.drop_fargs(_, g);
                        if (l && g instanceof Sn && g.expression === _) {
                            u = g.args;
                            for (c = 0; c < u.length; c++) {
                                if (u[c] instanceof On) break;
                            }
                        }
                        var p = _.argnames;
                        var d = _.rest;
                        var h = false, v = false;
                        if (d) {
                            v = true;
                            if (!u || c < p.length || d instanceof In) {
                                d = d.transform(U);
                            } else {
                                var f = Q(d, Fe(Pn, g, {
                                    elements: u.slice(p.length)
                                }), K, !_.uses_arguments, d);
                                d = f.name;
                                u.length = p.length;
                                if (f.value.elements.length) [].push.apply(u, f.value.elements);
                            }
                            if (d instanceof jn && !d.rest) {
                                if (d instanceof br) {
                                    if (d.elements.length == 0) d = null;
                                } else if (d.properties.length == 0) {
                                    d = null;
                                }
                            }
                            _.rest = d;
                            if (d) {
                                l = false;
                                h = true;
                            }
                        }
                        var m = l ? -1 : _.length();
                        var b = u && !_.uses_arguments && g !== z.parent();
                        for (var y = p.length; --y >= 0; ) {
                            var r = p[y];
                            if (r instanceof In) {
                                var s = r.definition();
                                if (s.id in I) {
                                    l = false;
                                    if (X(s, r) < 0) r.unused = null;
                                } else if (l) {
                                    W(r, "Dropping unused function argument {name}");
                                    p.pop();
                                    s.eliminated++;
                                    r.unused = true;
                                } else {
                                    r.unused = true;
                                }
                            } else {
                                v = true;
                                var w;
                                if (!u || c < y) {
                                    w = r.transform(U);
                                } else {
                                    var f = Q(r, u[y], K, b, r);
                                    w = f.name;
                                    if (f.value) u[y] = f.value;
                                }
                                if (w) {
                                    l = false;
                                    p[y] = w;
                                    if (!h) h = !(w instanceof In);
                                } else if (l) {
                                    G(r, "Dropping unused default argument {name}");
                                    p.pop();
                                } else if (y > m) {
                                    G(r, "Dropping unused default argument assignment {name}");
                                    if (r.name instanceof In) {
                                        r.name.unused = true;
                                    } else {
                                        h = true;
                                    }
                                    p[y] = r.name;
                                } else {
                                    G(r, "Dropping unused default argument value {name}");
                                    p[y] = r = r.clone();
                                    r.value = Fe(Bn, r, {
                                        value: 0
                                    });
                                    h = true;
                                }
                            }
                        }
                        if (v && !h && _.uses_arguments && !V.has_directive("use strict")) {
                            _.rest = Fe(br, _, {
                                elements: []
                            });
                        }
                        L.push(_);
                    }
                }
                if (_ instanceof ir && _.argname instanceof jn) {
                    _.argname.transform(U);
                }
                if (_ instanceof or && !(g instanceof vt && g.init === _)) {
                    var x = [], k = [], E = [];
                    var S = [];
                    var T = 0;
                    var A = _ instanceof ur;
                    _.definitions.forEach(function(t) {
                        if (t.value) t.value = t.value.transform(V);
                        var e = t.value;
                        if (t.name instanceof jn) {
                            var n = Q(t.name, e, function(e) {
                                if (!F) return e;
                                if (e.definition().id in I) return e;
                                if (v(e)) return e;
                                if (A && !Ce(e)) return e;
                                return null;
                            }, true);
                            if (n.name) {
                                t = Fe(kn, t, {
                                    name: n.name,
                                    value: e = n.value
                                });
                                m();
                            } else if (n.value) {
                                S.push(n.value);
                            }
                            return;
                        }
                        var a = t.name.definition();
                        var r = A ? Ce(t.name) : Ye(a);
                        if (!r || !F || a.id in I) {
                            var i;
                            if (e && ((i = X(a, t)) < 0 || l(e.tail_node()))) {
                                t = t.clone();
                                e = e.drop_side_effect_free(z);
                                if (e) vn.warn("Side effects in definition of variable {name} [{start}]", t.name);
                                if (_ instanceof sr) {
                                    t.value = e || Fe(Bn, t, {
                                        value: 0
                                    });
                                } else {
                                    t.value = null;
                                    if (e) S.push(e);
                                }
                                e = null;
                                if (i >= 0) j[a.id][i] = t;
                            }
                            var o, s;
                            if (!e && !(_ instanceof fr)) {
                                if (g instanceof cr) {
                                    m();
                                } else if (r && H[a.id] > 1) {
                                    vn.info("Dropping declaration of variable {name} [{start}]", t.name);
                                    H[a.id]--;
                                    a.eliminated++;
                                } else {
                                    k.push(t);
                                }
                            } else if (z.option("functions") && !z.option("ie") && r && e && H[a.id] == 1 && a.assignments == 0 && (s = e.tail_node()) instanceof xt && !ze(a) && !kt(s) && p(s, a.references) && d(s) && (o = h(s, t.name.name)) !== false) {
                                vn.warn("Declaring {name} as function [{start}]", t.name);
                                var f;
                                switch (s.CTOR) {
                                  case qt:
                                    f = Mt;
                                    break;

                                  case Ot:
                                    f = Ft;
                                    break;

                                  case $t:
                                    f = Pt;
                                    break;

                                  case zt:
                                    f = jt;
                                    break;
                                }
                                var u = Fe(f, s);
                                u.name = Fe(Cr, t.name);
                                var c = t.name.scope.resolve().def_function(u.name);
                                if (o) o.forEach(function(e) {
                                    e.name = c.name;
                                    e.thedef = c;
                                    e.reference();
                                });
                                x.push(u);
                                if (e !== s) [].push.apply(S, e.expressions.slice(0, -1));
                            } else {
                                if (r && H[a.id] > 1 && !(g instanceof cr) && a.orig.indexOf(t.name) > a.eliminated) {
                                    H[a.id]--;
                                    T++;
                                }
                                m();
                            }
                        } else if (v(t.name)) {
                            e = e && e.drop_side_effect_free(z);
                            if (e) S.push(e);
                            if (H[a.id] > 1) {
                                vn.warn("Dropping duplicated declaration of variable {name} [{start}]", t.name);
                                H[a.id]--;
                                a.eliminated++;
                            } else {
                                t.value = null;
                                k.push(t);
                            }
                        } else {
                            e = e && e.drop_side_effect_free(z);
                            if (e) {
                                vn.warn("Side effects in initialization of unused variable {name} [{start}]", t.name);
                                S.push(e);
                            } else {
                                W(t.name, "Dropping unused variable {name}");
                            }
                            a.eliminated++;
                        }
                        function l(e) {
                            return e instanceof Hn && e.definition() === a;
                        }
                        function p(n, e) {
                            if (e.length == 0) return n === t.name.fixed_value();
                            return dn(e, function(e) {
                                return n === e.fixed_value();
                            });
                        }
                        function d(e) {
                            if (!A || z.has_directive("use strict") || !(e instanceof $t)) {
                                return g instanceof bn;
                            }
                            return g instanceof ft || g instanceof ht && g.init === _ || g instanceof xn;
                        }
                        function h(t, r) {
                            if (!t.name) return null;
                            var e = t.name.definition();
                            if (e.orig.length > 1) return null;
                            if (e.assignments > 0) return false;
                            if (e.name == r) return e;
                            if (z.option("keep_fnames")) return false;
                            var i;
                            switch (r) {
                              case "await":
                                i = Et;
                                break;

                              case "yield":
                                i = St;
                                break;
                            }
                            return dn(e.references, function(e) {
                                var n = e.scope;
                                if (n.find_variable(r) !== a) return false;
                                if (i) do {
                                    n = n.resolve();
                                    if (i(n)) return false;
                                } while (n !== t && (n = n.parent_scope));
                                return true;
                            }) && e;
                        }
                        function v(e) {
                            var n = e.definition();
                            return n.orig[0] instanceof Pr && n.scope.resolve() === e.scope.resolve();
                        }
                        function m() {
                            if (S.length > 0) {
                                if (E.length == 0) {
                                    x.push(Fe(_n, _, {
                                        body: Pe(_, S)
                                    }));
                                } else if (e) {
                                    S.push(e);
                                    t.value = Pe(e, S);
                                } else {
                                    t.value = Fe(zn, t, {
                                        operator: "void",
                                        expression: Pe(t, S)
                                    });
                                }
                                S = [];
                            }
                            E.push(t);
                        }
                    });
                    switch (k.length) {
                      case 0:
                        if (E.length == 0) break;
                        if (E.length == T) {
                            [].unshift.apply(S, E.map(function(e) {
                                vn.info("Dropping duplicated definition of variable {name} [{start}]", e.name);
                                var n = e.name.definition();
                                var t = Fe(Hn, e.name);
                                n.references.push(t);
                                var r = Fe(Fn, e, {
                                    operator: "=",
                                    left: t,
                                    right: e.value
                                });
                                var i = X(n, e);
                                if (i >= 0) j[n.id][i] = r;
                                n.assignments++;
                                n.eliminated++;
                                return r;
                            }));
                            break;
                        }

                      case 1:
                        if (E.length == 0) {
                            var D = k[0].name.definition().id;
                            if (D in N) {
                                _.definitions = k;
                                N[D].init = _;
                                break;
                            }
                        }

                      default:
                        var q;
                        if (E.length > 0 && (q = E[0].value) instanceof Tn) {
                            E[0].value = q.tail_node();
                            x.push(Fe(_n, _, {
                                body: Pe(q, q.expressions.slice(0, -1))
                            }));
                        }
                        _.definitions = k.concat(E);
                        x.push(_);
                    }
                    if (S.length > 0) {
                        x.push(Fe(_n, _, {
                            body: Pe(_, S)
                        }));
                    }
                    return J(x, _, e);
                }
                if (_ instanceof Fn) {
                    n(_, V);
                    if (!(_.left instanceof jn)) return _;
                    var f = Q(_.left, _.right, function(e) {
                        return e;
                    }, _.write_only === true);
                    if (f.name) return Fe(Fn, _, {
                        operator: _.operator,
                        left: f.name,
                        right: f.value
                    });
                    if (f.value) return f.value;
                    if (g instanceof Tn && g.tail_node() !== _) return Xn.skip;
                    return Fe(Bn, _, {
                        value: 0
                    });
                }
                if (_ instanceof ut && _.body instanceof ht) {
                    n(_, V);
                    if (_.body instanceof gn) {
                        var O = _.body;
                        _.body = O.body.pop();
                        O.body.push(_);
                        return e ? Xn.splice(O.body) : O;
                    }
                    return _;
                }
                if (_ instanceof bn) {
                    $();
                    return _;
                }
                if (_ instanceof Or) {
                    if (!z.option("imports") || _.definition().id in I) return _;
                    return e ? Xn.skip : null;
                }
                function $() {
                    var e = Y;
                    Y = _;
                    n(_, V);
                    Y = e;
                }
            }, function(e, n) {
                if (e instanceof gn) return q(e, V.parent(), n);
                if (e instanceof cr) {
                    var t = e.body;
                    if (!(t instanceof gn)) return;
                    e.body = t.body.pop();
                    t.body.push(e);
                    return n ? Xn.splice(t.body) : t;
                }
                if (e instanceof ht) return Je(e, n);
                if (e instanceof mt) {
                    if (!F || !z.option("loops")) return;
                    if (!ue(e.body)) return;
                    var r = A(e);
                    if (!r) return;
                    var i = r.definition();
                    if (i.id in I) return;
                    W(r, "Dropping unused loop variable {name}");
                    if (N[i.id] === e) delete N[i.id];
                    var a = [];
                    var o = e.object.drop_side_effect_free(z);
                    if (o) {
                        vn.warn("Side effects in object of for-in loop [{start}]", o);
                        a.push(Fe(_n, e, {
                            body: o
                        }));
                    }
                    if (e.init instanceof or && i.orig[0] instanceof Pr) {
                        a.push(e.init);
                    }
                    return J(a, e, n);
                }
                if (e instanceof dr) {
                    if (e.properties && e.properties.length == 0) e.properties = null;
                    return e;
                }
                if (e instanceof Tn) {
                    if (e.expressions.length > 1) return;
                    return je(V.parent(), e, e.expressions[0]);
                }
            });
            V.push(z.parent());
            V.directives = Object.create(z.directives);
            C.transform(V);
            if (C instanceof yn && C.body.length == 1 && C.body[0] instanceof it && C.body[0].value == "use strict") {
                C.body.length = 0;
            }
            B.forEach(function(e) {
                Ee(e, z, L);
            });
            function W(e, n) {
                vn[e.definition().references.length > 0 ? "info" : "warn"](n + " [{start}]", e);
            }
            function G(e, n) {
                if (e.name instanceof In) {
                    W(e.name, n);
                } else {
                    vn.info(n + " [{start}]", e);
                }
            }
            function r(e) {
                return e[e instanceof Fn ? "right" : "value"];
            }
            function J(e, n, t) {
                switch (e.length) {
                  case 0:
                    return t ? Xn.skip : Fe(mn, n);

                  case 1:
                    return e[0];

                  default:
                    return t ? Xn.splice(e) : Fe(gn, n, {
                        body: e
                    });
                }
            }
            function k(e, n) {
                if (e.scope.resolve() !== C) return false;
                if (!e.fixed || !n.fixed) j[e.id] = false;
                return j[e.id] !== false;
            }
            function E(e, n) {
                if (!j[e.id]) j[e.id] = [];
                if (n.fixed.assigns) Kn(j[e.id], n.fixed.assigns);
            }
            function X(e, n) {
                var t = j[e.id];
                return t && t.indexOf(n);
            }
            function T(e) {
                if (_[e.id] > 1 && !(e.id in I)) {
                    I[e.id] = true;
                    m.push(e);
                }
                _[e.id] = 0;
            }
            function S(e, n, t) {
                if (e.id in I) return;
                if (n && t) {
                    I[e.id] = n;
                    m.push(e);
                } else {
                    g[e.id] = n;
                    b[e.id] = t;
                }
            }
            function Z(e, n) {
                var t = e.definition();
                var r = I[t.id];
                if (!r) return true;
                if (n[n instanceof Fn ? "left" : "expression"] !== e) return false;
                return r === e && t.references.length - t.replaced == 1 || X(t, n) < 0;
            }
            function ee(e) {
                var n = e.right;
                if (!e.write_only) return n;
                if (!(n instanceof Cn && He[n.operator])) return n;
                if (!(n.left instanceof Hn)) return n;
                if (!(e.left instanceof Hn)) return n;
                var t = e.left.definition();
                if (n.left.definition() !== t) return n;
                if (n.right.has_side_effects(z)) return n;
                if (k(t, n.left)) E(t, n.left);
                return n.right;
            }
            function A(e) {
                var n = e.init;
                if (n instanceof or) {
                    n = n.definitions[0].name;
                    return n instanceof Dr && n;
                }
                while (n instanceof An) n = n.expression.tail_node();
                if (n instanceof Hn) return n;
            }
            function f(e, n, t) {
                if (e instanceof Fn && e.left instanceof Hn) {
                    var r = e.left.definition();
                    if (r.scope.resolve() === C) y.add(r.id, e);
                }
                if (e instanceof Hn && e.in_arg) H[e.definition().id] = 0;
                if (e instanceof $n && e.expression instanceof Hn) {
                    var r = e.expression.definition();
                    if (r.scope.resolve() === C) y.add(r.id, e);
                }
                var i = [], a = P(e, i);
                if (a) {
                    var o = a.definition();
                    if (o.scope.resolve() !== C && C.variables.get(a.name) !== o) return;
                    if (ze(o) && !dn(C.argnames, function(e) {
                        return !e.match_symbol(function(e) {
                            if (e instanceof In) {
                                var n = e.definition();
                                return n.references.length > n.replaced;
                            }
                        }, true);
                    })) return;
                    if (e.write_only === "p" && e.right.may_throw_on_access(z, true)) return;
                    var s = i.assign;
                    if (s) {
                        s.write_only = true;
                        s.walk(x);
                    }
                    i.forEach(function(e) {
                        e.walk(x);
                    });
                    if (e instanceof Fn) {
                        var f = ee(e), u = false;
                        if (t && e.write_only === true && !f.has_side_effects(z)) {
                            w.add(o.id, f);
                        } else {
                            f.walk(x);
                            u = f.tail_node().operator == "=";
                        }
                        if (e.left === a) {
                            if (!e.write_only || u) {
                                S(o, a, b[o.id]);
                            }
                        } else {
                            var c = a.fixed_value();
                            if (!c || !c.is_constant()) {
                                S(o, g[o.id], true);
                            }
                        }
                    }
                    if (k(o, a) && fi(a, e) !== a) E(o, a);
                    T(o);
                    return true;
                }
                if (e instanceof Cn) {
                    if (e.operator != "instanceof") return;
                    var a = e.right;
                    if (!(a instanceof Hn)) return;
                    var l = a.definition().id;
                    if (!_[l]) return;
                    e.left.walk(x);
                    _[l]++;
                    return true;
                }
                if (e instanceof mt) {
                    if (e.init instanceof Hn && Y === C) {
                        var l = e.init.definition().id;
                        if (!(l in N)) N[l] = e;
                    }
                    if (!F || !z.option("loops")) return;
                    if (!ue(e.body)) return;
                    if (e.init.has_side_effects(z)) return;
                    var a = A(e);
                    if (!a) return;
                    var r = a.definition();
                    if (r.scope.resolve() !== C) {
                        var p = v(a.name);
                        if (p === r || p && p.redefined() === r) return;
                    }
                    e.object.walk(x);
                    return true;
                }
                if (e instanceof Hn) {
                    var o = e.definition();
                    if (!(o.id in I)) {
                        I[o.id] = true;
                        m.push(o);
                    }
                    if (ne(o.scope, e.scope)) {
                        var d = o.redefined();
                        if (d && !(d.id in I)) {
                            I[d.id] = true;
                            m.push(d);
                        }
                    }
                    if (k(o, e)) E(o, e);
                    return true;
                }
                if (e instanceof bn) {
                    var h = Y;
                    Y = e;
                    n();
                    Y = h;
                    return true;
                }
            }
            function a(e) {
                return (e instanceof En ? e.name : e) instanceof Dr;
            }
            function K(e) {
                if (e.definition().id in I) return e;
                if (e instanceof In) e.unused = true;
                return null;
            }
            function D(e, n) {
                n.value = n.value.transform(V);
                var t = n.name.transform(e);
                if (!t) {
                    if (n.name instanceof jn) return null;
                    var r = n.value.drop_side_effect_free(z);
                    if (!r) return null;
                    W(n.name, "Side effects in default value of unused variable {name}");
                    n = n.clone();
                    n.name.unused = null;
                    n.value = r;
                }
                return n;
            }
            function Q(e, m, _, g, b) {
                var y = new Zr(function(a) {
                    if (a instanceof En) {
                        if (!(z.option("default_values") && m && m.is_defined(z))) {
                            var e = g;
                            g = false;
                            var n = D(y, a);
                            g = e;
                            if (!n && g && m) m = m.drop_side_effect_free(z);
                            return n;
                        } else if (a === b) {
                            b = a = a.name;
                        } else {
                            a = a.name;
                        }
                    }
                    if (a instanceof br) {
                        var e = g;
                        var t = m;
                        if (m instanceof Hn) {
                            g = false;
                            m = m.fixed_value();
                        }
                        var r = m instanceof Pn && m.elements;
                        var i = [], o = g && [], s = 0;
                        a.elements.forEach(function(e, n) {
                            m = r && r[n];
                            if (m instanceof Gr) {
                                m = null;
                            } else if (m instanceof On) {
                                if (g) {
                                    o.length = s;
                                    ye(t, o);
                                    [].push.apply(o, r.slice(n));
                                    t.elements = o;
                                }
                                m = r = false;
                            }
                            e = e.transform(y);
                            if (e) i[s] = e;
                            if (g && m) o[s] = m;
                            if (e || m || !g || !r) s++;
                        });
                        m = r && Fe(Pn, t, {
                            elements: r.slice(a.elements.length)
                        });
                        if (a.rest) {
                            var f = g;
                            g = false;
                            a.rest = a.rest.transform(z.option("rests") ? y : V);
                            g = f;
                            if (a.rest) i.length = s;
                        }
                        if (g) {
                            if (m && !a.rest) m = m.drop_side_effect_free(z);
                            if (m instanceof Pn) {
                                m = m.elements;
                            } else if (m instanceof Tn) {
                                m = m.expressions;
                            } else if (m) {
                                m = [ m ];
                            }
                            if (m && m.length) {
                                o.length = s;
                                [].push.apply(o, m);
                            }
                        }
                        m = t;
                        g = e;
                        if (r && o) {
                            ye(m, o);
                            m = m.clone();
                            m.elements = o;
                        }
                        if (!a.rest && (m instanceof Pn || m && m.is_string(z))) switch (i.length) {
                          case 0:
                            if (a === b) break;
                            if (g) m = m.drop_side_effect_free(z);
                            return null;

                          case 1:
                            if (!g) break;
                            if (a === b) break;
                            var u = i[0];
                            if (u.has_side_effects(z)) break;
                            if (m.has_side_effects(z) && u.match_symbol(function(e) {
                                return e instanceof An;
                            })) break;
                            m = Fe(qn, a, {
                                expression: m,
                                property: Fe(Bn, a, {
                                    value: 0
                                })
                            });
                            return u;
                        }
                        ye(a, i);
                        a.elements = i;
                        return a;
                    }
                    if (a instanceof wr) {
                        var e = g;
                        var t = m;
                        if (m instanceof Hn) {
                            g = false;
                            m = m.fixed_value();
                        }
                        var c, l, r;
                        if (m instanceof Nn) {
                            c = [];
                            l = new hn();
                            r = m.properties.map(function(e, n) {
                                e = e.clone();
                                if (e instanceof On) {
                                    l = false;
                                } else {
                                    var t = e.key;
                                    if (t instanceof vn) t = t.evaluate(z, true);
                                    if (t instanceof vn) {
                                        l = false;
                                    } else if (l && !(e instanceof Sr)) {
                                        l.set(t, e);
                                    }
                                    c[n] = t;
                                }
                                return e;
                            });
                        }
                        if (a.rest) {
                            m = false;
                            a.rest = a.rest.transform(z.option("rests") ? y : V);
                        }
                        var p = new hn();
                        var d = g && new hn();
                        var h = [];
                        a.properties.map(function(e) {
                            var n = e.key;
                            if (n instanceof vn) {
                                e.key = n = n.transform(V);
                                n = n.evaluate(z, true);
                            }
                            if (n instanceof vn) {
                                d = false;
                            } else {
                                p.set(n, !p.has(n));
                            }
                            return n;
                        }).forEach(function(e, n) {
                            var t = a.properties[n], r;
                            if (e instanceof vn) {
                                g = false;
                                m = false;
                                r = t.value.transform(y) || x(t.value);
                            } else {
                                g = d && p.get(e);
                                var i = l && l.get(e);
                                if (i) {
                                    m = i.value;
                                    if (m instanceof wt) m = false;
                                } else {
                                    m = false;
                                }
                                r = t.value.transform(y);
                                if (!r) {
                                    if (a.rest || w(t)) r = x(t.value);
                                    if (d && !d.has(e)) {
                                        if (i) {
                                            d.set(e, i);
                                            if (m === null) {
                                                l.set(e, w(i) && Fe(kr, i, {
                                                    key: i.key,
                                                    value: Fe(Bn, i, {
                                                        value: 0
                                                    })
                                                }));
                                            }
                                        } else {
                                            d.set(e, true);
                                        }
                                    }
                                } else if (d) {
                                    d.set(e, false);
                                }
                                if (m) i.value = m;
                            }
                            if (r) {
                                t.value = r;
                                h.push(t);
                            }
                        });
                        m = t;
                        g = e;
                        if (d && c) {
                            m = m.clone();
                            m.properties = Xn(r, function(e, n) {
                                if (e instanceof On) return e;
                                var t = c[n];
                                if (t instanceof vn) return e;
                                if (d.has(t)) {
                                    var r = d.get(t);
                                    if (!r) return e;
                                    if (r === e) return l.get(t) || Xn.skip;
                                } else if (a.rest) {
                                    return e;
                                }
                                var i = e.value.drop_side_effect_free(z);
                                if (i) {
                                    e.value = i;
                                    return e;
                                }
                                return w(e) ? Fe(kr, e, {
                                    key: e.key,
                                    value: Fe(Bn, e, {
                                        value: 0
                                    })
                                }) : Xn.skip;
                            });
                        }
                        if (m && !a.rest) switch (h.length) {
                          case 0:
                            if (a === b) break;
                            if (m.may_throw_on_access(z, true)) break;
                            if (g) m = m.drop_side_effect_free(z);
                            return null;

                          case 1:
                            if (!g) break;
                            if (a === b) break;
                            var v = h[0];
                            if (v.key instanceof vn) break;
                            if (v.value.has_side_effects(z)) break;
                            if (m.has_side_effects(z) && v.value.match_symbol(function(e) {
                                return e instanceof An;
                            })) break;
                            m = Fe(qn, a, {
                                expression: m,
                                property: fe(v.key, v)
                            });
                            return v.value;
                        }
                        a.properties = h;
                        return a;
                    }
                    if (a instanceof Gr) {
                        a = null;
                    } else {
                        a = _(a);
                    }
                    if (!a && g && m) m = m.drop_side_effect_free(z);
                    return a;
                });
                return {
                    name: e.transform(y),
                    value: m
                };
                function w(e) {
                    return e.key instanceof vn && e.key.has_side_effects(z);
                }
                function n(e) {
                    if (e instanceof Fn) {
                        e.write_only = false;
                        n(e.right);
                    } else if (e instanceof Cn) {
                        if (!He[e.operator]) return;
                        n(e.left);
                        n(e.right);
                    } else if (e instanceof Mn) {
                        n(e.consequent);
                        n(e.alternative);
                    } else if (e instanceof Tn) {
                        n(e.tail_node());
                    } else if (e instanceof $n) {
                        e.write_only = false;
                    }
                }
                function x(e) {
                    if (e instanceof En) return x(e.name);
                    if (e instanceof jn) {
                        if (m === null) {
                            m = Fe(Bn, e, {
                                value: 0
                            });
                        } else if (m) {
                            if (m.may_throw_on_access(z, true)) {
                                m = Fe(Pn, e, {
                                    elements: m instanceof Tn ? m.expressions : [ m ]
                                });
                            } else {
                                n(m);
                            }
                        }
                        return Fe(wr, e, {
                            properties: []
                        });
                    }
                    e.unused = null;
                    return e;
                }
            }
        });
        bn.DEFMETHOD("hoist_declarations", function(o) {
            if (o.has_directive("use asm")) return;
            var s = o.option("hoist_funs");
            var f = o.option("hoist_vars");
            var u = this;
            if (f) {
                var n = 0;
                u.walk(new Ln(function(e) {
                    if (n > 1) return true;
                    if (e instanceof cr) return true;
                    if (e instanceof bn && e !== u) return true;
                    if (e instanceof ur) {
                        n++;
                        return true;
                    }
                }));
                if (n <= 1) f = false;
            }
            if (!s && !f) return;
            var c = new hn();
            var l = [];
            var p = [];
            var d = new hn();
            var h = new Zr(function(e, n, t) {
                if (e === u) return;
                if (e instanceof it) {
                    l.push(e);
                    return t ? Xn.skip : Fe(mn, e);
                }
                if (e instanceof Ct) {
                    if (!s) return e;
                    var r = h.parent();
                    if (r instanceof cr) return e;
                    if (r instanceof lr) return e;
                    if (r !== u && o.has_directive("use strict")) return e;
                    p.push(e);
                    return t ? Xn.skip : Fe(mn, e);
                }
                if (e instanceof ur) {
                    if (!f) return e;
                    var r = h.parent();
                    if (r instanceof cr) return e;
                    if (!dn(e.definitions, function(e) {
                        var n = e.name;
                        return n instanceof zr && !c.has(n.name) && u.find_variable(n.name) === n.definition();
                    })) return e;
                    e.definitions.forEach(function(e) {
                        d.set(e.name.name, e);
                    });
                    var i = e.to_assignments();
                    if (r instanceof vt && r.init === e) {
                        if (i) return i;
                        var a = e.definitions[0].name;
                        return Fe(Hn, a);
                    }
                    if (r instanceof ht && r.init === e) return i;
                    if (!i) return t ? Xn.skip : Fe(mn, e);
                    return Fe(_n, e, {
                        body: i
                    });
                }
                if (e instanceof bn) return e;
                if (e instanceof qr) {
                    c.set(e.name, true);
                    return e;
                }
            });
            u.transform(h);
            if (d.size() > 0) {
                var v = [];
                if (u instanceof yn) u.each_argname(function(e) {
                    if (dn(e.definition().references, function(e) {
                        return !e.in_arg;
                    })) d.del(e.name);
                });
                d.each(function(e, n) {
                    e = e.clone();
                    e.name = e.name.clone();
                    e.value = null;
                    v.push(e);
                    d.set(n, e);
                    e.name.definition().orig.unshift(e.name);
                });
                if (v.length > 0) {
                    m(u.body);
                    p.push(Fe(ur, u, {
                        definitions: v
                    }));
                }
            }
            u.body = l.concat(p, u.body);
            function m(e) {
                while (e.length) {
                    var n = e[0];
                    if (n instanceof _n) {
                        var t = n.body, r, i;
                        if (t instanceof Fn && t.operator == "=" && (r = t.left) instanceof Ar && d.has(r.name)) {
                            var a = d.get(r.name);
                            if (a.value) break;
                            var o = t.right;
                            if (o instanceof Tn) o = o.clone();
                            a.value = o;
                            Zn(v, a);
                            v.push(a);
                            e.shift();
                            continue;
                        }
                        if (t instanceof Tn && (i = t.expressions[0]) instanceof Fn && i.operator == "=" && (r = i.left) instanceof Ar && d.has(r.name)) {
                            var a = d.get(r.name);
                            if (a.value) break;
                            a.value = i.right;
                            Zn(v, a);
                            v.push(a);
                            n.body = Pe(t, t.expressions.slice(1));
                            continue;
                        }
                    }
                    if (n instanceof mn) {
                        e.shift();
                        continue;
                    }
                    if (n instanceof gn && !m(n.body)) {
                        e.shift();
                        continue;
                    }
                    break;
                }
                return e.length;
            }
        });
        function y(n, t) {
            n.walk(new Ln(function(e) {
                if (e instanceof wn) {
                    t(e);
                    return true;
                }
                if (e instanceof bn && e !== n) return true;
            }));
        }
        function _(e) {
            var r = Object.create(null);
            y(e, function(e) {
                var n = e.value;
                if (n) n = n.tail_node();
                if (n instanceof Hn) {
                    var t = n.definition().id;
                    r[t] = (r[t] || 0) + 1;
                }
            });
            return r;
        }
        function g(e, n, t) {
            if (t.exposed(e)) return false;
            switch (e.references.length - e.replaced - (n[e.id] || 0)) {
              case e.drop_return:
                return "d";

              case e.bool_return:
                return true;
            }
        }
        function D(e, r) {
            y(e, function(e) {
                e.in_bool = true;
                var n = e.value;
                if (n) {
                    var t = C(r, n);
                    if (!t) {
                        n = n.drop_side_effect_free(r);
                        e.value = n ? Pe(e.value, [ n, Fe(Bn, e.value, {
                            value: 0
                        }) ]) : null;
                    } else if (!(t instanceof vn)) {
                        n = n.drop_side_effect_free(r);
                        e.value = n ? Pe(e.value, [ n, Fe(Bn, e.value, {
                            value: 1
                        }) ]) : Fe(Bn, e.value, {
                            value: 1
                        });
                    }
                }
            });
        }
        bn.DEFMETHOD("process_returns", Wn);
        Pt.DEFMETHOD("process_returns", function(e) {
            if (!e.option("booleans")) return;
            if (e.parent() instanceof lr) return;
            switch (g(this.name.definition(), _(this), e)) {
              case "d":
                N(e, this, true);
                break;

              case true:
                D(this, e);
                break;
            }
        });
        $t.DEFMETHOD("process_returns", function(n) {
            if (!n.option("booleans")) return;
            var t = true;
            var r = _(this);
            if (this.name && !c(this.name.definition())) return;
            var e = n.parent();
            if (e instanceof Fn) {
                if (e.operator != "=") return;
                var i = e.left;
                if (!(i instanceof Hn)) return;
                if (!c(i.definition())) return;
            } else if (e instanceof Sn && e.expression !== this) {
                var a = e.expression;
                if (a instanceof Hn) a = a.fixed_value();
                if (!(a instanceof yn)) return;
                if (a.uses_arguments || a.pinned()) return;
                var o = e.args, i;
                for (var s = 0; s < o.length; s++) {
                    var f = o[s];
                    if (f === this) {
                        i = a.argnames[s];
                        if (!i && a.rest) return;
                        break;
                    }
                    if (f instanceof On) return;
                }
                if (i instanceof En) i = i.name;
                if (i instanceof In && !c(i.definition())) return;
            } else if (e.TYPE == "Call") {
                n.pop();
                var u = n.in_boolean_context();
                n.push(this);
                switch (u) {
                  case true:
                    t = false;

                  case "d":
                    break;

                  default:
                    return;
                }
            } else return;
            if (t) {
                N(n, this, true);
            } else {
                D(this, n);
            }
            function c(e) {
                switch (g(e, r, n)) {
                  case true:
                    t = false;

                  case "d":
                    return true;
                }
            }
        });
        ot.DEFMETHOD("var_names", function() {
            var t = this._var_names;
            if (!t) {
                this._var_names = t = new hn();
                this.enclosed.forEach(function(e) {
                    t.set(e.name, true);
                });
                this.variables.each(function(e, n) {
                    t.set(n, true);
                });
            }
            return t;
        });
        bn.DEFMETHOD("make_var", function(e, n, t) {
            var r = [ this ];
            if (n instanceof Dr) n.definition().references.forEach(function(e) {
                var n = e.scope;
                do {
                    if (!Kn(r, n)) return;
                    n = n.parent_scope;
                } while (n && n !== this);
            });
            t = t.replace(/^[^a-z_$]|[^a-z0-9_$]/gi, "_");
            var i = t;
            for (var a = 0; !dn(r, function(e) {
                return !e.var_names().has(i);
            }); a++) i = t + "$" + a;
            var o = Fe(e, n, {
                name: i,
                scope: this
            });
            var s = this.def_variable(o);
            r.forEach(function(e) {
                e.enclosed.push(s);
                e.var_names().set(i, true);
            });
            return o;
        });
        bn.DEFMETHOD("hoist_properties", function(a) {
            if (!a.option("hoist_props") || a.has_directive("use asm")) return;
            var u = this;
            var o = u instanceof bt && a.top_retain || cn;
            var c = Object.create(null);
            var l = new Zr(function(r, e) {
                if (r instanceof Fn) {
                    if (r.operator != "=") return;
                    if (!r.write_only) return;
                    if (!p(r.left, r.right, 1)) return;
                    e(r, l);
                    var i = new hn();
                    var a = [];
                    var o = [];
                    r.right.properties.forEach(function(e) {
                        var n = f(zr, r.left, e.key);
                        o.push(Fe(kn, r, {
                            name: n,
                            value: null
                        }));
                        var t = Fe(Hn, r, {
                            name: n.name,
                            scope: u,
                            thedef: n.definition()
                        });
                        t.reference();
                        a.push(Fe(Fn, r, {
                            operator: "=",
                            left: t,
                            right: e.value
                        }));
                    });
                    i.value = r.right;
                    c[r.left.definition().id] = i;
                    u.body.splice(u.body.indexOf(l.stack[1]) + 1, 0, Fe(ur, r, {
                        definitions: o
                    }));
                    return Pe(r, a);
                }
                if (r instanceof bn) {
                    if (r === u) return;
                    var n = l.parent();
                    if (n.TYPE == "Call" && n.expression === r) return;
                    return r;
                }
                if (r instanceof kn) {
                    if (!p(r.name, r.value, 0)) return;
                    e(r, l);
                    var i = new hn();
                    var t = [];
                    var s = r.clone();
                    s.value = r.name instanceof qr ? Fe(Bn, r, {
                        value: 0
                    }) : null;
                    t.push(s);
                    r.value.properties.forEach(function(e) {
                        t.push(Fe(kn, r, {
                            name: f(r.name.CTOR, r.name, e.key),
                            value: e.value
                        }));
                    });
                    i.value = r.value;
                    c[r.name.definition().id] = i;
                    return Xn.splice(t);
                }
                function f(e, n, t) {
                    var r = u.make_var(e, n, n.name + "_" + t);
                    i.set(t, r.definition());
                    return r;
                }
            });
            u.transform(l);
            u.transform(new Zr(function(e, n) {
                if (e instanceof An) {
                    if (!(e.expression instanceof Hn)) return;
                    var t = c[e.expression.definition().id];
                    if (!t) return;
                    if (e.expression.fixed_value() !== t.value) return;
                    var r = t.get(e.get_property());
                    var i = Fe(Hn, e, {
                        name: r.name,
                        scope: e.expression.scope,
                        thedef: r
                    });
                    i.reference();
                    return i;
                }
                if (e instanceof Hn) {
                    var t = c[e.definition().id];
                    if (!t) return;
                    if (e.fixed_value() !== t.value) return;
                    return Fe(Nn, e, {
                        properties: []
                    });
                }
            }));
            function p(e, n, t) {
                if (!(e instanceof Ar)) return;
                var r = e.definition();
                if (r.assignments != t) return;
                if (r.references.length - r.replaced == t) return;
                if (r.single_use) return;
                if (u.find_variable(e.name) !== r) return;
                if (o(r)) return;
                if (e.fixed_value() !== n) return;
                var i = e.fixed || r.fixed;
                if (i.direct_access) return;
                if (i.escaped && i.escaped.depth == 1) return;
                return n instanceof Nn && n.properties.length > 0 && Ce(e, a) && dn(n.properties, function(e) {
                    return on(e) && e.key !== "__proto__";
                });
            }
        });
        function xe(e, n) {
            if (!e.name || !n.option("ie")) return true;
            var t = e.name.definition();
            if (n.exposed(t)) return false;
            return dn(t.references, function(e) {
                return !(e instanceof Hn);
            });
        }
        function N(o, n, e) {
            if (!(n instanceof yn)) return;
            var t = kt(n);
            var r = Et(n);
            var s = false;
            var i = false;
            if (t && o.option("arrows")) {
                if (!n.value) {
                    i = true;
                } else if (!r || x(o, n.value)) {
                    var a = n.value.drop_side_effect_free(o);
                    if (a !== n.value) {
                        s = true;
                        n.value = a;
                    }
                }
            } else if (!St(n)) {
                if (!e && n.name) {
                    var f = n.name.definition();
                    i = f.references.length == f.replaced;
                } else {
                    i = true;
                }
            }
            if (i) {
                n.process_expression(false, function(e) {
                    var n = e.value;
                    if (n) {
                        if (r && !x(o, n)) return e;
                        n = n.drop_side_effect_free(o, true);
                    }
                    s = true;
                    if (!n) return Fe(mn, e);
                    return Fe(_n, e, {
                        body: n
                    });
                });
                y(n, function(e) {
                    var n = e.value;
                    if (n) {
                        if (r && !x(o, n)) return;
                        var t = n.drop_side_effect_free(o);
                        if (t !== n) {
                            s = true;
                            if (t && r && !x(o, t)) {
                                t = t.negate(o);
                            }
                            e.value = t;
                        }
                    }
                });
            }
            if (r && o.option("awaits")) {
                if (i) n.process_expression("awaits", function(e) {
                    var n = e.body;
                    if (n instanceof _r) {
                        if (x(o, n.expression)) {
                            s = true;
                            n = n.expression.drop_side_effect_free(o, true);
                            if (!n) return Fe(mn, e);
                            e.body = n;
                        }
                    } else if (n instanceof Tn) {
                        var t = n.expressions;
                        for (var r = t.length; --r >= 0; ) {
                            var i = t[r];
                            if (!(i instanceof _r)) break;
                            var a = i.expression;
                            if (!x(o, a)) break;
                            s = true;
                            if (t[r] = a.drop_side_effect_free(o)) break;
                        }
                        switch (r) {
                          case -1:
                            return Fe(mn, e);

                          case 0:
                            e.body = t[0];
                            break;

                          default:
                            t.length = r + 1;
                            break;
                        }
                    }
                    return e;
                });
                var u = !i && n.name || t && n.value && !x(o, n.value);
                var c = new Ln(function(e) {
                    if (u) return true;
                    if (c.parent() === n && e.may_throw(o)) return u = true;
                    if (e instanceof _r) return u = true;
                    if (e instanceof _t) return u = true;
                    if (e instanceof wn) {
                        if (e.value && !x(o, e.value)) return u = true;
                        return;
                    }
                    if (e instanceof bn && e !== n) return true;
                });
                n.walk(c);
                if (!u) {
                    var l;
                    switch (n.CTOR) {
                      case Dt:
                        l = At;
                        break;

                      case qt:
                        l = $t;
                        break;

                      case Ot:
                        l = zt;
                        break;
                    }
                    return Fe(l, n);
                }
            }
            return s && n.clone();
        }
        (function(e) {
            function d(e, n, t, r) {
                var i = e.length;
                var a = [], o = false;
                for (var s = 0; s < i; s++) {
                    var f = e[s];
                    var u;
                    if (r && f instanceof On) {
                        u = r(f, n, t);
                    } else {
                        u = f.drop_side_effect_free(n, t);
                    }
                    if (u !== f) o = true;
                    if (u) {
                        a.push(u);
                        t = false;
                    }
                }
                return a.length ? o ? a : e : null;
            }
            function c(e, n, t) {
                var r = e.expression;
                if (!r.is_string(n)) return e;
                return r.drop_side_effect_free(n, t);
            }
            function l(e) {
                return e instanceof On ? Fe(Pn, e, {
                    elements: [ e ]
                }) : e;
            }
            e(vn, Gn);
            e(wt, Jn);
            e(Pn, function(e, n) {
                var t = d(this.elements, e, n, c);
                if (!t) return null;
                if (t === this.elements && dn(t, function(e) {
                    return e instanceof On;
                })) return this;
                return Pe(this, t.map(l));
            });
            e(Fn, function(e) {
                var n = this.left;
                if (n instanceof An) {
                    var t = n.expression;
                    if (t.may_throw_on_access(e, true)) return this;
                    if (e.has_directive("use strict") && t.is_constant()) return this;
                }
                if (n.has_side_effects(e)) return this;
                if (He[this.operator.slice(0, -1)]) return this;
                this.write_only = true;
                if (!vr(n).is_constant_expression(e.find_parent(bn))) return this;
                return this.right.drop_side_effect_free(e);
            });
            e(_r, function(e) {
                if (!e.option("awaits")) return this;
                var n = this.expression;
                if (!x(e, n)) return this;
                if (n instanceof zn && n.operator == "!") n = n.expression;
                var t = n.drop_side_effect_free(e);
                if (t === n) return this;
                if (!t) {
                    t = Fe(Bn, n, {
                        value: 0
                    });
                } else if (!x(e, t)) {
                    t = t.negate(e);
                }
                var r = this.clone();
                r.expression = t;
                return r;
            });
            e(Cn, function(e, n) {
                var t = this.left;
                var r = this.right;
                var i = this.operator;
                if (!Ke(i, r, e)) {
                    var a = t.drop_side_effect_free(e, n);
                    if (a === t) return this;
                    var o = this.clone();
                    o.left = a || Fe(Bn, t, {
                        value: 0
                    });
                    return o;
                }
                var s = r.drop_side_effect_free(e, n);
                if (!s) return t.drop_side_effect_free(e, n);
                if (He[i] && s.has_side_effects(e)) {
                    var o = this;
                    if (s !== r) {
                        o = o.clone();
                        o.right = s.drop_side_effect_free(e);
                    }
                    if (i == "??") return o;
                    var f = o.clone();
                    f.operator = i == "&&" ? "||" : "&&";
                    f.left = t.negate(e, n);
                    if (f.operator == f.right.operator) qe(f);
                    var u = n ? A : le;
                    return i == "&&" ? u(o, f) : u(f, o);
                }
                var a = t.drop_side_effect_free(e, n);
                if (!a) return s;
                s = s.drop_side_effect_free(e);
                if (!s) return a;
                return Pe(this, [ a, s ]);
            });
            function p(e, n) {
                e.new = true;
                var t = dn(e.body, function(e) {
                    return !e.has_side_effects(n);
                }) && dn(e.argnames, function(e) {
                    return !e.match_symbol(cn);
                }) && !(e.rest && e.rest.match_symbol(cn));
                e.new = false;
                return t;
            }
            e(Sn, function(e, n) {
                var t = this;
                if (t.is_expr_pure(e)) {
                    if (t.pure) vn.warn("Dropping __PURE__ call [{start}]", t);
                    var r = d(t.args, e, n, c);
                    return r && Pe(t, r.map(l));
                }
                var i = t.expression;
                if (t.is_call_pure(e)) {
                    var a = t.args.slice();
                    a.unshift(i.expression);
                    a = d(a, e, n, c);
                    return a && Pe(t, a.map(l));
                }
                if (e.option("yields") && St(i)) {
                    var o = t.clone();
                    o.expression = Fe($t, i);
                    o.expression.body = [];
                    var s = o.transform(e);
                    if (s !== o) return s.drop_side_effect_free(e, n);
                }
                var f = N(e, i);
                if (f) {
                    t = t.clone();
                    t.expression = f;
                    if (i._squeezed) t.expression._squeezed = true;
                }
                if (t instanceof hr) {
                    var u = i;
                    if (u instanceof Hn) u = u.fixed_value();
                    if (u instanceof yn) {
                        if (p(u, e)) {
                            var a = t.args.slice();
                            a.unshift(i);
                            a = d(a, e, n, c);
                            return a && Pe(t, a.map(l));
                        }
                        if (!u.contains_this()) {
                            t = Fe(Sn, t);
                            t.expression = t.expression.clone();
                            t.args = t.args.slice();
                        }
                    }
                }
                t.call_only = true;
                return t;
            });
            e(Ht, function(e, n) {
                var t = this;
                var r = [], i = [], a = 0;
                var o = t.properties;
                for (var s = 0; s < o.length; s++) {
                    var f = o[s];
                    if (f.key instanceof vn) r.push(f.key);
                    if (!te(f)) continue;
                    var u = f.value;
                    if (!u.has_side_effects(e)) continue;
                    if (u.contains_this()) return t;
                    if (f instanceof Vt) {
                        a++;
                        i.push(f);
                    } else {
                        i.push(u);
                    }
                }
                var c = t.extends;
                if (c) {
                    if (c instanceof Hn) c = c.fixed_value();
                    c = !Be(c);
                    if (!c) r.unshift(t.extends);
                }
                r = d(r, e, n);
                if (r) n = false;
                i = d(i, e, n);
                if (!r) {
                    if (!c && !i && !t.name) return null;
                    r = [];
                }
                if (c || t.name || !e.has_directive("use strict")) {
                    var l = re(t);
                    if (!c) l.extends = null;
                    l.properties = [];
                    if (i) {
                        if (i.length == a) {
                            if (r.length) i.unshift(Fe(Rt, t, {
                                key: Pe(t, r),
                                value: null
                            }));
                            l.properties = i;
                        } else l.properties.push(Fe(Rt, t, {
                            static: true,
                            key: r.length ? Pe(t, r) : "c",
                            value: p()
                        }));
                    } else if (r.length) l.properties.push(Fe(Ut, t, {
                        key: Pe(t, r),
                        value: Fe($t, t, {
                            argnames: [],
                            body: []
                        }).init_vars(l)
                    }));
                    return l;
                }
                if (i) r.push(Fe(Sn, t, {
                    expression: Fe(At, t, {
                        argnames: [],
                        body: [],
                        value: p()
                    }).init_vars(t.parent_scope),
                    args: []
                }));
                return Pe(t, r);
                function p() {
                    return Pe(t, i.map(function(e) {
                        if (!(e instanceof Vt)) return e;
                        var n = Fe(At, e.value);
                        n.argnames = [];
                        return Fe(Sn, e, {
                            expression: n,
                            args: []
                        });
                    }));
                }
            });
            e(Mn, function(e) {
                var n = this.consequent.drop_side_effect_free(e);
                var t = this.alternative.drop_side_effect_free(e);
                if (n === this.consequent && t === this.alternative) return this;
                var r;
                if (e.option("ie")) {
                    r = [];
                    if (n instanceof $t) {
                        r.push(n);
                        n = null;
                    }
                    if (t instanceof $t) {
                        r.push(t);
                        t = null;
                    }
                }
                var i;
                if (!n) {
                    i = t ? Fe(Cn, this, {
                        operator: "||",
                        left: this.condition,
                        right: t
                    }) : this.condition.drop_side_effect_free(e);
                } else if (!t) {
                    i = Fe(Cn, this, {
                        operator: "&&",
                        left: this.condition,
                        right: n
                    });
                } else {
                    i = this.clone();
                    i.consequent = n;
                    i.alternative = t;
                }
                if (!r) return i;
                if (i) r.push(i);
                return r.length == 0 ? null : Pe(this, r);
            });
            e(Yn, Jn);
            e(Dn, function(e, n) {
                var t = this.expression;
                if (t.may_throw_on_access(e)) return this;
                return t.drop_side_effect_free(e, n);
            });
            e($t, function(e) {
                return xe(this, e) ? null : this;
            });
            e(xt, Jn);
            e(Nn, function(e, n) {
                var t = [];
                this.properties.forEach(function(e) {
                    if (e instanceof On) {
                        t.push(e);
                    } else {
                        if (e.key instanceof vn) t.push(e.key);
                        t.push(e.value);
                    }
                });
                var r = d(t, e, n, function(e, n, t) {
                    var r = e.expression;
                    return r.safe_to_spread() ? r.drop_side_effect_free(n, t) : e;
                });
                if (!r) return null;
                if (r === t && !dn(r, function(e) {
                    return !(e instanceof On);
                })) return this;
                return Pe(this, r.map(function(e) {
                    return e instanceof On ? Fe(Nn, e, {
                        properties: [ e ]
                    }) : e;
                }));
            });
            e(Nr, Jn);
            e(Tn, function(e, n) {
                var t = d(this.expressions, e, n);
                if (!t) return null;
                var r = t.length - 1;
                var i = t[r];
                if (e.option("awaits") && r > 0 && i instanceof _r && i.expression.is_constant()) {
                    t = t.slice(0, -1);
                    r--;
                    var a = t[r];
                    i.expression = x(e, a) ? a : a.negate(e);
                    t[r] = i;
                }
                var o, s, f;
                if (e.option("conditionals") && r > 0 && (o = t[r - 1]) instanceof Fn && o.operator == "=" && (f = o.left) instanceof Hn && (s = ee(e, f.definition(), o.right, i))) {
                    o = o.clone();
                    o.right = s;
                    t = t.slice(0, -2);
                    t.push(o.drop_side_effect_free(e, n));
                }
                return t === this.expressions ? this : Pe(this, t);
            });
            e(qn, function(e, n) {
                var t = this.expression;
                if (t.may_throw_on_access(e)) return this;
                var r = this.property;
                t = t.drop_side_effect_free(e, n);
                if (!t) return r.drop_side_effect_free(e, n);
                r = r.drop_side_effect_free(e);
                if (!r) return t;
                return Pe(this, [ t, r ]);
            });
            e(Hn, function(e) {
                return this.is_declared(e) && Ce(this, e) ? null : this;
            });
            e(Rr, function(e, n) {
                var t = this;
                if (t.is_expr_pure(e)) {
                    var r = t.expressions;
                    if (r.length == 0) return null;
                    return Pe(t, r).drop_side_effect_free(e, n);
                }
                var i = t.tag;
                var a = N(e, i);
                if (a) {
                    t = t.clone();
                    t.tag = a;
                    if (i._squeezed) t.tag._squeezed = true;
                }
                return t;
            });
            e($n, function(e, n) {
                var t = this.expression;
                if (si[this.operator]) {
                    this.write_only = !t.has_side_effects(e);
                    return this;
                }
                if (this.operator == "typeof" && t instanceof Hn && Ce(t, e)) {
                    return null;
                }
                var r = t.drop_side_effect_free(e, n);
                if (n && r && be(r)) {
                    if (r === t && this.operator == "!") return this;
                    return r.negate(e, n);
                }
                return r;
            });
        })(function(e, n) {
            e.DEFMETHOD("drop_side_effect_free", n);
        });
        e(_n, function(e, n) {
            if (n.option("side_effects")) {
                var t = e.body;
                var r = t.drop_side_effect_free(n, true);
                if (!r) {
                    vn.warn("Dropping side-effect-free statement [{start}]", e);
                    return Fe(mn, e);
                }
                if (r !== t) {
                    return Fe(_n, e, {
                        body: r
                    });
                }
            }
            return e;
        });
        e(dt, function(e, n) {
            return n.option("loops") ? Fe(ht, e).optimize(n) : e;
        });
        function I(n, e, t) {
            if (!t) t = Xt;
            var r = false;
            var i = new Ln(function(e) {
                if (r || e instanceof bn) return true;
                if (e instanceof t && i.loopcontrol_target(e) === n) {
                    return r = true;
                }
            });
            if (e instanceof ut) i.push(e);
            i.push(n);
            n.body.walk(i);
            return r;
        }
        e(pt, function(t, e) {
            if (!e.option("loops")) return t;
            var n = C(e, t.condition);
            if (!(n instanceof vn)) {
                if (n && !I(t, e.parent(), Qt)) return Fe(ht, t, {
                    body: Fe(gn, t.body, {
                        body: [ t.body, Fe(_n, t.condition, {
                            body: t.condition
                        }) ]
                    })
                }).optimize(e);
                if (!I(t, e.parent())) return Fe(gn, t.body, {
                    body: [ t.body, Fe(_n, t.condition, {
                        body: t.condition
                    }) ]
                }).optimize(e);
            }
            if (t.body instanceof gn && !I(t, e.parent(), Qt)) {
                var r = t.body.body;
                for (var i = r.length; --i >= 0; ) {
                    var a = r[i];
                    if (a instanceof xn && !a.alternative && a.body instanceof Kt && e.loopcontrol_target(a.body) === t) {
                        if (o(a.condition)) break;
                        t.condition = Fe(Cn, t, {
                            operator: "&&",
                            left: a.condition.negate(e),
                            right: t.condition
                        });
                        r.splice(i, 1);
                    } else if (a instanceof _n) {
                        if (o(a.body)) break;
                        t.condition = Pe(t, [ a.body, t.condition ]);
                        r.splice(i, 1);
                    } else if (!Y(a, true)) {
                        break;
                    }
                }
                t.body = q(t.body, e.parent());
            }
            if (t.body instanceof mn) return Fe(ht, t).optimize(e);
            if (t.body instanceof _n) return Fe(ht, t, {
                condition: Pe(t.condition, [ t.body.body, t.condition ]),
                body: Fe(mn, t)
            }).optimize(e);
            return t;
            function o(e) {
                var n = false;
                e.walk(new Ln(function(e) {
                    if (n) return true;
                    if (e instanceof Hn) {
                        if (!Un(e.definition(), t.enclosed)) n = true;
                        return true;
                    }
                }));
                return n;
            }
        });
        function W(n, t) {
            var e = o(n.body);
            if (t.option("dead_code") && (e instanceof Kt || e instanceof Qt && s(e) || e instanceof Gt)) {
                var r = [];
                if (at(n.init)) {
                    r.push(n.init);
                } else if (n.init) {
                    r.push(Fe(_n, n.init, {
                        body: n.init
                    }));
                }
                var i = s(e) || e instanceof Gt;
                if (n.condition && i) {
                    r.push(Fe(xn, n, {
                        condition: n.condition,
                        body: e,
                        alternative: null
                    }));
                } else if (n.condition) {
                    r.push(Fe(_n, n.condition, {
                        body: n.condition
                    }));
                } else if (i) {
                    r.push(e);
                }
                z(t, n.body, r);
                return Fe(gn, n, {
                    body: r
                });
            }
            if (e instanceof xn) {
                var a = o(e.body);
                if (a instanceof Kt && !s(a)) {
                    if (n.condition) {
                        n.condition = Fe(Cn, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition.negate(t)
                        });
                    } else {
                        n.condition = e.condition.negate(t);
                    }
                    var r = U(e.alternative);
                    z(t, e.body, r);
                    return f(r);
                }
                a = o(e.alternative);
                if (a instanceof Kt && !s(a)) {
                    if (n.condition) {
                        n.condition = Fe(Cn, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition
                        });
                    } else {
                        n.condition = e.condition;
                    }
                    var r = U(e.body);
                    z(t, e.alternative, r);
                    return f(r);
                }
            }
            return n;
            function o(e) {
                return e instanceof gn ? e.body[0] : e;
            }
            function s(e) {
                return t.loopcontrol_target(e) !== t.self();
            }
            function f(e) {
                if (n.body instanceof gn) {
                    n.body = n.body.clone();
                    n.body.body = e.concat(n.body.body.slice(1));
                    n.body = n.body.transform(t);
                } else {
                    n.body = Fe(gn, n.body, {
                        body: e
                    }).transform(t);
                }
                return W(n, t);
            }
        }
        e(ht, function(e, n) {
            if (!n.option("loops")) return e;
            if (n.option("side_effects")) {
                if (e.init) e.init = e.init.drop_side_effect_free(n);
                if (e.step) e.step = e.step.drop_side_effect_free(n);
            }
            if (e.condition) {
                var t = C(n, e.condition);
                if (!t) {
                    if (n.option("dead_code")) {
                        var r = [];
                        if (at(e.init)) {
                            r.push(e.init);
                        } else if (e.init) {
                            r.push(Fe(_n, e.init, {
                                body: e.init
                            }));
                        }
                        r.push(Fe(_n, e.condition, {
                            body: e.condition
                        }));
                        z(n, e.body, r);
                        return Fe(gn, e, {
                            body: r
                        }).optimize(n);
                    }
                } else if (!(t instanceof vn)) {
                    e.body = Fe(gn, e.body, {
                        body: [ Fe(_n, e.condition, {
                            body: e.condition
                        }), e.body ]
                    });
                    e.condition = null;
                }
            }
            return W(e, n);
        });
        e(vt, function(e, t) {
            if (t.option("varify") && L(e.init)) {
                var n = e.init.definitions[0].name;
                if ((n instanceof jn || n instanceof $r) && !n.match_symbol(function(e) {
                    if (e instanceof Dr) {
                        var n = e.definition();
                        return !Re(n) || X(t, n);
                    }
                }, true)) {
                    e.init = K(e.init);
                }
            }
            return e;
        });
        function B(e, n, t) {
            if (e instanceof Tn) e = e.tail_node();
            if (!(e instanceof Cn)) return;
            if (!(e.left instanceof Rn)) {
                switch (e.operator) {
                  case "&&":
                    B(e.left, n);
                    B(e.right, n);
                    break;

                  case "||":
                    B(p(e.left), t);
                    B(p(e.right), t);
                    break;
                }
                return;
            }
            if (!(e.right instanceof zn)) return;
            if (e.right.operator != "typeof") return;
            var r = e.right.expression;
            if (!Ne(r)) return;
            var i;
            var a = e.left.value == "undefined";
            switch (e.operator) {
              case "==":
                i = a ? t : n;
                break;

              case "!=":
                i = a ? n : t;
                break;

              default:
                return;
            }
            if (!i) return;
            var o = false;
            var s = r.definition();
            var f;
            var u = [];
            var c = [];
            var l = new Ln(function(e, n) {
                if (o) return true;
                if (e instanceof Fn) {
                    var t = e.left;
                    if (!(t instanceof Hn && t.definition() === s)) return;
                    e.right.walk(l);
                    switch (e.operator) {
                      case "=":
                      case "&&=":
                        o = true;
                    }
                    return true;
                }
                if (e instanceof Sn) {
                    n();
                    f = e.expression.tail_node();
                    var r;
                    if (f instanceof Hn) {
                        f = f.fixed_value();
                        r = u.length;
                    }
                    if (!(f instanceof yn)) {
                        o = true;
                    } else if (Kn(c, f)) {
                        f.walk(l);
                    }
                    if (r >= 0) u.length = r;
                    return true;
                }
                if (e instanceof lt) {
                    var r = u.length;
                    n();
                    if (o) u.length = r;
                    return true;
                }
                if (e instanceof ht) {
                    if (e.init) e.init.walk(l);
                    var r = u.length;
                    if (e.condition) e.condition.walk(l);
                    e.body.walk(l);
                    if (e.step) e.step.walk(l);
                    if (o) u.length = r;
                    return true;
                }
                if (e instanceof vt) {
                    e.object.walk(l);
                    var r = u.length;
                    e.init.walk(l);
                    e.body.walk(l);
                    if (o) u.length = r;
                    return true;
                }
                if (e instanceof bn) {
                    if (e === f) return;
                    return true;
                }
                if (e instanceof Hn) {
                    if (e.definition() === s) u.push(e);
                    return true;
                }
            });
            i.walk(l);
            u.forEach(function(e) {
                e.defined = true;
            });
            function p(e) {
                if (!(e instanceof Cn)) return;
                switch (e.operator) {
                  case "==":
                    e = e.clone();
                    e.operator = "!=";
                    return e;

                  case "!=":
                    e = e.clone();
                    e.operator = "==";
                    return e;
                }
            }
        }
        function C(e, n, t) {
            if (n.truthy) return true;
            if (Ie(n)) return undefined;
            if (n.falsy && !t) return false;
            if (n.is_truthy()) return true;
            return n.evaluate(e, true);
        }
        function G(e, n) {
            var t;
            var r = 0;
            var i = false;
            var a = e.self();
            if (!at(a)) while (true) {
                t = a;
                a = e.parent(r++);
                if (a instanceof Cn) {
                    switch (t) {
                      case a.left:
                        if (He[a.operator]) continue;
                        break;

                      case a.right:
                        if (s(a.left)) switch (a.operator) {
                          case "&&":
                            n[i ? "falsy" : "truthy"] = true;
                            break;

                          case "||":
                          case "??":
                            n[i ? "truthy" : "falsy"] = true;
                            break;
                        }
                        break;
                    }
                } else if (a instanceof Mn) {
                    var o = a.condition;
                    if (o === t) continue;
                    if (s(o)) switch (t) {
                      case a.consequent:
                        n[i ? "falsy" : "truthy"] = true;
                        break;

                      case a.alternative:
                        n[i ? "truthy" : "falsy"] = true;
                        break;
                    }
                } else if (a instanceof Gt) {
                    break;
                } else if (a instanceof xn) {
                    break;
                } else if (a instanceof Tn) {
                    if (a.expressions[0] === t) continue;
                } else if (a instanceof _n) {
                    break;
                }
                return;
            }
            while (true) {
                t = a;
                a = e.parent(r++);
                if (a instanceof gn) {
                    if (a.body[0] === t) continue;
                } else if (a instanceof xn) {
                    if (s(a.condition)) switch (t) {
                      case a.body:
                        n[i ? "falsy" : "truthy"] = true;
                        break;

                      case a.alternative:
                        n[i ? "truthy" : "falsy"] = true;
                        break;
                    }
                }
                return;
            }
            function s(e) {
                if (n.equals(e)) return true;
                if (!(e instanceof zn)) return false;
                if (e.operator != "!") return false;
                if (!n.equals(e.expression)) return false;
                i = true;
                return true;
            }
        }
        e(xn, function(e, u) {
            if (ue(e.alternative)) e.alternative = null;
            if (!u.option("conditionals")) return e;
            if (u.option("booleans") && !e.condition.has_side_effects(u)) {
                G(u, e.condition);
            }
            if (u.option("dead_code")) {
                var n = C(u, e.condition);
                if (!n) {
                    vn.warn("Condition always false [{start}]", e.condition);
                    var t = [ Fe(_n, e.condition, {
                        body: e.condition
                    }).transform(u) ];
                    z(u, e.body, t);
                    if (e.alternative) t.push(e.alternative);
                    return Fe(gn, e, {
                        body: t
                    }).optimize(u);
                } else if (!(n instanceof vn)) {
                    vn.warn("Condition always true [{start}]", e.condition);
                    var t = [ Fe(_n, e.condition, {
                        body: e.condition
                    }).transform(u), e.body ];
                    if (e.alternative) z(u, e.alternative, t);
                    return Fe(gn, e, {
                        body: t
                    }).optimize(u);
                }
            }
            var r = e.condition.negate(u);
            var i = e.condition.print_to_string().length;
            var a = r.print_to_string().length;
            var o = a < i;
            if (e.alternative && o) {
                o = false;
                e.condition = r;
                var s = e.body;
                e.body = e.alternative;
                e.alternative = ue(s) ? null : s;
            }
            var f = [];
            var c = [];
            var l = [];
            var p = $(e.body, f, c, l);
            var d = [];
            var h = [];
            var v = [];
            var m = $(e.alternative, d, h, v);
            if (p instanceof gn || m instanceof gn) {
                var t = [], _ = [];
                if (p) {
                    [].push.apply(t, f);
                    [].push.apply(_, c);
                    if (p instanceof gn) {
                        e.body = p;
                    } else if (p.length == 0) {
                        e.body = Fe(mn, e.body);
                    } else {
                        e.body = Fe(_n, e.body, {
                            body: Pe(e.body, p)
                        });
                    }
                    l.forEach(P);
                }
                if (m) {
                    [].push.apply(t, d);
                    [].push.apply(_, h);
                    if (m instanceof gn) {
                        e.alternative = m;
                    } else if (m.length == 0) {
                        e.alternative = null;
                    } else {
                        e.alternative = Fe(_n, e.alternative, {
                            body: Pe(e.alternative, m)
                        });
                    }
                    v.forEach(P);
                }
                if (_.length > 0) t.push(Fe(ur, e, {
                    definitions: _
                }));
                if (t.length > 0) {
                    t.push(e.transform(u));
                    return Fe(gn, e, {
                        body: t
                    }).optimize(u);
                }
            } else if (p && m) {
                var t = f.concat(d);
                if (c.length > 0 || h.length > 0) t.push(Fe(ur, e, {
                    definitions: c.concat(h)
                }));
                if (p.length == 0) {
                    t.push(Fe(_n, e.condition, {
                        body: m.length > 0 ? Fe(Cn, e, {
                            operator: "||",
                            left: e.condition,
                            right: Pe(e.alternative, m)
                        }).transform(u) : e.condition.clone()
                    }).optimize(u));
                } else if (m.length == 0) {
                    if (i === a && !o && e.condition instanceof Cn && e.condition.operator == "||") {
                        o = true;
                    }
                    t.push(Fe(_n, e, {
                        body: Fe(Cn, e, {
                            operator: o ? "||" : "&&",
                            left: o ? r : e.condition,
                            right: Pe(e.body, p)
                        }).transform(u)
                    }).optimize(u));
                } else {
                    t.push(Fe(_n, e, {
                        body: Fe(Mn, e, {
                            condition: e.condition,
                            consequent: Pe(e.body, p),
                            alternative: Pe(e.alternative, m)
                        })
                    }).optimize(u));
                }
                l.forEach(P);
                v.forEach(P);
                return Fe(gn, e, {
                    body: t
                }).optimize(u);
            }
            if (ue(e.body)) e = Fe(xn, e, {
                condition: r,
                body: e.alternative,
                alternative: null
            });
            if (e.alternative instanceof Gt && e.body.TYPE == e.alternative.TYPE) {
                var g = Fe(e.body.CTOR, e, {
                    value: Fe(Mn, e, {
                        condition: e.condition,
                        consequent: e.body.value || Fe(Wr, e.body).transform(u),
                        alternative: e.alternative.value || Fe(Wr, e.alternative).transform(u)
                    })
                });
                if (g instanceof wn) g.in_bool = e.body.in_bool || e.alternative.in_bool;
                return g;
            }
            if (e.body instanceof xn && !e.body.alternative && !e.alternative) {
                e = Fe(xn, e, {
                    condition: Fe(Cn, e.condition, {
                        operator: "&&",
                        left: e.condition,
                        right: e.body.condition
                    }),
                    body: e.body.body,
                    alternative: null
                });
            }
            if (R(e.body) && e.alternative) {
                var b = e.alternative;
                e.alternative = null;
                return Fe(gn, e, {
                    body: [ e, b ]
                }).optimize(u);
            }
            if (R(e.alternative)) {
                var t = e.body;
                e.body = e.alternative;
                e.condition = o ? r : e.condition.negate(u);
                e.alternative = null;
                return Fe(gn, e, {
                    body: [ e, t ]
                }).optimize(u);
            }
            if (e.alternative) {
                var y = D(e.body);
                var w = q(y);
                var x = D(e.alternative);
                var k = q(x);
                for (var E = []; w >= 0 && k >= 0; ) {
                    var S = y[w];
                    var T = x[k];
                    if (S.equals(T)) {
                        y.splice(w--, 1);
                        x.splice(k--, 1);
                        E.unshift(S);
                    } else {
                        if (!(S instanceof _n)) break;
                        if (!(T instanceof _n)) break;
                        var A = S.body.tail_node();
                        if (!A.equals(T.body.tail_node())) break;
                        w = O(y, S.body, w);
                        k = O(x, T.body, k);
                        E.unshift(Fe(_n, A, {
                            body: A
                        }));
                    }
                }
                if (E.length > 0) {
                    e.body = y.length > 0 ? Fe(gn, e, {
                        body: y
                    }) : Fe(mn, e);
                    e.alternative = x.length > 0 ? Fe(gn, e, {
                        body: x
                    }) : null;
                    E.unshift(e);
                    return Fe(gn, e, {
                        body: E
                    }).optimize(u);
                }
            }
            if (u.option("typeofs")) B(e.condition, e.body, e.alternative);
            return e;
            function D(e) {
                return e instanceof gn ? e.body : [ e ];
            }
            function q(e) {
                for (var n = e.length; --n >= 0; ) {
                    if (!Y(e[n], true)) break;
                }
                return n;
            }
            function O(e, n, t) {
                if (n instanceof Tn) {
                    e[t] = Fe(_n, n, {
                        body: Pe(n, n.expressions.slice(0, -1))
                    });
                } else {
                    e.splice(t--, 1);
                }
                return t;
            }
            function $(e, n, t, r) {
                if (e == null) return [];
                if (e instanceof gn) {
                    var i = [];
                    for (var a = 0; a < e.body.length; a++) {
                        var o = e.body[a];
                        if (o instanceof mn) continue;
                        if (o instanceof Gt) {
                            if (a == 0) return;
                            if (i.length > 0) {
                                o = o.clone();
                                i.push(o.value || Fe(Wr, o).transform(u));
                                o.value = Pe(e, i);
                            }
                            var s = e.clone();
                            s.body = s.body.slice(a + 1);
                            s.body.unshift(o);
                            return s;
                        }
                        if (o instanceof Ct) {
                            n.push(o);
                        } else if (o instanceof _n) {
                            if (!u.option("sequences") && i.length > 0) return;
                            i.push(o.body);
                        } else if (o instanceof ur) {
                            if (!u.option("sequences") && i.length > 0) return;
                            o.remove_initializers(u, t);
                            o.definitions.forEach(f);
                        } else {
                            return;
                        }
                    }
                    return i;
                }
                if (e instanceof Ct) {
                    n.push(e);
                    return [];
                }
                if (e instanceof mn) return [];
                if (e instanceof _n) return [ e.body ];
                if (e instanceof ur) {
                    var i = [];
                    e.remove_initializers(u, t);
                    e.definitions.forEach(f);
                    return i;
                }
                function f(e) {
                    if (!e.value) return;
                    i.push(Fe(Fn, e, {
                        operator: "=",
                        left: e.name.convert_symbol(Hn, function(e) {
                            r.push(e);
                        }),
                        right: e.value
                    }));
                }
            }
        });
        e(Zt, function(r, t) {
            if (!t.option("switches")) return r;
            if (!t.option("dead_code")) return r;
            var e = [];
            var n;
            var i = [];
            var a;
            var o;
            var s = [];
            for (var f = 0, u = r.body.length; f < u; f++) {
                n = r.body[f];
                if (n instanceof nr) {
                    var c = e[e.length - 1];
                    if (a || w(n.body[0], t) && (!c || R(c))) {
                        k(n, c);
                        continue;
                    } else {
                        a = n;
                    }
                } else {
                    var l = n.expression;
                    var p = Fe(Cn, r, {
                        operator: "===",
                        left: r.expression,
                        right: l
                    }).evaluate(t, true);
                    if (!p) {
                        if (l.has_side_effects(t)) s.push(l);
                        k(n, e[e.length - 1]);
                        continue;
                    }
                    if (!(p instanceof vn)) {
                        if (a) {
                            var d = e.indexOf(a);
                            e.splice(d, 1);
                            k(a, e[d - 1]);
                            a = null;
                        }
                        if (l.has_side_effects(t)) {
                            o = n;
                        } else {
                            a = n = Fe(nr, n);
                        }
                        while (++f < u) k(r.body[f], n);
                    }
                }
                if (f + 1 >= u || R(n)) {
                    var c = e[e.length - 1];
                    var h = n.body;
                    if (R(c)) switch (c.body.length - h.length) {
                      case 1:
                        var v = c.body[c.body.length - 1];
                        if (!w(v, t)) break;
                        h = h.concat(v);

                      case 0:
                        var m = Fe(gn, c);
                        var _ = Fe(gn, n, {
                            body: h
                        });
                        if (m.equals(_)) c.body = [];
                    }
                }
                if (s.length) {
                    if (n instanceof nr) {
                        e.push(Fe(tr, r, {
                            expression: Pe(r, s),
                            body: []
                        }));
                    } else {
                        s.push(n.expression);
                        n.expression = Pe(r, s);
                    }
                    s = [];
                }
                e.push(n);
            }
            if (s.length && !o) {
                e.push(Fe(tr, r, {
                    expression: Pe(r, s),
                    body: []
                }));
            }
            while (n = e[e.length - 1]) {
                var v = n.body[n.body.length - 1];
                if (w(v, t)) n.body.pop();
                if (n === a) {
                    if (!E(n)) break;
                } else if (n.expression.has_side_effects(t)) {
                    break;
                } else if (a) {
                    if (!E(a)) break;
                    if (e[e.length - 2] !== a) break;
                    a.body = a.body.concat(n.body);
                    n.body = [];
                } else if (!E(n)) break;
                k(n);
                if (e.pop() === a) a = null;
            }
            if (!n) {
                i.push(Fe(_n, r.expression, {
                    body: r.expression
                }));
                if (s.length) i.push(Fe(_n, r, {
                    body: Pe(r, s)
                }));
                return Fe(gn, r, {
                    body: i
                }).optimize(t);
            }
            if (n === a) while (n = e[e.length - 2]) {
                if (n instanceof nr) break;
                if (!E(n)) break;
                var l = n.expression;
                if (l.has_side_effects(t)) {
                    var c = e[e.length - 3];
                    if (c && !R(c)) break;
                    a.body.unshift(Fe(_n, r, {
                        body: l
                    }));
                }
                k(n);
                e.splice(-2, 1);
            }
            e[0].body = i.concat(e[0].body);
            r.body = e;
            if (t.option("conditionals")) switch (e.length) {
              case 1:
                if (!x(e[0])) break;
                var l = e[0].expression;
                var h = e[0].body.slice();
                if (e[0] !== a && e[0] !== o) return Fe(xn, r, {
                    condition: Fe(Cn, r, {
                        operator: "===",
                        left: r.expression,
                        right: l
                    }),
                    body: Fe(gn, r, {
                        body: h
                    }),
                    alternative: null
                }).optimize(t);
                if (l) h.unshift(Fe(_n, l, {
                    body: l
                }));
                h.unshift(Fe(_n, r.expression, {
                    body: r.expression
                }));
                return Fe(gn, r, {
                    body: h
                }).optimize(t);

              case 2:
                if (!Un(a, e) || !x(e[1])) break;
                var h = e[0].body.slice();
                var g = h.length && w(h[h.length - 1], t);
                if (g) h.pop();
                if (!dn(h, x)) break;
                var b = e[1].body.length && Fe(gn, e[1]);
                var y = Fe(xn, r, {
                    condition: Fe(Cn, r, e[0] === a ? {
                        operator: "!==",
                        left: r.expression,
                        right: e[1].expression
                    } : {
                        operator: "===",
                        left: r.expression,
                        right: e[0].expression
                    }),
                    body: Fe(gn, e[0], {
                        body: h
                    }),
                    alternative: g && b || null
                });
                if (!g && b) y = Fe(gn, r, {
                    body: [ y, b ]
                });
                return y.optimize(t);
            }
            return r;
            function w(e, n) {
                return e instanceof Kt && n.loopcontrol_target(e) === r;
            }
            function x(e) {
                var n = false;
                var t = new Ln(function(e) {
                    if (n || e instanceof yn || e instanceof _n) return true;
                    if (w(e, t)) n = true;
                });
                t.push(r);
                e.walk(t);
                return !n;
            }
            function k(e, n) {
                if (n && !R(n)) {
                    n.body = n.body.concat(e.body);
                } else {
                    z(t, e, i);
                }
            }
        });
        e(rr, function(e, n) {
            e.body = c(e.body, n);
            if (n.option("dead_code")) {
                if (E(e) && !(e.bcatch && e.bcatch.argname && e.bcatch.argname.match_symbol(function(e) {
                    return e instanceof Pr && !Ce(e);
                }, true))) {
                    var t = [];
                    if (e.bcatch) {
                        z(n, e.bcatch, t);
                        t.forEach(function(e) {
                            if (!(e instanceof ur)) return;
                            e.definitions.forEach(function(e) {
                                var n = e.name.definition().redefined();
                                if (!n) return;
                                e.name = e.name.clone();
                                e.name.thedef = n;
                            });
                        });
                    }
                    t.unshift(Fe(gn, e).optimize(n));
                    if (e.bfinally) {
                        t.push(Fe(gn, e.bfinally).optimize(n));
                    }
                    return Fe(gn, e, {
                        body: t
                    }).optimize(n);
                }
                if (e.bfinally && E(e.bfinally)) {
                    var t = Fe(gn, e.bfinally).optimize(n);
                    t = e.body.concat(t);
                    if (!e.bcatch) return Fe(gn, e, {
                        body: t
                    }).optimize(n);
                    e.body = t;
                    e.bfinally = null;
                }
            }
            return e;
        });
        function J(i) {
            return function(n, t) {
                var r = false;
                this.definitions.forEach(function(e) {
                    if (e.value) r = true;
                    e.name.match_symbol(function(e) {
                        if (e instanceof Dr) t.push(Fe(kn, e, {
                            name: e,
                            value: i(n, e)
                        }));
                    }, true);
                });
                return r;
            };
        }
        sr.DEFMETHOD("remove_initializers", J(function(e, n) {
            return Fe(Wr, n).optimize(e);
        }));
        fr.DEFMETHOD("remove_initializers", J(Jn));
        ur.DEFMETHOD("remove_initializers", J(Jn));
        or.DEFMETHOD("to_assignments", function() {
            var e = this.definitions.reduce(function(e, t) {
                var r = t.name.definition();
                var n = t.value;
                if (n) {
                    if (n instanceof Tn) n = n.clone();
                    var i = Fe(Hn, t.name);
                    var a = Fe(Fn, t, {
                        operator: "=",
                        left: i,
                        right: n
                    });
                    e.push(a);
                    var o = function() {
                        return a.right;
                    };
                    o.assigns = [ a ];
                    o.direct_access = r.direct_access;
                    o.escaped = r.escaped;
                    i.fixed = o;
                    r.references.forEach(function(e) {
                        if (!e.fixed) return;
                        var n = e.fixed.assigns;
                        if (!n) return;
                        if (n[0] !== t) return;
                        if (n.length > 1 || e.fixed.to_binary || e.fixed.to_prefix) {
                            n[0] = a;
                        } else {
                            e.fixed = o;
                            if (r.fixed === e.fixed) r.fixed = o;
                        }
                    });
                    r.references.push(i);
                }
                r.assignments++;
                r.eliminated++;
                r.single_use = false;
                return e;
            }, []);
            if (e.length == 0) return null;
            return Pe(this, e);
        });
        function Ye(e) {
            return e.name != "arguments" && e.orig.length < (e.orig[0] instanceof Mr ? 3 : 2);
        }
        function X(e, n) {
            if (e.exposed(n)) return true;
            var t = n.scope.resolve();
            for (var r = n.scope; r !== t; ) {
                r = r.parent_scope;
                if (r.var_names().has(n.name)) return true;
            }
        }
        function K(e) {
            return Fe(ur, e, {
                definitions: e.definitions.map(function(e) {
                    return Fe(kn, e, {
                        name: e.name.convert_symbol(zr, function(e, n) {
                            var t = e.definition();
                            t.orig[t.orig.indexOf(n)] = e;
                            var r = t.scope.resolve();
                            if (t.scope === r) return;
                            t.scope = r;
                            r.variables.set(t.name, t);
                            r.enclosed.push(t);
                            r.var_names().set(t.name, true);
                        }),
                        value: e.value
                    });
                })
            });
        }
        function Q(e, n) {
            if (!n.fixed_value()) return false;
            var t = n.definition();
            return Ye(t) && Re(t) && !X(e, t);
        }
        function Z(e, n) {
            return n.option("varify") && dn(e.definitions, function(e) {
                return !e.name.match_symbol(function(e) {
                    if (e instanceof Dr) return !Q(n, e);
                }, true);
            }) ? K(e) : e;
        }
        e(sr, Z);
        e(fr, Z);
        function ke(e, n) {
            if (!n.option("optional_chains")) return;
            if (e.terminal) do {
                var t = e.expression;
                if (e.optional) {
                    var r = C(n, t, true);
                    if (r == null) return Fe(zn, e, {
                        operator: "void",
                        expression: t
                    }).optimize(n);
                    if (!(r instanceof vn)) e.optional = false;
                }
                e = t;
            } while ((e.TYPE == "Call" || e instanceof An) && !e.terminal);
        }
        function he(e, n) {
            var t = e.expression;
            if (!(t instanceof Tn)) return e;
            var r = t.expressions.slice();
            var i = e.clone();
            i.expression = r.pop();
            r.push(i);
            return Pe(e, r);
        }
        function Ee(e, t, n) {
            var r = e.expression;
            var i = r instanceof Hn ? r.fixed_value() : r;
            if (!(i instanceof yn)) return;
            if (i.uses_arguments) return;
            if (i.pinned()) return;
            if (n && n.indexOf(i) < 0) return;
            var a = e.args;
            if (!dn(a, function(e) {
                return !(e instanceof On);
            })) return;
            var o = i.argnames;
            var s = i === r && !i.name;
            if (i.rest) {
                if (!(s && t.option("rests"))) return;
                var f = o.length;
                a = a.slice(0, f);
                while (a.length < f) a.push(Fe(Wr, e).optimize(t));
                a.push(Fe(Pn, e, {
                    elements: e.args.slice(f)
                }));
                o = o.concat(i.rest);
                i.rest = null;
            } else {
                a = a.slice();
                o = o.slice();
            }
            var u = 0, c = 0;
            var l = s && t.option("default_values");
            var p = s && t.drop_fargs(i, e) ? function(e, n) {
                if (!e) return true;
                if (e instanceof br) {
                    return e.elements.length == 0 && !e.rest && n instanceof Pn;
                }
                if (e instanceof wr) {
                    return e.properties.length == 0 && !e.rest && n && !n.may_throw_on_access(t);
                }
                return e.unused;
            } : cn;
            var d = [];
            for (var h = 0; h < a.length; h++) {
                var v = o[h];
                if (l && v instanceof En && a[h].is_defined(t)) {
                    o[h] = v = v.name;
                }
                if (!v || v.unused !== undefined) {
                    var m = a[h].drop_side_effect_free(t);
                    if (p(v)) {
                        if (v) o.splice(h, 1);
                        a.splice(h, 1);
                        if (m) d.push(m);
                        h--;
                        continue;
                    } else if (m) {
                        d.push(m);
                        a[u++] = Pe(e, d);
                        d = [];
                    } else if (v) {
                        if (d.length) {
                            a[u++] = Pe(e, d);
                            d = [];
                        } else {
                            a[u++] = Fe(Bn, a[h], {
                                value: 0
                            });
                            continue;
                        }
                    }
                } else if (p(v, a[h])) {
                    var m = a[h].drop_side_effect_free(t);
                    o.splice(h, 1);
                    a.splice(h, 1);
                    if (m) d.push(m);
                    h--;
                    continue;
                } else {
                    d.push(a[h]);
                    a[u++] = Pe(e, d);
                    d = [];
                }
                c = u;
            }
            for (;h < o.length; h++) {
                if (p(o[h])) o.splice(h--, 1);
            }
            i.argnames = o;
            a.length = c;
            e.args = a;
            if (!d.length) return;
            var _ = Pe(e, d);
            a.push(a.length < o.length ? Fe(zn, e, {
                operator: "void",
                expression: _
            }) : _);
        }
        function ve(e, n) {
            if (!n) n = e.find_parent(bn);
            var t = [];
            if (Et(n) || n instanceof bt && e.option("module")) {
                t.push("await");
            }
            if (St(n)) t.push("yield");
            return t.length && pn(t);
        }
        function Se(t, r) {
            if (!r) return true;
            var i = true;
            var a = new Ln(function(e) {
                if (!i) return true;
                if (e instanceof bn) {
                    if (e === t) return;
                    if (kt(e)) {
                        for (var n = 0; i && n < e.argnames.length; n++) e.argnames[n].walk(a);
                    } else if (e instanceof Ct && r[e.name.name]) {
                        i = false;
                    }
                    return true;
                }
                if (e instanceof Ar && r[e.name] && e !== t.name) i = false;
            });
            t.walk(a);
            return i;
        }
        function Te(e, n) {
            return e.in_strict_mode(n) || !n.has_directive("use strict");
        }
        e(Sn, function(p, c) {
            var a = p.expression;
            var P = ke(p, c);
            if (P) return P;
            if (c.option("sequences")) {
                if (a instanceof An) {
                    var e = he(a, c);
                    if (e !== a) {
                        var n = p.clone();
                        n.expression = e.expressions.pop();
                        e.expressions.push(n);
                        return e.optimize(c);
                    }
                } else if (!ge(a.tail_node())) {
                    var e = he(p, c);
                    if (e !== p) return e.optimize(c);
                }
            }
            if (c.option("unused")) Ee(p, c);
            if (c.option("unsafe")) {
                if (Ne(a)) switch (a.name) {
                  case "Array":
                    if (p.args.length == 1) {
                        var t = p.args[0];
                        if (t instanceof Bn) try {
                            var r = t.value;
                            if (r > 6) break;
                            var i = Array(r);
                            for (var o = 0; o < r; o++) i[o] = Fe(Gr, p);
                            return Fe(Pn, p, {
                                elements: i
                            });
                        } catch (e) {
                            vn.warn("Invalid array length: {length} [{start}]", {
                                length: r,
                                start: p.start
                            });
                            break;
                        }
                        if (!t.is_boolean(c) && !t.is_string(c)) break;
                    }
                    return Fe(Pn, p, {
                        elements: p.args
                    });

                  case "Object":
                    if (p.args.length == 0) return Fe(Nn, p, {
                        properties: []
                    });
                    break;

                  case "String":
                    if (p.args.length == 0) return Fe(Rn, p, {
                        value: ""
                    });
                    if (p.args.length == 1) return Fe(Cn, p, {
                        operator: "+",
                        left: Fe(Rn, p, {
                            value: ""
                        }),
                        right: p.args[0]
                    }).optimize(c);
                    break;

                  case "Number":
                    if (p.args.length == 0) return Fe(Bn, p, {
                        value: 0
                    });
                    if (p.args.length == 1) return Fe(zn, p, {
                        operator: "+",
                        expression: Fe(Cn, p, {
                            operator: "+",
                            left: Fe(Rn, p, {
                                value: ""
                            }),
                            right: p.args[0]
                        })
                    }).optimize(c);
                    break;

                  case "Boolean":
                    if (p.args.length == 0) return Fe(Kr, p).optimize(c);
                    if (p.args.length == 1) return Fe(zn, p, {
                        operator: "!",
                        expression: Fe(zn, p, {
                            operator: "!",
                            expression: p.args[0]
                        })
                    }).optimize(c);
                    break;

                  case "RegExp":
                    var j = [];
                    if (dn(p.args, function(e) {
                        var n = e.evaluate(c);
                        j.unshift(n);
                        return e !== n;
                    })) try {
                        return pe(c, p, Fe(Lr, p, {
                            value: RegExp.apply(RegExp, j)
                        }));
                    } catch (e) {
                        vn.warn("Error converting {this} [{start}]", p);
                    }
                    break;
                } else if (a instanceof Dn) switch (a.property) {
                  case "toString":
                    var s = a.expression;
                    if (p.args.length == 0 && !(s.may_throw_on_access(c) || s instanceof Ir)) {
                        return Fe(Cn, p, {
                            operator: "+",
                            left: Fe(Rn, p, {
                                value: ""
                            }),
                            right: s
                        }).optimize(c);
                    }
                    break;

                  case "join":
                    if (a.expression instanceof Pn && p.args.length < 2) e: {
                        var f = p.args[0];
                        if (a.expression.elements.length == 0 && !(f instanceof On)) {
                            return f ? Pe(p, [ f, Fe(Rn, p, {
                                value: ""
                            }) ]).optimize(c) : Fe(Rn, p, {
                                value: ""
                            });
                        }
                        if (f) {
                            f = f.evaluate(c);
                            if (f instanceof vn) break e;
                        }
                        var i = [];
                        var u = [];
                        for (var o = 0; o < a.expression.elements.length; o++) {
                            var l = a.expression.elements[o];
                            var d = l.evaluate(c);
                            if (d !== l) {
                                u.push(d);
                            } else if (l instanceof On) {
                                break e;
                            } else {
                                if (u.length > 0) {
                                    i.push(Fe(Rn, p, {
                                        value: u.join(f)
                                    }));
                                    u.length = 0;
                                }
                                i.push(l);
                            }
                        }
                        if (u.length > 0) i.push(Fe(Rn, p, {
                            value: u.join(f)
                        }));
                        if (i.length == 1) {
                            if (i[0].is_string(c)) return i[0];
                            return Fe(Cn, i[0], {
                                operator: "+",
                                left: Fe(Rn, p, {
                                    value: ""
                                }),
                                right: i[0]
                            });
                        }
                        if (f == "") {
                            var t;
                            if (i[0].is_string(c) || i[1].is_string(c)) {
                                t = i.shift();
                            } else {
                                t = Fe(Rn, p, {
                                    value: ""
                                });
                            }
                            return i.reduce(function(e, n) {
                                return Fe(Cn, n, {
                                    operator: "+",
                                    left: e,
                                    right: n
                                });
                            }, t).optimize(c);
                        }
                        var h = p.clone();
                        h.expression = h.expression.clone();
                        h.expression.expression = h.expression.expression.clone();
                        h.expression.expression.elements = i;
                        return pe(c, p, h);
                    }
                    break;

                  case "charAt":
                    if (p.args.length < 2) {
                        var h = Fe(Cn, p, {
                            operator: "||",
                            left: Fe(qn, p, {
                                expression: a.expression,
                                property: p.args.length ? Fe(Cn, p.args[0], {
                                    operator: "|",
                                    left: Fe(Bn, p, {
                                        value: 0
                                    }),
                                    right: p.args[0]
                                }) : Fe(Bn, p, {
                                    value: 0
                                })
                            }).optimize(c),
                            right: Fe(Rn, p, {
                                value: ""
                            })
                        });
                        h.is_string = ln;
                        return h.optimize(c);
                    }
                    break;

                  case "apply":
                    if (p.args.length == 2 && p.args[1] instanceof Pn) {
                        var v = p.args[1].elements.slice();
                        v.unshift(p.args[0]);
                        return Fe(Sn, p, {
                            expression: Fe(Dn, a, {
                                expression: a.expression,
                                property: "call"
                            }),
                            args: v
                        }).optimize(c);
                    }
                    break;

                  case "call":
                    var m = a.expression;
                    if (m instanceof Hn) {
                        m = m.fixed_value();
                    }
                    if (m instanceof yn && !m.contains_this()) {
                        return (p.args.length ? Pe(p, [ p.args[0], Fe(Sn, p, {
                            expression: a.expression,
                            args: p.args.slice(1)
                        }) ]) : Fe(Sn, p, {
                            expression: a.expression,
                            args: []
                        })).optimize(c);
                    }
                    break;
                } else if (c.option("side_effects") && a instanceof Sn && a.args.length == 1 && Ne(a.expression) && a.expression.name == "Object") {
                    var n = p.clone();
                    n.expression = je(p, a, a.args[0]);
                    return n.optimize(c);
                }
            }
            if (c.option("unsafe_Function") && Ne(a) && a.name == "Function") {
                if (p.args.length == 0) return Fe($t, p, {
                    argnames: [],
                    body: []
                }).init_vars(a.scope);
                if (dn(p.args, function(e) {
                    return e instanceof Rn;
                })) {
                    try {
                        var _ = "n(function(" + p.args.slice(0, -1).map(function(e) {
                            return e.value;
                        }).join() + "){" + p.args[p.args.length - 1].value + "})";
                        var g = ai(_);
                        var b = {
                            ie: c.option("ie")
                        };
                        g.figure_out_scope(b);
                        var N = new ui(c.options);
                        g = g.transform(N);
                        g.figure_out_scope(b);
                        g.compute_char_frequency(b);
                        g.mangle_names(b);
                        var y;
                        g.walk(new Ln(function(e) {
                            if (y) return true;
                            if (e instanceof yn) {
                                y = e;
                                return true;
                            }
                        }));
                        var _ = ci();
                        gn.prototype._codegen.call(y, _);
                        p.args = [ Fe(Rn, p, {
                            value: y.argnames.map(function(e) {
                                return e.print_to_string();
                            }).join()
                        }), Fe(Rn, p.args[p.args.length - 1], {
                            value: _.get().replace(/^\{|\}$/g, "")
                        }) ];
                        return p;
                    } catch (e) {
                        if (e instanceof ti) {
                            vn.warn("Error parsing code passed to new Function [{start}]", p.args[p.args.length - 1]);
                            vn.warn(e.toString());
                        } else {
                            throw e;
                        }
                    }
                }
            }
            var w = a instanceof Hn ? a.fixed_value() : a;
            var x = c.parent(), k = c.self();
            var E = w instanceof yn && (!Et(w) || c.option("awaits") && x instanceof _r) && (!St(w) || c.option("yields") && k instanceof gr && k.nested);
            var S = E && w.first_statement();
            var T = 0, A = false;
            var D = !dn(p.args, function(e) {
                return !(e instanceof On);
            });
            var I = E && dn(w.argnames, function(e, n) {
                if (T == 1 && p.args[n] instanceof On) T = 2;
                if (e instanceof En) {
                    if (!T) T = 1;
                    var t = T == 1 && p.args[n];
                    if (!Ie(t)) T = 2;
                    if (me(w, e.value)) return false;
                    e = e.name;
                }
                if (e instanceof jn) {
                    A = true;
                    if (me(w, e)) return false;
                }
                return true;
            }) && !(w.rest instanceof jn && me(w, w.rest));
            var H = I && c.option("inline") && !p.is_expr_pure(c) && (a === w || Te(w, c));
            if (H && S instanceof wn) {
                var d = S.value;
                if (a === w && !w.name && (!d || d.is_constant_expression()) && Se(w, ve(c))) {
                    return Pe(p, G(d)).optimize(c);
                }
            }
            if (E && !w.contains_this()) {
                var q, d, O = false;
                if (H && !w.uses_arguments && !w.pinned() && !(w.name && w instanceof xt) && (a === w || !Qe(c, q = a.definition(), w) && w.is_constant_expression(Me(c))) && (d = K(S))) {
                    var Y = a === w || q.single_use && q.references.length - q.replaced == 1;
                    if (Z()) {
                        var v = p.args.slice();
                        var R = [];
                        var B = d.clone(true).transform(new Zr(function(e) {
                            if (e instanceof Hn) {
                                var n = e.definition();
                                if (w.variables.get(e.name) !== n) {
                                    R.push(e);
                                    return e;
                                }
                                var t = Q(n);
                                var r = v[t];
                                if (!r) return Fe(Wr, p);
                                v[t] = null;
                                var i = this.parent();
                                return i ? je(i, e, r) : r;
                            }
                        }));
                        var L = w.inlined;
                        if (a !== w) w.inlined = true;
                        var U = [];
                        v.forEach(function(e) {
                            if (!e) return;
                            e = e.clone(true);
                            e.walk(new Ln(function(e) {
                                if (e instanceof Hn) R.push(e);
                            }));
                            U.push(e);
                        }, []);
                        U.push(B);
                        var h = Pe(p, U).optimize(c);
                        w.inlined = L;
                        h = je(x, k, h);
                        if (Y || le(h, p) === h) {
                            R.forEach(function(e) {
                                e.scope = a === w ? w.parent_scope : a.scope;
                                e.reference();
                                var n = e.definition();
                                if (Y) n.replaced++;
                                n.single_use = false;
                            });
                            return h;
                        } else if (!h.has_side_effects(c)) {
                            p.drop_side_effect_free = function(e, n) {
                                var t = this;
                                var r = t.args.slice();
                                r.unshift(t.expression);
                                return Pe(t, r).drop_side_effect_free(e, n);
                            };
                        }
                    }
                    var $, V, z, C;
                    if (Y && re()) {
                        w._squeezed = true;
                        if (a !== w) w.parent_scope = a.scope;
                        var h = Pe(p, se()).optimize(c);
                        return je(x, k, h);
                    }
                }
                if (c.option("side_effects") && I && dn(w.body, ue) && (w === a ? xe(w, c) : !T && !A && !w.rest) && !(kt(w) && w.value) && Se(w, ve(c))) {
                    return Pe(p, G()).optimize(c);
                }
            }
            if (c.option("drop_console")) {
                if (a instanceof An) {
                    var M = a.expression;
                    while (M.expression) {
                        M = M.expression;
                    }
                    if (Ne(M) && M.name == "console") {
                        return Fe(Wr, p).optimize(c);
                    }
                }
            }
            if (c.option("negate_iife") && x instanceof _n && be(k)) {
                return p.negate(c, true);
            }
            return de(c, p);
            function W(e) {
                return Fe(qn, e, {
                    expression: Fe(Pn, e, {
                        elements: []
                    }),
                    property: Fe(Bn, e, {
                        value: 0
                    })
                });
            }
            function G(e) {
                var n = p.args.slice();
                var t = T > 1 || A || w.rest;
                if (t || D) n = [ Fe(Pn, p, {
                    elements: n
                }) ];
                if (t) {
                    var o = new Zr(function(r, e) {
                        if (r instanceof En) return Fe(En, r, {
                            name: r.name.transform(o) || W(r),
                            value: r.value
                        });
                        if (r instanceof br) {
                            var t = [];
                            r.elements.forEach(function(e, n) {
                                e = e.transform(o);
                                if (e) t[n] = e;
                            });
                            ye(r, t);
                            return Fe(br, r, {
                                elements: t
                            });
                        }
                        if (r instanceof wr) {
                            var i = [], a = [];
                            r.properties.forEach(function(e) {
                                var n = e.key;
                                var t = e.value.transform(o);
                                if (t) {
                                    if (a.length) {
                                        if (!(n instanceof vn)) n = fe(n, e);
                                        a.push(n);
                                        n = Pe(r, a);
                                        a = [];
                                    }
                                    i.push(Fe(yr, e, {
                                        key: n,
                                        value: t
                                    }));
                                } else if (n instanceof vn) {
                                    a.push(n);
                                }
                            });
                            if (a.length) i.push(Fe(yr, r, {
                                key: Pe(r, a),
                                value: W(r)
                            }));
                            return Fe(wr, r, {
                                properties: i
                            });
                        }
                        if (r instanceof In) return null;
                    });
                    var r = [];
                    w.argnames.forEach(function(e, n) {
                        e = e.transform(o);
                        if (e) r[n] = e;
                    });
                    var i = w.rest && w.rest.transform(o);
                    if (i) r.length = w.argnames.length;
                    ye(w, r);
                    n[0] = Fe(Fn, p, {
                        operator: "=",
                        left: Fe(br, w, {
                            elements: r,
                            rest: i
                        }),
                        right: n[0]
                    });
                } else w.argnames.forEach(function(e) {
                    if (e instanceof En) n.push(e.value);
                });
                n.push(e || Fe(Wr, p));
                return n;
            }
            function J() {
                return p.call_only ? Fe(Bn, p, {
                    value: 0
                }) : Fe(Wr, p);
            }
            function X(e) {
                if (!e) return J();
                if (e instanceof wn) return e.value || J();
                if (e instanceof _n) {
                    return p.call_only ? e.body : Fe(zn, e, {
                        operator: "void",
                        expression: e.body
                    });
                }
            }
            function K(e) {
                var n = w.body.length;
                if (n < 2) {
                    e = X(e);
                    if (e) return e;
                }
                if (c.option("inline") < 3) return false;
                e = null;
                for (var t = 0; t < n; t++) {
                    var r = w.body[t];
                    if (r instanceof ur) {
                        if (O) {
                            if (!e) continue;
                            if (!(e instanceof _n)) return false;
                            if (!ce(r)) e = null;
                        } else if (!ce(r)) {
                            if (e && !(e instanceof _n)) return false;
                            e = null;
                            O = true;
                        }
                    } else if (r instanceof Mt || r instanceof Pt || r instanceof mn) {
                        continue;
                    } else if (e) {
                        return false;
                    } else {
                        e = r;
                    }
                }
                return X(e);
            }
            function Q(e) {
                for (var n = w.argnames.length; --n >= 0; ) {
                    if (w.argnames[n].definition() === e) return n;
                }
            }
            function Z() {
                if (T || A || D || O || w.rest) return;
                if (c.option("inline") < 2 && w.argnames.length) return;
                if (!w.variables.all(function(e) {
                    return e.references.length - e.replaced < 2 && e.orig[0] instanceof In;
                })) return;
                var n = c.find_parent(bn);
                var i = false;
                var a = ve(c, n);
                var o;
                var s = [];
                var f = false;
                var u = new Ln(function(e, n) {
                    if (i) return true;
                    if (e instanceof Cn && He[e.operator] || e instanceof Mn) {
                        s = null;
                        return;
                    }
                    if (e instanceof bn) return i = true;
                    if (a && e instanceof Ar && a[e.name]) return i = true;
                    if (e instanceof Hn) {
                        var t = e.definition();
                        if (w.variables.get(e.name) !== t) {
                            s = null;
                            return;
                        }
                        if (t.init instanceof Ct) return i = true;
                        if (fi(e, u.parent())) return i = true;
                        var r = Q(t);
                        if (!(o < r)) o = r;
                        if (!s) return;
                        if (f) {
                            s = null;
                        } else {
                            s.push(w.argnames[r]);
                        }
                        return;
                    }
                    if (f) return;
                    if (e instanceof Fn && e.left instanceof An) {
                        e.left.expression.walk(u);
                        if (e.left instanceof qn) e.left.property.walk(u);
                        e.right.walk(u);
                        f = true;
                        return true;
                    }
                    if (e.has_side_effects(c)) {
                        n();
                        f = true;
                        return true;
                    }
                });
                d.walk(u);
                if (i) return;
                var e = p.args.length;
                if (s && w.argnames.length >= e) {
                    e = w.argnames.length;
                    while (e-- > o && w.argnames[e] === s.pop());
                    e++;
                }
                return e <= o || dn(p.args.slice(o, e), f && !s ? function(e) {
                    return e.is_constant_expression(n);
                } : function(e) {
                    return !e.has_side_effects(c);
                });
            }
            function ee(e, n) {
                return e.has(n) || _e[n] || C.var_names().has(n);
            }
            function ne(n, t) {
                var r = false;
                w.each_argname(function(e) {
                    if (r) return;
                    if (e.unused) return;
                    if (!t || ee(n, e.name)) return r = true;
                    $.set(e.name, true);
                    if (z) z.push(e.definition());
                });
                return !r;
            }
            function te(n, e) {
                for (var t = 0; t < w.body.length; t++) {
                    var r = w.body[t];
                    if (r instanceof Ct) {
                        var i = r.name;
                        if (!e) return false;
                        if ($.has(i.name)) return false;
                        if (ee(n, i.name)) return false;
                        if (!dn(r.enclosed, function(e) {
                            return e.scope === C || e.scope === r || !n.has(e.name);
                        })) return false;
                        if (z) z.push(i.definition());
                        continue;
                    }
                    if (!(r instanceof ur)) continue;
                    if (!e) return false;
                    for (var a = r.definitions.length; --a >= 0; ) {
                        var i = r.definitions[a].name;
                        if (ee(n, i.name)) return false;
                        if (z) z.push(i.definition());
                    }
                }
                return true;
            }
            function re() {
                var n = new hn();
                var e = 0, t;
                C = k;
                do {
                    if (C.variables) C.variables.each(function(e) {
                        n.set(e.name, true);
                    });
                    t = C;
                    C = c.parent(e++);
                    if (C instanceof Rt) {
                        if (!C.static) return false;
                    } else if (C instanceof lt) {
                        z = [];
                    } else if (C instanceof ht) {
                        if (C.init === t) continue;
                        z = [];
                    } else if (C instanceof vt) {
                        if (C.init === t) continue;
                        if (C.object === t) continue;
                        z = [];
                    }
                } while (!(C instanceof bn));
                V = C.body.indexOf(t) + 1;
                if (!V) return false;
                if (!Se(w, ve(c, C))) return false;
                var r = (a !== w || w.parent_scope.resolve() === C) && !C.pinned();
                if (C instanceof bt) {
                    if (c.toplevel.vars) {
                        n.set("arguments", true);
                    } else {
                        r = false;
                    }
                }
                $ = new hn();
                var i = c.option("inline");
                if (!ne(n, i >= 2 && r)) return false;
                if (!te(n, i >= 3 && r)) return false;
                return !z || z.length == 0 || !nn(w, z);
            }
            function F(e, n, t, r) {
                var i = t.definition();
                if (!C.var_names().has(t.name)) {
                    C.var_names().set(t.name, true);
                    e.push(Fe(kn, t, {
                        name: t,
                        value: null
                    }));
                }
                C.variables.set(t.name, i);
                C.enclosed.push(i);
                if (!r) return;
                var a = Fe(Hn, t);
                i.assignments++;
                i.references.push(a);
                n.push(Fe(Fn, p, {
                    operator: "=",
                    left: a,
                    right: r
                }));
            }
            function ie(e, n) {
                var t = w.argnames.length;
                for (var r = p.args.length; --r >= t; ) {
                    n.push(p.args[r]);
                }
                var i = [];
                for (r = t; --r >= 0; ) {
                    var a = w.argnames[r];
                    var o;
                    if (a instanceof En) {
                        i.push(a);
                        o = a.name;
                    } else {
                        o = a;
                    }
                    var s = p.args[r];
                    if (o.unused || C.var_names().has(o.name)) {
                        if (s) n.push(s);
                    } else {
                        var f = Fe(zr, o);
                        var u = o.definition();
                        u.orig.push(f);
                        u.eliminated++;
                        if (o.unused !== undefined) {
                            F(e, n, f);
                            if (s) n.push(s);
                        } else {
                            if (!s && a === o && (z || o.name == "arguments" && !kt(w) && kt(C))) {
                                s = Fe(Wr, p);
                            }
                            F(e, n, f, s);
                        }
                    }
                }
                e.reverse();
                n.reverse();
                for (r = i.length; --r >= 0; ) {
                    var c = i[r];
                    if (c.name.unused !== undefined) {
                        n.push(c.value);
                    } else {
                        var l = Fe(Hn, c.name);
                        c.name.definition().references.push(l);
                        n.push(Fe(Fn, c, {
                            operator: "=",
                            left: l,
                            right: c.value
                        }));
                    }
                }
            }
            function ae(i, a) {
                a.push(Fe(Fn, p, {
                    operator: "=",
                    left: Fe(br, p, {
                        elements: w.argnames.map(function(e) {
                            if (e.unused) return Fe(Gr, e);
                            return e.convert_symbol(Hn, n);
                        }),
                        rest: w.rest && w.rest.convert_symbol(Hn, n)
                    }),
                    right: Fe(Pn, p, {
                        elements: p.args.slice()
                    })
                }));
                function n(e, n) {
                    if (n.unused) return W(n);
                    var t = n.definition();
                    t.assignments++;
                    t.references.push(e);
                    var r = Fe(zr, n);
                    t.orig.push(r);
                    t.eliminated++;
                    F(i, a, r);
                }
            }
            function oe(r, e) {
                var t = [ V, 0 ];
                var a = [], i = [], o = [], s = [], f = [];
                w.body.filter(z ? function(e) {
                    if (!(e instanceof Ct)) return true;
                    var n = Fe(zr, sn(e.name));
                    var t = n.definition();
                    t.fixed = false;
                    t.orig.push(n);
                    t.eliminated++;
                    F(r, i, n, we(e, true));
                    return false;
                } : function(e) {
                    if (!(e instanceof Ct)) return true;
                    var n = e.name.definition();
                    C.functions.set(n.name, n);
                    C.variables.set(n.name, n);
                    C.enclosed.push(n);
                    C.var_names().set(n.name, true);
                    t.push(e);
                    return false;
                }).forEach(function(e) {
                    if (!(e instanceof ur)) {
                        if (e instanceof _n) f.push(e.body);
                        return;
                    }
                    for (var n = 0; n < e.definitions.length; n++) {
                        var t = e.definitions[n];
                        var r = sn(t.name);
                        var i = t.value;
                        if (i && f.length > 0) {
                            f.push(i);
                            i = Pe(t, f);
                            f = [];
                        }
                        F(a, o, r, i);
                        if (!z) continue;
                        if ($.has(r.name)) continue;
                        if (r.definition().orig.length == 1 && w.functions.has(r.name)) continue;
                        s.push(un(c, r));
                    }
                });
                [].push.apply(r, a);
                [].push.apply(e, s);
                [].push.apply(e, i);
                [].push.apply(e, o);
                return t;
            }
            function se() {
                var e = [];
                var n = [];
                if (T > 1 || A || D || w.rest) {
                    ae(e, n);
                } else {
                    ie(e, n);
                }
                var t = oe(e, n);
                n.push(d);
                if (e.length) t.push(Fe(ur, w, {
                    definitions: e
                }));
                [].splice.apply(C.body, t);
                w.enclosed.forEach(function(e) {
                    if (C.var_names().has(e.name)) return;
                    C.enclosed.push(e);
                    C.var_names().set(e.name, true);
                });
                return n;
            }
        });
        e(hr, function(e, n) {
            if (n.option("unsafe")) {
                var t = e.expression;
                if (Ne(t)) switch (t.name) {
                  case "Array":
                  case "Error":
                  case "Function":
                  case "Object":
                  case "RegExp":
                    return Fe(Sn, e).transform(n);
                }
            }
            if (n.option("sequences")) {
                var r = he(e, n);
                if (r !== e) return r.optimize(n);
            }
            if (n.option("unused")) Ee(e, n);
            return e;
        });
        function ee(t, r, e, n) {
            if (!(n instanceof Cn)) return;
            if (!(n.operator == "&&" || n.operator == "||")) return;
            if (!(n.right instanceof Fn)) return;
            if (n.right.operator != "=") return;
            if (!(n.right.left instanceof Hn)) return;
            if (n.right.left.definition() !== r) return;
            if (e.has_side_effects(t)) return;
            if (!i(n.left)) return;
            if (!i(n.right.right)) return;
            r.replaced++;
            return n.operator == "&&" ? Fe(Mn, n, {
                condition: n.left,
                consequent: n.right.right,
                alternative: e
            }) : Fe(Mn, n, {
                condition: n.left,
                consequent: e,
                alternative: n.right.right
            });
            function i(e) {
                if (e.has_side_effects(t)) return;
                var n = false;
                e.walk(new Ln(function(e) {
                    if (n) return true;
                    if (e instanceof Hn && e.definition() === r) return n = true;
                }));
                return !n;
            }
        }
        e(Tn, function(e, a) {
            var o = n();
            var s = o.length - 1;
            r();
            t();
            if (s == 0) {
                e = je(a.parent(), a.self(), o[0]);
                if (!(e instanceof Tn)) e = e.optimize(a);
                return e;
            }
            e.expressions = o;
            return e;
            function n() {
                if (!a.option("side_effects")) return e.expressions;
                var t = [];
                var r = nt(a);
                var i = e.expressions.length - 1;
                e.expressions.forEach(function(e, n) {
                    if (n < i) e = e.drop_side_effect_free(a, r);
                    if (e) {
                        k(t, e);
                        r = false;
                    }
                });
                return t;
            }
            function t() {
                if (!a.option("side_effects")) return;
                while (s > 0 && Ie(o[s], a)) s--;
                if (s < o.length - 1) {
                    o[s] = Fe(zn, e, {
                        operator: "void",
                        expression: o[s]
                    });
                    o.length = s + 1;
                }
            }
            function f(e) {
                return e instanceof Fn && e.operator == "=" && e.left instanceof Hn && e.left.definition();
            }
            function r() {
                for (var e = 1; e < s; e++) {
                    var n = o[e - 1];
                    var t = f(n);
                    if (!t) continue;
                    var r = o[e];
                    if (a.option("conditionals")) {
                        var i = ee(a, t, n.right, r);
                        if (i) {
                            n.right = i;
                            o.splice(e--, 1);
                            s--;
                            continue;
                        }
                    }
                    if (a.option("dead_code") && f(r) === t && r.right.is_constant_expression(t.scope.resolve())) {
                        o[--e] = n.right;
                    }
                }
            }
        });
        e(mr, function(e, n) {
            if (n.option("sequences")) {
                var t = he(e, n);
                if (t !== e) return t.optimize(n);
            }
            return de(n, e);
        });
        var ie = pn("+ -");
        var ae = pn("* / %");
        e(zn, function(e, n) {
            var t = e.operator;
            var r = e.expression;
            if (n.option("sequences") && u()) {
                var i = he(e, n);
                if (i !== e) return i.optimize(n);
            }
            switch (t) {
              case "+":
                if (!n.option("evaluate")) break;
                if (!r.is_number(n, true)) break;
                var a = n.parent();
                if (a instanceof zn && a.operator == "delete") break;
                return r;

              case "-":
                if (r instanceof Jr) r = r.transform(n);
                if (r instanceof Bn || r instanceof Jr) return e;
                break;

              case "!":
                if (!n.option("booleans")) break;
                if (r.is_truthy()) return Pe(e, [ r, Fe(Kr, e) ]).optimize(n);
                if (n.in_boolean_context()) {
                    if (r instanceof zn && r.operator == "!") return r.expression;
                    if (r instanceof Cn) {
                        var o = nt(n);
                        e = (o ? A : le)(e, r.negate(n, o));
                    }
                }
                break;

              case "delete":
                if (!n.option("evaluate")) break;
                if (f(r)) break;
                return Pe(e, [ r, Fe(Qr, e) ]).optimize(n);

              case "typeof":
                if (!n.option("booleans")) break;
                if (!n.in_boolean_context()) break;
                vn.warn("Boolean expression always true [{start}]", e);
                var s = [ Fe(Qr, e) ];
                if (!(r instanceof Hn && Ce(r, n))) s.unshift(r);
                return Pe(e, s).optimize(n);

              case "void":
                if (!n.option("side_effects")) break;
                r = r.drop_side_effect_free(n);
                if (!r) return Fe(Wr, e).optimize(n);
                e.expression = r;
                return e;
            }
            if (n.option("evaluate") && r instanceof Cn && ie[t] && ae[r.operator] && (r.left.is_constant() || !r.right.has_side_effects(n))) {
                return Fe(Cn, e, {
                    operator: r.operator,
                    left: Fe(zn, r.left, {
                        operator: t,
                        expression: r.left
                    }),
                    right: r.right
                });
            }
            return de(n, e);
            function f(e) {
                return e instanceof Jr || e instanceof Vr || e instanceof Yr || e instanceof An || e instanceof Hn || e instanceof Wr;
            }
            function u() {
                switch (t) {
                  case "delete":
                    return !f(r.tail_node());

                  case "typeof":
                    return !Ne(r.tail_node());

                  default:
                    return true;
                }
            }
        });
        e(_r, function(e, n) {
            if (!n.option("awaits")) return e;
            if (n.option("sequences")) {
                var t = he(e, n);
                if (t !== e) return t.optimize(n);
            }
            if (n.option("side_effects")) {
                var r = e.expression;
                if (r instanceof _r) return r.optimize(n);
                if (r instanceof zn && r.expression instanceof _r) return r.optimize(n);
                for (var i = 0, a = e, o; o = n.parent(i++); a = o) {
                    if (kt(o)) {
                        if (o.value === a) return r.optimize(n);
                    } else if (o instanceof wn) {
                        var s = true;
                        do {
                            a = o;
                            o = n.parent(i++);
                            if (o instanceof rr && (o.bfinally || o.bcatch) !== a) {
                                s = false;
                                break;
                            }
                        } while (o && !(o instanceof bn));
                        if (s) return r.optimize(n);
                    } else if (o instanceof Tn) {
                        if (o.tail_node() === a) continue;
                    }
                    break;
                }
            }
            return e;
        });
        e(gr, function(e, n) {
            if (!n.option("yields")) return e;
            if (n.option("sequences")) {
                var t = he(e, n);
                if (t !== e) return t.optimize(n);
            }
            var r = e.expression;
            if (e.nested && r.TYPE == "Call") {
                var i = r.clone().optimize(n);
                if (i.TYPE != "Call") return i;
            }
            return e;
        });
        Cn.DEFMETHOD("lift_sequences", function(e) {
            if (this.left instanceof An) {
                if (!(this.left.expression instanceof Tn)) return this;
                var n = this.left.expression.expressions.slice();
                var t = this.clone();
                t.left = t.left.clone();
                t.left.expression = n.pop();
                n.push(t);
                return Pe(this, n);
            }
            if (this.left instanceof Tn) {
                var n = this.left.expressions.slice();
                var t = this.clone();
                t.left = n.pop();
                n.push(t);
                return Pe(this, n);
            }
            if (this.right instanceof Tn) {
                if (this.left.has_side_effects(e)) return this;
                var r = this.operator == "=" && this.left instanceof Hn;
                var n = this.right.expressions;
                var i = n.length - 1;
                for (var a = 0; a < i; a++) {
                    if (!r && n[a].has_side_effects(e)) break;
                }
                if (a == i) {
                    n = n.slice();
                    var t = this.clone();
                    t.right = n.pop();
                    n.push(t);
                    return Pe(this, n);
                }
                if (a > 0) {
                    var t = this.clone();
                    t.right = Pe(this.right, n.slice(a));
                    n = n.slice(0, a);
                    n.push(t);
                    return Pe(this, n);
                }
            }
            return this;
        });
        var oe = pn("indexOf lastIndexOf");
        var se = pn("== === != !== * & | ^");
        function Ae(e) {
            if (e instanceof Fn) return e.operator == "=" && Ae(e.right);
            if (e instanceof Tn) return Ae(e.tail_node());
            if (e instanceof Hn) return Ae(e.fixed_value());
            return e instanceof Pn || e instanceof Nt || e instanceof yn || e instanceof hr || e instanceof Nn;
        }
        function Ke(e, n, t) {
            switch (e) {
              case "in":
                return Ae(n) || t && t.option("unsafe_comps");

              case "instanceof":
                if (n instanceof Hn) n = n.fixed_value();
                return O(n) || t && t.option("unsafe_comps");

              default:
                return true;
            }
        }
        function x(e, n) {
            if (n.is_constant()) return true;
            if (n instanceof Fn) return n.operator != "=" || x(e, n.right);
            if (n instanceof Cn) {
                return !He[n.operator] || x(e, n.left) && x(e, n.right);
            }
            if (n instanceof Mn) {
                return x(e, n.consequent) && x(e, n.alternative);
            }
            if (n instanceof Tn) return x(e, n.tail_node());
            if (n instanceof Hn) {
                var t = n.fixed_value();
                return t && x(e, t);
            }
            if (n instanceof Rr) return !n.tag || Oe(e, n.tag);
            if (n instanceof $n) return true;
        }
        function De(e, n) {
            if (n instanceof Dn) return De(e, n.expression);
            if (n instanceof qn) {
                return De(e, n.expression) && De(e, n.property);
            }
            if (n instanceof Ar) return true;
            return !n.has_side_effects(e);
        }
        function qe(e, n) {
            var t = e.right;
            e.left = Fe(Cn, e, {
                operator: e.operator,
                left: e.left,
                right: t.left,
                start: e.left.start,
                end: t.left.end
            });
            e.right = t.right;
            if (n) {
                e.left = e.left.transform(n);
            } else if (e.operator == t.left.operator) {
                qe(e.left);
            }
        }
        e(Cn, function(r, i) {
            if (se[r.operator] && r.right.is_constant() && !r.left.is_constant() && !(r.left instanceof Cn && ii[r.left.operator] >= ii[r.operator])) {
                D();
            }
            if (i.option("sequences")) {
                var e = r.lift_sequences(i);
                if (e !== r) return e.optimize(i);
            }
            if (i.option("assignments") && He[r.operator]) {
                var n = r.right;
                if (r.left instanceof Hn && n instanceof Fn && n.operator == "=" && r.left.equals(n.left)) {
                    return Fe(Fn, r, {
                        operator: "=",
                        left: n.left,
                        right: Fe(Cn, r, {
                            operator: r.operator,
                            left: r.left,
                            right: n.right
                        })
                    }).optimize(i);
                }
            }
            if (i.option("comparisons")) switch (r.operator) {
              case "===":
              case "!==":
                if (Ie(r.left, i) && r.right.is_defined(i)) {
                    vn.warn("Expression always defined [{start}]", r);
                    return Pe(r, [ r.right, Fe(r.operator == "===" ? Kr : Qr, r) ]).optimize(i);
                }
                var t = true;
                if (r.left.is_string(i) && r.right.is_string(i) || r.left.is_number(i) && r.right.is_number(i) || r.left.is_boolean(i) && r.right.is_boolean(i) || De(i, r.left) && r.left.equals(r.right)) {
                    r.operator = r.operator.slice(0, 2);
                }

              case "==":
              case "!=":
                if (!t && Ie(r.left, i)) {
                    r.left = Fe(Ur, r.left);
                } else if (i.option("typeofs") && r.left instanceof Rn && r.left.value == "undefined" && r.right instanceof zn && r.right.operator == "typeof") {
                    var a = r.right.expression;
                    if (a instanceof Hn ? a.is_declared(i) : !(a instanceof An && i.option("ie"))) {
                        r.right = a;
                        r.left = Fe(Wr, r.left).optimize(i);
                        if (r.operator.length == 2) r.operator += "=";
                    }
                } else if (r.left instanceof Hn && r.right instanceof Hn && r.left.definition() === r.right.definition() && Ae(r.left)) {
                    return Fe(r.operator[0] == "=" ? Qr : Kr, r).optimize(i);
                }
                break;

              case "&&":
              case "||":
                var o = r.left;
                if (o.operator == r.operator) o = o.right;
                var a = o.right;
                if (a instanceof Fn && a.operator == "=") a = a.left;
                if (o instanceof Cn && o.operator == (r.operator == "&&" ? "!==" : "===") && r.right instanceof Cn && o.operator == r.right.operator && (Ie(o.left, i) && r.right.left instanceof Ur || o.left instanceof Ur && Ie(r.right.left, i)) && !a.has_side_effects(i) && a.equals(r.right.right)) {
                    o.operator = o.operator.slice(0, -1);
                    o.left = Fe(Ur, r);
                    return r.left;
                }
                break;
            }
            var s = false;
            var f = i.parent();
            if (i.option("booleans")) {
                var o = r.left;
                if (He[r.operator] && !o.has_side_effects(i)) {
                    if (o.equals(r.right)) {
                        return je(f, i.self(), o).optimize(i);
                    }
                    G(i, o);
                }
                s = i.in_boolean_context();
            }
            if (s) switch (r.operator) {
              case "+":
                var u = r.left.evaluate(i, true);
                if (u && typeof u == "string" || (u = r.right.evaluate(i, true)) && typeof u == "string") {
                    vn.warn("+ in boolean context always true [{start}]", r);
                    var c = [];
                    if (r.left.evaluate(i) instanceof vn) c.push(r.left);
                    if (r.right.evaluate(i) instanceof vn) c.push(r.right);
                    if (c.length < 2) {
                        c.push(Fe(Qr, r));
                        return Pe(r, c).optimize(i);
                    }
                    r.truthy = true;
                }
                break;

              case "==":
                if (r.left instanceof Rn && r.left.value == "" && r.right.is_string(i)) {
                    return Fe(zn, r, {
                        operator: "!",
                        expression: r.right
                    }).optimize(i);
                }
                break;

              case "!=":
                if (r.left instanceof Rn && r.left.value == "" && r.right.is_string(i)) {
                    return r.right.optimize(i);
                }
                break;
            }
            if (i.option("comparisons") && r.is_boolean(i)) {
                if (f.TYPE != "Binary") {
                    var l = Fe(zn, r, {
                        operator: "!",
                        expression: r.negate(i)
                    });
                    if (pe(i, r, l) === l) return l;
                }
                switch (r.operator) {
                  case ">":
                    D("<");
                    break;

                  case ">=":
                    D("<=");
                    break;
                }
            }
            if (i.option("conditionals") && He[r.operator] && r.right instanceof Cn && r.operator == r.right.operator) {
                qe(r, i);
            }
            if (i.option("strings") && r.operator == "+") {
                if (r.right instanceof Rn && r.right.value == "" && r.left.is_string(i)) {
                    return r.left.optimize(i);
                }
                if (r.left instanceof Rn && r.left.value == "" && r.right.is_string(i)) {
                    return r.right.optimize(i);
                }
                if (r.left instanceof Cn && r.left.operator == "+" && r.left.left instanceof Rn && r.left.left.value == "" && r.right.is_string(i) && (r.left.right.is_constant() || !r.right.has_side_effects(i))) {
                    r.left = r.left.right;
                    return r.optimize(i);
                }
                if (r.right instanceof Cn && r.operator == r.right.operator && (r.left.is_string(i) && r.right.is_string(i) || r.right.left.is_string(i) && (r.left.is_constant() || !r.right.right.has_side_effects(i)))) {
                    qe(r, i);
                }
            }
            if (i.option("evaluate")) {
                var p = true;
                switch (r.operator) {
                  case "&&":
                    var d = C(i, r.left);
                    if (!d) {
                        vn.warn("Condition left of && always false [{start}]", r);
                        return je(f, i.self(), r.left).optimize(i);
                    } else if (!(d instanceof vn)) {
                        vn.warn("Condition left of && always true [{start}]", r);
                        return Pe(r, [ r.left, r.right ]).optimize(i);
                    }
                    if (!r.right.evaluate(i, true)) {
                        if (s && !(r.right.evaluate(i) instanceof vn)) {
                            vn.warn("Boolean && always false [{start}]", r);
                            return Pe(r, [ r.left, Fe(Kr, r) ]).optimize(i);
                        } else r.falsy = true;
                    } else if ((s || f.operator == "&&" && f.left === i.self()) && !(r.right.evaluate(i) instanceof vn)) {
                        vn.warn("Dropping side-effect-free && [{start}]", r);
                        return r.left.optimize(i);
                    }
                    if (r.left.operator == "||") {
                        var h = C(i, r.left.right);
                        if (!h) return Fe(Mn, r, {
                            condition: r.left.left,
                            consequent: r.right,
                            alternative: r.left.right
                        }).optimize(i);
                    }
                    break;

                  case "??":
                    var v = true;

                  case "||":
                    var d = C(i, r.left, v);
                    if (v ? d == null : !d) {
                        vn.warn("Condition left of {operator} always {value} [{start}]", {
                            operator: r.operator,
                            value: v ? "nulish" : "false",
                            start: r.start
                        });
                        return Pe(r, [ r.left, r.right ]).optimize(i);
                    } else if (!(d instanceof vn)) {
                        vn.warn("Condition left of {operator} always {value} [{start}]", {
                            operator: r.operator,
                            value: v ? "defined" : "true",
                            start: r.start
                        });
                        return je(f, i.self(), r.left).optimize(i);
                    }
                    var m;
                    if (!v && (m = r.right.evaluate(i, true)) && !(m instanceof vn)) {
                        if (s && !(r.right.evaluate(i) instanceof vn)) {
                            vn.warn("Boolean || always true [{start}]", r);
                            return Pe(r, [ r.left, Fe(Qr, r) ]).optimize(i);
                        } else r.truthy = true;
                    } else if ((s || f.operator == "||" && f.left === i.self()) && !r.right.evaluate(i)) {
                        vn.warn("Dropping side-effect-free {operator} [{start}]", r);
                        return r.left.optimize(i);
                    }
                    if (!v && r.left.operator == "&&") {
                        var h = C(i, r.left.right);
                        if (h && !(h instanceof vn)) return Fe(Mn, r, {
                            condition: r.left.left,
                            consequent: r.left.right,
                            alternative: r.right
                        }).optimize(i);
                    }
                    break;

                  case "+":
                    if (r.left instanceof Yn && r.right instanceof Cn && r.right.operator == "+" && r.right.left instanceof Yn && r.right.is_string(i)) {
                        r = Fe(Cn, r, {
                            operator: "+",
                            left: Fe(Rn, r.left, {
                                value: "" + r.left.value + r.right.left.value,
                                start: r.left.start,
                                end: r.right.left.end
                            }),
                            right: r.right.right
                        });
                    }
                    if (r.right instanceof Yn && r.left instanceof Cn && r.left.operator == "+" && r.left.right instanceof Yn && r.left.is_string(i)) {
                        r = Fe(Cn, r, {
                            operator: "+",
                            left: r.left.left,
                            right: Fe(Rn, r.right, {
                                value: "" + r.left.right.value + r.right.value,
                                start: r.left.right.start,
                                end: r.right.end
                            })
                        });
                    }
                    if (r.right instanceof zn && r.right.operator == "-" && r.left.is_number(i)) {
                        r = Fe(Cn, r, {
                            operator: "-",
                            left: r.left,
                            right: r.right.expression
                        });
                        break;
                    }
                    if (r.left instanceof zn && r.left.operator == "-" && A() && r.right.is_number(i)) {
                        r = Fe(Cn, r, {
                            operator: "-",
                            left: r.right,
                            right: r.left.expression
                        });
                        break;
                    }
                    if (i.option("unsafe_math") && r.left instanceof Cn && ii[r.left.operator] == ii[r.operator] && r.right.is_constant() && (r.right.is_boolean(i) || r.right.is_number(i)) && r.left.is_number(i) && !r.left.right.is_constant() && (r.left.left.is_boolean(i) || r.left.left.is_number(i))) {
                        r = Fe(Cn, r, {
                            operator: r.left.operator,
                            left: Fe(Cn, r, {
                                operator: r.operator,
                                left: r.right,
                                right: r.left.left
                            }),
                            right: r.left.right
                        });
                        break;
                    }

                  case "-":
                    if (r.right instanceof zn && r.right.operator == "-" && r.left.is_number(i) && r.right.expression.is_number(i)) {
                        r = Fe(Cn, r, {
                            operator: "+",
                            left: r.left,
                            right: r.right.expression
                        });
                        break;
                    }

                  case "*":
                  case "/":
                    p = i.option("unsafe_math");
                    if (r.operator != "+") [ "left", "right" ].forEach(function(e) {
                        var n = r[e];
                        if (n instanceof zn && n.operator == "+") {
                            var t = n.expression;
                            if (t.is_boolean(i) || t.is_number(i) || t.is_string(i)) {
                                r[e] = t;
                            }
                        }
                    });

                  case "&":
                  case "|":
                  case "^":
                    if (r.operator != "-" && r.operator != "/" && (r.left.is_boolean(i) || r.left.is_number(i)) && (r.right.is_boolean(i) || r.right.is_number(i)) && A() && !(r.left instanceof Cn && r.left.operator != r.operator && ii[r.left.operator] >= ii[r.operator])) {
                        r = pe(i, r, Fe(Cn, r, {
                            operator: r.operator,
                            left: r.right,
                            right: r.left
                        }), r.right instanceof Yn && !(r.left instanceof Yn));
                    }
                    if (!p || !r.is_number(i)) break;
                    if (r.right instanceof Cn && r.right.operator != "%" && ii[r.right.operator] == ii[r.operator] && r.right.is_number(i) && (r.operator != "+" || r.right.left.is_boolean(i) || r.right.left.is_number(i)) && (r.operator != "-" || !r.left.is_negative_zero()) && (r.right.left.is_constant_expression() || !r.right.right.has_side_effects(i)) && !x(r.right.right)) {
                        r = Fe(Cn, r, {
                            operator: k(r.operator, r.right.operator),
                            left: Fe(Cn, r.left, {
                                operator: r.operator,
                                left: r.left,
                                right: r.right.left,
                                start: r.left.start,
                                end: r.right.left.end
                            }),
                            right: r.right.right
                        });
                        if (r.operator == "+" && !r.right.is_boolean(i) && !r.right.is_number(i)) {
                            r.right = Fe(zn, r.right, {
                                operator: "+",
                                expression: r.right
                            });
                        }
                    }
                    if (r.right instanceof Yn && r.left instanceof Cn && r.left.operator != "%" && ii[r.left.operator] == ii[r.operator] && r.left.is_number(i)) {
                        if (r.left.left instanceof Yn) {
                            var o = E(r.operator, r.left.left, r.right, {
                                start: r.left.left.start,
                                end: r.right.end
                            });
                            r = E(r.left.operator, de(i, o), r.left.right, r);
                        } else if (r.left.right instanceof Yn) {
                            var _ = k(r.left.operator, r.operator);
                            var g = de(i, E(_, r.left.right, r.right, r.left));
                            if (g.is_constant() && !(r.left.operator == "-" && r.right.value != 0 && +g.value == 0 && r.left.left.is_negative_zero())) {
                                r = E(r.left.operator, r.left.left, g, r);
                            }
                        }
                    }
                    break;

                  case "instanceof":
                    if (O(r.right)) return Pe(r, [ r, Fe(Kr, r) ]).optimize(i);
                    break;
                }
                if (!(f instanceof zn && f.operator == "delete")) {
                    if (r.left instanceof Bn && !r.right.is_constant()) switch (r.operator) {
                      case "+":
                        if (r.left.value == 0) {
                            if (r.right.is_boolean(i)) return Fe(zn, r, {
                                operator: "+",
                                expression: r.right
                            }).optimize(i);
                            if (r.right.is_number(i) && !r.right.is_negative_zero()) return r.right;
                        }
                        break;

                      case "*":
                        if (r.left.value == 1) return Fe(zn, r, {
                            operator: "+",
                            expression: r.right
                        }).optimize(i);
                        break;
                    }
                    if (r.right instanceof Bn && !r.left.is_constant()) switch (r.operator) {
                      case "+":
                        if (r.right.value == 0) {
                            if (r.left.is_boolean(i)) return Fe(zn, r, {
                                operator: "+",
                                expression: r.left
                            }).optimize(i);
                            if (r.left.is_number(i) && !r.left.is_negative_zero()) return r.left;
                        }
                        break;

                      case "-":
                        if (r.right.value == 0) return Fe(zn, r, {
                            operator: "+",
                            expression: r.left
                        }).optimize(i);
                        break;

                      case "/":
                        if (r.right.value == 1) return Fe(zn, r, {
                            operator: "+",
                            expression: r.left
                        }).optimize(i);
                        break;
                    }
                }
            }
            if (i.option("typeofs")) switch (r.operator) {
              case "&&":
                B(r.left, r.right, null);
                break;

              case "||":
                B(r.left, null, r.right);
                break;
            }
            if (i.option("unsafe")) {
                var b = S(r.right);
                if (s && b && (r.operator == "==" || r.operator == "!=") && r.left instanceof Bn && r.left.value == 0) {
                    return (r.operator == "==" ? Fe(zn, r, {
                        operator: "!",
                        expression: r.right
                    }) : r.right).optimize(i);
                }
                var y = S(r.left);
                if (i.option("comparisons") && T()) {
                    var w = Fe(zn, r, {
                        operator: "!",
                        expression: Fe(zn, r, {
                            operator: "~",
                            expression: y ? r.left : r.right
                        })
                    });
                    switch (r.operator) {
                      case "<":
                        if (y) break;

                      case "<=":
                      case "!=":
                        w = Fe(zn, r, {
                            operator: "!",
                            expression: w
                        });
                        break;
                    }
                    return w.optimize(i);
                }
            }
            return de(i, r);
            function x(e) {
                var n = false;
                e.walk(new Ln(function(e) {
                    if (n) return true;
                    if (e instanceof Fn) {
                        if (e.left instanceof An) return n = true;
                    } else if (e instanceof $n) {
                        if (si[e.operator] && e.expression instanceof An) {
                            return n = true;
                        }
                    }
                }));
                return n;
            }
            function k(e, n) {
                switch (e) {
                  case "-":
                    return n == "+" ? "-" : "+";

                  case "/":
                    return n == "*" ? "/" : "*";

                  default:
                    return n;
                }
            }
            function E(e, n, t, r) {
                if (e == "+") {
                    if (!n.is_boolean(i) && !n.is_number(i)) {
                        n = Fe(zn, n, {
                            operator: "+",
                            expression: n
                        });
                    }
                    if (!t.is_boolean(i) && !t.is_number(i)) {
                        t = Fe(zn, t, {
                            operator: "+",
                            expression: t
                        });
                    }
                }
                return Fe(Cn, r, {
                    operator: e,
                    left: n,
                    right: t
                });
            }
            function S(e) {
                return e.TYPE == "Call" && e.expression instanceof Dn && oe[e.expression.property];
            }
            function T() {
                switch (r.operator) {
                  case "<=":
                    return b && r.left instanceof Bn && r.left.value == 0;

                  case "<":
                    if (y && r.right instanceof Bn && r.right.value == 0) return true;

                  case "==":
                  case "!=":
                    if (!b) return false;
                    return r.left instanceof Bn && r.left.value == -1 || r.left instanceof zn && r.left.operator == "-" && r.left.expression instanceof Bn && r.left.expression.value == 1;
                }
            }
            function A() {
                return r.left.is_constant() || r.right.is_constant() || !r.left.has_side_effects(i) && !r.right.has_side_effects(i);
            }
            function D(e) {
                if (A()) {
                    if (e) r.operator = e;
                    var n = r.left;
                    r.left = r.right;
                    r.right = n;
                }
            }
        });
        e(jr, function(e) {
            return e;
        });
        function Qe(e, n, t) {
            var r = 0, i = e.self();
            do {
                if (i === t) return i;
                if (O(i) && i.name && i.name.definition() === n) return i;
            } while (i = e.parent(r++));
        }
        function Re(e) {
            var n = e.scope.resolve();
            return dn(e.references, function(e) {
                return n === e.scope.resolve();
            });
        }
        e(Hn, function(t, e) {
            if (!e.option("ie") && Ne(t) && !(t.scope.resolve().uses_with && e.find_parent(gt))) {
                switch (t.name) {
                  case "undefined":
                    return Fe(Wr, t).optimize(e);

                  case "NaN":
                    return Fe(Vr, t).optimize(e);

                  case "Infinity":
                    return Fe(Jr, t).optimize(e);
                }
            }
            var n = e.parent();
            if (e.option("reduce_vars") && fi(e.self(), n) !== e.self()) {
                var r = t.definition();
                var i = t.fixed_value();
                var a = r.single_use && !(n instanceof Sn && n.is_expr_pure(e));
                if (a) {
                    if (O(i)) {
                        if ((r.scope !== t.scope.resolve() || r.in_loop) && (!e.option("reduce_funcs") || r.escaped.depth == 1 || i.inlined)) {
                            a = false;
                        } else if (r.redefined()) {
                            a = false;
                        } else if (Qe(e, r, i)) {
                            a = false;
                        } else if (i.name && i.name.definition() !== r) {
                            a = false;
                        } else if (i.parent_scope !== t.scope || oi(r)) {
                            if (!Te(i, e)) {
                                a = false;
                            } else if ((a = i.is_constant_expression(t.scope)) == "f") {
                                var o = t.scope;
                                do {
                                    if (o instanceof Ct || o instanceof xt) {
                                        o.inlined = true;
                                    }
                                } while (o = o.parent_scope);
                            }
                        } else if (i.name && (i.name.name == "await" && Et(i) || i.name.name == "yield" && St(i))) {
                            a = false;
                        } else if (i.has_side_effects(e)) {
                            a = false;
                        } else if (e.option("ie") && i instanceof Nt) {
                            a = false;
                        }
                        if (a) i.parent_scope = t.scope;
                    } else if (!i || r.recursive_refs > 0 || !i.is_constant_expression() || i.drop_side_effect_free(e)) {
                        a = false;
                    }
                }
                if (a) {
                    r.single_use = false;
                    i._squeezed = true;
                    i.single_use = true;
                    if (i instanceof It) i = re(i);
                    if (i instanceof Ct) i = we(i);
                    if (O(i)) {
                        var s = [];
                        var o = t.scope;
                        do {
                            s.push(o);
                            if (o === r.scope) break;
                        } while (o = o.parent_scope);
                        i.enclosed.forEach(function(e) {
                            if (i.variables.has(e.name)) return;
                            for (var n = 0; n < s.length; n++) {
                                var t = s[n];
                                if (!Kn(t.enclosed, e)) return;
                                t.var_names().set(e.name, true);
                            }
                        });
                    }
                    var f;
                    if (r.recursive_refs > 0) {
                        f = i.clone(true);
                        var u = f.name.definition();
                        var c = f.variables.get(f.name.name);
                        var l = c && c.orig[0];
                        var p, d;
                        if (f instanceof Nt) {
                            p = "def_function";
                            d = Fr;
                        } else {
                            p = "def_variable";
                            d = Mr;
                        }
                        if (!(l instanceof d)) {
                            l = Fe(d, f.name);
                            l.scope = f;
                            f.name = l;
                            c = f[p](l);
                            c.recursive_refs = r.recursive_refs;
                        }
                        f.walk(new Ln(function(e) {
                            if (e instanceof Dr) {
                                if (e !== l) {
                                    var n = e.definition();
                                    n.orig.push(e);
                                    n.eliminated++;
                                }
                                return;
                            }
                            if (!(e instanceof Hn)) return;
                            var n = e.definition();
                            if (n === u) {
                                e.thedef = n = c;
                            } else {
                                n.single_use = false;
                                var t = e.fixed_value();
                                if (O(t) && t.name && t.name.definition() === n && n.scope === t.name.scope && i.variables.get(t.name.name) === n) {
                                    t.name = t.name.clone();
                                    e.thedef = n = f.variables.get(t.name.name) || f[p](t.name);
                                }
                            }
                            n.references.push(e);
                        }));
                    } else {
                        if (i instanceof bn) {
                            e.push(i);
                            f = i.optimize(e);
                            e.pop();
                        } else {
                            f = i.optimize(e);
                        }
                        f = f.transform(new Zr(function(e, n) {
                            if (e instanceof bn) return e;
                            e = e.clone();
                            n(e, this);
                            return e;
                        }));
                    }
                    r.replaced++;
                    return f;
                }
                var h;
                if (i && (h = t.fixed || r.fixed).should_replace !== false) {
                    var v, m;
                    if (i instanceof Hr) {
                        if (!oi(r) && Re(r) && !y(r)) m = i;
                    } else if ((v = i.evaluate(e, true)) !== i && typeof v != "function" && (v === null || typeof v != "object" || e.option("unsafe_regexp") && v instanceof RegExp && !r.cross_loop && Re(r))) {
                        m = fe(v, i);
                    }
                    if (m) {
                        if (h.should_replace === undefined) {
                            var _ = m.optimize(e).print_to_string().length;
                            if (!w(i)) {
                                _ = Math.min(_, i.print_to_string().length);
                            }
                            var g = r.name.length;
                            if (e.option("unused") && !e.exposed(r)) {
                                var b = r.references.length - r.replaced - r.assignments;
                                b = Math.min(b, r.references.filter(function(e) {
                                    return e.fixed === h;
                                }).length);
                                g += (g + 2 + _) / Math.max(1, b);
                            }
                            h.should_replace = _ - Math.floor(g) < e.eval_threshold;
                        }
                        if (h.should_replace) {
                            var f;
                            if (w(i)) {
                                f = m.optimize(e);
                                if (f === m) f = f.clone(true);
                            } else {
                                f = le(m.optimize(e), i);
                                if (f === m || f === i) f = f.clone(true);
                            }
                            r.replaced++;
                            return f;
                        }
                    }
                }
            }
            return t;
            function y(e) {
                var n = t.scope;
                while (n !== e.scope) {
                    if (n instanceof Nt) return true;
                    n = n.parent_scope;
                }
            }
            function w(e) {
                var n;
                e.walk(new Ln(function(e) {
                    if (e instanceof Hn) n = true;
                    if (n) return true;
                }));
                return n;
            }
        });
        function Oe(e, n) {
            return e.option("unsafe") && n instanceof Dn && n.property == "raw" && Ne(n.expression) && n.expression.name == "String";
        }
        function Ze(e) {
            var r = false;
            e = e.replace(/\\(u\{[^{}]*\}?|u[\s\S]{0,4}|x[\s\S]{0,2}|[0-9]+|[\s\S])/g, function(e, n) {
                var t = ni(n);
                if (typeof t == "string") return t;
                r = true;
            });
            if (!r) return e;
        }
        e(Rr, function(e, t) {
            if (!t.option("templates")) return e;
            var r = e.tag;
            if (!r || Oe(t, r)) {
                var n = [];
                var i = [];
                for (var a = 0, o; a < e.strings.length; a++) {
                    var s = e.strings[a];
                    if (!r) {
                        var f = Ze(s);
                        if (f) s = v(f);
                    }
                    if (a > 0) {
                        var u = e.expressions[a - 1];
                        var c = m(u);
                        if (c) {
                            var l = i[i.length - 1];
                            var p = l + c + s;
                            var d;
                            if (r || typeof (d = Ze(p)) == o) {
                                i[i.length - 1] = d ? v(d) : p;
                                continue;
                            }
                        }
                        n.push(u);
                    }
                    i.push(s);
                    if (!r) o = typeof f;
                }
                if (!r && i.length > 1) {
                    if (i[i.length - 1] == "") return Fe(Cn, e, {
                        operator: "+",
                        left: Fe(Rr, e, {
                            expressions: n.slice(0, -1),
                            strings: i.slice(0, -1)
                        }).transform(t),
                        right: n[n.length - 1]
                    }).optimize(t);
                    if (i[0] == "") {
                        var h = Fe(Cn, e, {
                            operator: "+",
                            left: Fe(Rn, e, {
                                value: ""
                            }),
                            right: n[0]
                        });
                        for (var a = 1; i[a] == "" && a < n.length; a++) {
                            h = Fe(Cn, e, {
                                operator: "+",
                                left: h,
                                right: n[a]
                            });
                        }
                        return pe(t, e, Fe(Cn, e, {
                            operator: "+",
                            left: h.transform(t),
                            right: Fe(Rr, e, {
                                expressions: n.slice(a),
                                strings: i.slice(a)
                            }).transform(t)
                        }).optimize(t));
                    }
                }
                e.expressions = n;
                e.strings = i;
            }
            return de(t, e);
            function v(e) {
                return e.replace(/\r|\\|`|\${/g, function(e) {
                    return "\\" + (e == "\r" ? "r" : e);
                });
            }
            function m(e) {
                var n = e.evaluate(t);
                if (n === e) return;
                if (r && /\r|\\|`/.test(n)) return;
                n = v("" + n);
                if (n.length > e.print_to_string().length + "${}".length) return;
                return n;
            }
        });
        function en(e, n) {
            return e instanceof Hn || e.TYPE === n.TYPE;
        }
        e(Wr, function(e, n) {
            if (n.option("unsafe_undefined")) {
                var t = Me(n).find_variable("undefined");
                if (t) {
                    var r = Fe(Hn, e, {
                        name: "undefined",
                        scope: t.scope,
                        thedef: t
                    });
                    r.is_undefined = true;
                    return r;
                }
            }
            var i = fi(n.self(), n.parent());
            if (i && en(i, e)) return e;
            return Fe(zn, e, {
                operator: "void",
                expression: Fe(Bn, e, {
                    value: 0
                })
            });
        });
        e(Jr, function(e, n) {
            var t = fi(n.self(), n.parent());
            if (t && en(t, e)) return e;
            if (n.option("keep_infinity") && !t && !Me(n).find_variable("Infinity")) {
                return e;
            }
            return Fe(Cn, e, {
                operator: "/",
                left: Fe(Bn, e, {
                    value: 1
                }),
                right: Fe(Bn, e, {
                    value: 0
                })
            });
        });
        e(Vr, function(e, n) {
            var t = fi(n.self(), n.parent());
            if (t && en(t, e)) return e;
            if (!t && !Me(n).find_variable("NaN")) return e;
            return Fe(Cn, e, {
                operator: "/",
                left: Fe(Bn, e, {
                    value: 0
                }),
                right: Fe(Bn, e, {
                    value: 0
                })
            });
        });
        function nn(t, n) {
            var r = false;
            var i = new Ln(function(e) {
                if (r) return true;
                if (e instanceof Hn && Un(e.definition(), n)) return r = true;
            });
            var a = new Ln(function(e) {
                if (r) return true;
                if (e instanceof yn && e !== t) {
                    if (!(e.name || Et(e) || St(e))) {
                        var n = a.parent();
                        if (n instanceof Sn && n.expression === e) return;
                    }
                    e.walk(i);
                    return true;
                }
            });
            t.walk(a);
            return r;
        }
        var tn = pn("+ - * / % >> << >>> | ^ &");
        var rn = pn("* | ^ &");
        e(Fn, function(a, o) {
            if (o.option("dead_code")) {
                if (a.left instanceof An) {
                    if (a.operator == "=") {
                        if (a.redundant) {
                            var e = [ a.left.expression ];
                            if (a.left instanceof qn) e.push(a.left.property);
                            e.push(a.right);
                            return Pe(a, e).optimize(o);
                        }
                        if (a.left.equals(a.right) && !a.left.has_side_effects(o)) {
                            return a.right;
                        }
                        var n = a.left.expression;
                        if (n instanceof yn || !o.has_directive("use strict") && n instanceof Yn && !n.may_throw_on_access(o)) {
                            return a.left instanceof Dn ? a.right : Pe(a, [ a.left.property, a.right ]).optimize(o);
                        }
                    }
                } else if (a.left instanceof Hn && Ce(a.left, o)) {
                    var t;
                    if (a.operator == "=" && a.left.equals(a.right) && !((t = o.parent()) instanceof zn && t.operator == "delete")) {
                        return a.right;
                    }
                    if (a.left.is_immutable()) return _();
                    var r = a.left.definition();
                    var s = r.scope.resolve();
                    var i = s === o.find_parent(yn);
                    var f = 0, u;
                    t = o.self();
                    if (!(s.uses_arguments && oi(r)) || o.has_directive("use strict")) do {
                        u = t;
                        t = o.parent(f++);
                        if (t instanceof Fn) {
                            if (t.left instanceof Hn && t.left.definition() === r) {
                                if (m(f, t, !i)) break;
                                return _(r);
                            }
                            if (t.left.match_symbol(function(e) {
                                if (e instanceof An) return true;
                            })) break;
                            continue;
                        }
                        if (t instanceof Gt) {
                            if (!i) break;
                            if (m(f, t)) break;
                            if (nn(s, [ r ])) break;
                            return _(r);
                        }
                        if (t instanceof _n) {
                            if (!i) break;
                            if (nn(s, [ r ])) break;
                            var c;
                            do {
                                c = t;
                                t = o.parent(f++);
                                if (t === s && T(t.body, c)) return _(r);
                            } while (v(c, t));
                            break;
                        }
                        if (t instanceof kn) {
                            if (!(t.name instanceof Dr)) continue;
                            if (t.name.definition() !== r) continue;
                            if (m(f, t)) break;
                            return _(r);
                        }
                    } while (h(u, t));
                }
            }
            if (o.option("sequences")) {
                var l = a.lift_sequences(o);
                if (l !== a) return l.optimize(o);
            }
            if (o.option("assignments")) {
                if (a.operator == "=" && a.left instanceof Hn && a.right instanceof Cn) {
                    var p;
                    if ((p = a.right.left) instanceof Hn && p.name == a.left.name && tn[a.right.operator]) {
                        if (a.left.fixed) a.left.fixed.to_binary = function() {
                            return p;
                        };
                        return Fe(Fn, a, {
                            operator: a.right.operator + "=",
                            left: a.left,
                            right: a.right.right
                        });
                    }
                    if ((p = a.right.right) instanceof Hn && p.name == a.left.name && rn[a.right.operator] && !a.right.left.has_side_effects(o)) {
                        if (a.left.fixed) a.left.fixed.to_binary = function() {
                            return p;
                        };
                        return Fe(Fn, a, {
                            operator: a.right.operator + "=",
                            left: a.left,
                            right: a.right.left
                        });
                    }
                }
                if ((a.operator == "-=" || a.operator == "+=" && (a.left.is_boolean(o) || a.left.is_number(o))) && a.right instanceof Bn && a.right.value == 1) {
                    var d = a.operator.slice(0, -1);
                    return Fe(zn, a, {
                        operator: d + d,
                        expression: a.left
                    });
                }
            }
            return de(o, a);
            function h(e, n) {
                if (n instanceof Cn) {
                    return n.right === e || n.right.is_constant_expression(s);
                }
                if (n instanceof Mn) {
                    return n.condition !== e || n.consequent.is_constant_expression(s) && n.alternative.is_constant_expression(s);
                }
                if (n instanceof Tn) {
                    var t = n.expressions;
                    var r = t.indexOf(e);
                    if (r < 0) return false;
                    for (var i = t.length; --i > r; ) {
                        if (!t[i].is_constant_expression(s)) return false;
                    }
                    return true;
                }
                if (n instanceof zn) return true;
            }
            function v(e, n) {
                if (n instanceof gn) return T(n.body, e);
                if (n instanceof ir) return T(n.body, e);
                if (n instanceof ar) return T(n.body, e);
                if (n instanceof xn) return n.body === e || n.alternative === e;
                if (n instanceof rr) return n.bfinally ? n.bfinally === e : n.bcatch === e;
            }
            function m(e, n, t) {
                var r = a.right;
                a.right = Fe(Ur, r);
                var i = n.may_throw(o);
                a.right = r;
                return Ue(o, e, n, s, i, t);
            }
            function _(e) {
                if (e) e.fixed = false;
                return (a.operator != "=" ? Fe(Cn, a, {
                    operator: a.operator.slice(0, -1),
                    left: a.left,
                    right: a.right
                }) : je(o.parent(), a, a.right)).optimize(o);
            }
        });
        e(Mn, function(u, n) {
            if (n.option("sequences") && u.condition instanceof Tn) {
                var e = u.condition.expressions.slice();
                var t = u.clone();
                t.condition = e.pop();
                e.push(t);
                return Pe(u, e).optimize(n);
            }
            if (!n.option("conditionals")) return u;
            var c = u.condition;
            if (n.option("booleans") && !c.has_side_effects(n)) {
                G(n, c);
            }
            c = C(n, c);
            if (!c) {
                vn.warn("Condition always false [{start}]", u);
                return Pe(u, [ u.condition, u.alternative ]).optimize(n);
            } else if (!(c instanceof vn)) {
                vn.warn("Condition always true [{start}]", u);
                return Pe(u, [ u.condition, u.consequent ]).optimize(n);
            }
            var r = nt(n);
            var i = c.negate(n, r);
            if ((r ? A : le)(c, i) === i) {
                u = Fe(Mn, u, {
                    condition: i,
                    consequent: u.alternative,
                    alternative: u.consequent
                });
                i = c;
                c = u.condition;
            }
            var a = u.consequent;
            var o = u.alternative;
            if (De(n, c)) {
                if (c.equals(a)) return Fe(Cn, u, {
                    operator: "||",
                    left: c,
                    right: o
                }).optimize(n);
                if (c.equals(o)) return Fe(Cn, u, {
                    operator: "&&",
                    left: c,
                    right: a
                }).optimize(n);
            }
            var s = a.tail_node();
            if (s instanceof Fn) {
                var f = s.operator == "=";
                var l = f ? o.tail_node() : o;
                if ((f || a === s) && l instanceof Fn && s.operator == l.operator && s.left.equals(l.left) && (f && s.left instanceof Hn || !c.has_side_effects(n) && k(a) && k(o))) {
                    return Fe(Fn, u, {
                        operator: s.operator,
                        left: s.left,
                        right: Fe(Mn, u, {
                            condition: c,
                            consequent: E(a),
                            alternative: E(o)
                        })
                    });
                }
            }
            var l = o.tail_node();
            if (s.equals(l)) {
                return Pe(u, a.equals(o) ? [ c, a ] : [ Fe(Mn, u, {
                    condition: c,
                    consequent: S(a),
                    alternative: S(o)
                }), s ]).optimize(n);
            }
            var p = x(a, o, true);
            if (p) return p;
            var d;
            if (a instanceof Sn && o.TYPE == a.TYPE && (d = b(a, o)) >= 0 && a.expression.equals(o.expression) && !c.has_side_effects(n) && !a.expression.has_side_effects(n)) {
                var t = a.clone();
                var h = a.args[d];
                t.args[d] = h instanceof On ? Fe(On, u, {
                    expression: Fe(Mn, u, {
                        condition: c,
                        consequent: h.expression,
                        alternative: o.args[d].expression
                    })
                }) : Fe(Mn, u, {
                    condition: c,
                    consequent: h,
                    alternative: o.args[d]
                });
                return t;
            }
            if (s instanceof Mn && s.alternative.equals(o)) {
                return Fe(Mn, u, {
                    condition: Fe(Cn, u, {
                        left: c,
                        operator: "&&",
                        right: y(a, s, "condition")
                    }),
                    consequent: s.consequent,
                    alternative: o
                });
            }
            if (s instanceof Mn && s.consequent.equals(o)) {
                return Fe(Mn, u, {
                    condition: Fe(Cn, u, {
                        left: i,
                        operator: "||",
                        right: y(a, s, "condition")
                    }),
                    consequent: o,
                    alternative: s.alternative
                });
            }
            if (l instanceof Mn && a.equals(l.consequent)) {
                return Fe(Mn, u, {
                    condition: Fe(Cn, u, {
                        left: c,
                        operator: "||",
                        right: y(o, l, "condition")
                    }),
                    consequent: a,
                    alternative: l.alternative
                });
            }
            if (l instanceof Mn && a.equals(l.alternative)) {
                return Fe(Mn, u, {
                    condition: Fe(Cn, u, {
                        left: i,
                        operator: "&&",
                        right: y(o, l, "condition")
                    }),
                    consequent: l.consequent,
                    alternative: a
                });
            }
            if (s instanceof Cn && s.operator == "&&" && s.right.equals(o)) {
                return Fe(Cn, u, {
                    operator: "&&",
                    left: Fe(Cn, u, {
                        operator: "||",
                        left: i,
                        right: y(a, s, "left")
                    }),
                    right: o
                }).optimize(n);
            }
            if (s instanceof Cn && s.operator == "||" && s.right.equals(o)) {
                return Fe(Cn, u, {
                    operator: "||",
                    left: Fe(Cn, u, {
                        operator: "&&",
                        left: c,
                        right: y(a, s, "left")
                    }),
                    right: o
                }).optimize(n);
            }
            if (l instanceof Cn && l.operator == "&&" && l.right.equals(a)) {
                return Fe(Cn, u, {
                    operator: "&&",
                    left: Fe(Cn, u, {
                        operator: "||",
                        left: c,
                        right: y(o, l, "left")
                    }),
                    right: a
                }).optimize(n);
            }
            if (l instanceof Cn && l.operator == "||" && l.right.equals(a)) {
                return Fe(Cn, u, {
                    operator: "||",
                    left: Fe(Cn, u, {
                        operator: "&&",
                        left: i,
                        right: y(o, l, "left")
                    }),
                    right: a
                }).optimize(n);
            }
            var v = n.option("booleans") && n.in_boolean_context();
            if (_(a)) {
                if (g(o)) return m(c);
                return Fe(Cn, u, {
                    operator: "||",
                    left: m(c),
                    right: o
                });
            }
            if (g(a)) {
                if (_(o)) return m(c.negate(n));
                return Fe(Cn, u, {
                    operator: "&&",
                    left: m(c.negate(n)),
                    right: o
                });
            }
            if (_(o)) return Fe(Cn, u, {
                operator: "||",
                left: m(c.negate(n)),
                right: a
            });
            if (g(o)) return Fe(Cn, u, {
                operator: "&&",
                left: m(c),
                right: a
            });
            if (n.option("typeofs")) B(c, a, o);
            return u;
            function m(e) {
                if (e.is_boolean(n)) return e;
                return Fe(zn, e, {
                    operator: "!",
                    expression: e.negate(n)
                });
            }
            function _(e) {
                return e instanceof Qr || v && e instanceof Yn && e.value || e instanceof zn && e.operator == "!" && e.expression instanceof Yn && !e.expression.value;
            }
            function g(e) {
                return e instanceof Kr || v && (e instanceof Yn && !e.value || e instanceof zn && e.operator == "void" && !e.expression.has_side_effects(n)) || e instanceof zn && e.operator == "!" && e.expression instanceof Yn && e.expression.value;
            }
            function b(e, n) {
                var t = e.args;
                var r = n.args;
                var i = t.length;
                if (i != r.length) return -2;
                for (var a = 0; a < i; a++) {
                    if (!t[a].equals(r[a])) {
                        if (t[a] instanceof On !== r[a] instanceof On) return -3;
                        for (var o = a + 1; o < i; o++) {
                            if (!t[o].equals(r[o])) return -2;
                        }
                        return a;
                    }
                }
                return -1;
            }
            function y(e, n, t) {
                if (e === n) return n[t];
                var r = e.expressions.slice(0, -1);
                r.push(n[t]);
                return Pe(e, r);
            }
            function w(e, n) {
                if (e.TYPE != n.TYPE) return;
                if (e.optional != n.optional) return;
                if (e instanceof Sn) {
                    if (b(e, n) != -1) return;
                    return e.TYPE != "Call" || !(e.expression instanceof An || n.expression instanceof An) || w(e.expression, n.expression);
                }
                if (!(e instanceof An)) return;
                var t = e.property;
                var r = n.property;
                return (t instanceof vn ? t.equals(r) : t == r) && !(e.expression instanceof Ir || n.expression instanceof Ir);
            }
            function x(e, n, t) {
                var r = e.tail_node();
                var i = n.tail_node();
                if (!w(r, i)) return !t && Fe(Mn, u, {
                    condition: c,
                    consequent: e,
                    alternative: n
                });
                var a = r.clone();
                var o = y(e, r, "expression");
                var s = y(n, i, "expression");
                var f = x(o, s);
                if (r.expression instanceof Tn) {
                    f = je(r, r.expression, f);
                }
                a.expression = f;
                return a;
            }
            function k(e) {
                return e === e.tail_node() || dn(e.expressions.slice(0, -1), function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function E(e) {
                if (!(e instanceof Tn)) return e.right;
                var n = e.expressions.slice();
                n.push(n.pop().right);
                return Pe(e, n);
            }
            function S(e) {
                if (!(e instanceof Tn)) return Fe(Bn, e, {
                    value: 0
                });
                return Pe(e, e.expressions.slice(0, -1));
            }
        });
        e(Xr, function(e, n) {
            if (!n.option("booleans")) return e;
            if (n.in_boolean_context()) return Fe(Bn, e, {
                value: +e.value
            });
            var t = n.parent();
            if (t instanceof Cn && (t.operator == "==" || t.operator == "!=")) {
                vn.warn("Non-strict equality against boolean: {operator} {value} [{start}]", {
                    operator: t.operator,
                    value: e.value,
                    start: t.start
                });
                return Fe(Bn, e, {
                    value: +e.value
                });
            }
            return Fe(zn, e, {
                operator: "!",
                expression: Fe(Bn, e, {
                    value: 1 - e.value
                })
            });
        });
        e(On, function(e, n) {
            var t = e.expression;
            if (n.option("spreads") && t instanceof Pn && !(n.parent() instanceof Nn)) {
                return Xn.splice(t.elements.map(function(e) {
                    return e instanceof Gr ? Fe(Wr, e).optimize(n) : e;
                }));
            }
            return e;
        });
        function an(e, n) {
            if (!e) return false;
            var t = n.parent();
            if (t.TYPE != "Call") return true;
            if (t.expression !== n.self()) return true;
            if (e instanceof Hn) {
                e = e.fixed_value();
                if (!e) return false;
            }
            return e instanceof yn && !e.contains_this();
        }
        e(qn, function(e, t) {
            var n = e.expression;
            var r = e.property;
            var i = ke(e, t);
            if (i) return i;
            if (t.option("properties")) {
                var a = r.evaluate(t);
                if (a !== r) {
                    if (typeof a == "string") {
                        if (a == "undefined") {
                            a = undefined;
                        } else {
                            var o = parseFloat(a);
                            if (o.toString() == a) {
                                a = o;
                            }
                        }
                    }
                    r = e.property = le(r, fe(a, r).transform(t));
                    var s = "" + a;
                    if (ei(s) && s.length <= r.print_to_string().length + 1) {
                        return Fe(Dn, e, {
                            optional: e.optional,
                            expression: n,
                            property: s
                        }).optimize(t);
                    }
                }
            }
            var f = t.parent();
            var u = fi(t.self(), f);
            var c, l, p, d;
            if (t.option("arguments") && n instanceof Hn && ze(c = n.definition()) && !n.in_arg && r instanceof Bn && Math.floor(d = r.value) == d && (l = c.scope) === S() && l.uses_arguments < (u ? 2 : 3)) {
                if (f instanceof zn && f.operator == "delete") {
                    if (!c.deleted) c.deleted = [];
                    c.deleted[d] = true;
                }
                var h = l.argnames[d];
                if (c.deleted && c.deleted[d]) {
                    h = null;
                } else if (h) {
                    var v;
                    if (!(h instanceof In) || h.name == "await" || n.scope.find_variable(h.name) !== (v = h.definition())) {
                        h = null;
                    } else if (t.has_directive("use strict") || l.name || l.rest || !(p instanceof Sn && d < p.args.length && dn(p.args.slice(0, d + 1), function(e) {
                        return !(e instanceof On);
                    })) || !dn(l.argnames, function(e) {
                        return e instanceof In;
                    })) {
                        if (T() || v.assignments || v.orig.length > 1) h = null;
                    }
                } else if ((u || !T()) && d < l.argnames.length + 5 && t.drop_fargs(l, p) && !l.rest) {
                    while (d >= l.argnames.length) {
                        h = l.make_var(In, l, "argument_" + l.argnames.length);
                        l.argnames.push(h);
                    }
                }
                if (h && Vn(function(e) {
                    return e.name === h.name;
                }, l.argnames) === h) {
                    if (u) c.reassigned--;
                    var m = Fe(Hn, h);
                    m.reference();
                    h.unused = undefined;
                    return m;
                }
            }
            if (u) return e;
            if (t.option("sequences") && f.TYPE != "Call" && !(f instanceof vt && f.init === e)) {
                var _ = he(e, t);
                if (_ !== e) return _.optimize(t);
            }
            if (a !== r) {
                var g = e.flatten_object(s, t);
                if (g) {
                    n = e.expression = g.expression;
                    r = e.property = g.property;
                }
            }
            var b;
            if (t.option("properties") && t.option("side_effects") && r instanceof Bn && n instanceof Pn && dn(b = n.elements, function(e) {
                return !(e instanceof On);
            })) {
                var d = r.value;
                var y = b[d];
                if (an(y, t)) {
                    var w = y instanceof Gr;
                    var x = !w;
                    var k = [];
                    for (var E = b.length; --E > d; ) {
                        var o = b[E].drop_side_effect_free(t);
                        if (o) {
                            k.unshift(o);
                            if (x && o.has_side_effects(t)) x = false;
                        }
                    }
                    if (!x) k.unshift(y);
                    while (--E >= 0) {
                        var o = b[E].drop_side_effect_free(t);
                        if (o) {
                            k.unshift(o);
                        } else if (w) {
                            k.unshift(Fe(Gr, b[E]));
                        } else {
                            d--;
                        }
                    }
                    if (x) {
                        k.push(y);
                        return Pe(e, k).optimize(t);
                    }
                    return Fe(qn, e, {
                        expression: Fe(Pn, n, {
                            elements: k
                        }),
                        property: Fe(Bn, r, {
                            value: d
                        })
                    });
                }
            }
            return de(t, e);
            function S() {
                var e = 0, n;
                while (n = t.parent(e++)) {
                    if (n instanceof yn) {
                        if (n instanceof wt) return;
                        if (kt(n)) continue;
                        p = t.parent(e);
                        return n;
                    }
                }
            }
            function T() {
                return !t.option("reduce_vars") || c.reassigned;
            }
        });
        xt.DEFMETHOD("contains_super", function() {
            var n = false;
            var t = this;
            t.walk(new Ln(function(e) {
                if (n) return true;
                if (e instanceof Ir) return n = true;
                if (e !== t && e instanceof bn && !kt(e)) return true;
            }));
            return n;
        });
        (function(e) {
            e(At, cn);
            e(Dt, cn);
            e(vn, function() {
                var n = false;
                var t = this;
                t.walk(new Ln(function(e) {
                    if (n) return true;
                    if (e instanceof Hr) return n = true;
                    if (e !== t && e instanceof bn && !kt(e)) return true;
                }));
                return n;
            });
        })(function(e, n) {
            e.DEFMETHOD("contains_this", n);
        });
        function on(e) {
            return e instanceof kr && typeof e.key == "string" && !(e instanceof Er && e.value.contains_super());
        }
        An.DEFMETHOD("flatten_object", function(e, n) {
            if (!n.option("properties")) return;
            if (e === "__proto__") return;
            var t = this;
            var r = t.expression;
            if (!(r instanceof Nn)) return;
            var i = r.properties;
            for (var a = i.length; --a >= 0; ) {
                var o = i[a];
                if (o.key !== e) continue;
                if (!dn(i, on)) return;
                if (!an(o.value, n)) return;
                var s, f, u = [];
                for (var c = 0; c < i.length; c++) {
                    var l = i[c].value;
                    if (i[c] instanceof Er) {
                        var p = !(l.uses_arguments || St(l) || l.contains_this());
                        if (p) {
                            if (!f) f = n.find_parent(bn);
                            var d = ve(n, f);
                            l.each_argname(function(e) {
                                if (d[e.name]) p = false;
                            });
                        }
                        var h;
                        if (p) {
                            h = Et(l) ? Dt : At;
                        } else if (a != c || (s = n.parent()) instanceof Sn && s.expression === t) {
                            h = l.CTOR;
                        } else {
                            return;
                        }
                        l = Fe(h, l);
                    }
                    u.push(l);
                }
                return Fe(qn, t, {
                    expression: Fe(Pn, r, {
                        elements: u
                    }),
                    property: Fe(Bn, t, {
                        value: a
                    })
                });
            }
        });
        e(Dn, function(e, n) {
            if (e.property == "arguments" || e.property == "caller") {
                vn.warn("Function.prototype.{property} not supported [{start}]", e);
            }
            var t = n.parent();
            if (fi(n.self(), t)) return e;
            var r = ke(e, n);
            if (r) return r;
            if (n.option("sequences") && t.TYPE != "Call" && !(t instanceof vt && t.init === e)) {
                var i = he(e, n);
                if (i !== e) return i.optimize(n);
            }
            if (n.option("unsafe_proto") && e.expression instanceof Dn && e.expression.property == "prototype") {
                var a = e.expression.expression;
                if (Ne(a)) switch (a.name) {
                  case "Array":
                    e.expression = Fe(Pn, e.expression, {
                        elements: []
                    });
                    break;

                  case "Function":
                    e.expression = Fe($t, e.expression, {
                        argnames: [],
                        body: []
                    }).init_vars(a.scope);
                    break;

                  case "Number":
                    e.expression = Fe(Bn, e.expression, {
                        value: 0
                    });
                    break;

                  case "Object":
                    e.expression = Fe(Nn, e.expression, {
                        properties: []
                    });
                    break;

                  case "RegExp":
                    e.expression = Fe(Lr, e.expression, {
                        value: /t/
                    });
                    break;

                  case "String":
                    e.expression = Fe(Rn, e.expression, {
                        value: ""
                    });
                    break;
                }
            }
            var o = e.flatten_object(e.property, n);
            if (o) return o.optimize(n);
            return de(n, e);
        });
        e(br, function(e, n) {
            if (n.option("rests") && e.rest instanceof br) {
                return Fe(br, e, {
                    elements: e.elements.concat(e.rest.elements),
                    rest: e.rest.rest
                });
            }
            return e;
        });
        e(yr, function(e, n) {
            if (n.option("objects")) {
                var t = e.key;
                if (t instanceof vn) {
                    t = t.evaluate(n);
                    if (t !== e.key) e.key = "" + t;
                }
            }
            return e;
        });
        e(Nn, function(r, i) {
            if (!i.option("objects")) return r;
            var a = false;
            var t = false;
            var o = false;
            var s = i.has_directive("use strict");
            var f = [];
            var u = new hn();
            var c = [];
            r.properties.forEach(function(e) {
                if (!(e instanceof On)) return p(e);
                t = true;
                var n = e.expression;
                if (i.option("spreads") && n instanceof Nn && dn(n.properties, function(e) {
                    if (e instanceof Tr) return false;
                    if (e instanceof On) return false;
                    if (e.key !== "__proto__") return true;
                    if (e instanceof Sr) return true;
                    return !e.value.has_side_effects(i);
                })) {
                    a = true;
                    n.properties.forEach(function(e) {
                        var n = e.key;
                        var t = e instanceof Sr;
                        if (n === "__proto__") {
                            if (!t) return;
                            n = fe(n, e);
                        }
                        p(t ? Fe(kr, e, {
                            key: n,
                            value: Fe(Wr, e).optimize(i)
                        }) : e);
                    });
                } else {
                    o = true;
                    l();
                    c.push(e);
                }
            });
            l();
            if (!a) return r;
            if (t && o && c.length == 1) {
                var e = c[0];
                if (e instanceof xr && e.key instanceof Bn) {
                    e.key = "" + e.key.value;
                }
            }
            return Fe(Nn, r, {
                properties: c
            });
            function l() {
                f.forEach(function(e) {
                    var n = u.get(e);
                    switch (n.length) {
                      case 0:
                        return;

                      case 1:
                        return c.push(n[0]);
                    }
                    a = true;
                    var t = s && !o && n.pop();
                    c.push(n.length == 1 ? n[0] : Fe(kr, r, {
                        key: n[0].key,
                        value: Pe(r, n.map(function(e) {
                            return e.value;
                        }))
                    }));
                    if (t) c.push(t);
                    n.length = 0;
                });
                f = [];
                u = new hn();
            }
            function p(e) {
                var n = e.key;
                if (n instanceof vn) {
                    t = true;
                    n = n.evaluate(i);
                    if (n === e.key || n === "__proto__") {
                        o = true;
                    } else {
                        n = e.key = "" + n;
                    }
                }
                if (on(e)) {
                    if (e.value.has_side_effects(i)) l();
                    f.push(n);
                    u.add(n, e);
                } else {
                    l();
                    c.push(e);
                }
                if (t && !o && typeof n == "string" && F.test(n)) {
                    o = true;
                    if (u.has(n)) e = u.get(n)[0];
                    e.key = Fe(Bn, e, {
                        value: +n
                    });
                }
            }
        });
        function sn(e) {
            var n = e.definition().redefined();
            if (n) {
                e = e.clone();
                e.thedef = n;
            }
            return e;
        }
        function me(n, e) {
            var t = false;
            e.walk(new Ln(function(e) {
                if (t) return true;
                if (e instanceof Hn && n.variables.get(e.name) === e.definition()) {
                    return t = true;
                }
            }));
            return t;
        }
        function fn(e, t) {
            var r = [];
            e.references.forEach(function(e) {
                var n = e.fixed;
                if (!n || !Kn(r, n)) return;
                if (n.assigns) {
                    n.assigns.unshift(t);
                } else {
                    n.assigns = [ t ];
                }
            });
        }
        function un(e, n) {
            var t = Fe(Hn, n);
            var r = Fe(Fn, n, {
                operator: "=",
                left: t,
                right: Fe(Wr, n).transform(e)
            });
            var i = n.definition();
            if (i.fixed) {
                t.fixed = function() {
                    return r.right;
                };
                t.fixed.assigns = [ r ];
                fn(i, r);
            }
            i.assignments++;
            i.references.push(t);
            return r;
        }
        (function(e) {
            e(vn, Wn);
            e(Fn, Wn);
            e(_r, function(t, e, n, r) {
                var i = this;
                var a = i.expression.try_inline(t, e, n, r, true);
                if (!a) return;
                if (!n) y(a, function(e) {
                    e.in_bool = false;
                    var n = e.value;
                    if (n instanceof _r) return;
                    e.value = Fe(_r, i, {
                        expression: n || Fe(Wr, e).transform(t)
                    });
                });
                return R(a) ? a : Fe(gn, i, {
                    body: [ a, Fe(_n, i, {
                        body: Fe(_r, i, {
                            expression: Fe(Bn, i, {
                                value: 0
                            })
                        })
                    }) ]
                });
            });
            e(Cn, function(n, e, t, r, i) {
                if (t === undefined) return;
                var a = this;
                var o = a.operator;
                if (!He[o]) return;
                var s = a.right.try_inline(n, e, t, r, i);
                if (!s) return;
                return Fe(xn, a, {
                    condition: f(a.left),
                    body: s,
                    alternative: t ? null : Fe(wn, a, {
                        value: Fe(Wr, a).transform(n)
                    })
                });
                function f(e) {
                    switch (o) {
                      case "&&":
                        return e;

                      case "||":
                        return e.negate(n);

                      case "??":
                        return Fe(Cn, a, {
                            operator: "==",
                            left: Fe(Ur, a),
                            right: e
                        });
                    }
                }
            });
            e(gn, function(e, n, t, r) {
                if (t) return;
                if (!this.variables) return;
                var i = this.body;
                var a = i.length - 1;
                if (a < 0) return;
                var o = i[a].try_inline(e, this, t, r);
                if (!o) return;
                i[a] = o;
                return this;
            });
            e(Sn, function(r, i, e, a, n) {
                if (r.option("inline") < 4) return;
                var o = this;
                if (o.is_expr_pure(r)) return;
                var s = o.expression;
                if (!(s instanceof xt)) return;
                if (s.name) return;
                if (s.uses_arguments) return;
                if (s.pinned()) return;
                if (St(s)) return;
                var f = kt(s);
                if (f && s.value) return;
                if (s.body[0] instanceof it) return;
                if (s.contains_this()) return;
                if (!i) i = Me(r);
                var t = new hn();
                t.set("NaN", true);
                while (!(i instanceof bn)) {
                    i.variables.each(function(e) {
                        t.set(e.name, true);
                    });
                    i = i.parent_scope;
                }
                if (!Un(i, r.stack)) return;
                if (i.pinned() && s.variables.size() > (f ? 0 : 1)) return;
                if (i instanceof bt) {
                    if (s.variables.size() > (f ? 0 : 1)) {
                        if (!r.toplevel.vars) return;
                        if (s.functions.size() > 0 && !r.toplevel.funcs) return;
                    }
                    t.set("arguments", true);
                }
                var u = !n && Et(s);
                if (u) {
                    if (!r.option("awaits")) return;
                    if (!Et(i)) return;
                    if (o.may_throw(r)) return;
                }
                var c = i.var_names();
                if (a) a = [];
                if (!s.variables.all(function(e, n) {
                    if (a) a.push(e);
                    if (!t.has(n) && !c.has(n)) return true;
                    return !f && n == "arguments" && e.orig.length == 1;
                })) return;
                if (a && a.length > 0 && nn(s, a)) return;
                var l = true;
                if (!dn(s.argnames, function(e) {
                    var n = false;
                    var t = new Ln(function(e) {
                        if (n) return true;
                        if (e instanceof En) {
                            if (me(s, e.value)) return n = true;
                            e.name.walk(t);
                            return true;
                        }
                        if (e instanceof yr) {
                            if (e.key instanceof vn && me(s, e.key)) return n = true;
                            e.value.walk(t);
                            return true;
                        }
                        if (e instanceof In && !dn(e.definition().orig, function(e) {
                            return !(e instanceof Cr);
                        })) return n = true;
                    });
                    e.walk(t);
                    if (n) return false;
                    if (!(e instanceof In)) l = false;
                    return true;
                })) return;
                if (s.rest) {
                    if (me(s, s.rest)) return;
                    l = false;
                }
                var p;
                if (e) {
                    p = function(e) {
                        var n = false;
                        e.walk(new Ln(function(e) {
                            if (n) return true;
                            if (u && e instanceof _r || e instanceof wn) return n = true;
                            if (e instanceof bn) return true;
                        }));
                        return !n;
                    };
                } else if (n && !Et(s) || H(i)) {
                    p = function(e) {
                        var n = false;
                        var t = new Ln(function(e) {
                            if (n) return true;
                            if (e instanceof wn) return n = true;
                            if (e instanceof bn) return true;
                        });
                        e.walk(new Ln(function(e) {
                            if (n) return true;
                            if (e instanceof rr) {
                                if (e.bfinally && dn(e.body, function(e) {
                                    e.walk(t);
                                    return !n;
                                }) && e.bcatch) e.bcatch.walk(t);
                                return true;
                            }
                            if (e instanceof bn) return true;
                        }));
                        return !n;
                    };
                }
                if (p && !dn(s.body, p)) return;
                if (!Se(s, ve(r, i))) return;
                s.functions.each(function(e, n) {
                    i.functions.set(n, e);
                });
                var d = [];
                s.variables.each(function(n, e) {
                    if (!f && e == "arguments" && n.orig.length == 1) return;
                    c.set(e, true);
                    i.enclosed.push(n);
                    i.variables.set(e, n);
                    n.single_use = false;
                    if (!a) return;
                    if (n.references.length == n.replaced) return;
                    if (n.orig.length == n.eliminated) return;
                    if (n.orig.length == 1 && s.functions.has(e)) return;
                    if (!dn(n.orig, function(e) {
                        if (e instanceof qr) return false;
                        if (e instanceof In) return !e.unused && n.scope.resolve() !== s;
                        if (e instanceof $r) return false;
                        return true;
                    })) return;
                    var t = n.orig[0];
                    if (t instanceof Pr) return;
                    d.push(Fe(_n, t, {
                        body: un(r, sn(t))
                    }));
                });
                var h = Object.create(null), v = new hn();
                if (l && dn(o.args, function(e) {
                    return !(e instanceof On);
                })) {
                    var m = o.args.slice();
                    s.argnames.forEach(function(e) {
                        var n = m.shift();
                        if (e.unused) {
                            if (n) d.push(Fe(_n, o, {
                                body: n
                            }));
                            return;
                        }
                        var t = Fe(kn, o, {
                            name: e.convert_symbol(zr, g),
                            value: n || Fe(Wr, o).transform(r)
                        });
                        if (e instanceof In) fn(e.definition(), t);
                        d.push(Fe(ur, o, {
                            definitions: [ t ]
                        }));
                    });
                    if (m.length) d.push(Fe(_n, o, {
                        body: Pe(o, m)
                    }));
                } else {
                    d.push(Fe(ur, o, {
                        definitions: [ Fe(kn, o, {
                            name: Fe(br, o, {
                                elements: s.argnames.map(function(e) {
                                    if (e.unused) return Fe(Gr, e);
                                    return e.convert_symbol(zr, g);
                                }),
                                rest: s.rest && s.rest.convert_symbol(zr, g)
                            }),
                            value: Fe(Pn, o, {
                                elements: o.args.slice()
                            })
                        }) ]
                    }));
                }
                v.each(function(e, n) {
                    var t = h[n];
                    [].unshift.apply(t.orig, e);
                    t.eliminated += e.length;
                });
                [].push.apply(d, a ? s.body.filter(function(e) {
                    if (!(e instanceof Ct)) return true;
                    var n = Fe(zr, sn(e.name));
                    var t = n.definition();
                    t.fixed = false;
                    t.orig.push(n);
                    t.eliminated++;
                    d.push(Fe(ur, e, {
                        definitions: [ Fe(kn, e, {
                            name: n,
                            value: we(e, true)
                        }) ]
                    }));
                    return false;
                }) : s.body);
                var _ = Fe(gn, o, {
                    body: d
                });
                if (!e) {
                    if (u) y(_, function(e) {
                        var n = e.value;
                        if (Ie(n)) return;
                        e.value = Fe(_r, o, {
                            expression: n
                        });
                    });
                    d.push(Fe(wn, o, {
                        value: H(i) ? Fe(Wr, o).transform(r) : null
                    }));
                }
                return _;
                function g(e, n) {
                    var t = n.definition();
                    h[t.id] = t;
                    v.add(t.id, e);
                }
            });
            e(Mn, function(e, n, t, r, i) {
                var a = this;
                var o = a.consequent.try_inline(e, n, t, r, i);
                var s = a.alternative.try_inline(e, n, t, r, i);
                if (!o && !s) return;
                return Fe(xn, a, {
                    condition: a.condition,
                    body: o || f(a.consequent),
                    alternative: s || f(a.alternative)
                });
                function f(e) {
                    if (t) return Fe(_n, e, {
                        body: e
                    });
                    return Fe(wn, e, {
                        value: e
                    });
                }
            });
            e(ht, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, true, true);
                if (i) this.body = i;
                var a = this.init;
                if (a) {
                    a = a.try_inline(e, n, true, r);
                    if (a) {
                        this.init = null;
                        if (a instanceof gn) {
                            a.body.push(this);
                            return a;
                        }
                        return Fe(gn, a, {
                            body: [ a, this ]
                        });
                    }
                }
                return i && this;
            });
            e(vt, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, true, true);
                if (i) this.body = i;
                var a = this.object;
                if (a instanceof Tn) {
                    var o = f(e, n, true, r, false, a, 1);
                    if (o) {
                        this.object = a.tail_node();
                        o.body.push(this);
                        return o;
                    }
                }
                return i && this;
            });
            e(xn, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, t, r);
                if (i) this.body = i;
                var a = this.alternative;
                if (a) {
                    a = a.try_inline(e, n, t, r);
                    if (a) this.alternative = a;
                }
                var o = this.condition;
                if (o instanceof Tn) {
                    var s = f(e, n, true, r, false, o, 1);
                    if (s) {
                        this.condition = o.tail_node();
                        s.body.push(this);
                        return s;
                    }
                }
                return (i || a) && this;
            });
            e(ct, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, true, true);
                if (!i) return;
                this.body = i;
                return this;
            });
            e(ut, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, t, r);
                if (!i) return;
                if (this.body instanceof ct && i instanceof gn) {
                    var a = i.body.pop();
                    this.body = a;
                    i.body.push(this);
                    return i;
                }
                this.body = i;
                return this;
            });
            e(hr, Wn);
            e(wn, function(e, n, t, r) {
                var i = this.value;
                return i && i.try_inline(e, n, undefined, r === "try");
            });
            function f(e, n, t, r, i, a, o) {
                var s = [], f = a.expressions, u = t;
                for (var c = f.length - (o || 0), l = c; --c >= 0; u = true, i = false) {
                    var p = f[c].try_inline(e, n, u, r, i);
                    if (!p) continue;
                    d();
                    s.push(p);
                }
                if (s.length == 0) return;
                d();
                if (!t && s[0] instanceof _n) {
                    s[0] = Fe(wn, a, {
                        value: s[0].body
                    });
                }
                return Fe(gn, a, {
                    body: s.reverse()
                });
                function d() {
                    if (l > c + 1) s.push(Fe(_n, a, {
                        body: Pe(a, f.slice(c + 1, l))
                    }));
                    l = c;
                }
            }
            e(Tn, function(e, n, t, r, i) {
                return f(e, n, t, r, i, this);
            });
            e(_n, function(e, n, t, r) {
                var i = this.body;
                while (i instanceof zn) {
                    var a = i.operator;
                    if (si[a]) break;
                    if (a == "void") break;
                    i = i.expression;
                }
                if (!t && !Ie(i)) i = Fe(zn, this, {
                    operator: "void",
                    expression: i
                });
                return i.try_inline(e, n, t || false, r);
            });
            e(zn, function(t, e, n, r, i) {
                var a = this;
                var o = a.operator;
                if (si[o]) return;
                if (!n && o == "void") n = false;
                var s = a.expression.try_inline(t, e, n, r, i);
                if (!s) return;
                if (!n) y(s, function(e) {
                    e.in_bool = false;
                    var n = e.value;
                    if (o == "void" && Ie(n)) return;
                    e.value = Fe(zn, a, {
                        operator: o,
                        expression: n || Fe(Wr, e).transform(t)
                    });
                });
                return s;
            });
            e(gt, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, t, r);
                if (i) this.body = i;
                var a = this.expression;
                if (a instanceof Tn) {
                    var o = f(e, n, true, r, false, a, 1);
                    if (o) {
                        this.expression = a.tail_node();
                        o.body.push(this);
                        return o;
                    }
                }
                return i && this;
            });
            e(gr, function(e, n, t, r) {
                if (!e.option("yields")) return;
                if (!this.nested) return;
                var i = this.expression;
                if (i.TYPE != "Call") return;
                var a = i.expression;
                switch (a.CTOR) {
                  case Ot:
                    a = Fe(qt, a);
                    break;

                  case zt:
                    a = Fe($t, a);
                    break;

                  default:
                    return;
                }
                i = i.clone();
                i.expression = a;
                return i.try_inline(e, n, t, r);
            });
        })(function(e, n) {
            e.DEFMETHOD("try_inline", n);
        });
        e(wn, function(e, n) {
            var t = e.value;
            if (t && n.option("side_effects") && Ie(t, n) && !H(n.find_parent(bn))) {
                e.value = null;
            }
            return e;
        });
    })(function(e, r) {
        e.DEFMETHOD("optimize", function(e) {
            var n = this;
            if (n._optimized) return n;
            if (e.has_directive("use asm")) return n;
            var t = r(n, e);
            t._optimized = true;
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function oe(e) {
        return e.type == "comment2" && /@preserve|@license|@cc_on/i.test(e.value);
    }
    function ci(f) {
        f = we(f, {
            annotations: false,
            ascii_only: false,
            beautify: false,
            braces: false,
            comments: false,
            galio: false,
            ie: false,
            indent_level: 4,
            indent_start: 0,
            inline_script: true,
            keep_quoted_props: false,
            max_line_len: false,
            preamble: null,
            preserve_line: false,
            quote_keys: false,
            quote_style: 0,
            semicolons: true,
            shebang: true,
            source_map: null,
            v8: false,
            webkit: false,
            width: 80,
            wrap_iife: false
        }, true);
        var u = cn;
        if (f.comments) {
            var n = f.comments;
            if (typeof f.comments === "string" && /^\/.*\/[a-zA-Z]*$/.test(f.comments)) {
                var e = f.comments.lastIndexOf("/");
                n = new RegExp(f.comments.substr(1, e - 1), f.comments.substr(e + 1));
            }
            if (n instanceof RegExp) {
                u = function(e) {
                    return e.type != "comment5" && n.test(e.value);
                };
            } else if (typeof n === "function") {
                u = function(e) {
                    return e.type != "comment5" && n(this, e);
                };
            } else if (n === "some") {
                u = oe;
            } else {
                u = ln;
            }
        }
        function t(e) {
            if (typeof e == "number") return new Array(e + 1).join(" ");
            if (!e) return "";
            if (!/^\s*$/.test(e)) throw new Error("unsupported indentation: " + JSON.stringify("" + e));
            return e;
        }
        var c = 0;
        var l = 1;
        var r = t(f.indent_start);
        var i = t(f.indent_level);
        var P = i.length + 1 >> 1;
        var o;
        var s = 0;
        var p = true;
        var d = f.source_map && [];
        var h;
        var v;
        var m;
        var _;
        var g = false;
        var b = false;
        var y;
        var a;
        var w = "";
        function x() {
            o = "";
            m = false;
            _ = false;
            a = [];
            var e = y;
            y = "";
            return e;
        }
        x();
        var k = f.ascii_only ? function(e, t) {
            if (t) e = e.replace(/[\ud800-\udbff][\udc00-\udfff]/g, function(e) {
                return "\\u{" + (e.charCodeAt(0) - 55232 << 10 | e.charCodeAt(1) - 56320).toString(16) + "}";
            });
            return e.replace(/[\u0000-\u001f\u007f-\uffff]/g, function(e) {
                var n = e.charCodeAt(0).toString(16);
                if (n.length <= 2 && !t) {
                    while (n.length < 2) n = "0" + n;
                    return "\\x" + n;
                } else {
                    while (n.length < 4) n = "0" + n;
                    return "\\u" + n;
                }
            });
        } : function(e) {
            var n = "";
            for (var t = 0, r = 0; t < e.length; t++) {
                var i = e.charCodeAt(t);
                if (re(i)) {
                    if (ie(e.charCodeAt(t + 1))) {
                        t++;
                        continue;
                    }
                } else if (!ie(i)) {
                    continue;
                }
                n += e.slice(r, t) + "\\u" + i.toString(16);
                r = t + 1;
            }
            return r == 0 ? e : n + e.slice(r);
        };
        function E(e) {
            return "'" + e.replace(/\x27/g, "\\'") + "'";
        }
        function S(e) {
            return '"' + e.replace(/\x22/g, '\\"') + '"';
        }
        var j = [ null, E, S, function(e, n) {
            return n == "'" ? E(e) : S(e);
        } ][f.quote_style] || function(e, n, t, r) {
            return t > r ? E(e) : S(e);
        };
        function T(t, e) {
            var r = 0, i = 0;
            t = t.replace(/[\\\b\f\n\r\v\t\x22\x27\u2028\u2029\0\ufeff]/g, function(e, n) {
                switch (e) {
                  case '"':
                    ++r;
                    return '"';

                  case "'":
                    ++i;
                    return "'";

                  case "\\":
                    return "\\\\";

                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\\t";

                  case "\b":
                    return "\\b";

                  case "\f":
                    return "\\f";

                  case "\v":
                    return f.ie ? "\\x0B" : "\\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  case "\ufeff":
                    return "\\ufeff";

                  case "\0":
                    return /[0-9]/.test(t.charAt(n + 1)) ? "\\x00" : "\\0";
                }
                return e;
            });
            return j(k(t), e, r, i);
        }
        var N = d ? function(n, t) {
            d.forEach(function(e) {
                e.line += n;
                e.col += t;
            });
        } : Wn;
        var A = d ? function() {
            d.forEach(function(e) {
                f.source_map.add(e.token.file, e.line, e.col, e.token.line, e.token.col, !e.name && e.token.type == "name" ? e.token.value : e.name);
            });
            d = [];
        } : Wn;
        function D(e) {
            w += y.slice(0, s);
            y = y.slice(s);
            var n = y.length;
            N(e, n - c);
            l += e;
            c = n;
            while (e--) w += "\n";
        }
        var q = f.max_line_len ? function(e) {
            if (p) {
                if (c > f.max_line_len) {
                    vn.warn("Output exceeds {max_line_len} characters", f);
                }
                return;
            }
            if (c > f.max_line_len) {
                D(1);
                p = true;
            }
            if (p || e) A();
        } : Wn;
        var I = pn("( [ + * / - , .");
        function O(e, n, t) {
            return ae(e) && (ae(n) || n == "\\") || n == "/" && n == e || (n == "+" || n == "-") && n == o || o == "--" && n == ">" || o == "!" && t == "--" || e == "/" && (t == "in" || t == "instanceof");
        }
        var $ = f.beautify || f.comments || f.max_line_len || f.preserve_line || f.shebang || !f.semicolons || f.source_map || f.width ? function(e) {
            var n = e.charAt(0);
            if (g && n) {
                g = false;
                if (n != "\n") {
                    $("\n");
                    C();
                }
            }
            if (b && n) {
                b = false;
                if (!/[\s;})]/.test(n)) {
                    z();
                }
            }
            var t = o.slice(-1);
            if (_) {
                _ = false;
                if (t == ":" && n == "}" || t != ";" && (!n || ";}".indexOf(n) < 0)) {
                    var r = I[n];
                    if (r || f.semicolons) {
                        y += ";";
                        c++;
                        if (!p) {
                            q();
                            if (p && !r && y == ";") {
                                y = "";
                                c = 0;
                            }
                        }
                        if (s == y.length - 1) s++;
                    } else {
                        q();
                        y += "\n";
                        l++;
                        c = 0;
                        if (/^\s+$/.test(e)) _ = true;
                    }
                    if (!f.beautify) m = false;
                }
            }
            if (m) {
                if (O(t, n, e)) {
                    y += " ";
                    c++;
                }
                if (t != "<" || e != "!") m = false;
            }
            if (v) {
                d.push({
                    token: v,
                    name: h,
                    line: l,
                    col: c
                });
                v = false;
                if (p) A();
            }
            y += e;
            var i = e.split(/\r?\n/), a = i.length - 1;
            l += a;
            c += i[0].length;
            if (a > 0) {
                q();
                c = i[a].length;
            }
            o = e;
        } : function(e) {
            var n = e.charAt(0);
            var t = o.slice(-1);
            if (_) {
                _ = false;
                if (t == ":" && n == "}" || (!n || ";}".indexOf(n) < 0) && t != ";") {
                    y += ";";
                    m = false;
                }
            }
            if (m) {
                if (O(t, n, e)) y += " ";
                if (t != "<" || e != "!") m = false;
            }
            y += e;
            o = e;
        };
        var z = f.beautify ? function() {
            $(" ");
        } : function() {
            m = true;
        };
        var C = f.beautify ? function(e) {
            if (g) $("\n");
            $(e ? r.slice(0, -P) : r);
        } : Wn;
        var H = f.beautify ? function(e) {
            var n = r;
            r += i;
            e();
            r = n;
        } : function(e) {
            e();
        };
        var M = f.max_line_len || f.preserve_line ? function() {
            q();
            s = y.length;
            p = false;
        } : Wn;
        var Y = f.beautify ? function() {
            $("\n");
            s = y.length;
        } : M;
        var R = f.beautify ? function() {
            $(";");
        } : function() {
            _ = true;
        };
        function B() {
            if (_) $(";");
            $(";");
        }
        function L(e, n) {
            $("{");
            Y();
            H(e);
            J(n);
            C();
            $("}");
        }
        function U(e) {
            $("(");
            M();
            e();
            M();
            $(")");
        }
        function V(e) {
            $("[");
            M();
            e();
            M();
            $("]");
        }
        function W() {
            M();
            $(",");
            M();
            z();
        }
        function G() {
            $(":");
            z();
        }
        var J = d ? function(e, n) {
            v = e;
            h = n;
        } : Wn;
        function X() {
            if (!p) q(true);
            return w + y;
        }
        function K() {
            return /(^|\n) *$/.test(y);
        }
        function F(e, n) {
            if (g) return;
            if (e.nlb && (n || !K())) {
                g = true;
            } else if (n) {
                b = true;
            }
        }
        function Q(e) {
            var n = e.value.replace(/[@#]__PURE__/g, " ");
            if (/^\s*$/.test(n) && !/^\s*$/.test(e.value)) return false;
            if (/comment[134]/.test(e.type)) {
                $("//" + n);
                g = true;
            } else if (e.type == "comment2") {
                $("/*" + n + "*/");
            }
            return true;
        }
        function Z(e, n) {
            if (n instanceof Cn) return n.left === e;
            if (n.TYPE == "Call") return n.expression === e;
            if (n instanceof Mn) return n.condition === e;
            if (n instanceof Dn) return n.expression === e;
            if (n instanceof Gt) return true;
            if (n instanceof Tn) return n.expressions[0] === e;
            if (n instanceof qn) return n.expression === e;
            if (n instanceof mr) return true;
            if (n instanceof gr) return true;
        }
        function ee(e) {
            var r = this;
            var i;
            if (e instanceof Gt) {
                i = e.value;
            } else if (e instanceof gr) {
                i = e.expression;
            }
            var t = s(e);
            if (!t) t = [];
            if (i) {
                var a = new Ln(function(e) {
                    if (!Z(e, a.parent())) return true;
                    var n = s(e);
                    if (n) t = t.concat(n);
                });
                a.push(e);
                i.walk(a);
            }
            if (l == 1 && c == 0) {
                if (t.length > 0 && f.shebang && t[0].type == "comment5") {
                    $("#!" + t.shift().value + "\n");
                    C();
                }
                var n = f.preamble;
                if (n) $(n.replace(/\r\n?|\u2028|\u2029|(^|\S)\s*$/g, "$1\n"));
            }
            t = t.filter(u, e);
            var o = false;
            t.forEach(function(e, n) {
                F(e, n);
                if (Q(e)) o = true;
            });
            if (o) F(e.start, true);
            function s(e) {
                var n = e.start;
                if (!n) {
                    if (!i) return;
                    e.start = n = new te();
                }
                var t = n.comments_before;
                if (!t) {
                    if (!i) return;
                    n.comments_before = t = [];
                }
                if (t._dumped === r) return;
                t._dumped = r;
                return t;
            }
        }
        function ne(e, t) {
            var n = this;
            var r = e.end;
            if (!r) return;
            var i = r[t ? "comments_before" : "comments_after"];
            if (!i || i._dumped === n) return;
            if (!(e instanceof tt || dn(i, function(e) {
                return !/comment[134]/.test(e.type);
            }))) return;
            i._dumped = n;
            i.filter(u, e).forEach(function(e, n) {
                F(e, n || !t);
                Q(e);
            });
        }
        return {
            get: X,
            reset: x,
            indent: C,
            should_break: f.beautify && f.width ? function() {
                return c >= f.width;
            } : cn,
            has_parens: function() {
                return o.slice(-1) == "(";
            },
            newline: Y,
            print: $,
            space: z,
            comma: W,
            colon: G,
            last: function() {
                return o;
            },
            semicolon: R,
            force_semicolon: B,
            to_utf8: k,
            print_name: function(e) {
                $(k(e.toString(), true));
            },
            print_string: f.inline_script ? function(e, n) {
                e = T(e, n).replace(/<\x2f(script)([>\/\t\n\f\r ])/gi, "<\\/$1$2");
                $(e.replace(/\x3c!--/g, "\\x3c!--").replace(/--\x3e/g, "--\\x3e"));
            } : function(e, n) {
                $(T(e, n));
            },
            with_indent: H,
            with_block: L,
            with_parens: U,
            with_square: V,
            add_mapping: J,
            option: function(e) {
                return f[e];
            },
            prepend_comments: f.comments || f.shebang ? ee : Wn,
            append_comments: f.comments ? ne : Wn,
            push_node: function(e) {
                a.push(e);
            },
            pop_node: f.preserve_line ? function() {
                var e = a.pop();
                if (e.start && e.start.line > l) {
                    D(e.start.line - l);
                }
            } : function() {
                a.pop();
            },
            parent: function(e) {
                return a[a.length - 2 - (e || 0)];
            }
        };
    }
    (function() {
        function e(e, n) {
            e.DEFMETHOD("_codegen", n);
        }
        var s = false;
        vn.DEFMETHOD("print", function(e, n) {
            var t = this;
            e.push_node(t);
            if (n || t.needs_parens(e)) {
                e.with_parens(r);
            } else {
                r();
            }
            e.pop_node();
            function r() {
                e.prepend_comments(t);
                t.add_source_map(e);
                t._codegen(e);
                e.append_comments(t);
            }
        });
        var t = ci({
            inline_script: false,
            shebang: false,
            width: false
        });
        vn.DEFMETHOD("print_to_string", function(e) {
            if (e) {
                var n = ci(e);
                this.print(n);
                return n.get();
            }
            this.print(t);
            return t.reset();
        });
        function n(e, n) {
            e.DEFMETHOD("needs_parens", n);
        }
        n(vn, cn);
        function r(e) {
            var n = e.parent();
            if (!e.has_parens() && nt(e, false, true)) {
                return this.name || !(n instanceof lr);
            }
            if (e.option("webkit") && n instanceof An && n.expression === this) return true;
            if (e.option("wrap_iife") && n instanceof Sn && n.expression === this) return true;
        }
        n(qt, r);
        n(Ot, r);
        n(Ht, r);
        n($t, r);
        n(zt, r);
        function i(e) {
            return !e.has_parens() && nt(e, true);
        }
        n(Nn, i);
        function a(e) {
            var n = e.parent();
            if (n instanceof Cn) return n.operator == "**" && n.left === this;
            if (n instanceof Sn) return n.expression === this;
            if (n instanceof Nt) return true;
            if (n instanceof An) return n.expression === this;
            if (n instanceof Rr) return n.tag === this;
        }
        n(_r, a);
        n($n, a);
        n(Tn, function(e) {
            var n = e.parent();
            return n instanceof Pn || kt(n) && n.value === this || n instanceof _r || n instanceof Cn || n instanceof Sn || n instanceof Nt || n instanceof Yt || n instanceof Mn || n instanceof En || n instanceof yr || n instanceof lr || n instanceof xe || n instanceof xr || n instanceof An && n.expression === this || n instanceof On || n instanceof Rr && n.tag === this || n instanceof $n || n instanceof kn || n instanceof gr;
        });
        n(Cn, function(e) {
            var n = e.parent();
            if (n instanceof _r) return true;
            if (n instanceof Cn) {
                var t = n.operator, r = ii[t];
                var i = this.operator, a = ii[i];
                return r > a || t == "??" && (i == "&&" || i == "||") || r == a && this === n[t == "**" ? "left" : "right"];
            }
            if (n instanceof Sn) return n.expression === this;
            if (n instanceof Nt) return true;
            if (n instanceof An) return n.expression === this;
            if (n instanceof Rr) return n.tag === this;
            if (n instanceof $n) return true;
        });
        function o(e, n) {
            if (!e.terminal) return false;
            if (!(n instanceof Sn || n instanceof An)) return false;
            return n.expression === e;
        }
        n(An, function(e) {
            var n = this;
            var t = e.parent();
            if (t instanceof hr && t.expression === n && vr(n).TYPE == "Call") return true;
            return o(n, t);
        });
        n(Sn, function(e) {
            var n = this;
            var t = e.parent();
            if (t instanceof hr) return t.expression === n;
            if (e.option("webkit") && n.expression instanceof $t && t instanceof An && t.expression === n) {
                var r = e.parent(1);
                if (r instanceof Fn && r.left === t) return true;
            }
            return o(n, t);
        });
        n(hr, function(e) {
            if (z(this, e)) return false;
            var n = e.parent();
            if (n instanceof Sn) return n.expression === this;
            if (n instanceof An) return true;
            if (n instanceof Rr) return n.tag === this;
        });
        n(Bn, function(e) {
            if (!e.option("galio")) return false;
            var n = e.parent();
            return n instanceof An && n.expression === this && /^0/.test(C(this.value));
        });
        function f(e, n) {
            var t = n.parent();
            if (t instanceof _r) return true;
            if (t instanceof Cn) return !(t instanceof Fn);
            if (t instanceof Sn) return t.expression === e;
            if (t instanceof Nt) return true;
            if (t instanceof Mn) return t.condition === e;
            if (t instanceof An) return t.expression === e;
            if (t instanceof Rr) return t.tag === e;
            if (t instanceof $n) return true;
        }
        n(At, function(e) {
            return f(this, e);
        });
        n(Fn, function(e) {
            if (f(this, e)) return true;
            if (e.option("v8")) return this.left instanceof jn;
            if (this.left instanceof wr) return i(e);
        });
        n(Dt, function(e) {
            return f(this, e);
        });
        n(Mn, function(e) {
            return f(this, e);
        });
        n(gr, function(e) {
            return f(this, e);
        });
        e(it, function(e) {
            var n = this.quote;
            var t = this.value;
            switch (e.option("quote_style")) {
              case 0:
              case 2:
                if (t.indexOf('"') == -1) n = '"';
                break;

              case 1:
                if (t.indexOf("'") == -1) n = "'";
                break;
            }
            e.print(n + t + n);
            e.semicolon();
        });
        e(rt, function(e) {
            e.print("debugger");
            e.semicolon();
        });
        function u(e, t, r, n) {
            var i = e.length - 1;
            var a = n;
            var o = s;
            e.forEach(function(e, n) {
                if (a) {
                    if (e instanceof it) {
                        if (e.value == "use asm") s = true;
                    } else if (!(e instanceof mn)) {
                        if (e instanceof _n && e.body instanceof Rn) {
                            r.force_semicolon();
                        }
                        a = false;
                    }
                }
                if (e instanceof mn) return;
                r.indent();
                e.print(r);
                if (n == i && t) return;
                r.newline();
                if (t) r.newline();
            });
            s = o;
        }
        e(bt, function(e) {
            u(this.body, true, e, true);
            e.print("");
        });
        e(ut, function(e) {
            this.label.print(e);
            e.colon();
            this.body.print(e);
        });
        e(_n, function(e) {
            this.body.print(e);
            e.semicolon();
        });
        function c(e, n) {
            n.print("{");
            n.with_indent(function() {
                n.append_comments(e, true);
            });
            n.print("}");
        }
        function l(e, n, t) {
            if (e.body.length > 0) {
                n.with_block(function() {
                    u(e.body, false, n, t);
                }, e.end);
            } else c(e, n);
        }
        e(gn, function(e) {
            l(this, e);
        });
        e(mn, function(e) {
            e.semicolon();
        });
        e(pt, function(e) {
            var n = this;
            e.print("do");
            M(n.body, e);
            e.space();
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.semicolon();
        });
        e(dt, function(e) {
            var n = this;
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            $(n.body, e);
        });
        e(ht, function(e) {
            var n = this;
            e.print("for");
            e.space();
            e.with_parens(function() {
                if (n.init) {
                    if (n.init instanceof or) {
                        n.init.print(e);
                    } else {
                        E(n.init, e, true);
                    }
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.condition) {
                    n.condition.print(e);
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.step) {
                    n.step.print(e);
                }
            });
            $(n.body, e);
        });
        function p(t, r) {
            return function(e) {
                var n = this;
                e.print(t);
                e.space();
                e.with_parens(function() {
                    n.init.print(e);
                    e.space();
                    e.print(r);
                    e.space();
                    n.object.print(e);
                });
                $(n.body, e);
            };
        }
        e(_t, p("for await", "of"));
        e(mt, p("for", "in"));
        e(xe, p("for", "of"));
        e(gt, function(e) {
            var n = this;
            e.print("with");
            e.space();
            e.with_parens(function() {
                n.expression.print(e);
            });
            $(n.body, e);
        });
        e(cr, function(e) {
            e.print("export");
            e.space();
            this.body.print(e);
        });
        e(lr, function(e) {
            e.print("export");
            e.space();
            e.print("default");
            e.space();
            var n = this.body;
            n.print(e);
            if (n instanceof Ht) {
                if (!n.name) return;
            }
            if (n instanceof It) return;
            if (n instanceof Ct) return;
            if (n instanceof xt) {
                if (!n.name && !kt(n)) return;
            }
            e.semicolon();
        });
        function d(e, n) {
            var t = e.value;
            if (t == "*" || ei(t)) {
                n.print_name(t);
            } else {
                n.print_string(t, e.quote);
            }
        }
        e(ke, function(r) {
            var i = this;
            r.print("export");
            r.space();
            var n = i.keys.length;
            if (n == 0) {
                c(i, r);
            } else if (i.keys[0].value == "*") {
                t(0);
            } else r.with_block(function() {
                r.indent();
                t(0);
                for (var e = 1; e < n; e++) {
                    r.print(",");
                    r.newline();
                    r.indent();
                    t(e);
                }
                r.newline();
            }, i.end);
            r.space();
            r.print("from");
            r.space();
            i.path.print(r);
            r.semicolon();
            function t(e) {
                var n = i.aliases[e];
                var t = i.keys[e];
                d(t, r);
                if (n.value != t.value) {
                    r.space();
                    r.print("as");
                    r.space();
                    d(n, r);
                }
            }
        });
        e(pr, function(e) {
            var n = this;
            e.print("export");
            e.space();
            A(n, e);
            e.semicolon();
        });
        e(dr, function(e) {
            var n = this;
            e.print("import");
            e.space();
            if (n.default) n.default.print(e);
            if (n.all) {
                if (n.default) e.comma();
                n.all.print(e);
            }
            if (n.properties) {
                if (n.default) e.comma();
                A(n, e);
            }
            if (n.all || n.default || n.properties) {
                e.space();
                e.print("from");
                e.space();
            }
            n.path.print(e);
            e.semicolon();
        });
        function h(e, t) {
            t.with_parens(function() {
                e.argnames.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                if (e.rest) {
                    if (e.argnames.length) t.comma();
                    t.print("...");
                    e.rest.print(t);
                }
            });
        }
        function v(e, n) {
            var t = e.argnames.length == 1 && !e.rest && e.argnames[0];
            if (t instanceof In && t.name != "yield") {
                t.print(n);
            } else {
                h(e, n);
            }
            n.space();
            n.print("=>");
            n.space();
            if (e.value) {
                e.value.print(n);
            } else {
                l(e, n, true);
            }
        }
        e(At, function(e) {
            v(this, e);
        });
        e(Dt, function(e) {
            e.print("async");
            e.space();
            v(this, e);
        });
        function m(e, n) {
            if (e.name) {
                n.space();
                e.name.print(n);
            }
            h(e, n);
            n.space();
            l(e, n, true);
        }
        e(yn, function(e) {
            e.print("function");
            m(this, e);
        });
        function _(e) {
            e.print("async");
            e.space();
            e.print("function");
            m(this, e);
        }
        e(Mt, _);
        e(qt, _);
        function g(e) {
            e.print("async");
            e.space();
            e.print("function*");
            m(this, e);
        }
        e(Ft, g);
        e(Ot, g);
        function b(e) {
            e.print("function*");
            m(this, e);
        }
        e(jt, b);
        e(zt, b);
        e(Nt, function(e) {
            var n = this;
            e.print("class");
            if (n.name) {
                e.space();
                n.name.print(e);
            }
            if (n.extends) {
                e.space();
                e.print("extends");
                e.space();
                n.extends.print(e);
            }
            e.space();
            A(n, e, true);
        });
        e(Rt, function(e) {
            var n = this;
            if (n.static) {
                e.print("static");
                e.space();
            }
            D(n, e);
            if (n.value) {
                e.space();
                e.print("=");
                e.space();
                n.value.print(e);
            }
            e.semicolon();
        });
        e(Bt, q("get"));
        e(Lt, q("set"));
        function y(e, n) {
            var t = e.value;
            if (Et(t)) {
                n.print("async");
                n.space();
            }
            if (St(t)) n.print("*");
            D(e, n);
            m(e.value, n);
        }
        e(Ut, function(e) {
            var n = this;
            if (n.static) {
                e.print("static");
                e.space();
            }
            y(n, e);
        });
        e(Vt, function(e) {
            e.print("static");
            e.space();
            l(this.value, e);
        });
        function w(t, r) {
            return function(e) {
                e.print(t);
                var n = this[r];
                if (n) {
                    e.space();
                    n.print(e);
                }
                e.semicolon();
            };
        }
        e(wn, w("return", "value"));
        e(Jt, w("throw", "value"));
        e(Kt, w("break", "label"));
        e(Qt, w("continue", "label"));
        function P(e, n) {
            var t = e.body;
            if (n.option("braces") && !(t instanceof sr || t instanceof fr) || n.option("ie") && t instanceof pt) return M(t, n);
            if (!t) return n.force_semicolon();
            while (true) {
                if (t instanceof xn) {
                    if (!t.alternative) {
                        M(e.body, n);
                        return;
                    }
                    t = t.alternative;
                } else if (t instanceof N) {
                    t = t.body;
                } else break;
            }
            $(e.body, n);
        }
        e(xn, function(e) {
            var n = this;
            e.print("if");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            if (n.alternative) {
                P(n, e);
                e.space();
                e.print("else");
                if (n.alternative instanceof xn) {
                    e.space();
                    n.alternative.print(e);
                } else {
                    $(n.alternative, e);
                }
            } else {
                $(n.body, e);
            }
        });
        e(Zt, function(t) {
            var e = this;
            t.print("switch");
            t.space();
            t.with_parens(function() {
                e.expression.print(t);
            });
            t.space();
            var r = e.body.length - 1;
            if (r < 0) c(e, t); else t.with_block(function() {
                e.body.forEach(function(e, n) {
                    t.indent(true);
                    e.print(t);
                    if (n < r && e.body.length > 0) t.newline();
                });
            }, e.end);
        });
        function x(e, n) {
            n.newline();
            e.body.forEach(function(e) {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        e(nr, function(e) {
            e.print("default:");
            x(this, e);
        });
        e(tr, function(e) {
            var n = this;
            e.print("case");
            e.space();
            n.expression.print(e);
            e.print(":");
            x(n, e);
        });
        e(rr, function(e) {
            var n = this;
            e.print("try");
            e.space();
            l(n, e);
            if (n.bcatch) {
                e.space();
                n.bcatch.print(e);
            }
            if (n.bfinally) {
                e.space();
                n.bfinally.print(e);
            }
        });
        e(ir, function(e) {
            var n = this;
            e.print("catch");
            if (n.argname) {
                e.space();
                e.with_parens(function() {
                    n.argname.print(e);
                });
            }
            e.space();
            l(n, e);
        });
        e(ar, function(e) {
            e.print("finally");
            e.space();
            l(this, e);
        });
        function k(r) {
            return function(t) {
                var e = this;
                t.print(r);
                t.space();
                e.definitions.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                var n = t.parent();
                if (!(n instanceof ct && n.init === e)) t.semicolon();
            };
        }
        e(sr, k("const"));
        e(fr, k("let"));
        e(ur, k("var"));
        function E(e, n, t) {
            var r = false;
            if (t) e.walk(new Ln(function(e) {
                if (r) return true;
                if (e instanceof Cn && e.operator == "in") return r = true;
                if (e instanceof bn && !(kt(e) && e.value)) return true;
            }));
            e.print(n, r);
        }
        e(kn, function(e) {
            var n = this;
            n.name.print(e);
            if (n.value) {
                e.space();
                e.print("=");
                e.space();
                var t = e.parent(1);
                var r = t instanceof ht || t instanceof vt;
                E(n.value, e, r);
            }
        });
        e(En, function(e) {
            var n = this;
            n.name.print(e);
            e.space();
            e.print("=");
            e.space();
            n.value.print(e);
        });
        function S(e, n) {
            if (!n.option("annotations")) return;
            if (!e.pure) return;
            var t = 0, r = e, i;
            do {
                i = r;
                r = n.parent(t++);
                if (r instanceof Sn && r.expression === i) return;
            } while (r instanceof An && r.expression === i);
            n.print("/*@__PURE__*/");
        }
        function T(e, t) {
            t.with_parens(function() {
                e.args.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                t.add_mapping(e.end);
            });
        }
        e(Sn, function(e) {
            var n = this;
            S(n, e);
            n.expression.print(e);
            if (n.optional) e.print("?.");
            T(n, e);
        });
        e(hr, function(e) {
            var n = this;
            S(n, e);
            e.print("new");
            e.space();
            n.expression.print(e);
            if (z(n, e)) T(n, e);
        });
        e(Tn, function(t) {
            this.expressions.forEach(function(e, n) {
                if (n > 0) {
                    t.comma();
                    if (t.should_break()) {
                        t.newline();
                        t.indent();
                    }
                }
                e.print(t);
            });
        });
        e(Dn, function(e) {
            var n = this;
            var t = n.expression;
            t.print(e);
            var r = n.property;
            if (e.option("ie") && I[r]) {
                if (n.optional) e.print("?.");
                e.with_square(function() {
                    e.add_mapping(n.end);
                    e.print_string(r);
                });
            } else {
                if (t instanceof Bn && !/[ex.)]/i.test(e.last())) e.print(".");
                e.print(n.optional ? "?." : ".");
                e.add_mapping(n.end);
                e.print_name(r);
            }
        });
        e(qn, function(e) {
            var n = this;
            n.expression.print(e);
            if (n.optional) e.print("?.");
            e.with_square(function() {
                n.property.print(e);
            });
        });
        e(On, function(e) {
            e.print("...");
            this.expression.print(e);
        });
        e(zn, function(e) {
            var n = this.operator;
            var t = this.expression;
            e.print(n);
            if (/^[a-z]/i.test(n) || /[+-]$/.test(n) && t instanceof zn && /^[+-]/.test(t.operator)) {
                e.space();
            }
            t.print(e);
        });
        e(mr, function(e) {
            var n = this;
            n.expression.print(e);
            e.add_mapping(n.end);
            e.print(n.operator);
        });
        e(Cn, function(e) {
            var n = this;
            n.left.print(e);
            e.space();
            e.print(n.operator);
            e.space();
            n.right.print(e);
        });
        e(Mn, function(e) {
            var n = this;
            n.condition.print(e);
            e.space();
            e.print("?");
            e.space();
            n.consequent.print(e);
            e.space();
            e.colon();
            n.alternative.print(e);
        });
        e(_r, function(e) {
            e.print("await");
            e.space();
            this.expression.print(e);
        });
        e(gr, function(e) {
            e.print(this.nested ? "yield*" : "yield");
            if (this.expression) {
                e.space();
                this.expression.print(e);
            }
        });
        e(Pn, function(t) {
            var e = this.elements, r = e.length;
            t.with_square(r > 0 ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                    if (n === r - 1 && e instanceof Gr) t.comma();
                });
                t.space();
            } : Wn);
        });
        e(br, function(t) {
            var e = this.elements, n = e.length, r = this.rest;
            t.with_square(n || r ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                if (r) {
                    if (n) t.comma();
                    t.print("...");
                    r.print(t);
                } else if (e[n - 1] instanceof Gr) {
                    t.comma();
                }
                t.space();
            } : Wn);
        });
        e(yr, function(e) {
            var n = this;
            var t = D(n, e);
            var r = n.value;
            if (t) {
                if (r instanceof En) {
                    if (r.name instanceof Ar && t == O(r.name)) {
                        e.space();
                        e.print("=");
                        e.space();
                        r.value.print(e);
                        return;
                    }
                } else if (r instanceof Ar) {
                    if (t == O(r)) return;
                }
            }
            e.colon();
            r.print(e);
        });
        e(wr, function(t) {
            var e = this;
            var n = e.properties, r = n.length, i = e.rest;
            if (r || i) t.with_block(function() {
                n.forEach(function(e, n) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                if (i) {
                    if (r) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    t.print("...");
                    i.print(t);
                }
                t.newline();
            }, e.end); else c(e, t);
        });
        function A(e, t, r) {
            var n = e.properties;
            if (n.length > 0) t.with_block(function() {
                n.forEach(function(e, n) {
                    if (n) {
                        if (!r) t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                t.newline();
            }, e.end); else c(e, t);
        }
        e(Nn, function(e) {
            A(this, e);
        });
        function D(e, n) {
            var t = e.key;
            if (t instanceof vn) return n.with_square(function() {
                t.print(n);
            });
            var r = e.start && e.start.quote;
            if (n.option("quote_keys") || r && n.option("keep_quoted_props")) {
                n.print_string(t, r);
            } else if ("" + +t == t && t >= 0) {
                n.print(C(t));
            } else if (e.private) {
                n.print_name(t);
            } else if (I[t] ? !n.option("ie") : ei(t)) {
                n.print_name(t);
                return t;
            } else {
                n.print_string(t, r);
            }
        }
        e(kr, function(e) {
            var n = this;
            D(n, e);
            e.colon();
            n.value.print(e);
        });
        e(Er, function(e) {
            y(this, e);
        });
        function q(t) {
            return function(e) {
                var n = this;
                if (n.static) {
                    e.print("static");
                    e.space();
                }
                e.print(t);
                e.space();
                D(n, e);
                m(n.value, e);
            };
        }
        e(Tr, q("get"));
        e(Sr, q("set"));
        function O(e) {
            var n = e.definition();
            return n && n.mangled_name || e.name;
        }
        e(Ar, function(e) {
            e.print_name(O(this));
        });
        e(jr, function(e) {
            var n = this;
            var t = O(n);
            e.print_name(t);
            var r = n.alias;
            if (r.value != t) {
                e.space();
                e.print("as");
                e.space();
                d(r, e);
            }
        });
        e(Or, function(e) {
            var n = this;
            var t = O(n);
            var r = n.key;
            if (r.value && r.value != t) {
                d(r, e);
                e.space();
                e.print("as");
                e.space();
            }
            e.print_name(t);
        });
        e(Gr, Wn);
        e(Rr, function(e) {
            var n = this;
            if (n.tag) n.tag.print(e);
            e.print("`");
            for (var t = 0; t < n.expressions.length; t++) {
                e.print(n.strings[t]);
                e.print("${");
                n.expressions[t].print(e);
                e.print("}");
            }
            e.print(n.strings[t]);
            e.print("`");
        });
        e(Yn, function(e) {
            e.print("" + this.value);
        });
        e(Rn, function(e) {
            e.print_string(this.value, this.quote);
        });
        e(Bn, function(e) {
            var n = this.start;
            if (s && n && n.raw != null) {
                e.print(n.raw);
            } else {
                e.print(C(this.value));
            }
        });
        e(Lr, function(e) {
            var n = this.value;
            var t = n.toString();
            var r = t.lastIndexOf("/");
            if (n.raw_source) {
                t = "/" + n.raw_source + t.slice(r);
            } else if (r == 1) {
                t = "/(?:)" + t.slice(r);
            } else if (t.indexOf("/", 1) < r) {
                t = "/" + t.slice(1, r).replace(/\\\\|[^/]?\//g, function(e) {
                    return e[0] == "\\" ? e : e.slice(0, -1) + "\\/";
                }) + t.slice(r);
            }
            e.print(e.to_utf8(t).replace(/\\(?:\0(?![0-9])|[^\0])/g, function(e) {
                switch (e[1]) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\t";

                  case "\b":
                    return "\b";

                  case "\f":
                    return "\f";

                  case "\0":
                    return "\0";

                  case "\v":
                    return "\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  default:
                    return e;
                }
            }).replace(/[\n\r\u2028\u2029]/g, function(e) {
                switch (e) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";
                }
            }));
        });
        function $(e, n) {
            if (n.option("braces") && !(e instanceof sr || e instanceof fr)) {
                M(e, n);
            } else if (e instanceof mn) {
                n.force_semicolon();
            } else {
                n.space();
                e.print(n);
            }
        }
        function z(e, n) {
            if (e.args.length > 0) return true;
            return n.option("beautify");
        }
        function j(e) {
            var n = e[0], t = n.length;
            for (var r = 1; r < e.length; ++r) {
                if (e[r].length < t) {
                    n = e[r];
                    t = n.length;
                }
            }
            return n;
        }
        function C(e) {
            var n = e.toString(10).replace(/^0\./, ".").replace("e+", "e");
            var t = [ n ];
            if (Math.floor(e) === e) {
                if (e < 0) {
                    t.push("-0x" + (-e).toString(16).toLowerCase());
                } else {
                    t.push("0x" + e.toString(16).toLowerCase());
                }
            }
            var r, i, a;
            if (r = /^\.0+/.exec(n)) {
                i = r[0].length;
                a = n.slice(i);
                t.push(a + "e-" + (a.length + i - 1));
            } else if (r = /[^0]0+$/.exec(n)) {
                i = r[0].length - 1;
                t.push(n.slice(0, -i) + "e" + i);
            } else if (r = /^(\d)\.(\d+)e(-?\d+)$/.exec(n)) {
                t.push(r[1] + r[2] + "e" + (r[3] - r[2].length));
            }
            return j(t);
        }
        function M(e, n) {
            n.space();
            if (e instanceof mn) {
                c(e, n);
            } else if (e instanceof gn) {
                e.print(n);
            } else n.with_block(function() {
                n.indent();
                e.print(n);
                n.newline();
            }, e.end);
        }
        function F(e, n) {
            e.forEach(function(e) {
                e.DEFMETHOD("add_source_map", n);
            });
        }
        F([ vn, ut ], Wn);
        F([ Pn, _r, gn, ir, Yn, rt, or, jn, it, ar, Wt, yn, hr, Nn, On, N, Ar, Zt, er, rr, zn, gr ], function(e) {
            e.add_mapping(this.start);
        });
        F([ Yt, yr, xr ], function(e) {
            if (typeof this.key == "string") e.add_mapping(this.start, this.key);
        });
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var D = n("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/");
    var q = D.reduce(function(e, n, t) {
        e[n] = t;
        return e;
    }, Object.create(null));
    function O(e, n) {
        var t = 0;
        var r = 0;
        for (var i = 0, a = 0; i < n.length; i++) {
            var o = q[n[i]];
            t += (o & 31) << r;
            if (o & 32) {
                r += 5;
            } else {
                e[a++] += t & 1 ? 2147483648 | -(t >> 1) : t >> 1;
                t = r = 0;
            }
        }
        return a;
    }
    function $(e) {
        var n = "";
        e = Math.abs(e) << 1 | e >>> 31;
        do {
            var t = e & 31;
            if (e >>>= 5) t |= 32;
            n += D[t];
        } while (e);
        return n;
    }
    function z() {
        var t = new hn();
        var r = [];
        r.index = function(e) {
            var n = t.get(e);
            if (!(n >= 0)) {
                n = r.length;
                r.push(e);
                t.set(e, n);
            }
            return n;
        };
        return r;
    }
    function W(l) {
        var f = z();
        var a = l.includeSources && new hn();
        var u = z();
        var c = "";
        if (l.orig) Object.keys(l.orig).forEach(function(e) {
            var n = l.orig[e];
            var t = [ 0, 0, 1, 0, 0 ];
            l.orig[e] = {
                names: n.names,
                mappings: n.mappings.split(/;/).map(function(e) {
                    t[0] = 0;
                    return e.split(/,/).map(function(e) {
                        return t.slice(0, O(t, e));
                    });
                }),
                sources: n.sources
            };
            if (!a || !n.sourcesContent) return;
            for (var r = 0; r < n.sources.length; r++) {
                var i = n.sourcesContent[r];
                if (i) a.set(n.sources[r], i);
            }
        });
        var p;
        var d = 1;
        var h = 0;
        var v = 0;
        var m = 1;
        var _ = 0;
        var g = 0;
        return {
            add: l.orig ? function(e, n, t, r, i, a) {
                var o = l.orig[e];
                if (o) {
                    var s = o.mappings[r - 1];
                    if (!s) return;
                    var f;
                    for (var u = 0; u < s.length; u++) {
                        var c = s[u][0];
                        if (i >= c) f = s[u];
                        if (i <= c) break;
                    }
                    if (!f || f.length < 4) {
                        e = null;
                    } else {
                        e = o.sources[f[1]];
                        r = f[2];
                        i = f[3];
                        if (f.length > 4) a = o.names[f[4]];
                    }
                }
                b(e, n, t, r, i, a);
            } : b,
            setSourceContent: a ? function(e, n) {
                if (!a.has(e)) {
                    a.set(e, n);
                }
            } : Wn,
            toString: function() {
                return JSON.stringify({
                    version: 3,
                    file: l.filename || undefined,
                    sourceRoot: l.root || undefined,
                    sources: f,
                    sourcesContent: a ? f.map(function(e) {
                        return a.get(e) || null;
                    }) : undefined,
                    names: u,
                    mappings: c
                });
            }
        };
        function b(e, n, t, r, i, a) {
            if (p == null && e == null) return;
            p = e;
            if (d < n) {
                h = 0;
                do {
                    c += ";";
                } while (++d < n);
            } else if (c) {
                c += ",";
            }
            c += $(t - h);
            h = t;
            if (e == null) return;
            var o = f.index(e);
            c += $(o - v);
            v = o;
            c += $(r - m);
            m = r;
            c += $(i - _);
            _ = i;
            if (l.names && a != null) {
                var s = u.index(a);
                c += $(s - g);
                g = s;
            }
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    (function() {
        var r = {
            Program: function(e) {
                return new bt({
                    start: s(e),
                    end: f(e),
                    body: a(e.body.map(l))
                });
            },
            ArrowFunctionExpression: function(e) {
                var n = [], t = null;
                e.params.forEach(function(e) {
                    if (e.type == "RestElement") {
                        t = l(e.argument);
                    } else {
                        n.push(l(e));
                    }
                });
                var r = new (e.async ? Dt : At)({
                    start: s(e),
                    end: f(e),
                    argnames: n,
                    rest: t
                });
                var i = l(e.body);
                if (i instanceof gn) {
                    r.body = a(i.body);
                    r.value = null;
                } else {
                    r.body = [];
                    r.value = i;
                }
                return r;
            },
            FunctionDeclaration: function(e) {
                var n;
                if (e.async) {
                    n = e.generator ? Ft : Mt;
                } else {
                    n = e.generator ? jt : Pt;
                }
                var t = [], r = null;
                e.params.forEach(function(e) {
                    if (e.type == "RestElement") {
                        r = l(e.argument);
                    } else {
                        t.push(l(e));
                    }
                });
                return new n({
                    start: s(e),
                    end: f(e),
                    name: l(e.id),
                    argnames: t,
                    rest: r,
                    body: a(l(e.body).body)
                });
            },
            FunctionExpression: function(e) {
                var n;
                if (e.async) {
                    n = e.generator ? Ot : qt;
                } else {
                    n = e.generator ? zt : $t;
                }
                var t = [], r = null;
                e.params.forEach(function(e) {
                    if (e.type == "RestElement") {
                        r = l(e.argument);
                    } else {
                        t.push(l(e));
                    }
                });
                return new n({
                    start: s(e),
                    end: f(e),
                    name: l(e.id),
                    argnames: t,
                    rest: r,
                    body: a(l(e.body).body)
                });
            },
            ClassDeclaration: function(e) {
                return new It({
                    start: s(e),
                    end: f(e),
                    name: l(e.id),
                    extends: l(e.superClass),
                    properties: e.body.body.map(l)
                });
            },
            ClassExpression: function(e) {
                return new Ht({
                    start: s(e),
                    end: f(e),
                    name: l(e.id),
                    extends: l(e.superClass),
                    properties: e.body.body.map(l)
                });
            },
            MethodDefinition: function(e) {
                var n = e.key, t = false;
                if (e.computed) {
                    n = l(n);
                } else if (n.type == "PrivateIdentifier") {
                    t = true;
                    n = "#" + n.name;
                } else {
                    n = o(n);
                }
                var r = Ut, i = l(e.value);
                switch (e.kind) {
                  case "get":
                    r = Bt;
                    i = new wt(i);
                    break;

                  case "set":
                    r = Lt;
                    i = new wt(i);
                    break;
                }
                return new r({
                    start: s(e),
                    end: f(e),
                    key: n,
                    private: t,
                    static: e.static,
                    value: i
                });
            },
            PropertyDefinition: function(e) {
                var n = e.key, t = false;
                if (e.computed) {
                    n = l(n);
                } else if (n.type == "PrivateIdentifier") {
                    t = true;
                    n = "#" + n.name;
                } else {
                    n = o(n);
                }
                return new Rt({
                    start: s(e),
                    end: f(e),
                    key: n,
                    private: t,
                    static: e.static,
                    value: l(e.value)
                });
            },
            StaticBlock: function(e) {
                var n = s(e);
                var t = f(e);
                return new Vt({
                    start: n,
                    end: t,
                    value: new yt({
                        start: n,
                        end: t,
                        body: a(e.body.map(l))
                    })
                });
            },
            ForOfStatement: function(e) {
                return new (e.await ? _t : xe)({
                    start: s(e),
                    end: f(e),
                    init: l(e.left),
                    object: l(e.right),
                    body: l(e.body)
                });
            },
            TryStatement: function(e) {
                var n = e.handlers || [ e.handler ];
                if (n.length > 1 || e.guardedHandlers && e.guardedHandlers.length) {
                    throw new Error("Multiple catch clauses are not supported.");
                }
                return new rr({
                    start: s(e),
                    end: f(e),
                    body: l(e.block).body,
                    bcatch: l(n[0]),
                    bfinally: e.finalizer ? new ar(l(e.finalizer)) : null
                });
            },
            Property: function(e) {
                var n = e.computed ? l(e.key) : o(e.key);
                var t = {
                    start: s(e),
                    end: f(e),
                    key: n,
                    value: l(e.value)
                };
                if (e.kind == "init") return new (e.method ? Er : kr)(t);
                t.value = new wt(t.value);
                if (e.kind == "get") return new Tr(t);
                if (e.kind == "set") return new Sr(t);
            },
            ArrayExpression: function(e) {
                return new Pn({
                    start: s(e),
                    end: f(e),
                    elements: e.elements.map(function(e) {
                        return e === null ? new Gr() : l(e);
                    })
                });
            },
            ArrayPattern: function(e) {
                var n = [], t = null;
                e.elements.forEach(function(e) {
                    if (e === null) {
                        n.push(new Gr());
                    } else if (e.type == "RestElement") {
                        t = l(e.argument);
                    } else {
                        n.push(l(e));
                    }
                });
                return new br({
                    start: s(e),
                    end: f(e),
                    elements: n,
                    rest: t
                });
            },
            ObjectPattern: function(e) {
                var n = [], t = null;
                e.properties.forEach(function(e) {
                    if (e.type == "RestElement") {
                        t = l(e.argument);
                    } else {
                        n.push(new yr(l(e)));
                    }
                });
                return new wr({
                    start: s(e),
                    end: f(e),
                    properties: n,
                    rest: t
                });
            },
            MemberExpression: function(e) {
                return new (e.computed ? qn : Dn)({
                    start: s(e),
                    end: f(e),
                    optional: e.optional,
                    expression: l(e.object),
                    property: e.computed ? l(e.property) : e.property.name
                });
            },
            MetaProperty: function(e) {
                var n = l(e.meta);
                var t = o(e.property);
                if (n.name == "new" && t == "target") return new Yr({
                    start: s(e),
                    end: f(e),
                    name: "new.target"
                });
                return new Dn({
                    start: s(e),
                    end: f(e),
                    expression: n,
                    property: t
                });
            },
            SwitchCase: function(e) {
                return new (e.test ? tr : nr)({
                    start: s(e),
                    end: f(e),
                    expression: l(e.test),
                    body: e.consequent.map(l)
                });
            },
            ExportAllDeclaration: function(e) {
                var n = s(e);
                var t = f(e);
                return new ke({
                    start: n,
                    end: t,
                    aliases: [ e.exported ? p(e.exported) : new Rn({
                        start: n,
                        value: "*",
                        end: t
                    }) ],
                    keys: [ new Rn({
                        start: n,
                        value: "*",
                        end: t
                    }) ],
                    path: l(e.source)
                });
            },
            ExportDefaultDeclaration: function(e) {
                var n = l(e.declaration);
                if (!n.name) switch (n.CTOR) {
                  case Mt:
                    n = new qt(n);
                    break;

                  case Ft:
                    n = new Ot(n);
                    break;

                  case It:
                    n = new Ht(n);
                    break;

                  case Pt:
                    n = new $t(n);
                    break;

                  case jt:
                    n = new zt(n);
                    break;
                }
                return new lr({
                    start: s(e),
                    end: f(e),
                    body: n
                });
            },
            ExportNamedDeclaration: function(e) {
                if (e.declaration) return new cr({
                    start: s(e),
                    end: f(e),
                    body: l(e.declaration)
                });
                if (e.source) {
                    var n = [], t = [];
                    e.specifiers.forEach(function(e) {
                        n.push(p(e.exported));
                        t.push(p(e.local));
                    });
                    return new ke({
                        start: s(e),
                        end: f(e),
                        aliases: n,
                        keys: t,
                        path: l(e.source)
                    });
                }
                return new pr({
                    start: s(e),
                    end: f(e),
                    properties: e.specifiers.map(function(e) {
                        var n = new jr(l(e.local));
                        n.alias = p(e.exported);
                        return n;
                    })
                });
            },
            ImportDeclaration: function(e) {
                var t = s(e);
                var r = f(e);
                var i = null, a = null, o = null;
                e.specifiers.forEach(function(e) {
                    var n = new Or(l(e.local));
                    switch (e.type) {
                      case "ImportDefaultSpecifier":
                        a = n;
                        a.key = new Rn({
                            start: t,
                            value: "",
                            end: r
                        });
                        break;

                      case "ImportNamespaceSpecifier":
                        i = n;
                        i.key = new Rn({
                            start: t,
                            value: "*",
                            end: r
                        });
                        break;

                      default:
                        n.key = p(e.imported);
                        if (!o) o = [];
                        o.push(n);
                        break;
                    }
                });
                return new dr({
                    start: t,
                    end: r,
                    all: i,
                    default: a,
                    properties: o,
                    path: l(e.source)
                });
            },
            ImportExpression: function(e) {
                var n = s(e);
                var t = l(e.source);
                return new Sn({
                    start: n,
                    end: f(e),
                    expression: new Hn({
                        start: n,
                        end: t.start,
                        name: "import"
                    }),
                    args: [ t ]
                });
            },
            VariableDeclaration: function(e) {
                return new ({
                    const: sr,
                    let: fr
                }[e.kind] || ur)({
                    start: s(e),
                    end: f(e),
                    definitions: e.declarations.map(l)
                });
            },
            Literal: function(e) {
                var n = {
                    start: s(e),
                    end: f(e)
                };
                if (e.bigint) {
                    n.value = e.bigint.toLowerCase() + "n";
                    return new Br(n);
                }
                var t = e.value;
                if (t === null) return new Ur(n);
                var r = e.regex;
                if (r && r.pattern) {
                    n.value = new RegExp(r.pattern, r.flags);
                    n.value.raw_source = r.pattern;
                    return new Lr(n);
                } else if (r) {
                    n.value = e.regex && e.raw ? e.raw : t;
                    return new Lr(n);
                }
                switch (typeof t) {
                  case "string":
                    n.value = t;
                    return new Rn(n);

                  case "number":
                    if (isNaN(t)) return new Vr(n);
                    var i, a;
                    if (isFinite(t)) {
                        i = 1 / t < 0;
                        n.value = i ? -t : t;
                        a = new Bn(n);
                    } else {
                        i = t < 0;
                        a = new Jr(n);
                    }
                    return i ? new zn({
                        start: n.start,
                        end: n.end,
                        operator: "-",
                        expression: a
                    }) : a;

                  case "boolean":
                    return new (t ? Qr : Kr)(n);
                }
            },
            TemplateLiteral: function(e) {
                return new Rr({
                    start: s(e),
                    end: f(e),
                    expressions: e.expressions.map(l),
                    strings: e.quasis.map(function(e) {
                        return e.value.raw;
                    })
                });
            },
            TaggedTemplateExpression: function(e) {
                var n = l(e.quasi);
                n.start = s(e);
                n.end = f(e);
                n.tag = l(e.tag);
                return n;
            },
            Identifier: function(e) {
                var n, t = c.length - 1;
                do {
                    n = c[--t];
                } while (n.type == "ArrayPattern" || n.type == "AssignmentPattern" && n.left === c[t + 1] || n.type == "ObjectPattern" || n.type == "Property" && n.value === c[t + 1] || n.type == "VariableDeclarator" && n.id === c[t + 1]);
                var r = Hn;
                switch (n.type) {
                  case "ArrowFunctionExpression":
                    if (n.body !== c[t + 1]) r = In;
                    break;

                  case "BreakStatement":
                  case "ContinueStatement":
                    r = Te;
                    break;

                  case "CatchClause":
                    r = Pr;
                    break;

                  case "ClassDeclaration":
                    if (n.id === c[t + 1]) r = Ee;
                    break;

                  case "ClassExpression":
                    if (n.id === c[t + 1]) r = Fr;
                    break;

                  case "FunctionDeclaration":
                    r = n.id === c[t + 1] ? Cr : In;
                    break;

                  case "FunctionExpression":
                    r = n.id === c[t + 1] ? Mr : In;
                    break;

                  case "LabeledStatement":
                    r = Se;
                    break;

                  case "VariableDeclaration":
                    r = {
                        const: qr,
                        let: $r
                    }[n.kind] || zr;
                    break;
                }
                return new r({
                    start: s(e),
                    end: f(e),
                    name: e.name
                });
            },
            Super: function(e) {
                return new Ir({
                    start: s(e),
                    end: f(e),
                    name: "super"
                });
            },
            ThisExpression: function(e) {
                return new Hr({
                    start: s(e),
                    end: f(e),
                    name: "this"
                });
            },
            ParenthesizedExpression: function(e) {
                var n = l(e.expression);
                if (!n.start.parens) n.start.parens = [];
                n.start.parens.push(s(e));
                if (!n.end.parens) n.end.parens = [];
                n.end.parens.push(f(e));
                return n;
            },
            ChainExpression: function(e) {
                var n = l(e.expression);
                n.terminal = true;
                return n;
            }
        };
        r.UpdateExpression = r.UnaryExpression = function e(n) {
            var t = "prefix" in n ? n.prefix : n.type == "UnaryExpression" ? true : false;
            return new (t ? zn : mr)({
                start: s(n),
                end: f(n),
                operator: n.operator,
                expression: l(n.argument)
            });
        };
        u("EmptyStatement", mn);
        u("ExpressionStatement", _n, "expression>body");
        u("BlockStatement", gn, "body@body");
        u("IfStatement", xn, "test>condition, consequent>body, alternate>alternative");
        u("LabeledStatement", ut, "label>label, body>body");
        u("BreakStatement", Kt, "label>label");
        u("ContinueStatement", Qt, "label>label");
        u("WithStatement", gt, "object>expression, body>body");
        u("SwitchStatement", Zt, "discriminant>expression, cases@body");
        u("ReturnStatement", wn, "argument>value");
        u("ThrowStatement", Jt, "argument>value");
        u("WhileStatement", dt, "test>condition, body>body");
        u("DoWhileStatement", pt, "test>condition, body>body");
        u("ForStatement", ht, "init>init, test>condition, update>step, body>body");
        u("ForInStatement", mt, "left>init, right>object, body>body");
        u("DebuggerStatement", rt);
        u("VariableDeclarator", kn, "id>name, init>value");
        u("CatchClause", ir, "param>argname, body%body");
        u("BinaryExpression", Cn, "operator=operator, left>left, right>right");
        u("LogicalExpression", Cn, "operator=operator, left>left, right>right");
        u("AssignmentExpression", Fn, "operator=operator, left>left, right>right");
        u("AssignmentPattern", En, "left>name, right>value");
        u("ConditionalExpression", Mn, "test>condition, consequent>consequent, alternate>alternative");
        u("NewExpression", hr, "callee>expression, arguments@args, pure=pure");
        u("CallExpression", Sn, "callee>expression, arguments@args, optional=optional, pure=pure");
        u("SequenceExpression", Tn, "expressions@expressions");
        u("SpreadElement", On, "argument>expression");
        u("ObjectExpression", Nn, "properties@properties");
        u("AwaitExpression", _r, "argument>expression");
        u("YieldExpression", gr, "argument>expression, delegate=nested");
        h(bt, function e(n) {
            return g("Program", n);
        });
        h(Ct, function e(n) {
            var t = n.argnames.map(v);
            if (n.rest) t.push({
                type: "RestElement",
                argument: v(n.rest)
            });
            return {
                type: "FunctionDeclaration",
                id: v(n.name),
                async: Et(n),
                generator: St(n),
                params: t,
                body: g("BlockStatement", n)
            };
        });
        h(yn, function e(n) {
            var t = n.argnames.map(v);
            if (n.rest) t.push({
                type: "RestElement",
                argument: v(n.rest)
            });
            if (kt(n)) return {
                type: "ArrowFunctionExpression",
                async: Et(n),
                params: t,
                body: n.value ? v(n.value) : g("BlockStatement", n)
            };
            return {
                type: "FunctionExpression",
                id: v(n.name),
                async: Et(n),
                generator: St(n),
                params: t,
                body: g("BlockStatement", n)
            };
        });
        h(It, function e(n) {
            return {
                type: "ClassDeclaration",
                id: v(n.name),
                superClass: v(n.extends),
                body: {
                    type: "ClassBody",
                    body: n.properties.map(v)
                }
            };
        });
        h(Ht, function e(n) {
            return {
                type: "ClassExpression",
                id: v(n.name),
                superClass: v(n.extends),
                body: {
                    type: "ClassBody",
                    body: n.properties.map(v)
                }
            };
        });
        function e(r) {
            return function(e) {
                var n = e.key instanceof vn;
                var t = n ? v(e.key) : e.private ? {
                    type: "PrivateIdentifier",
                    name: e.key.slice(1)
                } : {
                    type: "Literal",
                    value: e.key
                };
                return {
                    type: "MethodDefinition",
                    kind: r,
                    computed: n,
                    key: t,
                    static: e.static,
                    value: v(e.value)
                };
            };
        }
        h(Bt, e("get"));
        h(Lt, e("set"));
        h(Ut, e("method"));
        h(Rt, function e(n) {
            var t = n.key instanceof vn;
            var r = t ? v(n.key) : n.private ? {
                type: "PrivateIdentifier",
                name: n.key.slice(1)
            } : {
                type: "Literal",
                value: n.key
            };
            return {
                type: "PropertyDefinition",
                computed: t,
                key: r,
                static: n.static,
                value: v(n.value)
            };
        });
        h(Vt, function e(n) {
            return g("StaticBlock", n.value);
        });
        function n(n) {
            return function(e) {
                return {
                    type: "ForOfStatement",
                    await: n,
                    left: v(e.init),
                    right: v(e.object),
                    body: v(e.body)
                };
            };
        }
        h(_t, n(true));
        h(xe, n(false));
        h(it, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: d(n, {
                    type: "Literal",
                    value: n.value
                })
            };
        });
        h(er, function e(n) {
            return {
                type: "SwitchCase",
                test: v(n.expression),
                consequent: n.body.map(v)
            };
        });
        h(rr, function e(n) {
            return {
                type: "TryStatement",
                block: _(n),
                handler: v(n.bcatch),
                guardedHandlers: [],
                finalizer: v(n.bfinally)
            };
        });
        h(ir, function e(n) {
            return {
                type: "CatchClause",
                param: v(n.argname),
                guard: null,
                body: _(n)
            };
        });
        h(cr, function e(n) {
            return {
                type: "ExportNamedDeclaration",
                declaration: v(n.body)
            };
        });
        h(lr, function e(n) {
            return {
                type: "ExportDefaultDeclaration",
                declaration: v(n.body)
            };
        });
        h(ke, function e(n) {
            if (n.keys[0].value == "*") return {
                type: "ExportAllDeclaration",
                exported: n.aliases[0].value == "*" ? null : m(n.aliases[0]),
                source: v(n.path)
            };
            var t = [];
            for (var r = 0; r < n.aliases.length; r++) {
                t.push(d({
                    start: n.keys[r].start,
                    end: n.aliases[r].end
                }, {
                    type: "ExportSpecifier",
                    local: m(n.keys[r]),
                    exported: m(n.aliases[r])
                }));
            }
            return {
                type: "ExportNamedDeclaration",
                specifiers: t,
                source: v(n.path)
            };
        });
        h(pr, function e(n) {
            return {
                type: "ExportNamedDeclaration",
                specifiers: n.properties.map(function(e) {
                    return d({
                        start: e.start,
                        end: e.alias.end
                    }, {
                        type: "ExportSpecifier",
                        local: v(e),
                        exported: m(e.alias)
                    });
                })
            };
        });
        h(dr, function e(n) {
            var t = n.properties ? n.properties.map(function(e) {
                return d({
                    start: e.key.start,
                    end: e.end
                }, {
                    type: "ImportSpecifier",
                    local: v(e),
                    imported: m(e.key)
                });
            }) : [];
            if (n.all) t.unshift(d(n.all, {
                type: "ImportNamespaceSpecifier",
                local: v(n.all)
            }));
            if (n.default) t.unshift(d(n.default, {
                type: "ImportDefaultSpecifier",
                local: v(n.default)
            }));
            return {
                type: "ImportDeclaration",
                specifiers: t,
                source: v(n.path)
            };
        });
        h(or, function e(n) {
            return {
                type: "VariableDeclaration",
                kind: n.TYPE.toLowerCase(),
                declarations: n.definitions.map(v)
            };
        });
        h(An, function e(n) {
            var t = n instanceof qn;
            var r = {
                type: "MemberExpression",
                object: v(n.expression),
                computed: t,
                optional: n.optional,
                property: t ? v(n.property) : {
                    type: "Identifier",
                    name: n.property
                }
            };
            return n.terminal ? {
                type: "ChainExpression",
                expression: r
            } : r;
        });
        h($n, function e(n) {
            return {
                type: n.operator == "++" || n.operator == "--" ? "UpdateExpression" : "UnaryExpression",
                operator: n.operator,
                prefix: n instanceof zn,
                argument: v(n.expression)
            };
        });
        h(Cn, function e(n) {
            return {
                type: n.operator == "&&" || n.operator == "||" ? "LogicalExpression" : "BinaryExpression",
                left: v(n.left),
                operator: n.operator,
                right: v(n.right)
            };
        });
        h(Pn, function e(n) {
            return {
                type: "ArrayExpression",
                elements: n.elements.map(v)
            };
        });
        h(br, function e(n) {
            var t = n.elements.map(v);
            if (n.rest) t.push({
                type: "RestElement",
                argument: v(n.rest)
            });
            return {
                type: "ArrayPattern",
                elements: t
            };
        });
        h(yr, function e(n) {
            var t = n.key instanceof vn;
            var r = t ? v(n.key) : {
                type: "Literal",
                value: n.key
            };
            return {
                type: "Property",
                kind: "init",
                computed: t,
                key: r,
                value: v(n.value)
            };
        });
        h(wr, function e(n) {
            var t = n.properties.map(v);
            if (n.rest) t.push({
                type: "RestElement",
                argument: v(n.rest)
            });
            return {
                type: "ObjectPattern",
                properties: t
            };
        });
        h(xr, function e(n) {
            var t = n.key instanceof vn;
            var r = t ? v(n.key) : {
                type: "Literal",
                value: n.key
            };
            var i;
            if (n instanceof kr) {
                i = "init";
            } else if (n instanceof Tr) {
                i = "get";
            } else if (n instanceof Sr) {
                i = "set";
            }
            return {
                type: "Property",
                kind: i,
                computed: t,
                method: n instanceof Er,
                key: r,
                value: v(n.value)
            };
        });
        h(Ar, function e(n) {
            var t = n.definition();
            return {
                type: "Identifier",
                name: t && t.mangled_name || n.name
            };
        });
        h(Ir, function e() {
            return {
                type: "Super"
            };
        });
        h(Hr, function e() {
            return {
                type: "ThisExpression"
            };
        });
        h(Yr, function e() {
            return {
                type: "MetaProperty",
                meta: {
                    type: "Identifier",
                    name: "new"
                },
                property: {
                    type: "Identifier",
                    name: "target"
                }
            };
        });
        h(Lr, function e(n) {
            var t = n.value.toString().match(/\/([gimuy]*)$/)[1];
            var r = "/" + n.value.raw_source + "/" + t;
            return {
                type: "Literal",
                value: r,
                raw: r,
                regex: {
                    pattern: n.value.raw_source,
                    flags: t
                }
            };
        });
        h(Br, function e(n) {
            var t = n.value;
            return {
                type: "Literal",
                bigint: t.slice(0, -1),
                raw: t
            };
        });
        function t(e) {
            var n = e.value;
            if (typeof n === "number" && (n < 0 || n === 0 && 1 / n < 0)) {
                return {
                    type: "UnaryExpression",
                    operator: "-",
                    prefix: true,
                    argument: {
                        type: "Literal",
                        value: -n,
                        raw: e.start.raw
                    }
                };
            }
            return {
                type: "Literal",
                value: n,
                raw: e.start.raw
            };
        }
        h(Xr, t);
        h(Yn, t);
        h(Ur, t);
        h(y, function e(n) {
            return {
                type: "Identifier",
                name: String(n.value)
            };
        });
        h(Rr, function e(n) {
            var t = n.strings.length - 1;
            var r = {
                type: "TemplateLiteral",
                expressions: n.expressions.map(v),
                quasis: n.strings.map(function(e, n) {
                    return {
                        type: "TemplateElement",
                        tail: n == t,
                        value: {
                            raw: e
                        }
                    };
                })
            };
            if (!n.tag) return r;
            return {
                type: "TaggedTemplateExpression",
                tag: v(n.tag),
                quasi: r
            };
        });
        ft.DEFMETHOD("to_mozilla_ast", gn.prototype.to_mozilla_ast);
        Gr.DEFMETHOD("to_mozilla_ast", Jn);
        vn.DEFMETHOD("to_mozilla_ast", function() {
            throw new Error("Cannot convert AST_" + this.TYPE);
        });
        function a(e) {
            for (var n = 0; n < e.length; n++) {
                var t = e[n];
                if (!(t instanceof _n)) break;
                var r = t.body;
                if (!(r instanceof Rn)) break;
                if (t.start.pos !== r.start.pos) break;
                e[n] = new it(r);
            }
            return e;
        }
        function i(e) {
            if (e.type == "Literal") {
                return e.raw != null ? e.raw : e.value + "";
            }
        }
        function s(e) {
            var n = e.loc, t = n && n.start;
            var r = e.range;
            return new te({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: r ? r[0] : e.start,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: r ? r[0] : e.start,
                raw: i(e)
            });
        }
        function f(e) {
            var n = e.loc, t = n && n.end;
            var r = e.range;
            return new te({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: r ? r[1] : e.end,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: r ? r[1] : e.end,
                raw: i(e)
            });
        }
        function o(e) {
            return "" + e[e.type == "Identifier" ? "name" : "value"];
        }
        function u(e, n, t) {
            var a = [ "start: my_start_token(M)", "end: my_end_token(M)" ];
            var o = [ "type: " + JSON.stringify(e) ];
            if (t) t.split(/\s*,\s*/).forEach(function(e) {
                var n = /([a-z0-9$_]+)(=|@|>|%)([a-z0-9$_]+)/i.exec(e);
                if (!n) throw new Error("Can't understand property map: " + e);
                var t = n[1], r = n[2], i = n[3];
                switch (r) {
                  case "@":
                    a.push(i + ": M." + t + ".map(from_moz)");
                    o.push(t + ": M." + i + ".map(to_moz)");
                    break;

                  case ">":
                    a.push(i + ": from_moz(M." + t + ")");
                    o.push(t + ": to_moz(M." + i + ")");
                    break;

                  case "=":
                    a.push(i + ": M." + t);
                    o.push(t + ": M." + i);
                    break;

                  case "%":
                    a.push(i + ": from_moz(M." + t + ").body");
                    o.push(t + ": to_moz_block(M)");
                    break;

                  default:
                    throw new Error("Can't understand operator in propmap: " + e);
                }
            });
            r[e] = new Function("U2", "my_start_token", "my_end_token", "from_moz", [ "return function From_Moz_" + e + "(M) {", "    return new U2.AST_" + n.TYPE + "({", a.join(",\n"), "    });", "};" ].join("\n"))(b, s, f, l);
            h(n, new Function("to_moz", "to_moz_block", "to_moz_scope", [ "return function To_Moz_" + e + "(M) {", "    return {", o.join(",\n"), "    };", "};" ].join("\n"))(v, _, g));
        }
        var c = null;
        function l(e) {
            c.push(e);
            var n = null;
            if (e) {
                if (!et(r, e.type)) throw new Error("Unsupported type: " + e.type);
                n = r[e.type](e);
            }
            c.pop();
            return n;
        }
        function p(e) {
            return new Rn({
                start: s(e),
                value: o(e),
                end: f(e)
            });
        }
        vn.from_mozilla_ast = function(e) {
            var n = c;
            c = [];
            var t = l(e);
            c = n;
            t.walk(new Ln(function(e) {
                if (e instanceof Te) {
                    for (var n = 0, t; t = this.parent(n); n++) {
                        if (t instanceof bn) break;
                        if (t instanceof ut && t.label.name == e.name) {
                            e.thedef = t.label;
                            break;
                        }
                    }
                    if (!e.thedef) {
                        var r = e.start;
                        qe("Undefined label " + e.name, r.file, r.line, r.col, r.pos);
                    }
                }
            }));
            return t;
        };
        function d(e, n) {
            var t = e.start;
            var r = e.end;
            if (t.pos != null && r.endpos != null) {
                n.range = [ t.pos, r.endpos ];
            }
            if (t.line) {
                n.loc = {
                    start: {
                        line: t.line,
                        column: t.col
                    },
                    end: r.endline ? {
                        line: r.endline,
                        column: r.endcol
                    } : null
                };
                if (t.file) {
                    n.loc.source = t.file;
                }
            }
            return n;
        }
        function h(e, n) {
            e.DEFMETHOD("to_mozilla_ast", function() {
                return d(this, n(this));
            });
        }
        function v(e) {
            return e != null ? e.to_mozilla_ast() : null;
        }
        function m(e) {
            return ei(e.value) ? d(e, {
                type: "Identifier",
                name: e.value
            }) : v(e);
        }
        function _(e) {
            return {
                type: "BlockStatement",
                body: e.body.map(v)
            };
        }
        function g(e, n) {
            var t = n.body.map(v);
            if (n.body[0] instanceof _n && n.body[0].body instanceof Rn) {
                t.unshift(v(new mn(n.body[0])));
            }
            return {
                type: e,
                body: t
            };
        }
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function G() {
        var n = new hn();
        [ "NaN", "null", "true", "false", "Infinity", "-Infinity", "undefined" ].forEach(r);
        [ "encodeURI", "encodeURIComponent", "escape", "eval", "decodeURI", "decodeURIComponent", "isFinite", "isNaN", "parseFloat", "parseInt", "unescape" ].forEach(r);
        var t = Function("return this")();
        [ "Array", "ArrayBuffer", "Atomics", "BigInt", "Boolean", "console", "DataView", "Date", "Error", "Function", "Int8Array", "Intl", "JSON", "Map", "Math", "Number", "Object", "Promise", "Proxy", "Reflect", "RegExp", "Set", "String", "Symbol", "WebAssembly" ].forEach(function(e) {
            r(e);
            var n = t[e];
            if (!n) return;
            Object.getOwnPropertyNames(n).map(r);
            if (typeof n != "function") return;
            if (n.__proto__) Object.getOwnPropertyNames(n.__proto__).map(r);
            if (n.prototype) Object.getOwnPropertyNames(n.prototype).map(r);
            try {
                Object.getOwnPropertyNames(new n()).map(r);
            } catch (e) {
                try {
                    Object.getOwnPropertyNames(n()).map(r);
                } catch (e) {}
            }
        });
        return (G = function() {
            return n.clone();
        })();
        function r(e) {
            n.set(e, true);
        }
    }
    function J(e, n) {
        e.walk(new Ln(function(e) {
            if (e instanceof Yt) {
                if (e.start && e.start.quote) t(e.key);
            } else if (e instanceof xr) {
                if (e.start && e.start.quote) t(e.key);
            } else if (e instanceof qn) {
                X(e.property, t);
            }
        }));
        function t(e) {
            Kn(n, e);
        }
    }
    function X(e, n) {
        if (e instanceof Mn) {
            X(e.consequent, n);
            X(e.alternative, n);
        } else if (e instanceof Tn) {
            X(e.tail_node(), n);
        } else if (e instanceof Rn) {
            n(e.value);
        }
    }
    function K(e, t) {
        t = we(t, {
            builtins: false,
            cache: null,
            debug: false,
            keep_quoted: false,
            regex: null,
            reserved: null
        }, true);
        var n = t.builtins ? new hn() : G();
        if (Array.isArray(t.reserved)) t.reserved.forEach(function(e) {
            n.set(e, true);
        });
        var r = -1;
        var i;
        if (t.cache) {
            i = t.cache.props;
            i.each(function(e) {
                n.set(e, true);
            });
        } else {
            i = new hn();
        }
        var a = t.regex;
        var o = t.debug !== false;
        var s;
        if (o) s = t.debug === true ? "" : t.debug;
        var f = new hn();
        var u = n.clone();
        e.walk(new Ln(function(e) {
            if (e instanceof Cn) {
                if (e.operator == "in") X(e.left, p);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof Dn) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof Hn)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    X(e.args[1], p);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    X(e.args[0], p);
                    break;
                }
            } else if (e instanceof Yt) {
                if (typeof e.key == "string") p(e.key);
            } else if (e instanceof Dn) {
                p(e.property);
            } else if (e instanceof xr) {
                if (typeof e.key == "string") p(e.key);
            } else if (e instanceof qn) {
                X(e.property, p);
            }
        }));
        e.walk(new Ln(function(e) {
            if (e instanceof Cn) {
                if (e.operator == "in") h(e.left);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof Dn) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof Hn)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    h(e.args[1]);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    h(e.args[0]);
                    break;
                }
            } else if (e instanceof Yt) {
                if (typeof e.key == "string") e.key = d(e.key);
            } else if (e instanceof Dn) {
                e.property = d(e.property);
            } else if (e instanceof xr) {
                if (typeof e.key == "string") e.key = d(e.key);
            } else if (e instanceof qn) {
                if (!t.keep_quoted) h(e.property);
            }
        }));
        function c(e) {
            if (u.has(e)) return false;
            if (/^-?[0-9]+(\.[0-9]+)?(e[+-][0-9]+)?$/.test(e)) return false;
            return true;
        }
        function l(e) {
            if (n.has(e)) return false;
            if (a && !a.test(e)) return false;
            return i.has(e) || f.has(e);
        }
        function p(e) {
            if (c(e)) f.set(e, true);
            if (!l(e)) u.set(e, true);
        }
        function d(e) {
            if (!l(e)) return e;
            var n = i.get(e);
            if (!n) {
                if (o) {
                    var t = "_$" + e + "$" + s + "_";
                    if (c(t)) n = t;
                }
                if (!n) do {
                    n = A(++r);
                } while (!c(n));
                if (/^#/.test(e)) n = "#" + n;
                i.set(e, n);
            }
            return n;
        }
        function h(e) {
            if (e instanceof Tn) {
                h(e.expressions.tail_node());
            } else if (e instanceof Rn) {
                e.value = d(e.value);
            } else if (e instanceof Mn) {
                h(e.consequent);
                h(e.alternative);
            }
        }
    }
    "use strict";
    var Q, Z;
    if (typeof Buffer == "undefined") {
        Q = atob;
        Z = btoa;
    } else if (typeof Buffer.alloc == "undefined") {
        Q = function(e) {
            return new Buffer(e, "base64").toString();
        };
        Z = function(e) {
            return new Buffer(e).toString("base64");
        };
    } else {
        Q = function(e) {
            return Buffer.from(e, "base64").toString();
        };
        Z = function(e) {
            return Buffer.from(e).toString("base64");
        };
    }
    function ee(e, n) {
        var t = n.end.comments_after;
        for (var r = t.length; --r >= 0; ) {
            var i = t[r];
            if (i.type != "comment1") break;
            var a = /^# ([^\s=]+)=(\S+)\s*$/.exec(i.value);
            if (!a) break;
            if (a[1] == "sourceMappingURL") {
                a = /^data:application\/json(;.*?)?;base64,([^,]+)$/.exec(a[2]);
                if (!a) break;
                return Q(a[2]);
            }
        }
        vn.warn("inline source map not found: {name}", {
            name: e
        });
    }
    function ne(n) {
        try {
            return JSON.parse(n);
        } catch (e) {
            throw new Error("invalid input source map: " + n);
        }
    }
    function se(n, t, e) {
        e.forEach(function(e) {
            if (t[e]) {
                if (typeof t[e] != "object") t[e] = {};
                if (!(n in t[e])) t[e][n] = t[n];
            }
        });
    }
    function fe(e) {
        if (!e) return;
        if (!("props" in e)) {
            e.props = new hn();
        } else if (!(e.props instanceof hn)) {
            e.props = hn.fromObject(e.props);
        }
    }
    function ue(e) {
        return {
            props: e.props.toObject()
        };
    }
    function ce(r, i) {
        try {
            i = we(i, {
                annotations: undefined,
                compress: {},
                enclose: false,
                expression: false,
                ie: false,
                ie8: false,
                keep_fargs: false,
                keep_fnames: false,
                mangle: {},
                module: false,
                nameCache: null,
                output: {},
                parse: {},
                rename: undefined,
                sourceMap: false,
                timings: false,
                toplevel: !!(i && i["module"]),
                v8: false,
                validate: false,
                warnings: false,
                webkit: false,
                wrap: false
            }, true);
            if (i.validate) vn.enable_validation();
            var e = i.timings && {
                start: Date.now()
            };
            if (i.annotations !== undefined) se("annotations", i, [ "compress", "output" ]);
            if (i.expression) se("expression", i, [ "compress", "parse" ]);
            if (i.ie8) i.ie = i.ie || i.ie8;
            if (i.ie) se("ie", i, [ "compress", "mangle", "output", "rename" ]);
            if (i.keep_fargs) se("keep_fargs", i, [ "compress", "mangle", "rename" ]);
            if (i.keep_fnames) se("keep_fnames", i, [ "compress", "mangle", "rename" ]);
            if (i.module) se("module", i, [ "compress", "parse" ]);
            if (i.toplevel) se("toplevel", i, [ "compress", "mangle", "rename" ]);
            if (i.v8) se("v8", i, [ "mangle", "output", "rename" ]);
            if (i.webkit) se("webkit", i, [ "compress", "mangle", "output", "rename" ]);
            var n;
            if (i.mangle) {
                i.mangle = we(i.mangle, {
                    cache: i.nameCache && (i.nameCache.vars || {}),
                    eval: false,
                    ie: false,
                    keep_fargs: false,
                    keep_fnames: false,
                    properties: false,
                    reserved: [],
                    toplevel: false,
                    v8: false,
                    webkit: false
                }, true);
                if (i.mangle.properties) {
                    if (typeof i.mangle.properties != "object") {
                        i.mangle.properties = {};
                    }
                    if (i.mangle.properties.keep_quoted) {
                        n = i.mangle.properties.reserved;
                        if (!Array.isArray(n)) n = [];
                        i.mangle.properties.reserved = n;
                    }
                    if (i.nameCache && !("cache" in i.mangle.properties)) {
                        i.mangle.properties.cache = i.nameCache.props || {};
                    }
                }
                fe(i.mangle.cache);
                fe(i.mangle.properties.cache);
            }
            if (i.rename === undefined) i.rename = i.compress && i.mangle;
            if (i.sourceMap) {
                i.sourceMap = we(i.sourceMap, {
                    content: null,
                    filename: null,
                    includeSources: false,
                    names: true,
                    root: null,
                    url: null
                }, true);
            }
            var t = [];
            if (i.warnings) vn.log_function(function(e) {
                t.push(e);
            }, i.warnings == "verbose");
            if (e) e.parse = Date.now();
            var a;
            i.parse = i.parse || {};
            if (r instanceof vn) {
                a = r;
            } else {
                if (typeof r == "string") r = [ r ];
                i.parse.toplevel = null;
                var o = i.sourceMap && i.sourceMap.content;
                if (typeof o == "string" && o != "inline") {
                    o = ne(o);
                }
                if (o) i.sourceMap.orig = Object.create(null);
                for (var s in r) if (et(r, s)) {
                    i.parse.filename = s;
                    i.parse.toplevel = a = ai(r[s], i.parse);
                    if (o == "inline") {
                        var f = ee(s, a);
                        if (f) i.sourceMap.orig[s] = ne(f);
                    } else if (o) {
                        i.sourceMap.orig[s] = o;
                    }
                }
            }
            if (i.parse.expression) a = a.wrap_expression();
            if (n) J(a, n);
            [ "enclose", "wrap" ].forEach(function(e) {
                var n = i[e];
                if (!n) return;
                var t = a.print_to_string().slice(0, -1);
                a = a[e](n);
                r[a.start.file] = a.print_to_string().replace(t, "");
            });
            if (i.validate) a.validate_ast();
            if (e) e.rename = Date.now();
            if (i.rename) {
                a.figure_out_scope(i.rename);
                a.expand_names(i.rename);
            }
            if (e) e.compress = Date.now();
            if (i.compress) {
                a = new ui(i.compress).compress(a);
                if (i.validate) a.validate_ast();
            }
            if (e) e.scope = Date.now();
            if (i.mangle) a.figure_out_scope(i.mangle);
            if (e) e.mangle = Date.now();
            if (i.mangle) {
                a.compute_char_frequency(i.mangle);
                a.mangle_names(i.mangle);
            }
            if (e) e.properties = Date.now();
            if (i.mangle && i.mangle.properties) K(a, i.mangle.properties);
            if (i.parse.expression) a = a.unwrap_expression();
            if (e) e.output = Date.now();
            var u = {};
            var c = we(i.output, {
                ast: false,
                code: true
            });
            if (c.ast) u.ast = a;
            if (c.code) {
                if (i.sourceMap) {
                    c.source_map = W(i.sourceMap);
                    if (i.sourceMap.includeSources) {
                        if (r instanceof bt) {
                            throw new Error("original source content unavailable");
                        } else for (var s in r) if (et(r, s)) {
                            c.source_map.setSourceContent(s, r[s]);
                        }
                    }
                }
                delete c.ast;
                delete c.code;
                var l = ci(c);
                a.print(l);
                u.code = l.get();
                if (i.sourceMap) {
                    u.map = c.source_map.toString();
                    var p = i.sourceMap.url;
                    if (p) {
                        u.code = u.code.replace(/\n\/\/# sourceMappingURL=\S+\s*$/, "");
                        if (p == "inline") {
                            u.code += "\n//# sourceMappingURL=data:application/json;charset=utf-8;base64," + Z(u.map);
                        } else {
                            u.code += "\n//# sourceMappingURL=" + p;
                        }
                    }
                }
            }
            if (i.nameCache && i.mangle) {
                if (i.mangle.cache) i.nameCache.vars = ue(i.mangle.cache);
                if (i.mangle.properties && i.mangle.properties.cache) {
                    i.nameCache.props = ue(i.mangle.properties.cache);
                }
            }
            if (e) {
                e.end = Date.now();
                u.timings = {
                    parse: .001 * (e.rename - e.parse),
                    rename: .001 * (e.compress - e.rename),
                    compress: .001 * (e.scope - e.compress),
                    scope: .001 * (e.mangle - e.scope),
                    mangle: .001 * (e.properties - e.mangle),
                    properties: .001 * (e.output - e.properties),
                    output: .001 * (e.end - e.output),
                    total: .001 * (e.end - e.start)
                };
            }
            if (t.length) {
                u.warnings = t;
            }
            return u;
        } catch (e) {
            return {
                error: e
            };
        } finally {
            vn.log_function();
            vn.disable_validation();
        }
    }
    b["Dictionary"] = hn;
    b["is_statement"] = at;
    b["List"] = Xn;
    b["minify"] = ce;
    b["parse"] = ai;
    b["push_uniq"] = Kn;
    b["TreeTransformer"] = Zr;
    b["TreeWalker"] = Ln;
})(typeof UglifyJS == "undefined" ? UglifyJS = {} : UglifyJS);
// @license-end
